// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
//"use strict";
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'ionic-native-transitions', 'ngCordova', 'Report', 'Health', 'HealthDetail', 'Drug', 'Directive', 'OnLineCustomer', 'FileUtil', 'Hospital', 'User', 'HealthData', 'Mine', 'HealthEnter', 'PSM', 'Filter', 'Message', 'Dom', 'Plan', 'PillBox', 'Device', 'Order', 'Alipay', 'Doctor', 'nameFilter', 'WristStrap', 'Product', 'Ecg','Wallet'])
  .run(function ($ionicPlatform, $rootScope, $cordovaNetwork, $ionicHistory, $cordovaLocalNotification, $ionicModal, $cordovaToast, $location, $cacheFactory, $interval, $state, $ionicNativeTransitions, nearbyHospitalService, WebSql, buletoothService, $cordovaGeolocation, Plan, $cordovaDevice, userService, $timeout, FS, healthService, $cordovaSms, $cordovaVibration, appService, $ionicPopup, $ionicLoading, $cordovaAppVersion, $cordovaFileTransfer, $cordovaFileOpener2, drugService, $cordovaMedia, $cordovaFile, $cordovaBadge, onlineService, BadgeService, DoctorService, DeviceData,$cordovaStatusbar) {
    //$(".zz_allHide").css("display", "block");
    $rootScope.regChannel = "";
    $rootScope.badgeCount = 0;
    $rootScope.userType = null; //用户类型
    $rootScope.longitude = null;
    $rootScope.latitude = null;
//        $rootScope.regChannel = "304医院";
//        $rootScope.regChannel = "";
    //提醒变量--start--
    $rootScope.remindInterval = null;
    //提醒变量--end--
    //监听返回键
    $ionicPlatform.registerBackButtonAction(function (e) {
      $(".dw-persp").css("display", "none");
      //如果执行了提醒框退出
      if ($rootScope.plan_remind.back_exe()) {
        return false;
      }
      //判断处于哪个页面时双击退出
      if ($location.path() == '/tab/health' || $location.path() == '/tab/home' || $location.path() == '/tab/mine' || $location.path() == '/tab/pillbox' || $location.path() == '/g_load/load_index' || $location.path() == '/g_load/load_index/tab.home' || $location.path() == '/g_load/load_index/tab.mine') {
        if ($rootScope.backButtonPressedOnceToExit) {
          //ionic.Platform.exitApp();
          backAsHome.trigger(function () {
            console.log("Success");
          }, function () {
            console.log("Error");
          });
        } else {
          $rootScope.backButtonPressedOnceToExit = true;
          $cordovaToast.showShortBottom('再按一次返回桌面');
          window.setTimeout(function () {
            $rootScope.backButtonPressedOnceToExit = false;
          }, 2000);
        }
      } else {
        var c_name = $state.current.name;
        var cache = $cacheFactory.get(c_name);
        if (!cache) {
          $ionicHistory.goBack();
        } else {
          var special_back = cache.get('special_back');
          if (!special_back) {
            $ionicHistory.goBack();
          } else {
            $rootScope.$broadcast(c_name + "_HARDWARE_BACK");
          }
        }
      }
      e.preventDefault();
      return false;
    }, 351);

    $rootScope.add_plan_remind = {
      show: false,
      go: function () {
        this.show = false;
        if (!$rootScope.token) {
          $ionicNativeTransitions.stateGo('g_load', {backUrl: 'tab.home'}, {
            "type": "slide",
            "direction": "left",
            "duration": 500
          });
        } else {
          $ionicNativeTransitions.stateGo('add_drug', {backUrl: 'tab.home'}, {
            "type": "slide",
            "direction": "left",
            "duration": 500
          });
        }
      }
    };

    /**
     * 停止音乐和振动
     */
    $rootScope.stopRemind = function () {
      console.log("取消三次定时器---，并且关掉振动跟响铃");
//            $rootScope.hasClicked = true;
      console.debug("$rootScope.remindInterval:",$rootScope.remindInterval);
      $interval.cancel($rootScope.remindInterval);
      $("#music")[0].load();
      $cordovaVibration.vibrate(0);
    }

    /**
     * 计划提醒
     */
    $rootScope.plan_remind = {
      //当前正在提示的计划
      //采用栈操作的方式对同时显示的多种药进行操作
      modal: null,
      delay_modal: null,
      plans: [],
      wechat: function () {                //短信提醒
        Wechat.isInstalled(function (installed) {
          if (!installed) {
            ErrorShow("您还没安装微信哟");
            return;
          }
        }, function (e) {
          console.error(e);
        });

        console.log("点击了微信");
        $rootScope.stopRemind();
        var p = this.plans[this.plans.length - 1];
        var plan = p.plan;
        Plan.take(p.take_date, p.at.time, p.plan.id, null).then(function (data) {
        }, function (error) {
        });
        Wechat.share({
          text: '亲爱的' + plan.toUser.name + ',' + $rootScope.user.name + '提醒您' + '，您的' + plan.medicineName + '该用药了',
          scene: Wechat.Scene.SESSION   // share to Timeline
        }, function () {
          //alert("Success");
        }, function (reason) {
          //alert("Failed: " + reason);
        });
        this.show_pre();
      },
      sms: function () {
        console.log("点击了发短信");
        $rootScope.stopRemind();
        //短信提醒
        var p = this.plans[this.plans.length - 1];
        var plan = p.plan;
        Plan.take(p.take_date, p.at.time, p.plan.id, null).then(function (data) {
        }, function (error) {
        });
        $cordovaSms.send(plan.toUser.telephone, '亲爱的' + plan.toUser.name + ',' + $rootScope.user.name + '提醒您' + '，您的' + plan.medicineName + '该用药了', {
          replaceLineBreaks: false, // true to replace \n by a new line, false by default
          android: {
            intent: 'INTENT'  // send SMS with the native android SMS messaging
            //intent: ‘‘ // send SMS without open any other app
          }
        }).then(function (d) {
        }, function (error) {
          // An error occurred
          //alert(error);
        });
        this.show_pre();
      },
      call: function () {
        console.log("点击了拨打电话");
        $rootScope.stopRemind();
        var p = this.plans[this.plans.length - 1];
        var plan = p.plan;
        Plan.take(p.take_date, p.at.time, p.plan.id, null).then(function (data) {
        }, function (error) {
        });
        //安卓和ios拨打电话不同之处
        if ($rootScope.os == "Android") {
          window.plugins.CallNumber.callNumber(function () {
          }, function () {
          }, plan.toUser.telephone);
        } else {
          window.PhoneCaller.call(plan.toUser.telephone, function () {
          }, function () {
          })
        }
        this.show_pre();
      },
      //显示药品信息
      show_dom: function (data) {
        var plan = data.plan;
        var at = data.at;
        $('#plan_remind_medicine_surface').attr('src', plan.surface.url);
        //如果外观颜色存在
        if (plan.surface.color != 'ffffff') {
          $('#plan_remind_header').css('background', '#' + plan.surface.color);
        } else {
          $('#plan_remind_header').css('background', '#64b2e1');
          $('#plan_remind_medicine_pic').css('background-color', '#e1e1e1');
        }
        //如果剂量用法存在
        if (plan.medicine.usage) {
          $('#plan_remind_medicine_usage').css('display', 'block');
        } else {
          $('#plan_remind_medicine_usage').css('display', 'none');
        }
        $('#plan_remind_medicine_dosage').html(plan.dosage_unit);
        $('#plan_remind_alarm_time').html(at.bucket + at.time);
        if (plan.toUser) {
          console.debug("plan.toUser:plan", plan);
          //如果提醒用户是别人
          $('#plan_remind_other_ope').css('display', 'block');
          $('#plan_remind_me_ope').css('display', 'none');
          // $('#plan_remind_self').css('display', 'none');

          $('#plan_remind_self').css('display', 'block');
          if (plan.medicine.forbidden) {
            $('#plan_remind_medicine_forbid').css('display', 'block').html("禁忌：" + plan.medicine.forbidden);
          } else {
            $('#plan_remind_medicine_forbid').css('display', 'none');
          }
          $('#plan_remind_medicine_name').html((plan.toUser.name + '的' + plan.medicineName).substr(0, 12));

          this.show_otherInfo(plan);
        } else {
          //如果提醒用户是自己
          $('#plan_remind_other_ope').css('display', 'none');
          $('#plan_remind_me_ope').css('display', 'block');
          $('#plan_remind_self').css('display', 'block');
          var title_name = ((($rootScope.user && $rootScope.user.name ) ? ($rootScope.user.name + '的') : '我的') + plan.medicineName).substr(0, 12);
          $('#plan_remind_medicine_name').html(title_name);
          if (plan.medicine.forbidden) {
            $('#plan_remind_medicine_forbid').css('display', 'block').html("禁忌：" + plan.medicine.forbidden);
          } else {
            $('#plan_remind_medicine_forbid').css('display', 'none');
          }
          this.show_otherInfo(plan);
          // if (plan.remark) {
          //     $('#plan_remind_remark_total').css('display', 'block');
          //     $('#plan_remind_remark').css('display', 'block');
          //     $('#plan_remind_remark_title').css('display', 'block');
          //     $('plan_remind_remark_time').css('display', 'block');
          //     $('#zz_remark').attr('src', plan.remark);
          //     $('#plan_remind_remark_text_div').css('display', 'none');
          // } else if (plan.remarkText) {
          //     $('#plan_remind_remark_total').css('display', 'block');
          //     $('#plan_remind_remark').css('display', 'none');
          //     $('#plan_remind_remark_title').css('display', 'block');
          //     $('plan_remind_remark_time').css('display', 'none');
          //     $('#plan_remind_remark_text_div').css('display', 'block');
          //     $('#plan_remind_remark_text').html(plan.remarkText);
          // } else {
          //     $('#plan_remind_remark_total').css('display', 'none');
          // }
          // if (!(plan.remarkText || plan.remark || plan.medicine.usage)) {
          //     $('#plan_remind_self').css('display', 'none');
          // }
        }
      },
      show: function (data) {
        if (this.plans.length == 0) {
          this.modal.show();
        }
        var p_this = this;
        if (data.is_list) {
          p_this.plans = p_this.plans.concat(data.list);
          p_this.show_dom(data.list[data.list.length - 1]);
        } else {
          p_this.plans.push(data);
          p_this.show_dom(data);
        }
      },
      show_pre: function () {
        //弹出镇定元素
        this.plans.pop();
        if (this.plans.length > 0) {
          this.modal.hide();
          var p_this = this;
          var p = this.plans[this.plans.length - 1];
          $timeout(function () {
            p_this.modal.show();
            p_this.show_dom(p);
          }, 1000);
        } else {
          //alert('没有消息了');
          //选择完毕重新加载消息
          Plan.clear_all();
          $timeout(function () {
            $rootScope.$broadcast('RELOAD_MESSAGE');
          }, 2000);
          this.modal.hide();
        }
      },
      //跳过
      skip: function () {
        console.log("点击了跳过");
        $rootScope.stopRemind();
        this.show_pre();
      },
      //推迟
      delay: function () {
        console.log("点击了推迟,停止提醒");
        $rootScope.stopRemind();
        this.delay_modal.show();
      },
      //服用全部
      takeAll: function () {
        console.log("点击了服用");
        $rootScope.stopRemind();
        if (window.cordova) {
          if ($cordovaNetwork.isOffline()) {
            //alert("网络异常，数据无法同步");
            $("#ERROR").css('display', 'block').html("网络异常，数据无法同步");
            $timeout(function () {
              $("#ERROR").css('display', 'none');
            }, 500);
          }
        }
        var p = this.plans[this.plans.length - 1];
        Plan.take(p.take_date, p.at.time, p.plan.id, null).then(function (data) {
        }, function (error) {
        });
        this.show_pre();
      },
      /**
       * 播放备注
       */
      playRemark: function () {
        if ($('#zz_remark').length > 0) {
          $('#zz_remark')[0].play();
        }
      },
      cancel_delay: function () {
        this.delay_modal.hide();
      },
      /**
       * 按分钟数推迟计划
       * @param minute
       */
      delay_plan: function (minute) {
        this.delay_modal.hide();
        //弹栈 对象包括具体计划和执行时间
        var p = this.plans[this.plans.length - 1];
        //推迟闹钟
        //-------------推迟更新添加数据库和发送广播
        console.log("p", p);
        drugService.delayPlan(p.at.time, p.plan.id, minute);
        $timeout(function () {
          $rootScope.$emit('REFRESH_PLAN_IMG');
        }, 500);

        console.log('服药', p);
        //  plantuichi.put();
        //-------------结束----------------------

        Plan.delay_alarm(p, minute);
        //显示栈顶元素
        this.show_pre();
      },
      is_top_time: function (time) {
        var ret = false;
        if (this.plans.length > 0) {
          var alarm = this.plans[this.plans.length - 1];
          if (time == alarm.at.time) {
            ret = true;
          }
        }
        return ret;
      },
      /**
       * 跳转到剂量界面
       */
      goUsage: function () {
        /* this.modal.hide();*/
        var p = this.plans[this.plans.length - 1];
        var url2 = $rootScope.reqUrl + p.plan.medicine.usage.url;
        cordova.ThemeableBrowser.open(url2, '_blank', {
          toolbar: {
            height: 44,
            color: '#f0f0f0ff'
          },
          title: {
            color: '#003264ff',
            showPageTitle: true
          },
          backButton: {
            wwwImage: 'img/cha3.png',
            wwwImagePressed: 'img/cha3.png',
            align: 'left',
            event: 'backPressed'
          },
          backButtonCanClose: true
        }).addEventListener('backPressed', function (e) {
          //alert(e);
          /*$ionicNativeTransitions.stateGo('tab.pillbox', {}, {
           "type": "slide",
           "direction": "right",
           "duration": 200
           });*/
        });
      },
      /**
       * 重新显示弹出框
       */
      re_show: function () {
        if (this.plans.length > 0) {
          $timeout(function () {
            this.modal.show();
          }, 1000);
        }
      },
      is_showing: function () {
        return this.plans.length > 0;
      },
      //返回键退出方法
      back_exe: function () {
        var ret = false;
        if (this.delay_modal.isShown()) {
          this.delay_modal.hide();
          ret = true;
        } else {
          if (this.plans.length > 0) {
            this.show_pre();
            ret = true;
          }
        }
        return ret;
      },
      //停止播放音乐
      stop_music: function () {
        $("#music")[0].load();
        $cordovaVibration.vibrate(0);
      },

      //关闭提醒吃药模态框
      closeRemindModal: function () {
        this.modal.hide();
      },
      /**
       * 显示备注信息
       * @param plan
       */
      show_otherInfo: function (plan) {
        if (plan.remark) {
          $('#plan_remind_remark_total').css('display', 'block');
          $('#plan_remind_remark').css('display', 'block');
          $('#plan_remind_remark_title').css('display', 'block');
          $('plan_remind_remark_time').css('display', 'block');
          $('#zz_remark').attr('src', plan.remark);
          $('#plan_remind_remark_text_div').css('display', 'none');
        } else if (plan.remarkText) {
          $('#plan_remind_remark_total').css('display', 'block');
          $('#plan_remind_remark').css('display', 'none');
          $('#plan_remind_remark_title').css('display', 'block');
          $('plan_remind_remark_time').css('display', 'none');
          $('#plan_remind_remark_text_div').css('display', 'block');
          $('#plan_remind_remark_text').html(plan.remarkText);
        } else {
          $('#plan_remind_remark_total').css('display', 'none');
        }
        if (!(plan.remarkText || plan.remark || plan.medicine.usage)) {
          $('#plan_remind_self').css('display', 'none');
        }
      }
    };

    $rootScope.bug = {
      modal: null,
      clear: function () {
        var t = this;
        this.modal.show();
        $timeout(function () {
          t.modal.hide();
        });
      }
    };

    $ionicModal.fromTemplateUrl('plan_remind.html', {
      scope: $rootScope,
      animation: 'slide-in-up'
    }).then(function (modal) {
      $rootScope.plan_remind.modal = modal;
    });

    $ionicModal.fromTemplateUrl('delay.html', {
      scope: $rootScope,
      animation: 'slide-in-up'
    }).then(function (modal) {
      $rootScope.plan_remind.delay_modal = modal;
    });

    $ionicModal.fromTemplateUrl('bug.html', {
      scope: $rootScope,
      animation: 'slide-in-up'
    }).then(function (modal) {
      $rootScope.bug.modal = modal;
    });
//测试


    //$rootScope.jpushPrefix = "test_patient";
    //$rootScope.reqUrl = 'http://localhost:8080/HealthMonitor';
    //$rootScope.reqUrl = 'http://192.168.31.251:8080/HealthMonitor';
    //$rootScope.reqUrl = 'http://appdemo.sinoicity.com:8888/HealthMonitor';
    /*$rootScope.reqUrl = 'http://jky.sinoicity.cn:9989/HealthMonitor';
    $rootScope.reqUrl_short = "http://appdemo.sinoicity.com:8888";
    $rootScope.reqUrlshare = 'http://appdemo.sinoicity.com/';//分享链接--测试库
    $rootScope.reqUrlshare = 'http://wx.sinoicity.cn/';//分享链接--测试库
    $rootScope.reqwxAppid = 'wxfacr4527cbe22b7d9';//微信appid--测试库
    $rootScope.reqQQAppid = '101327838';//QQappid--测试库
    $rootScope.hxAppkey = "sinoicity-health#zhylapp";  //环信appkey*/


    //正式
    $rootScope.reqUrl = 'https://health.sinoicity.com/HealthMonitor';
    $rootScope.reqUrl_short = "https://health.sinoicity.com:9000";
    $rootScope.jpushPrefix = "sinoicity_patient";
    $rootScope.reqUrlshare = 'https://wx.sinoicity.com/';//分享链接--正式库
    $rootScope.reqwxAppid = 'wx3fb4be70de453b37';//微信appid--正式库
    $rootScope.reqQQAppid = '101307779';//QQappid--正式库
    $rootScope.hxAppkey = "sinoicity-health#doctorapp";
    //获取用户信息
    $rootScope.get_user_info = function () {
      userService.getProfile($rootScope.token).then(function (d) {
        $rootScope.user = d;
        if (d.headImg)  //注册时的默认头像
        {
          //alert(localStorage.getItem("headImg"));
          $rootScope.user.headImg = d.headImg;
        }
        if (d.userType == 6 && !d.phone) {  //如果为游客类型
          $rootScope.userType = 6;
        }

        $rootScope.date = d.date;
        $rootScope.user.date = d.date;
        $rootScope.gender = d.gender;
        $rootScope.name = d.name;
        console.log(d);
        //上传日志
        if ($rootScope.user.userId) {//存在再上传
          $timeout(function () {
            userService.upLoginLogs($rootScope.user.userId).then(function (d) {
              console.log(d);
            }, function (e) {
              console.log(e);
            });
          }, 10000);
        }
        $rootScope.$broadcast('REFRESH_SUCCESS');
      }, function (error) {
        console.log(error);
        $rootScope.$broadcast('f');
      });
    };
    //如果本地缓存token存在取出
    $rootScope.sound = {
      ring: "file://sound/pillbox.mp3",
      audio: true,
      zhendong: true,
      show: '药瓶晃动',
      index: 1,
      duration: 3,
      url: "pillbox.mp3"
    };
    var storage_sound = localStorage.getItem("sound");
    if (localStorage.getItem("token")) {
      $rootScope.token = localStorage.getItem("token");
      //铃声设置
      if (typeof storage_sound == "object") { //判断对象是否存在
        localStorage.removeItem("sound");
      } else if (storage_sound) {
        $rootScope.sound = JSON.parse(localStorage.getItem("sound"));
        console.log("从本地取出铃声：" + $rootScope.sound.ring);
        console.log("从本地取震动：" + $rootScope.sound.zhendong);
      }
      $rootScope.get_user_info();
    } else {
      //$rootScope.add_plan_remind.show = true;
    }

    /**
     * 加药提醒标识
     */
    var scanRemind = localStorage.getItem("scanRemind");
    console.log(scanRemind);
    if (!scanRemind) {
      localStorage.setItem("scanRemind", 0);
    }

    /**
     * 延迟加载其他页面的数据
     */

//获取地理位置
    /*        var posOptions = {timeout: 2000, enableHighAccuracy: false};
     console.log($cordovaGeolocation);
     $cordovaGeolocation
     .getCurrentPosition(posOptions)
     .then(function (position) {
     $rootScope.lat = position.coords.latitude;
     $rootScope.long = position.coords.longitude;
     */
    /* alert("经度："+$rootScope.lat+"\n"+"纬度："+$rootScope.long+"\n");*/
    /*
     }, function (err) {
     //alert(err);
     });*/

    //获取各种设备的屏幕的高度与宽度
    $rootScope.screenWidth = window.screen.width;
    $rootScope.screenHeight = window.screen.height - 24;
    nearbyHospitalService.init();
    buletoothService.initBTooth();
    WebSql.init();
    WebSql.createTable();
    WebSql.createInformMessageTable();  //社区消息表
//        WebselectChatList
    //WebSql.selectOneMessage('10101019');
    $rootScope.isImLogin = false;  //是否已经登录环信
    $rootScope.logoutFlag = false;  //是否退出登录标识
    $rootScope.isConnClose = false;
    $ionicPlatform.ready(function () {
      if (localStorage.getItem("fontSize")) {
        var fontSize = localStorage.getItem("fontSize");
        if (fontSize == 100) {
          $("html").css({"font-size": "15px"});
          localStorage.setItem("user_message_width", "30%");
        } else {
          $("html").css({"font-size": "10px"});
          localStorage.setItem("user_message_width", "45%");
        }
      }

      $rootScope.initImVideo = function () {
        var data = {
          loginuser: sessionStorage.getItem("imid"),
          loginpwd: sessionStorage.getItem("pwd")
        }
        console.debug("data:", data);
        EasemobPlugin.login(data, function (ret, err) {
          if (ret) {
            $rootScope.ImVideo_login_flag = true;
            console.info("环信视频聊天登录成功---");
          }
          if (err) {
            console.error("视频聊天登录失败");
          }
        });
      }

      $rootScope.InitIm = function () {
        console.log("初始化环信");
        //-----------登录环信并监听消息---------------
        $rootScope.messageDetils = [];
        var handleTextMessage = function (message) {
          $("#sysMessage")[0].play();
          $rootScope.badgeCount += 1;
          console.log('message:', message);
          var played = null;
          var msgObj = new Object();
          msgObj.time = new Date().getTime();
          var fromDoctorId = message.from.substring(1);
          console.log(fromDoctorId);
          if (message.ext.type == "image") {
            msgObj.content = message.ext.url;
            msgObj.isFromeMe = false;
            msgObj.type = "image";
            $rootScope.messageDetils.push(msgObj);
          } else if (message.ext.type == "audio") {
            msgObj.content = message.ext.url;
            msgObj.isFromeMe = false;
            msgObj.type = "audio";
            msgObj.audioTime = message.ext.audioTime;
            msgObj.played = 1;
            console.log(msgObj);
            $rootScope.messageDetils.push(msgObj);

          } else {
            msgObj.content = message.data;
            msgObj.isFromeMe = false;
            msgObj.type = 'text';
            $rootScope.messageDetils.push(msgObj);
          }

          DoctorService.getDoctorInfo(fromDoctorId).then(function (doctor) {
            console.log("app.js", doctor);
            msgObj.fromId = doctor.profile.id;
            msgObj.fromName = doctor.profile.name;
            msgObj.fromHeadImg = doctor.headImg;
            $rootScope.Message = msgObj;
            //角标 /z_health/z_message_chat/
            if (!isContains($location.path(), msgObj.fromId)) {
              var bcount = BadgeService.saveBadgeCount(fromDoctorId);
              console.log(fromDoctorId + "的未读消息数量是：" + bcount + "条");
            }
            WebSql.insertChatMessage($rootScope.user.userId, fromDoctorId, msgObj.fromName, msgObj.type, msgObj.content, msgObj.fromHeadImg, msgObj.audioTime, 0, 1, msgObj.played, msgObj.time);

            $rootScope.$broadcast("receiveMsg", $rootScope.Message);
            console.log($rootScope.Message);
          }, function (e) {
            console.log(e);
          });


        };
        //多处登录踢线操作;
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
          user_cache = $cacheFactory('user');
        }
        /**
         * 注销
         */
        $rootScope.loginout = function () {
          if (window.cordova) {
            EasemobPlugin.logout();
          }
          $rootScope.logoutFlag = true;
          if ($rootScope.connection && !$rootScope.isConnClose) {
            $rootScope.connection.close();
            console.log("注销动作中关闭环信连接");
          }
          var doctors_cache = $cacheFactory.get("doctors_cache");
          var doctorInfoCache = $cacheFactory.get("doctorInfoCache");
          var card_cache = $cacheFactory.get('g_card');
          var plan_cache = $cacheFactory.get('plan');
          if (!plan_cache) {
            plan_cache = $cacheFactory('plan');
          }
          $rootScope.token = null;
          $rootScope.userId = null;
          $rootScope.user = null;
          $rootScope.url = null;
          $rootScope.aliPay = null;
          //  localStorage.removeItem("headImg");
          localStorage.removeItem("token");
          user_cache.destroy();
          plan_cache.destroy();
          if (card_cache) {
            card_cache.destroy();
          }
          if (doctors_cache) {
            doctors_cache.destroy();
          }
          if (doctorInfoCache) {
            doctorInfoCache.destroy();
          }
          $rootScope.$emit('logout');
          $ionicNativeTransitions.stateGo('g_load', {backUrl: 'tab.mine'}, {
            "type": "slide",
            "direction": "left",
            "duration": 500
          });
        };
        $rootScope.confirmLogout = function () {
          $("#zz_logout").css("display", "none");
          $("#ZHEZHAO").css("display", "none");
          //用户多处登录的则提示
          $rootScope.loginout();
        };
        $rootScope.interval = null;
        //获取环信登录信息
        onlineService.getChatInfo().then(function (data) {
          sessionStorage.setItem("imid", data.imid);
          sessionStorage.setItem("pwd", data.passwd);
          $rootScope.im_id = data.imid;
          $rootScope.im_password = data.passwd;
          console.log(data);
          $rootScope.connection.open({
            user: data.imid,
            pwd: data.passwd,
            appKey: $rootScope.hxAppkey
          });
        }, function (error) {
        });

        $rootScope.$on('$cordovaNetwork:online', function (event, networkState) {
          console.log("网络重练，去重新获取环信连接");
          $rootScope.connection.open({
            user: sessionStorage.getItem("imid"),
            pwd: sessionStorage.getItem("pwd"),
            appKey: $rootScope.hxAppkey
          });
        });


        //初始化环信连接
        var loginTime = null;
        $rootScope.connection = new Easemob.im.Connection();
        $rootScope.connection.init({
          onOpened: function (message) {
            $rootScope.isImLogin = true;
            console.log(message);
            $rootScope.connection.setPresence();
            loginTime = new Date().getTime();
            console.log("环信登录成功" + "----" + loginTime);
//                        if ($rootScope.interval) {
//                            $interval.cancel($rootScope.interval);
//                        }
            /**
             *
             * 手机环境下初始化环信视频聊天
             */
            $rootScope.ImVideo_login_flag = false;


            $rootScope.initImVideo();
          },
          onClosed: function () {
            console.log("环信断开连接:" + new Date());
//                        if (!$rootScope.logoutFlag) {  //非退出登录或者非异地登录才重连
//                            $rootScope.interval = $interval(function () {
//                                $rootScope.connection.open({
//                                    user: $rootScope.im_id,
//                                    pwd: $rootScope.im_password,
//                                    appKey: 'sinoicity-health#doctorapp'
//                                    appKey: 'sinoicity-health#zhylapp'      //测试环境
//                                });
//                            }, 1000);
//                        }

          },
          onTextMessage: handleTextMessage, //收到文本消息处理动作
          onEmotionMessage: function (message) {
          }, //收到表情消息处理动作
          onPictureMessage: function (message) {
          }, //收到表情消息处理动作
          onAudioMessage: function (message) {
          }//收到语音消息处理动作
        });
//                $rootScope.connection = conn;
        //----------登录环信并监听消息----------------
      }
      if ($rootScope.token && !$rootScope.isImLogin) {   //若登录过并且环信未登录就去初始化环信
        if ($rootScope.connection) {
          $rootScope.connection.close();
        }
        $rootScope.isConnClose = true;
        $rootScope.logoutFlag = true;
        $rootScope.InitIm();
      }
//            if (window.cordova) {
//                $cordovaBadge.clear().then(function () {
//                    // You have permission, badge cleared.
//                    console.log("清除成功");
//                }, function (err) {
//                    // You do not have permission.
//                });
//            }
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      Plan.resetAlarm();
      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
//                window.devicePath = cordova.file.dataDirectory;
        window.devicePath = cordova.file.externalRootDirectory;
        var t = localStorage.getItem("token");
        if (t) {
          $rootScope.token = t;
          //重设闹钟
          // Plan.resetAlarm();
        }
//                $rootScope.apkUrl = $rootScope.reqUrl + '/app/healthpatient/cyyy/HealthPatientCy.apk';
        $rootScope.apkUrl = $rootScope.reqUrl + '/app/healthpatient/HealthPatient.apk';
        // 检查更新
        $rootScope.updateApp = function (res) {
          console.log(res);
          if (confirmPopup) {
            confirmPopup.close();
          }
          var downloadProgress = 0;
          console.log(res);
          var loading = null;
          if (res) {
            $(".g_zz_page").css('display', 'block');
            var url = $rootScope.apkUrl; //可以从服务端获取更新APP的路径
            $cordovaFile.checkDir(window.devicePath + 'HealthPatient/', date2str(new Date(), 'yyyy-MM-dd')).then(function (res) {
              $cordovaFile.removeDir(window.devicePath + 'HealthPatient/', date2str(new Date(), 'yyyy-MM-dd')).then(function (success) {
                // success
                $cordovaFile.createDir(window.devicePath + 'HealthPatient/', date2str(new Date(), 'yyyy-MM-dd'), true).then(function (res) {
                }, function (err) {
                })
              }, function (error) {
                // error
              });
            }, function (err) {                      //创建小视频缓存文件夹
              $cordovaFile.createDir(window.devicePath + 'HealthPatient/', date2str(new Date(), 'yyyy-MM-dd'), true).then(function (res) {
              }, function (err) {
              })
            });
            var targetPath = window.devicePath + 'HealthPatient/' + date2str(new Date(), 'yyyy-MM-dd') + '/HealthPatient.apk';
            //判断Apk文件是否已经下载，如果已经下载直接开始安装。否则下载并安装
            var trustHosts = true;
            var options = {};
            $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
              // 打开下载下来的APP
              $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive').then(function () {

              }, function (err) {
                // 错误
              });
              // loading.close();
              // $(".g_zz_page").css('display', 'none');
            }, function (err) {
              loading.close();
              $(".g_zz_page").css('display', 'none');
            }, function (progress) {
              //进度，这里使用文字显示下载百分比
              $timeout(function () {
                downloadProgress = (progress.loaded / progress.total) * 100;
                $("#graphbox2").css("width", Math.floor(downloadProgress) + '%');
                $("#zz_downloadProgress").html('版本更新&nbsp;&nbsp' + Math.floor(downloadProgress) + '%');
                if (downloadProgress > 99) {
                  loading.close();
                  $(".g_zz_page").css('display', 'none');
                } else {
                }
              })
            });
            loading = $ionicPopup.show({
              template: '<div class="g_ttt"><div class="graphbox"><div class="graphbox2" id="graphbox2"></div></div><a class="g_a" id="zz_downloadProgress">0%</a></div>'
            });
          }
          else {
            // 取消更新
          }
        };
        function checkUpdate() {
          appService.getLatestVersion().then(function (data) {
            $cordovaAppVersion.getVersionNumber().then(function (version) {
              //alert('应用版本:' + version);
              var old = version.split(".");
              old = parseInt(old[0]) * 100 + parseInt(old[1]) * 10 + parseInt(old[2]);
              var newVer = data.version.split(".");
              newVer = parseInt(newVer[0]) * 100 + parseInt(newVer[1]) * 10 + parseInt(newVer[2]);
              //alert(newVer);
              //alert(old);
              if (newVer > old) {
                var info = '';
                for (var i = 0; i < data.info.length; i++) {
                  info = info + data.info[i] + '<br/>'
                }
                showUpdateConfirm(info);
              }
            });
          }, function (error) {

          });
        }

        // 显示是否更新对话框
        var confirmPopup = null;    //定义版本升级对话框
        function showUpdateConfirm(info) {
          confirmPopup = $ionicPopup.show({
            template: '<div class="g_t10"><a class="g_light"><img src="img/g_light2.png" alt=""/></a><p>' + info + '</p><a class="g_t10_a g_t10_aa" ng-click="updateApp(false)">冷漠忽略</a><a class="g_t10_a" ng-click="updateApp(true)">系统升级</a></div>'
          });
        };
        if ($rootScope.token) {
          checkUpdate();
        }
        $timeout(function () {
          FS.init();
        }, 1000);

        $rootScope.deviceId = jQuery.md5($rootScope.jpushPrefix + $cordovaDevice.getUUID());
        // alert($rootScope.deviceId);

        $rootScope.os = $cordovaDevice.getPlatform();

        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);

        //解决键盘闪动
        //cordova.plugins.Keyboard.disableScroll(true);
        ionic.Platform.isFullScreen = true;
        //解决键盘闪动
        window.plugins.jPushPlugin.init();
//                window.plugins.jPushPlugin.setAlias($rootScope.deviceId);
        var tags = [$rootScope.jpushPrefix];
        window.plugins.jPushPlugin.setTagsWithAlias(tags, $rootScope.deviceId);
        console.log('jpush:tag' + tags + "deviceId:" + $rootScope.deviceId);

        console.log("打开通知的回调");
        //打开通知的回调
        var onOpenNotification = function (event) {
          console.log("打开了通知");
          var data;
          var extras;
          data = window.plugins.jPushPlugin.openNotification;
          console.log("data:", JSON.stringify(data));
          if (typeof data == 'string') {
            data = eval("(" + data + ")");
          }

          if ($rootScope.os == "Android") {
            extras = data.extras["cn.jpush.android.EXTRA"];
            if (extras.type == 5) {

            } else if (extras.type == 1) {
              //血压数据推送类型
              // alert('测量血压推送消息' + JSON.stringify(extras));
              //$rootScope.$broadcast('CHECK_BP', extras);
            } else if (extras.type == 4) {
              //修改，添加血氧推送，发送广播
              //$rootScope.$broadcast('CHECK_OX', extras);
            } else if (extras.type == 6) {
              //alert('微信分享生成消息');
              $ionicNativeTransitions.stateGo('user_messages', {
                backUrl: 'tab.home',
                shareId: extras.relation
              }, {
                "type": "slide",
                "direction": "left",
                "duration": 500
              });
            } else if (extras.type == 7) {
              //alert('微信回复生成消息');
              $ionicNativeTransitions.stateGo('user_messages', {
                backUrl: 'tab.home',
                shareId: extras.relation
              }, {
                "type": "slide",
                "direction": "left",
                "duration": 500
              });
            } else if (extras.type == 8) {
              //alert('未测量体征数据消息推送');
            }
          } else {    //ios处理
            extras = event;
            if (extras.xtype == 5) {
              $rootScope.$broadcast('REPORT_GENERATE', extras);
            } else if (extras.xtype == 1) {
              //血压数据推送类型
              $rootScope.$broadcast('CHECK_BP', extras);
            } else if (extras.xtype == 4) {
              //修改，添加血氧推送，发送广播
              $rootScope.$broadcast('CHECK_OX', extras);
            } else if (extras.xtype == 6) {
              //alert('微信分享生成消息');
              $rootScope.$broadcast('WECHAT_SHARE', extras);
              $ionicNativeTransitions.stateGo('user_messages', {
                backUrl: 'tab.home',
                shareId: extras.relation
              }, {
                "type": "slide",
                "direction": "left",
                "duration": 500
              });
            } else if (extras.xtype == 7) {
              //alert('微信回复生成消息');
              $rootScope.$broadcast('WECHAT_REPLY', extras);
              $ionicNativeTransitions.stateGo('user_messages', {
                backUrl: 'tab.home',
                shareId: extras.relation
              }, {
                "type": "slide",
                "direction": "left",
                "duration": 500
              });
            } else if (extras.xtype == 8) {
              //alert('未测量体征数据消息推送');
            }
          }
        };

        //接收通知的回调
        var onReceiveNotification = function (event) {
          console.log("平台：" + $rootScope.os + "--收到了通知");
          var data;
          var extras;
          var sendTime = date2str(new Date(), 'yyyy年MM月dd日 hh:mm:ss');
          data = window.plugins.jPushPlugin.receiveNotification;
          console.log("receiveMessage:" + JSON.stringify(data));
          if (typeof data == 'string') {
            data = eval("(" + data + ")");
          }
          if ($rootScope.os == "Android") {
            extras = data.extras["cn.jpush.android.EXTRA"];
            console.log("android ", JSON.stringify(extras));
            if (extras.type == 5) {
              //体检报告生成推送类型
              $rootScope.$broadcast('REPORT_GENERATE', extras);
            } else if (extras.type == 1) {
              //血压数据推送类型
              // alert('测量血压推送消息' + JSON.stringify(extras));
              $rootScope.$broadcast('CHECK_BP', extras);
            } else if (extras.type == 2) {
              //心率数据推送类型
              $rootScope.$broadcast('CHECK_HR', extras);
            } else if (extras.type == 3) {
              //血糖数据推送类型
              $rootScope.$broadcast('CHECK_BS', extras);
            } else if (extras.type == 4) {
              //修改，添加血氧推送，发送广播
              $rootScope.$broadcast('CHECK_OX', extras);
            } else if (extras.type == 6) {
              //alert('微信分享生成消息');
              $rootScope.$broadcast('WECHAT_SHARE', extras);
            } else if (extras.type == 7) {
              //alert('微信回复生成消息');
              $rootScope.$broadcast('WECHAT_REPLY', extras);
            } else if (extras.type == 8) {
              //alert('未测量体征数据消息推送');
              $rootScope.$broadcast('NO_CHECK', extras);
            } else if (extras.type == 10 && $rootScope.token) {
              $("#zzz_msg").html(extras.message);
              $("#zz_logout").css("display", "block");
              $("#ZHEZHAO").css("display", "block");
              $rootScope.connection.close();
              $rootScope.isConnClose = true;
              $rootScope.logoutFlag = true;
            } else if (extras.type == 11) { //社区消息
              $(".g_n_range").css({"display": "inline"});
              //接受到通知消息，存储消息
              console.info("收到社区消息");

              WebSql.insertInformMessageTable(data.title, data.alert, $rootScope.user.userId, 1, sendTime, 1);
            } else {//全体人员
              WebSql.insertInformMessageTable(data.title, data.alert, $rootScope.user.userId, 1, sendTime, 1);
            }
          } else {    //ios处理
            extras = event;
            console.log("ios ", JSON.stringify(event));
            var media = new Media("sound/three.mp3");
            //var media = new Media("http://xunlei.sc.chinaz.com/files/download/sound1/201402/4085.mp3");
            media.play();
            if (extras.xtype == 5) {
              //体检报告生成推送类型
              $rootScope.$broadcast('REPORT_GENERATE', extras);
            } else if (extras.xtype == 1) {
              //血压数据推送类型
              // alert('测量血压推送消息' + JSON.stringify(extras));
              $rootScope.$broadcast('CHECK_BP', extras);
            } else if (extras.xtype == 4) {
              //修改，添加血氧推送，发送广播
              $rootScope.$broadcast('CHECK_OX', extras);
            } else if (extras.xtype == 6) {
              //alert('微信分享生成消息');
              $rootScope.$broadcast('WECHAT_SHARE', extras);
            } else if (extras.xtype == 7) {
              //alert('微信回复生成消息');
              $rootScope.$broadcast('WECHAT_REPLY', extras);
            } else if (extras.xtype == 8) {
              //alert('未测量体征数据消息推送');
              $rootScope.$broadcast('NO_CHECK', extras);
            } else if (extras.xtype == 10) {      //下线通知
              $("#zzz_msg").html(extras.message);
              $("#zz_logout").css("display", "block");
              $("#ZHEZHAO").css("display", "block");
            } else if (extras.type == 11) { //社区消息
              $(".g_n_range").css({"display": "inline"});
              //接受到通知消息，存储消息
              console.info("收到社区消息");
              WebSql.insertInformMessageTable(data.title, data.alert, $rootScope.user.userId, 1, sendTime, 1);
            } else {//全体人员
              WebSql.insertInformMessageTable(data.title, data.alert, $rootScope.user.userId, 1, sendTime, 1);
            }
          }
        };
//
        document.addEventListener("jpush.openNotification", onOpenNotification, false);
        document.addEventListener("jpush.receiveNotification", onReceiveNotification, false);
        console.log("jpush监听编译完毕");
        //手环处理
        //查询是否配对了手环。
        //连接方法
        $rootScope.isReConnect = true; //是否重连标志位。默认为true
        $rootScope.showFail = false; //是否显示失败提示， 默认不显示
        $rootScope.$on('bindSuccess', function (evt, datas) {
          $timeout(function () {
            $rootScope.uploadFalg = 1; //0不上传，1上传心率，2上传步数，3上传睡眠
            var hrflag = false;
            var stepflag = false;
            var sleepflag = false;
            var count = 0;
            var temp;
            var dataFlag = false;
            bluetoothle.subscribe(function (data) {
              if (data.status == 'subscribedResult') {
                var bytes = bluetoothle.encodedStringToBytes(data.value);
                var string = bluetoothle.bytesToString(bytes);
                var a = strToHexCharCode(string);
                console.log(a)
                var b = stringToChar(a);
                if (stepflag && count < 3) {
                  temp = temp + a.substr(2, a.length);
                  count++;
                  if (count == 3) { //数据接收完成
                    count = 0;
                    stepflag = false;
                    var arr = stringToChar4(temp);
                    temp = null;
                    if (arr.length == 24) {
                      //处理数据
                      var timeArray = getTimeArray();
                      var stepArray = getStepArray(arr);
                      console.log('时间', timeArray);
                      console.log('数据', stepArray);
                      DeviceData.uploadBp(5, stepArray, timeArray).then(function (data) {
                        ErrorShow("上传数据成功");
                        $rootScope.uploadFalg = 1;
                        $rootScope.$broadcast("CHECK_STEPNUM");
                      }, function (e) {
                        ErrorShow("上传数据失败");
                        $rootScope.$broadcast("CHECK_FAIL", {type: 'stepnum'});
                      })
                    }
                  }
                } else if (hrflag && count < 2) {
                  temp = temp + a.substr(2, a.length);
                  count++;
                  if (count == 2) {
                    count = 0;
                    hrflag = false;
                    var hr = stringToChar(temp);
                    console.log(hr)
                    temp = null;
                    var a = parseInt(new Date().getHours());
                    var hrdate = hr[a];
                    console.log("心率数据", hrdate);
                    hrdate = parseInt(hrdate, 16);
                    var hrArr = [];
                    hrArr[0] = hrdate;
                    DeviceData.uploadBp(3, hrArr).then(function (data) {
                      ErrorShow("上传数据成功");
                    }, function (e) {
                      ErrorShow("上传数据失败");
                    })
                  }
                } else if (sleepflag) {
                  if (a.indexOf("ab") != -1) {  //有ab字符 结束接收,
                    sleepflag = false;
                    var arr = stringToChar4(temp);
                    console.log("最终数据", arr);
                    var str = "";
                    for (var i = 0; i < arr.length; i++) {
                      str = str + arr[i] + ",";
                    }
                    DeviceData.uploadBp(6, null, null, str).then(function (data) {
                      ErrorShow("上传数据成功");
                      $rootScope.uploadFalg = 1;
                      $rootScope.$broadcast("CHECK_SLEEP");
                    }, function (e) {
                      ErrorShow("上传数据失败");
                      $rootScope.$broadcast("CHECK_FAIL", {type: 'sleep'});
                    })
                  } else {
                    temp = temp + a.substr(2, a.length);
                  }
                }
                if (b[9] == '03' && b[11] == '02' && $rootScope.uploadFalg == 2) {  //步伐数据
                  temp = a.substr(36, a.length);
                  stepflag = true;
                } else if (b[9] == '03' && b[11] == '05' && $rootScope.uploadFalg == 1) {  //心率数据
                  temp = a.substr(36, a.length);
                  hrflag = true;
                } else if (b[9] == '03' && b[11] == '03' && $rootScope.uploadFalg == 3) { //睡眠数据
                  temp = a.substr(34, a.length);
                  sleepflag = true;
                  $rootScope.uploadTime = new Date().getTime();
                }
              }
            }, function (e) {
              console.log("数据传输失败", e);
              if (angular.isDefined($rootScope.reInter)) {
                console.group("启动定时器之前先关闭定时器");
                $interval.cancel($rootScope.reInter);
                console.log("停止重连定时器");
              }
              if ($rootScope.isReConnect) {
                $rootScope.reConnect(datas.address);
              }
            }, {
              "address": datas.address,
              "service": '0001',//ffe0
              "characteristic": '0003',//ffe1
              "isNotification": true
            })

          }, 5000)
        })
        //重连定时器
        $rootScope.reConnect = function (address) {
          if (angular.isDefined($rootScope.reInter)) {
            console.log("定时器之前先关闭定时器");
            $interval.cancel($rootScope.reInter);
          }
          $rootScope.reInter = $interval(function () {
            $rootScope.connectBlue(address);
          }, 5000)
        };
        $rootScope.blue_connect = function (address) {
          bluetoothle.connect(function (data) {
//                        ErrorShow("手环已连接");
            setWristTime(address);
            $rootScope.$broadcast("bindSuccess", {address: address});
            if (angular.isDefined($rootScope.reInter)) {
              $interval.cancel($rootScope.reInter);
              console.log("停止重连定时器");
            }
          }, function (e) {//蓝牙连接失败
            if ($rootScope.showFail) {
              $rootScope.showFail = false;
//                            ErrorShow("手环连接失败");
            }

            $("#zz_connect").hide();
            bluetoothle.close(function () {
            }, function () {
            }, {
              "address": address
            });
          }, {
            "address": address
          });
        };
        $rootScope.connectBlue = function (address) {
          $("#zz_mask").hide();
          $("#zz_band").hide();
          bluetoothle.isInitialized(function (data) {
            if (data.isInitialized) {//如果蓝牙已经初始化
              //判断蓝牙是否启用
              bluetoothle.isEnabled(function (data) {
                if (data.isEnabled) {
                  $rootScope.blue_connect(address);
                } else {
                  bluetoothle.enable(function () {//开启蓝牙
                    setTimeout(function () {
                      $rootScope.blue_connect(address);
                    }, 3000);
                  }, function () {
                  });
                }
              });
            } else {
              bluetoothle.initialize(function () {//初始化
                //判断蓝牙是否启用
                bluetoothle.isEnabled(function (data) {
                  if (data.isEnabled) {
                    $rootScope.blue_connect(address);
                  } else {
                    bluetoothle.enable(function () {//开启蓝牙
                      setTimeout(function () {
                        $rootScope.blue_connect(address);
                      }, 3000);
                    }, function () {
                    });
                  }
                });
              }, {
                "request": true,
                "statusReceiver": false
              });
            }
          });
        };
        //手环框点击取消
        $rootScope.Cancel = function () {
          $("#zz_mask").hide();
          $("#zz_band").hide();
        };
        $rootScope.strapAddress = null;
        buletoothService.PlaceSearchHistory.findByType(4).then(function (data) {
          if (data) {
            $rootScope.strapAddress = data.placeAddress;
            $rootScope.connectBlue($rootScope.strapAddress);
          }
        }, function (e) {

        });
        //向手环发送来电指令
        function sendPhoneRing() {
          if ($rootScope.strapAddress && localStorage.getItem('isCall') == 1) {
            var phoneRing = "ab00000c00000000020001000786e69da5e794b5";
            sendCommand(phoneRing, $rootScope.strapAddress, "0001", "0002");
            console.log("开始发送命令", $rootScope.strapAddress);
          }
        };
        //监听来电状态
        PhoneCallTrap.onCall(function (state) {
          console.log("CHANGE STATE: " + state);
          switch (state) {
            case "RINGING":
              sendPhoneRing();
              break;
            case "OFFHOOK":
              break;
            case "IDLE":
              break;
          }
        });
        //短息提醒监听开启
        SMS.startWatch(function (data) {
        }, function () {
        });
        var smsTime = new Date().getTime();
        document.addEventListener('onSMSArrive', function (e) {
          if (localStorage.getItem("isSms") == 1) {
            if (new Date().getTime() - smsTime > 3000) {
              smsTime = new Date().getTime();
              var smsStr = "ab00000c00000000020003000786e79fade681af";
              sendCommand(smsStr, $rootScope.strapAddress, "0001", "0002");
            }
          }
        });
      }


      // if (window.StatusBar) {
      //   // org.apache.cordova.statusbar required
      //   if ($rootScope.os == "Android") {
      //     statusbarTransparent.enable();
      //     // statusbarTransparent.toggle();
      //     console.debug("arg:","statusbarTransparent.toggle");
      //   } else {    //ios控制手机顶部显示颜色
      //     // StatusBar.styleLightContent();
      //   }
      // }
    });


//登录时间处理
    $rootScope.$on("login", function () {
      $rootScope.isImLogin = true;  //是否登陆过环信
      $rootScope.logoutFlag = false; //恢复默认值
      Plan.resetAlarm();
      $rootScope.InitIm();
    });

    $rootScope.$on('logout', function () {
      if (window.cordova) {
        Plan.cancelAlarm();
      }
      console.log("退出登录取消闹铃电脑端");
    });

//加药成功 重设闹钟
    $rootScope.$on('addMedicineSuccess', function (evt, data) {
      if (data) {
        console.group("设置闹钟开始");
        Plan.resetAlarm(data.plan);
        console.groupEnd();
      }
    });

//        $rootScope.$on('MEDICINE_TAKE', function (evt, data) {
//            Plan.deal_take_medicine(data);
//        });

    //重设闹钟广播监听
    $rootScope.$on('RESET_ALARM', function (evt, data) {
      Plan.resetAlarm();
    });

    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    $rootScope.$on('REFRESH', function (evt, data) {
      $rootScope.get_user_info();
      cache.put('network_error', false);

    });

    //网络连接失败时，重新连接获取亲朋列表
    $rootScope.$on('LOAD_MYFRIEND', function (evt, data) {
      drugService.getUser().then(function (data) {
        $rootScope.$broadcast('LOAD_MYFRIEND_SUCCESS');
      }, function (error) {
        // $rootScope.$broadcast('LOAD_MYFRIEND_ERROR');
      });
    });

    //监听通知栏点击事件
    $rootScope.$on('$cordovaLocalNotification:click',
      function (event, notification, state) {
        // ...
        $cordovaVibration.vibrate(0);
        if ($rootScope.os == 'iOS') {
          var today = date2str(new Date(), 'yyyy-MM-dd');
          //获取计划对象显示服药提醒
          var data = eval('(' + notification.data + ')');
          var time = null;
          if (data.is_list) {
            for (var i in data.list) {
              data.list[i].take_date = today;
            }
            //Plan.deal_alarm_trigger(today, data.list);
          } else {
            data.take_date = today;
            //Plan.deal_alarm_trigger(today, data);
          }
          $rootScope.plan_remind.show(data);
        }

      });

//计划提醒处理
    $rootScope.hasClicked = false;  //提醒后用户是否操作了的标识
    $rootScope.remindTimer = null;  //倒计时20秒计时器
    $rootScope.$on('$cordovaLocalNotification:trigger', function (event, notification, state) {
      console.debug("notification:" + JSON.stringify(notification));
      console.debug("soundUrl:", $rootScope.sound.ring);
      var src = "sound/" + $rootScope.sound.url;
      $("#music").attr("src", src);
//            document.getElementById("music").volume = 1.0;//设置音量最大
      /*  $timeout(function () {
       var index = $rootScope.sound.index;
       var src = "sound/" + $rootScope.sound.url;
       $("#music").attr("src", src);
       $('#music')[0].play();
       if ($rootScope.sound.zhendong) {
       $cordovaVibration.vibrate(15000);  //震动
       }
       $timeout(function () {
       $('#music')[0].load();
       $cordovaVibration.vibrate(0);
       }, 15000);
       }, ($rootScope.sound.duration + 1) * 1000);*/
      //通知手环吃药提醒
      if ($rootScope.strapAddress && localStorage.getItem('isEat') == 1) {
        var lookStr = "ab000005000000000200050000";
        sendCommand(lookStr, $rootScope.strapAddress, '0001', '0002');
      }
      var timer;
      if ($rootScope.sound.zhendong) {
        timer = $interval(function () {
          $cordovaVibration.vibrate(500);
        }, 1000);
        //震动
      }
      $timeout(function () {
        $cordovaVibration.vibrate(0);
        $interval.cancel(timer);
      }, 3000);


      var today = date2str(new Date(), 'yyyy-MM-dd');
      //获取计划对象显示服药提醒
      var data = eval('(' + notification.data + ')');
      var timer2 = null;
      if (data.is_list) {
        for (var i in data.list) {
          data.list[i].take_date = today;
        }
        //Plan.deal_alarm_trigger(today, data.list);
      } else {
        data.take_date = today;
        //Plan.deal_alarm_trigger(today, data);
      }
      $rootScope.plan_remind.show(data);
//            if (data.delay == 'HAVE_ALARM') {
//                //推迟已响闹钟
//            } else if (data.delay == 'NOT_FETCH') {
//                //推迟未响闹钟
//            }

//            倒计时20秒，若无操作5分钟后再响
      $rootScope.remindInterval = $interval(function () {
        console.info("进入remindInterval");
        //再次振动
        if ($rootScope.sound.zhendong) {
          console.debug("振动开关：", $rootScope.sound.zhendong);
          if ($rootScope.sound.audio) {
            console.debug("响铃开关：", $rootScope.sound.audio);
            $('#music')[0].play();
            console.log("music:" + $('#music')[0]);
            console.log("music中。。。");
          }
          timer2 = $interval(function () {
            $cordovaVibration.vibrate(500);
            console.log("振动中。。。");
          }, 1000, 4);
          //震动
        }
        $timeout(function () {
          console.info('timer2:', timer2);
          $cordovaVibration.vibrate(0);
          console.log("10秒过去了，取消振动定时器,停止铃声");
          $interval.cancel(timer2);
          $('#music')[0].load();
          timer2 = null;
        }, 10000);

        //-------------------------------------
      }, 10 * 60 * 1000, 2);

      $rootScope.remindInterval.then(function (d) {
        console.log("interval成功回调");
      }, function (e) {
        console.log("e:", e);
      }, function (n) {
        console.log("n:", n);
      });

    });
    /**
     * 健康页面弹窗
     * @type {string[]}
     * 取出用户缓存
     */
    var user_cache = $cacheFactory.get('user');
    if (!user_cache) {
      user_cache = $cacheFactory('user');
    }
    $rootScope.healthConfirm = {
      /**
       * 定义弹窗显示默认值
       * @type {boolean}
       */
      timeFlag: {
        send: 0,     //短信是否发送
        time: 60,
        count: 0,
        code: null  //验证码
      },
      id: '',
      users: null,
      phone: null,
      name: null,
      time_interval: null,
      //用户验证$("#zz_mask").css("display","block");
      user_verify: function (systemUserId, userArray) {
        $("#zz_mask").css("display", "block");
        $("#zz_validate").css("display", "block");
        console.log(123);
        this.id = systemUserId;
        this.users = userArray;
      },
      //点击未绑定用户
      user_bind: function (systemUserId, userArray) {
        $("#zz_mask").css("display", "block");
        $("#zz_inviting").css("display", "block");
      },
      /**
       * 取消方法
       */
      healthCancel: function () {
        var parent = this;
        if (angular.isDefined(parent.time_interval)) {
          $interval.cancel(parent.time_interval);
          parent.timeFlag.send = 1;
        }
        $("#zz_mask").css("display", "none");
        $("#zz_inviting").css("display", "none");
        $("#zz_validate").css("display", "none");
        $("#zz_confirmFlag").css("display", "none");
      },
      /**
       * 发送验证码
       */
      sendConfirmMsg: function () {
        this.timeFlag.code = null;
        for (var i = 0; i < this.users.length; i++) {
          if (this.users[i].systemUserId == this.id) {
            this.phone = this.users[i].telephone;
            this.name = this.users[i].name;
            this.users[i].bind = 2;
            var user_cache = $cacheFactory.get('user');
            if (!user_cache) {
              user_cache = $cacheFactory('user');
            }
            user_cache.put("alarm_users", this.users);
            break;
          }
        }
        this.timeFlag.time = 60;
        var parent = this;
        //发送验证码
        if (localStorage.getItem(parent.phone)) {
          var time1 = date2str(new Date(), 'yyyy-MM-dd');
          var value1 = localStorage.getItem(parent.phone);
          var s1 = value1.split('@');
          var count1 = parseInt(s1[1]);
          if (time1 == s1[0] && count1 > 2) {    //短信当天发送次数超过3次
            parent.timeFlag.send = 3;
            $("#zz_confirmFlag").css("display", "block");
            $("#zz_inviting").css("display", "none");
            $("#zz_validate").css("display", "none");
            return;
          }
        }
        var time = date2str(new Date(), 'yyyy-MM-dd');
        if (!localStorage.getItem(parent.phone)) {
          localStorage.setItem(parent.phone, time + '@' + 1);
          parent.timeFlag.count = 2;
        } else {
          var value = localStorage.getItem(parent.phone);
          var s = value.split('@');
          if (s[0] != time) {
            localStorage.setItem(parent.phone, time + '@' + 1);
            parent.timeFlag.count = 2;
          } else {
            var count = parseInt(s[1]) + 1;
            localStorage.setItem(parent.phone, time + '@' + count);
            parent.timeFlag.count = 3 - count;
          }
        }
        userService.getVcode(this.phone, 'UserVerify').then(function (data) {
          parent.timeFlag.send = 0;
          $("#zz_confirmFlag").css("display", "block");
          $("#zz_inviting").css("display", "none");
          $("#zz_validate").css("display", "none");
          console.log("发送验证码");
          parent.time_interval = $interval(function () {
            parent.timeFlag.time--;
          }, 1000);
          $timeout(function () {
            if (angular.isDefined(parent.time_interval)) {
              $interval.cancel(parent.time_interval);
              parent.timeFlag.send = 1;
            }
          }, 60000);
        }, function (error) {
          ErrorShow("网络异常")
        })
      },
      /**
       * 微信邀请
       */
      wechartInvite: function () {
        $("#zz_inviting").css("display", "none");
        $("#zz_mask").css("display", "none");
        var p_scene = Wechat.Scene.SESSION;
        var title = "微信邀请";
        /* var url = "http://health.sinoicity.com:8866/down/phone1.html";*/
        //var url="http://health.sinoicity.com:8866/HealthMonitor/download.htm?key=4";
        var url = $rootScope.reqUrl + "/download.htm?key=4";
        var desc = "我正在使用心常泰，家人时常忘记测量和吃药，心常泰您的必备好帮手";
        var thumb = "http://appdemo.sinoicity.com:8080/HealthMonitor/app/img/healthpatient.png";
        // 创建消息体
        var msg = {
          message: {
            title: title,
            description: desc,
            thumb: thumb,
            media: {
              type: Wechat.Type.WEBPAGE,
              webpageUrl: url
            }
          },
          scene: p_scene
        };
        Wechat.share(msg, function () {
          var type = p_scene == Wechat.Scene.SESSION ? 0 : 1;
          //微信分享成功回调
          Mes.addWechatShare(type).then(function (data) {
            $scope.goBack();
          }, function (error) {

          });
        }, function (reason) {
        });
      },
      checkConfirmMsg: function () {
        var parent = this;
        //提交验证码并验证
        /*                if (this.timeFlag.send == 3) {
         return;
         }*/
        var code = this.timeFlag.code;
        if (!code || code.length < 6 || code.length > 6) {
          var sendTemp = parent.timeFlag.send;
          parent.timeFlag.send = 2;
          $timeout(function () {
            parent.timeFlag.send = sendTemp;
          }, 1000);
          return;
        }
        var phone = this.phone;
        var users = this.users;
        healthService.userVerify(phone, code).then(function (data) {
          console.log(data);
          for (var i = 0; i < users.length; i++) {
            if (users[i].telephone == phone) {
              users[i] = data.data;
              var user_cache = $cacheFactory.get('user');
              if (!user_cache) {
                user_cache = $cacheFactory('user');
              }
              user_cache.put("alarm_users", users);
              $("#zz_confirmFlag").css("display", "none");
              $("#zz_mask").css("display", "none");
              break;
            }
          }
        }, function (error) {
          var sendTemp = parent.timeFlag.send;
          parent.timeFlag.send = 2;
          $timeout(function () {
            parent.timeFlag.send = sendTemp;
          }, 1000);
        })
      },
      //输入验证码框
      enter_check_code: function (id, users) {
        for (var i = 0; i < users.length; i++) {
          if (id == users[i].systemUserId) {
            this.phone = users[i].telephone;
            break;
          }
        }
        this.id = id;
        this.timeFlag.code = null;
        $("#zz_confirmFlag").css("display", "block");
        $("#zz_mask").css("display", "block");
      }
    };
    $rootScope.goBack = function () {
      $ionicHistory.goBack();
    };

    /**
     * 提示错误
     * @param error 输出错误信息
     */
    $rootScope.remindError = function (error) {
      //alert(error);
    };
    /**
     * 延时加载其它页面的数据
     * @type {string[]}
     */
    /*        $timeout(function () {
     console.log(healthService);
     healthService.healthindex($rootScope.token, 'bs', true, null);
     }, 3000);*/

//频率描述
    $rootScope.freqDesc = ['', '一日一次', '一日两次', '一日三次', '一日四次', '一日五次', '一日六次', '一日七次', '一日八次', '一日九次', '一日十次'];
//周几描述
    $rootScope.weekDesc = ['', '周一', '周二', '周三', '周四', '周五', '周六', '周日'];
//周期描述
    $rootScope.periodDesc = ['单日', '每天', '按天', '间隔', '连续'];
  })

  .config(function ($stateProvider, $urlRouterProvider, $ionicNativeTransitionsProvider, $ionicConfigProvider, $httpProvider, $sceProvider) {
    $sceProvider.enabled(false);
    //将ionic导航栏顶部变到底部
    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('standard');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('left');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');

    //原生跳转页面插件
    //网址：https://github.com/shprink/ionic-native-transitions

    $ionicNativeTransitionsProvider.setDefaultOptions({
      duration: 400, // in milliseconds (ms), default 400,
      slowdownfactor: 4, // overlap views (higher number is more) or no overlap (1), default 4
      iosdelay: -1, // ms to wait for the iOS webview to update before animation kicks in, default -1
      androiddelay: -1, // same as above but for Android, default -1
      winphonedelay: -1, // same as above but for Windows Phone, default -1,
      fixedPixelsTop: 0, // the number of pixels of your fixed header, default 0 (iOS and Android)
      fixedPixelsBottom: 0, // the number of pixels of your fixed footer (f.i. a tab bar), default 0 (iOS and Android)
      triggerTransitionEvent: '$ionicView.afterEnter', // internal ionic-native-transitions option
      backInOppositeDirection: false // Takes over default back transition and state back transition to use the opposite direction transition to go back
    });

    $ionicNativeTransitionsProvider.setDefaultTransition({
      type: 'slide',
      direction: 'left'
    });

    $ionicNativeTransitionsProvider.setDefaultBackTransition({
      type: 'slide',
      direction: 'right'
    });

    $stateProvider

    // setup an abstract state for the tabs directive
      .state('tab', {
        url: '/tab',
        abstract: true,
        templateUrl: 'templates/tabs.html'
        /*controller: 'mainCtrl'*/
      })

      .state('tab.home', {
        // url: '/home/:thumbsNum/:collect/:thumbsStatus/:collectStatus',
        url: '/home',
        nativeTransitions: null,
        views: {
          'tab-home': {
            templateUrl: 'templates/tab-home.html',
            controller: 'HomeCtrl'
          }
        },
//                resolve: {
//                    tipService: function (drugService) {
//                        return  drugService.queryArticle();
//                    }
//                },
//         onEnter: function ($rootScope, $cacheFactory, $state, $timeout, $ionicNativeTransitions) {
//           if (!$rootScope.token) {
//             console.log("sssss");
//             $timeout(function () {
//               $ionicNativeTransitions.stateGo('g_load', {backUrl: 'tab.home'}, {
//                 "type": "slide",
//                 "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
//                 "duration": 400 // in milliseconds (ms), default 400
//               });
//             });
//           }
//           var cache = $cacheFactory.get('tab.home');
//           if (!cache) {
//             cache = $cacheFactory('tab.home');
//           }
//           //如果页面存在失败标志进入404页面
//           if (cache && cache.get('network_error')) {
//             $timeout(function () {
//               $timeout(function () {
//                 $state.go('network_error', {backUrl: 'tab.home', broadcast_name: 'REFRESH'});
//               });
//             });
//           } else {
//             var see_add_remind = localStorage.getItem('SEE_ADD_REMIND');
//             if (!see_add_remind) {
//               localStorage.setItem('SEE_ADD_REMIND', 'yes');
//               $rootScope.add_plan_remind.show = true;
//             }
//           }
//         },
        onExit: function ($rootScope) {
          $rootScope.add_plan_remind.show = false;
        }
      })
      //药盒主界面
      .state('tab.pillbox', {
        url: '/pillbox',
//                cache: false,
        nativeTransitions: null,
        views: {
          'tab-pillbox': {
            templateUrl: 'templates/tab-pillbox.html',
            controller: 'pillboxCtrl'
          }
        },
        /**
         * 判断是否登录
         */
        onEnter: function ($state, $rootScope, $ionicNativeTransitions, $timeout, $cacheFactory) {
          if (!$rootScope.token) {
            $timeout(function () {
              $ionicNativeTransitions.stateGo('g_load', {backUrl: 'tab.home'}, {
                "type": "slide",
                "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
                "duration": 400 // in milliseconds (ms), default 400
              });
            });
          } else {
            /*var cache = $cacheFactory.get('tab.pillbox');
             if (!cache) {
             cache = $cacheFactory('tab.pillbox');
             }
             if (cache.get('network_error')) {
             $timeout(function () {
             $state.go('network_error', {backUrl: 'tab.pillbox', broadcast_name: 'REFRESH'});
             });
             }*/ //废弃于2017-3-2
          }
        }
      })
      .state('tab.health', {
        url: '/health',
        nativeTransitions: null,
        views: {
          'tab-health': {
            templateUrl: 'templates/tab-health.html',
            controller: 'healthController'

          }
        },
        /**
         * 判断是否登录
         */
        onEnter: function ($state, $rootScope, $ionicNativeTransitions, $timeout, $cacheFactory) {
          if (!$rootScope.token) {
            $timeout(function () {
              $ionicNativeTransitions.stateGo('g_load', {backUrl: 'tab.home'}, {
                "type": "slide",
                "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
                "duration": 400 // in milliseconds (ms), default 400
              });
            });
          } else {
            var cache = $cacheFactory.get('tab.health');
            if (!cache) {
              cache = $cacheFactory('tab.health');
            }
            // if (cache.get('network_error')) {
            //     $timeout(function () {
            //         $state.go('network_error', {backUrl: 'tab.health', broadcast_name: 'REFRESH'});
            //     });
            // } //废弃于2017-3-2
          }
        }
      })
      .state('tab.mine', {
        url: '/mine',
        nativeTransitions: null,
        views: {
          'tab-mine': {
            templateUrl: 'templates/tab-mine.html',
            controller: 'MineCtrl'
          }
        },
        onEnter: function ($rootScope, $state, $timeout) {
          if (!$rootScope.user && $rootScope.token) {
            var user = JSON.parse(localStorage.getItem("user"));
            $rootScope.user = user;
            $rootScope.token = localStorage.getItem("token");
            /*  $timeout(function () {
             $state.go('network_error', {backUrl: 'tab.mine', broadcast_name: 'REFRESH'});
             });*/ //废弃于2017-3-2
          }
        }
      })
      //引导页
      .state('linkPage', {
        url: '/linkPage',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/linkPage.html',
        controller: 'IndexCtrl',
        onEnter: function ($ionicNativeTransitions, $rootScope, $timeout) {
          if (localStorage.getItem('index') && localStorage.getItem('index') == 'yes') {
            if ($rootScope.token) {
              $ionicNativeTransitions.stateGo('tab.home', {}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
              });
            } else {
              $ionicNativeTransitions.stateGo('g_load', {backUrl: 'tab.home'}, {
                "type": "slide",
                "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
                "duration": 400 // in milliseconds (ms), default 400
              });
            }

          }
        }
      })
      .state('g_xuetang', {
        url: '/g_health/g_xuetang/:backUrl:index',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xuetang.html',
        controller: 'healthDetailController'
      })
      /*   .state('add_user', {
       url: '/addDrug/add_user/:backUrl',
       cache: false,
       nativeTransitions: null,
       templateUrl: 'templates/addDrug/add_user.html',
       controller: 'AddUserCtrl'
       })*/
      .state('add_drug', {
        url: '/addDrug/add_drug/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/add_drug.html',
        controller: 'AddDrugCtrl'
      })
      /* .state('drug_unit', {
       url: '/addDrug/drug_unit/:backUrl',
       nativeTransitions: null,
       templateUrl: 'templates/addDrug/drug_unit.html',
       controller: 'DrugUnitCtrl'
       })
       .state('drug_dosage', {
       url: '/addDrug/drug_dosage/:backUrl',
       cache: false,
       nativeTransitions: null,
       templateUrl: 'templates/addDrug/drug_dosage.html',
       controller: 'DrugDosageCtrl'
       })*/
      //用药频率设置
      .state('drug_frequency', {
        url: '/addDrug/drug_frequency/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/drug_frequency.html',
        controller: 'DrugFreqCtrl'
      })
      //用药周期设置
      .state('drug_cycle', {
        url: '/addDrug/drug_cycle/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/drug_cycle.html',
        controller: 'DrugCycleCtrl'
      })
      .state('remind_edit', {
        url: '/addDrug/remind_edit/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/remind_edit.html',
        controller: 'RemindEditCtrl'
      })
      //设置一周星期几服药
      /*    .state('drug_week', {
       url: '/addDrug/drug_week/:backUrl',
       cache: false,
       nativeTransitions: null,
       templateUrl: 'templates/addDrug/drug_week.html',
       controller: 'DrugWeekCtrl'
       })*/
      .state('drug_remind', {
        url: '/addDrug/drug_remind/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/drug_remind.html',
        controller: 'DrugRemindCtrl'
      })
      //编辑确认
      .state('drug_confirm', {
        url: '/addDrug/drug_confirm/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/drug_confirm.html',
        controller: 'DrugConfirmCtrl'
      })
      //药品外观设置
      .state('drug_surface', {
        url: '/addDrug/drug_surface/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/drug_surface.html',
        controller: 'DrugSurfaceCtrl'
      })
      //分享编辑页面
      .state('drug_share', {
        url: '/addDrug/toShare/:backUrl',
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/encourage.html',
        controller: 'DrugShareCtrl'
      })
      //新闻详情
      .state('news_detail', {

        //url: '/addDrug/news_detail/:title/:content/:backUrl/:id/:shareNum/:scanNum/:thumbsNum/:collect/:thumbsStatus/:collectStatus/:classId/:data',
        url: '/addDrug/news_detail/:title/:content/:backUrl/:id/:shareNum/:scanNum/:thumbsNum/:collect/:thumbsStatus/:collectStatus/:classId',
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/news_detail.html',
        cache: false,
        controller: 'newsCtrl'

      })

      //药盒历史用药
      .state('drug_history', {
        url: '/pillbox/history/:backUrl/:toUser',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/drug_history.html',
        controller: 'hisDrugCtrl'
      })
      //药盒日历
      .state('drug_calendar', {
        url: '/pillbox/calendar/:backUrl/:medicineId/:beginTime/:planId/:remarkText/:remarkTime/:remark/:imgurl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/drug_calendar.html',
        controller: 'calendarCtrl'
      })
      //点进去药盒
      .state('drug_bottle', {
        url: '/pillbox/bottle/:backUrl/:day/:self/:uid/:time',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/drug_bottle.html',
        controller: 'drugBottleCtrl'
      })
      //今日药品详情
      .state('drug_detailToday', {
        url: '/pillbox/detailToday/:backUrl/:m/:day/:toUser',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/drug_detailToday.html',
        controller: 'DrugDetailTodayCtrl'
      })
      //吃药进度
      .state('drug_schedule', {
        url: '/pillbox/schedule/:planId/:medicineName',
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/drug_schedule.html',
        controller: 'drugScheduleCtrl'
      })
      //药品详情
      .state('drug_detail', {
        url: '/pillbox/detail/:backUrl/:id/:toUser',
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/drug_detail.html',
        controller: 'drugDetailCtrl'
      })
      //剂量使用方法
      .state('drug_usage', {
        url: '/pillbox/usage/:backUrl/:url',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/drug_usage.html',
        controller: 'drugUsageCtrl',
        onExit: function ($rootScope) {
          $rootScope.plan_remind.re_show();
        }
      })
      //个人消息页面
      .state('user_messages', {
        url: '/addDrug/messages/:backUrl/:shareId',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/user_messages.html',
        controller: 'userMesCtrl'
      })
      //添加医生
      .state('add_doctor', {
        url: '/pillbox/add_doctor/:backUrl',
        nativeTransitions: null,
        cache: false,
        templateUrl: 'templates/pillbox/add_doctor.html',
        controller: 'addDoctorCtrl'
      })
      //咨询
      .state('doctor_consult', {
        url: '/pillbox/doctor_consult/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/doctor_consult.html',
        controller: 'consultCtrl'
      })
      //首页消息（调整后）
      .state('messages', {
        url: '/pillbox/messages/:backUrl',
        // cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/messages.html',
        controller: 'IndexMessageCtrl'
      })
      //医生详细资料
      .state('doctor_data', {
        url: '/pillbox/doctor_data/:doctorId/:backUrl',
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/doctor_data.html',
        controller: 'DoctorDataCtrl'
      })
      //手环功能
      .state('z_wristStrap', {
        url: '/g_my/z_wristStrap/:backUrl:address',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/z_wristStrap.html',
        controller: 'strapCtrl'
      })
      //我的手环
      .state('z_myWrist', {
        url: '/g_my/z_myWrist/:backUrl:address',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/z_myWrist.html',
        controller: 'myStrapCtrl'
      })
      //字体大小
      .state('fontSize', {
        url: '/pillbox/fontSize',
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/font_size.html',
        controller: 'fontCtrl'
      })
      //系统设置
      .state('mySetting', {
        url: '/pillbox/mySetting',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/pillbox/my_setting.html',
        controller: 'systemCtrl'
      })
      .state('g_xueya', {
        url: '/g_health/g_xueya/:backUrl:index',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xueya.html',
        controller: 'healthDetailController'
      })
      .state('g_xueyang', {
        url: '/g_health/g_xueyang/:backUrl:index',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xueyang.html',
        controller: 'healthDetailController'
      })
      .state('g_xinlv', {
        url: '/g_health/g_xinlv/:backUrl:index',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xinlv.html',
        controller: 'healthDetailController'
      })
      /*新增bmi*/
      .state('g_bmi', {
        url: '/g_health/g_bmi/:backUrl:index',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_bmi.html',
        controller: 'healthDetailController'
      })
      .state('g_bmi_detail', {
        url: '/g_health/g_bmi_detail/:backUrl/:type',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_bmi_detail.html',
        controller: 'healthBpController'
      })
      .state('g_bmi_enter', {
        url: '/g_health/g_bmi_enter/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_bmi_enter.html',
        controller: 'bmienterController'
      })
      .state('g_load', {
        url: '/g_load/load_index/:backUrl',
        nativeTransitions: null,
        /*cache: false,*/
        templateUrl: 'templates/g_load/load_index.html',
        controller: 'LoginController'
      })
      .state('load_forget1', {
        url: '/g_load/load_forget1',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_load/load_forget1.html',
        controller: 'forgetSendCtrl'
      })
      .state('load_forget2', {
        url: '/g_load/load_forget2',
        nativeTransitions: null,
        cache: false,
        templateUrl: 'templates/g_load/load_forget2.html',
        controller: 'findPwdCtrl'
      })
      .state('load_zc', {
        url: '/g_load/load_zc',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_load/load_zc.html',
        controller: 'regController'
      })
      .state('load_zc2', {
        url: '/g_load/load_zc2/:usage/:phone',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_load/load_zc2.html',
        controller: 'setPwdCtrl'
      })
      .state('load_myprofile', {
        url: '/g_load/load_myprofile',
        nativeTransitions: null,
        templateUrl: 'templates/g_load/load_myprofile.html',
        controller: 'setGenderCtrl'
      })
      .state('load_myprofile2', {
        url: '/g_load/load_myprofile2',
        nativeTransitions: null,
        templateUrl: 'templates/g_load/load_myprofile2.html',
        controller: 'setBirthCtrl'
      })
      //绑定支付宝账户
      .state('load_AlipayBound', {
        url: '/g_load/load_AlipayBound/:existAliPayAccount/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_load/load_AlipayBound.html',
        controller: 'aliPayCtrl'
      })
      .state('g_xt_detail', {
        url: '/g_health/g_xt_detail/:backUrl/:type',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xt_detail.html',
        controller: 'healthBpController'
      })
      .state('g_xy_detail', {
        url: '/g_health/g_xy_detail/:backUrl/:type',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xy_detail.html',
        controller: 'healthBpController'
      })
      .state('g_xueyang_detail', {
        url: '/g_health/g_xueyang_detail/:backUrl/:type',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xueyang_detail.html',
        controller: 'healthBpController'
      })
      .state('g_xinlv_detail', {
        url: '/g_health/g_xinlv_detail/:backUrl/:type',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xinlv_detail.html',
        controller: 'healthBpController'
      })
      .state('g_xt_enter', {
        url: '/g_health/g_xt_enter/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xt_enter.html',
        controller: 'xtenterController'
      })
      .state('g_xueya_enter', {
        url: '/g_health/g_xueya_enter/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xueya_enter.html',
        controller: 'xyenterController'
      })
      .state('g_xueyang_enter', {
        url: '/g_health/g_xueyang_enter/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xueyang_enter.html',
        controller: 'xueyangController'
      })
      .state('g_xinlv_enter', {
        url: '/g_health/g_xinlv_enter/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xinlv_enter.html',
        controller: 'xlenterController'
      })
      .state('g_xt_report', {
        url: '/g_health/g_xt_report/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xt_report.html',
        controller: 'healthReportController'
      })
      .state('g_xueya_report', {
        url: '/g_health/g_xueya_report/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xueya_report.html',
        controller: 'healthReportController'
      })
      .state('g_xueyang_report', {
        url: '/g_health/g_xueyang_report/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xueyang_report.html',
        controller: 'healthReportController'
      })
      .state('g_xinlv_report', {
        url: '/g_health/g_xinlv_report/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xinlv_report.html',
        controller: 'healthReportController'
      })
      .state('g_my_friends', {
        url: '/g_my/g_my_friends/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_friends.html',
        controller: 'MyFriendsCtrl'
      })
      .state('g_myWallet',{
        url:'/myWallet/myWallet/:backUrl',
        cache:false,
        nativeTransitions: null,
        templateUrl:'templates/myWallet/myWallet.html',
        controller:'MyWalletCtrl'
      })
      .state('g_withdrawCash',{
        url: '/myWallet/withdrawCash/:backUrl/:balance/:alipayDataName/:alipayDataId',
        cache:false,
        nativeTransitions: null,
        templateUrl:'templates/myWallet/withdrawCash.html',
        controller:'MyWithdrawCashCtrl'
      })
      .state('g_my_information', {
        url: '/g_my/g_my_information/:backUrl/:userId',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_information.html',
        controller: 'MyInformationCtrl'
      })
      .state('g_my_set', {
        url: '/g_my/g_my_set/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_set.html',
        controller: 'MySetCtrl'
      })
      .state('g_my_changemessage', {
        url: '/g_my/g_my_changemessage/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_changemessage.html',
        controller: 'ChangeMessageCtrl'
      })
      .state('g_my_changephone', {
        url: '/g_my/g_my_changephone/:backUrl/:userType',
        nativeTransitions: null,
        cache: false,
        templateUrl: 'templates/g_my/g_my_changephone.html',
        controller: 'ChangePhoneCtrl'
      })
      .state('g_my_music', {
        url: '/g_my/g_my_music/:backUrl',
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_music.html',
        controller: 'MyMusicCtrl'
      })
      .state('g_my_equipment', {
        url: '/g_my/g_my_equipment/:backUrl:address',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_equipment.html',
        controller: 'MyEquipmentCtrl'
      })
      //设备补全信息页面
      .state('z_completeInfo', {
        url: '/g_my/z_completeInfo/:backUrl:phone:birth:gender:stature:type',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/z_completeInfo.html',
        controller: 'MyCompleteInfoCtrl'
      })
      .state('g_my_product', {
        url: '/g_my/g_my_product/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_product.html',
        controller: 'proInfoCtrl'
      })
      .state('g_my_order', {
        url: '/g_my/g_my_order/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_order.html',
        controller: 'orderConfirmCtrl'
      })
      .state('g_my_address', {
        url: '/g_my/g_my_address/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_address.html',
        controller: 'addressInfoCtrl'
      })
      .state('g_product_detail', {
        url: '/g_my/g_product_detail/:backUrl/:type',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_product_detail.html',
        controller: 'productDetail'
      })
      .state('g_my_music_set', {
        url: '/g_my/g_my_music_set/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_music_set.html',
        controller: 'MyMusicSetCtrl'
      })
      .state('g_my_xueya', {
        url: '/g_my/g_my_xueya/:backUrl/:type/:backUrlFather:address',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_xueya.html',
        controller: 'MyXueCtrl'
      })
      .state('g_my_tizhi', {
        url: '/g_my/g_my_tizhi/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_tizhi.html',
        controller: 'MyTizhiCtrl'
      })
      .state('g_my_search', {
        url: '/g_my/g_my_search/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_search.html',
        controller: 'MySearchCtrl'
      })
      .state('g_my_eqone', {
        url: '/g_my/g_my_eqone/:backUrl/:type/:address',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_eqone.html',
        controller: 'MyEqoneCtrl'
      })
      .state('z_message_chat', {
        url: '/z_health/z_message_chat/:backUrl/:doctorId/:doctorName',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/z_message_chat.html',
        controller: 'onlineController'
      })
      .state('z_show_img', {
        url: '/z_health/z_show_image/:backUrl',
        nativeTransitions: null,
        templateUrl: 'templates/g_health/z_show_image.html',
        controller: 'showImageController'
      })
      .state('report', {
        url: '/report/healthReport',
        nativeTransitions: null,
        templateUrl: 'templates/report/health-report.html',
        controller: 'HealthReportCtrl'
      })
      .state('nearbyhospital', {
        url: '/hospital/nearbyHospital/:type/:backUrl',
        templateUrl: 'templates/hospital/nearby-hospital.html',
        controller: 'nearbyHospitalController',
        cache: false
      })
      /* .state('g_order_detail', {
       url: '/g_my/g_order_detail/:backUrl',
       cache: false,
       nativeTransitions: null,
       templateUrl: 'templates/g_my/g_order_detail.html'
       })*/
      .state('g_all_order', {
        url: '/g_my/g_all_order/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_all_order.html',
        controller: 'orderListCtrl'
      })
      .state('g_my_xueyang', {
        url: '/g_my/g_my_xueyang/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_my_xueyang.html',
        controller: 'MyXueYangCtrl'
      })
      .state('g_yindao', {
        url: '/g_health/g_yindao/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_yindao.html',
        controller: 'YinDaoCtrl'
      })
      //返回地址/广播名称
      .state('network_error', {
        url: '/network_error/:backUrl/:broadcast_name',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/tab-networkError.html',
        controller: 'NetworkErrorCtrl'
      })
      //常见问题
      .state('z_problems', {
        url: '/g_my/z_problems/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/z_problems.html',
        controller: 'ProblemCtrl'
      })
      //常见问题详情
      .state('z_problemDetail', {
        url: '/g_my/z_problemDetail/:backUrl/:id',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/z_problemDetail.html',
        controller: 'problemDetailCtrl'
      })
      /*消息列表*/
      .state('g_news', {
        url: '/g_my/g_news/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_news.html',
        controller: 'messageListCtrl'
      })
      /*消息详情*/
      .state('g_news_detail', {
        url: '/g_my/g_news_detail/:backUrl/:id',
        nativeTransitions: null,
        cache: false,
        templateUrl: 'templates/g_my/g_news_detail.html',
        controller: 'messageDetailCtrl'
      })
      /*急救卡-填写*/
      .state('g_card', {
        url: '/addDrug/g_card/:backUrl/:type',
        nativeTransitions: null,
        cache: false,
        templateUrl: 'templates/addDrug/g_card.html',
        controller: 'g_cardCtrl'
      })
      /*急救卡-显示*/
      .state('g_card2', {
        url: '/addDrug/g_card2/:backUrl',
        nativeTransitions: null,
        cache: false,
        templateUrl: 'templates/addDrug/g_card2.html',
        controller: 'g_cardCtrl2'
      })
      /*心电*/
      .state('g_xindian', {
        url: '/g_health/g_xindian/:backUrl/:ecg/:userId',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xindian.html',
        controller: 'ecgDetailController'
      })
      /*测量心电*/
      .state('g_xd_text', {
        url: '/g_health/g_xd_text/:backUrl/:address',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_health/g_xd_text.html',
        controller: 'TextController'
      })
      /*服务详情介绍*/
      .state('g_service', {
        url: '/addDrug/g_service/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/g_service.html',
        controller: 'serviceDetailCtrl'
      })
      /*国药准字确认*/
      .state('g_show', {
        url: '/addDrug/g_show/:backUrl/:image/:word',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/addDrug/g_show.html'
        /*  controller: 'serviceDetailCtrl'*/
      })
      /*手环链接提示页*/
      .state('g_ts1', {
        url: '/g_my/g_ts1/:backUrl/:type',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_ts1.html',
        controller: 'g_ts1Ctrl'
      })
      /*取消手环链接提示页*/
      .state('g_ts2', {
        url: '/g_my/g_ts2/:backUrl',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_ts2.html',
        controller: 'g_ts2Ctrl'
      })
      /**/
      .state('g_health_box', {
        url: '/g_my/g_health_box/:backUrl',
        // cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_health_box.html',
        controller: 'HealthBoxCtrl'
      })
      /*用户*/
      .state('g_box_user', {
        url: '/g_my/g_box_user/:backUrl/:boxName',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_box_user.html',
        controller: 'BoxUserCtrl'
      })
      /*详情*/
      .state('g_box_news', {
        url: '/g_my/g_box_news/:backUrl/:boxName/:userId1/:userId2/:currentUser/:deviceId',
        // cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_box_news.html',
        controller: 'BoxDetailCtrl'
      })
      /*信息列表*/
      .state('g_box_nlist', {
        url: '/g_my/g_box_nlist/:backUrl/:deviceId',
        // cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_box_nlist.html',
        controller: 'BoxMsgCtrl'
      })
      /*信息详情*/
      .state('g_box_newdetali', {
        url: '/g_my/g_box_newdetali/:backUrl/:id/:title/:content/:time/:sendTo',
        // cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_box_newdetali.html',
        controller: 'MsgDetailCtrl'
      })
      /*消息编辑*/
      .state('g_box_edit', {
        url: '/g_my/g_box_edit/:backUrl/:deviceId',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_box_edit.html',
        controller: 'BoxMsgEditCtrl'
      })
      /*健康数据*/
      .state('g_health_data', {
        url: '/g_my/g_health_data/:backUrl/:userId',
        cache: true,
        nativeTransitions: null,
        templateUrl: 'templates/g_my/g_health_data.html',
        controller: 'HealthDataCtrl'
      })
      /*会员支付*/
      .state('g_pay', {
        url: '/addDrug/g_pay/:backUrl',
        nativeTransitions: null,
        cache: false,
        templateUrl: 'templates/addDrug/g_pay.html',
        controller: 'g_payCtrl',
        resolve: {
          payData: function (userService) {
            return userService.getProducts();
          }
        }
      })
        //精选文章
        .state('article_list', {
            url: '/service/article_list',
            cache: false,
            nativeTransitions: null,
            templateUrl: 'templates/service/article_list.html',
            controller: 'ArticleCtrl'
        })
        //精彩活动
        .state('activity_list', {
            url: '/service/activity_list',
            cache: false,
            nativeTransitions: null,
            templateUrl: 'templates/service/activity_list.html',
            controller: 'ActivityCtrl'
        })
        //活动详情
        .state('activity_detail', {
          url: '/service/activity_detail/:activityId/:activityUrl/:title/:brief',
            cache: false,
            nativeTransitions: null,
          templateUrl: 'templates/service/activity_detail.html',
          controller: 'ActivityDetailCtrl'
        })
        //在线商城-购物车
        .state('shoppingCart', {
            url: '/onlineStore/shoppingCart',
            cache: false,
            nativeTransitions: null,
            templateUrl: 'templates/onlineStore/shoppingCart.html'
        })
        //在线商城-确认订单
        .state('myOrder', {
            url: '/onlineStore/myOrder',
            cache: false,
            nativeTransitions: null,
            templateUrl: 'templates/onlineStore/myOrder.html'
        })
        //我的钱包
      .state('myWallet', {
        url: '/myWallet/myWallet',
        cache: false,
        nativeTransitions: null,
        templateUrl: 'templates/myWallet/myWallet.html'
      })
        //零钱明细
        .state('changeDetails', {
            url: '/myWallet/changeDetails',
            cache: false,
            nativeTransitions: null,
          templateUrl: 'templates/myWallet/changeDetails.html',
          controller: 'changeDetailsCtrl'
        })
        //提现到支付宝
        // .state('withdrawCash', {
        //     url: '/myWallet/withdrawCash',
        //     cache: false,
        //     nativeTransitions: null,
        //     templateUrl: 'templates/myWallet/withdrawCash.html'
        // })
        //账单详情
        .state('billingDetails', {
          url: '/myWallet/billingDetails/:backUrl/:record',
            cache: false,
            nativeTransitions: null,
          templateUrl: 'templates/myWallet/billingDetails.html',
          controller: 'billingDetailsCtrl'
        })
        //选择支付宝
        .state('chooseAlipay', {
            url: '/myWallet/chooseAlipay',
            cache: false,
            nativeTransitions: null,
          templateUrl: 'templates/myWallet/chooseAlipay.html',
          controller: 'ChooseAlipayCtrl'
        })
        //管理支付宝
        .state('manageAlipay', {
            url: '/myWallet/manageAlipay',
            cache: false,
            nativeTransitions: null,
          templateUrl: 'templates/myWallet/manageAlipay.html',
          controller: 'manageAlipayCtrl'
        });

    $urlRouterProvider.otherwise('/linkPage');

    //配置post请求传递参数时参数的编码格式为UTF-8
    $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';

  });
