angular.module('Directive', ['FtActionSheet'])
    //照片选择popup
    .directive('selectPhoto', function ($ionicGesture, $rootScope, $ionicPopup, $timeout) {
        return {
            restrict: 'A',
            link: function ($scope, element) {
                $scope.closeImagePopup = function () {
                    $scope.imagePopup.close();
                    $(window).unbind('click');
                };
                $scope.getImageByPic = function () {
                    $scope.closeImagePopup();
                    $scope.selectImageByPic();
                };
                $scope.getImageByCamera = function () {
                    $scope.closeImagePopup();
                    $scope.selectImageByCamera();
                };
                var clickFn = function (e) {
                    $scope.imagePopup = $ionicPopup.show({
                        template: '<ion-item class="button z_popWrap" ng-click="getImageByCamera()"><a class="z_pop">相机</a></ion-item><ion-item ng-click="getImageByPic()" class="button z_popWrap"><a class="z_pop">照片</a></ion-item></ion-item>',
                        scope: $scope
                    });
                    $timeout(function () {
                        $(window).bind('click', function (e) {
                            $scope.closeImagePopup();
                        });
                    }, 100);
                };
                $ionicGesture.on("click", clickFn, element);
            }
        }
    }).directive('confirmEdit', function ($ionicGesture, $rootScope, $ionicPopup) {
        return {
            restrict: 'A',
            link: function ($scope, element) {
                $scope.closeImagePopup = function () {
                    $scope.imagePopup.close();
                };
                $scope.click1 = function () {
                    $scope.imagePopup.close();
                    $scope.click1Impl();
                };
                $scope.click2 = function () {
                    $scope.imagePopup.close();
                    $scope.click2Impl();
                };
                var clickFn = function () {
                    $scope.imagePopup = $ionicPopup.show({
                        template: '<div class="z_addSucc">已经成功添加！<!--<span>感冒冲剂</span><br/>是否继续添加？<div class="z_btn clearfix"><a class="button button-clear fR" ng-click="click1()">暂不添加</a><a class="button button-clear fR" ng-click="click2()">继续添加</a></div>--></div>',
                        scope: $scope
                    });
                };
                $ionicGesture.on("click", clickFn, element);
            }
        }
    })
    //选择剂量
    .directive('selectDosage', function ($ionicGesture, $rootScope, $ionicPopup, $timeout, $ionicScrollDelegate) {
        return {
            restrict: 'A',
            link: function ($scope, element) {
                $scope.closeImagePopup = function () {
                    $scope.imagePopup.close();
                    $(window).unbind('click');
                };
//              var unitArray = ['药片', '毫升','克', '毫克', '袋', '粒', '滴', '片','单元', '药勺', '汤勺', '贴剂', '微克', '国际单位', '毫当量', '盒','丸','副本', 'gr', 'puffs','spray'];
                var unitArray = ['药片', '毫升', '克', '毫克', '袋', '粒', '滴', '片', '药勺', '汤勺', '贴剂', '微克', '国际单位', '毫当量', '盒', '丸', '副本', 'gr', 'puffs', 'spray'];
                $scope.unitScroll = function () {
                    var unitSite = null;
                    console.log($ionicScrollDelegate.$getByHandle('unit').getScrollPosition())
                    var height = $ionicScrollDelegate.$getByHandle('unit').getScrollPosition().top;
                    if (height < 15) {
                        unitSite = 0;
                        $scope.form.medicineUnit = unitArray[unitSite];
                    } else if (height <= 240) {
                        unitSite = Math.ceil(height / 32);
                        $scope.form.medicineUnit = unitArray[unitSite];
                    } else {
                        unitSite = Math.ceil(height / 30);
                        $scope.form.medicineUnit = unitArray[unitSite];
                    }
                    $("#zz_scroll .z_unitCurrent").removeClass('z_unitCurrent');
                    unitSite = unitSite + 2;
                    $("#zz_scroll ion-item:eq(" + unitSite + ")").addClass('z_unitCurrent');
                    $scope.$apply();
                };
                $scope.confirm = function () {
                    if (!$scope.form.medicineCount) {
                        $scope.form.medicineCount = 1;
                    }
                };
                $scope.checkValue = function () {
                    $scope.form.medicineCount = $scope.form.medicineCount.replace(/[^0-9]+/, '');
                };
                var clickFn = function (e) {
                    $scope.imagePopup = $ionicPopup.show({
                        template: '<div class="z_selectDosage"><div class="z_selectTop">每次&nbsp;<span>{{form.medicineCount}}</span>&nbsp;<span>{{form.medicineUnit}}</span>' +
                            '<a href="" class="button fR" id="z_confirm" ng-click="confirm()">确定</a></div><div class="z_selectBody clearfix"><div class="z_box"></div><input type="number" maxlength="5" ng-model="form.medicineCount" id="zz_count"/>' +
                            '<ion-scroll direction="y" overflow-scroll="false" delegate-handle="unit" scrollbar-y="false" class="fR" on-scroll="unitScroll()" id="zz_scroll">' +
                            '<ion-item></ion-item><ion-item></ion-item><ion-item class="z_unitCurrent">药片</ion-item><ion-item>毫升</ion-item>' +
                            '<ion-item>克</ion-item><ion-item>毫克</ion-item><ion-item>袋</ion-item><ion-item>粒</ion-item><ion-item>滴</ion-item>' +
                            '<ion-item>片</ion-item><ion-item>药勺</ion-item><ion-item>汤勺</ion-item>' +
                            '<ion-item>贴剂</ion-item><ion-item>微克</ion-item><ion-item>国际单位</ion-item><ion-item>毫当量</ion-item><ion-item>盒</ion-item>' +
                            '<ion-item>丸</ion-item><ion-item>副本</ion-item><ion-item>gr</ion-item><ion-item>puffs</ion-item><ion-item>spray</ion-item></ion-scroll></div></div>',
                        scope: $scope
                    });
                    if(window.cordova){
                        cordova.plugins.Keyboard.show();
                    }
                    $timeout(function () {
                        $(".z_selectDosage").addClass("z_selectDosageUp");
                        $("#zz_count").focus();
                    }, 250);
                    $timeout(function () {
                        $("#z_confirm").bind('click', function (e) {
                            $scope.closeImagePopup();
                        });
                    }, 100);
                };
                $ionicGesture.on("click", clickFn, element);
            }
        }
    })
    //分享替换标签
    .directive('share', function ($ionicGesture, $ionicFtActionSheet,$rootScope,drugService) {
        return {
            restrict: 'A',
            link: function ($scope, $element) {

                var tapFn = function (evt) {
                    evt.stopPropagation();
                    $ionicFtActionSheet.show({
                        buttons: [
                            {
                                img: "img/g_qq_13.png",
                                text: "QQ"
                            },
                            {
                                img: "img/g_qq_14.png",
                                text: "朋友圈"
                            },
                            {
                                img: "img/g_qq_15.png",
                                text: "微信"
                            }
                        ],
                        destructiveText: '取消',
                        destructiveButtonClicked: function () {
                            console.log('取消分享');
                            return true;
                        },
                        buttonClicked: function (index) {
                            if (index == 0) {
                                $scope.qqShare();
                            } else if (index == 1) {
                                $scope.weiboShare();
                            } else if (index == 2) {
                                $scope.weixinShare();
                            }
                            return true;
                        }
                    });
                };
                $ionicGesture.on("tap", tapFn, $element);
            }
        }
    })
  .directive('homeShare', function ($ionicGesture, $ionicFtActionSheet,$rootScope,drugService) {
    return {
      restrict: 'A',
      scope:{
        info:"="
      },
      controller: ['$scope', function ($scope) {
        //分享到微信或朋友圈
        $scope.shareWechat = function (p_scene,articleId,title,content) {
          Wechat.isInstalled(function () {
            if (!title) {
              ErrorShow("标题不能为空！");
              return;
            }
            var url = $rootScope.reqUrl + "/share/news.htm?articleId=" + articleId;
            var desc = content.substr(0, 20);
            var thumb = $rootScope.reqUrl + "/app/img/healthpatient.png";
            var msg = {
              message: {
                title: title,
                description: desc,
                thumb: thumb,
                media: {
                  type: Wechat.Type.WEBPAGE,
                  webpageUrl: url
                }
              },
              scene: p_scene
            }

            Wechat.share(msg, function (data) {
              drugService.addShareNumService(articleId).then(function (data) {
                var temp = articleId;
                $rootScope.$emit("DIRECTIVE_SHARE_MODIFY",data,temp);
              }, function (e) {
                console.error(e);
              });
              var type = p_scene == Wechat.Scene.TIMELINE ? 0 : 1;
              console.info("data", data);
            }, function (error) {
              console.error("error:", error);
            });
          }, function () {
            alert('请安装微信客户端');
          });
        };

        //分享到QQ
        $scope.qqShare = function (articleId,title,content) {
          YCQQ.checkClientInstalled(function () {
            if (!title) {
              ErrorShow("标题不能为空");
              return;
            }
            var args = {};
            //正式库链接
            var reqUrlQQ = '';
            if ($rootScope.reqQQAppid == '101327838') {
              reqUrlQQ = 'appdemo.sinoicity.com';//测试库
            } else {
              reqUrlQQ = 'wx.sinoicity.com';//正式库
            }
            args.url = $rootScope.reqUrl + "/share/news.htm?articleId=" + articleId;
            args.title = title;
            args.description = content.substr(0,20);
            args.imageUrl = "http://appdemo.sinoicity.com:8080/HealthMonitor/app/img/healthpatient.png";
            args.appName = "心常态";
            YCQQ.shareToQQ(function () {
              drugService.addShareNumService(articleId).then(function (data) {
                var temp = articleId;
                $rootScope.$emit("DIRECTIVE_SHARE_MODIFY",data,temp);
              }, function (e) {
                console.error(e);
              });
              console.log("进如sharetoQQ方法");
            }, function (failReason) {
              console.error("failReason:", failReason);
            }, args);
          }, function () {
            ErrorShow('请安装QQ客户端');
          });
        };

        //分享到朋友圈
        $scope.CircleOfFriendsShare = function (articleId,title,content) {
          $scope.shareWechat(Wechat.Scene.TIMELINE,articleId,title,content);
        };
        //分享给微信好友
        $scope.weixinShare = function (articleId,title,content) {
          //console.log("获取首页点赞获取的文章ID",articleId);
         // console.log("获取首页点赞获取的文章title:",title);
          $scope.shareWechat(Wechat.Scene.SESSION,articleId,title,content);
        };
      }],
      link: function ($scope, $element) {
        //console.log("获取首页点赞获取的文章ID",$scope.info.id);
        var tapFn = function (evt) {
          evt.stopPropagation();
          $ionicFtActionSheet.show({
            buttons: [
              {
                img: "img/g_qq_13.png",
                text: "QQ"
              },
              {
                img: "img/g_qq_14.png",
                text: "朋友圈"
              },
              {
                img: "img/g_qq_15.png",
                text: "微信"
              }
            ],
            destructiveText: '取消',
            destructiveButtonClicked: function () {
              console.log('取消分享');
              return true;
            },
            buttonClicked: function (index) {
              if (index == 0) {
                var articleText =document.getElementById($scope.info.id+"homeArticleId").innerText;
                var regArticleText=articleText.replace(/<\/?.+?>/g,"");
                var content=regArticleText.replace(/&nbsp;/g,"");
                var contentText = content.replace(/ /g,"");
                $scope.qqShare($scope.info.id,$scope.info.title,contentText);
              }
              else if (index == 1) {
                var articleText =document.getElementById($scope.info.id+"homeArticleId").innerText;
                var regArticleText=articleText.replace(/<\/?.+?>/g,"");
                var content=regArticleText.replace(/&nbsp;/g,"");
                var contentText = content.replace(/ /g,"");
                $scope.CircleOfFriendsShare($scope.info.id,$scope.info.title,contentText);
              } else if (index == 2) {
                //var pattern = new RegExp("<\/?.+?>","ig");
                var articleText =document.getElementById($scope.info.id+"homeArticleId").innerText;
                var regArticleText=articleText.replace(/<\/?.+?>/g,"");
                var content=regArticleText.replace(/&nbsp;/g,"");
                var contentText = content.replace(/ /g,"");
                // console.log("自定义指令获取到的文章",contentText);
                $scope.weixinShare($scope.info.id,$scope.info.title,contentText);
              }
              return true;
            }
          });
        };
        $ionicGesture.on("tap", tapFn, $element);
      }
    }
  })
  .directive('closePopupBackDrop', ['$ionicGesture',function($ionicGesture) {
    return {
      scope: false,//共享父scope
      restrict: 'A',
      replace: false,
      link: function(scope, element, attrs, controller) {
        //要在html上添加点击事件, 试了很久- -!
        var  $htmlEl= angular.element(document.querySelector('html'));
        $ionicGesture.on("touch", function(event) {
          if (event.target.nodeName === "HTML" && scope.myPopup.isPopup) {
            scope.optionsPopup.close();
            scope.myPopup.isPopup = false;
          }
        },$htmlEl);
      }
    };
  }])
  //分享替换标签
    .directive('loadErrorDefault', function () {
        return {
            restrict: 'A',
            link: function ($scope, $element, $attr) {
                $element.bind('error', function () {
                    $element.attr('src', $attr["loadErrorDefault"]);
                });
            }
        }
    });
;
