/**
 * dom元素处理模块
 */
angular.module('Dom', [])
    .factory('MesDom', function ($rootScope) {
        var report_item_height = $rootScope.screenWidth * 192 / 690 + 25;
        var date = new Date();
        var ny = date.getFullYear();
        var nm = date.getMonth();
        var nd = date.getDate();
        var nh = date.getHours();
        var nMin = date.getMinutes();
        var today = date2str(date, 'yyyy-MM-dd');
        var b = [6, 12, 18, 24];
        var desc = ['beforeDawn', 'morning', 'afternoon', 'evening'];
        var week = ['星期日', '星期一', '星期二', '星期三', '星期四', '星期五', '星期六'];
        return {
            deal_name: function (dom_name, str_name, limit) {
                //姓名长度过滤
                dom_name.removeAttr('style');
                if (!str_name) {
                    str_name = '我';
                }
                if (!has_chinese(str_name)) {
                    dom_name.addClass("z_englishName");
                    limit = limit * 2;
                    dom_name.css('left', "2px");
                    if (!str_name) {
                        str_name = '我';
                    } else {
                        str_name = str_name.substr(0, limit);
                    }
                    dom_name.css('top', (str_name.length - 1) * 3 + 'px');
                } else {
                    dom_name.css('left', ($rootScope.screenWidth - 30) * 5 / 69 + "px");
                    if (!str_name) {
                        str_name = '我';
                    } else {
                        str_name = str_name.substr(0, limit);
                    }
                }
                if (str_name.length == 1) {
                    dom_name.css('line-height', '60px');
                } else if (str_name.length == 2) {
                    dom_name.css('line-height', '21px').css('padding-top', '7px');
                } else if (str_name.length == 3) {
                    dom_name.css('padding-top', '7px');
                }
                dom_name.html(str_name);
            },
            /**
             * 重设当前时间点
             */
            reset_now: function () {
                date = new Date();
                ny = date.getFullYear();
                nm = date.getMonth();
                nd = date.getDate();
                nh = date.getHours();
                nMin = date.getMinutes();
                today = date2str(date, 'yyyy-MM-dd');
            },
            /**
             * 根据时间获取时段描述
             * @param time 时间点
             * @returns {string}
             */
            get_at_time_desc: function (time) {
                var h = parseInt(time.split(':')[0]);
                var num = Math.floor(h / 6);
                return desc[num];
            },
            //获取一个药盒里面的药片列表
            get_meds: function (ymd, meds) {
                //当前时间戳
                var nowTime = new Date().getTime();
                var take = {ms: [], eatnum: 0, num: meds.length};
                var eat_no = [];
                var eat_ok = [];
                var eat_clock = [];
                var mcs = ['z_onePill', 'z_twoPill', 'z_threePill', 'z_fourPill'];
                var anum = take.num > 4 ? 4 : take.num;
                //根据最多显示的药片确定样式
                var mc = mcs[anum - 1];
                for (var k = 0; k < meds.length; k++) {
                    var t = meds[k];
                    //已经服用或者已经提醒数量+1  take.eatnum++
                    //判断是否存在推迟记录，如果有就进行判断推迟时间是否过了，并将图标改变为闹钟
                    if (t.delayPlan) {
                        var dp = t.delayPlan;
                        var setTime = new Date(dp.phoneLocalTime).getTime();
                        // console.log('设置时间', dp.phoneLocalTime);
                        if (t.take == 0 && (dp.tcsx > nowTime && nowTime > setTime)) {//
                            t.take = 4;
                        }
                    }
                    /**
                     * 将不同的状态分别放在不同的数组里面
                     * eat_no是未服用状态的药丸
                     * eat_ok  是已经服用了状态的药丸
                     * eat_clock是闹铃状态的药丸
                     */
                    if (t.take == 0 || t.take == 2) {
                        eat_no.push(t);
                    } else if (t.take == 1 || t.take == 3) {
                        eat_ok.push(t)
                        take.eatnum++;
                    } else if (t.take == 4) {
                        eat_clock.push(t)
                    }
                }
                //判断药丸的数量是否不足4，如果不足4个，则将闹钟的数组插入
                if (eat_no.length <= 3) {
                    Array.prototype.push.apply(eat_no, eat_clock);
                    if (eat_no.length <= 3) {//判断插入闹钟之后的药丸是否依旧不足4个，是则将已经服用的药丸数组插入
                        Array.prototype.push.apply(eat_no, eat_ok);
                    }
                }
                //console.log("eat_no",eat_no);
                for (var c = 0; c < eat_no.length; c++) {
                    var t = eat_no[c];
                    if (c < 4) {
                        //每个药盒最多只显示4个药片
                        var medicine = t.medicine;
                        var d = $('<div class="z_poaR fL">').addClass(mc);
                        var mi = $('<img/>').attr('src', medicine.surface.url);
                        //拼接药品id
                        var med_id = ymd + '_' + t.planId + '_' + t.alarmTime;
                        mi.attr('id', med_id);
                        //药片提醒标志 日期+计划id+提醒时间
                        var mf = $('<img/>');
                        //拼接服用标志id
                        var flag_id = ymd + '_' + t.planId + '_' + t.alarmTime + '_take';
                        mf.attr('id', flag_id);
                        if (t.take == 0) {
                            mf.attr('src', 'img/z_noeat.png');
                        } else if (t.take == 1) {
                            mf.attr('src', 'img/z_select.png');
                        } else if (t.take == 2) {
                            mf.attr('src', 'img/z_call.png');
                        } else if (t.take == 3) {
                            mf.attr('src', 'img/z_select.png');
                        } else if (t.take == 4) {
                            mf.attr('src', 'img/z_remind.png');
                        }
                        d.append(mi);
                        d.append(mf);
                        take.ms.push(d);

                    }
                }
                return take;
            },
            //判断当前时间是否在传入的当前时段
            is_now_bucket: function (h, t) {
                return Math.floor(h / 6) == t;
            },
            /**
             * 获取一天消息的DOM
             * @param obj 每天的消息汇总
             * @returns {*|jQuery}
             */
            get_day: function (obj) {
                this.reset_now();
                //消息时间
                var mes_date = new Date(obj.time);
                //一天dom
                console.log(obj);
//                if (obj.drug.length > 0) {
                    var div_day = $('<div class="z_diaryWrap"></div>').attr('id', obj.ymd);
                    //日期标题 如3月17日 星期四
                    var h_date = $('<h2></h2>').addClass('z_date')
                        .append($('<span style="margin-right:10px;"><span>').html(obj.date))
                        .append($('<span></span>').html(obj.week));
                    //加入日期dom
                    div_day.append(h_date);
//                }
                //一天的计划服药消息
                var plan_mes = obj.drug;
                //判断是否存在服药消息
                if (plan_mes.length > 0) {
                    //创建一天的药盒
                    var pillobox = $('<div class="z_pillBox" style="padding-top:{{(screenWidth-30)*11/69}}px;"></div>');
                    div_day.append(pillobox);
                    //遍历每个人得药盒
                    for (var j in plan_mes) {
                        //一个人的药盒
                        var one = plan_mes[j];
                        // 创建一个人的药盒
                        if (one.self) {
                            //自己的药盒
                            var box = $('<div class="mybox clearfix z_poaR"  style="background: #fff url(img/z_myFlag.png) no-repeat {{(screenWidth-30)*32/690}}px top; background-size: {{(screenWidth-30)*64/690}}px; padding:0 0 {{(screenWidth-30)*35/690}}px {{(screenWidth-30)*12/69}}px;"></div>');
                        } else {
                            //他人的药盒
                            var box = $('<div class="mybox clearfix z_poaR"  style="background: #fff url(img/z_myFlag2.png) no-repeat {{(screenWidth-30)*32/690}}px top; background-size: {{(screenWidth-30)*64/690}}px; padding:0 0 {{(screenWidth-30)*35/690}}px {{(screenWidth-30)*12/69}}px;"></div>');
                        }
                        pillobox.append(box);
                        var name = $('<div class="myName"></div>');
                        this.deal_name(name, one.toUser.name, 4);
                        //姓名拼接标志 本人:self_name 他人:(id)_name
                        var name_flag = one.toUser.id ? one.toUser.id : 'self';
                        name.attr('name_flag', name_flag);
                        box.append(name);
                        var admire = $('<a class="z_admire" style="width:{{(screenWidth-30)*114/690}}px;bottom:{{(screenWidth-30)*35/690}}px;"></a>')
                        if (one.toUser.id) {
                            admire.append($('<img src="img/z_admireOn.png" width="100%" alt="" />').attr('id', obj.ymd + '_' + one.toUser.id + '_share'));
                            admire.attr('ng-click', 'share("' + obj.ymd + '",' + one.toUser.id + ')');
                        } else {
                            admire.append($('<img src="img/z_admireOn.png" width="100%" alt="" />').attr('id', obj.ymd + '_self_share'));
                            admire.attr('ng-click', 'share("' + obj.ymd + '","self")');
                        }
                        box.append(admire);
                        //获取凌晨时段填充完药物的药瓶
                        var bottle = this.get_bottle(one, obj.ymd, 0);
                        box.append(bottle);
                        bottle = this.get_bottle(one, obj.ymd, 1);
                        box.append(bottle);
                        bottle = this.get_bottle(one, obj.ymd, 2);
                        box.append(bottle);
                        bottle = this.get_bottle(one, obj.ymd, 3);
                        box.append(bottle);
                    }
                }
                //一天的普通消息（如微信分享、微信回复、测量血压、心率等数据）
                var common_messages = obj.mes;
                if (common_messages.length > 0) {
                    var div_common_messages = this.get_other_message(common_messages);
                    //绑定其他消息id
                    div_common_messages.attr('id', obj.ymd + '_common_message');
                    if (plan_mes.length == 0) {
                        div_common_messages.css('margin-top', '0px');
                    }
                    div_day.append(div_common_messages);
                }
                return div_day;
            },
            //获取提示dom
            get_remind_day: function (type, d) {
                var ymd = date2str(new Date(), 'yyyy-MM-dd');
                var day = date2str(new Date(), 'MM月dd日');
                //一天dom
                var div_day = $('<div class="z_diaryWrap"></div>').attr('id', ymd);
                //日期标题 如3月17日 星期四
                var h_date = $('<h2></h2>').addClass('z_date')
                    .append($('<span style="margin-right:10px;"><span>').html(day))
                    .append($('<span></span>').html(week[new Date().getDay()]));
                //加入日期dom
                div_day.append(h_date);
                var pill_box = $('<div class="z_pillBox" style="padding-top:' + ($rootScope.screenWidth - 30) * 11 / 69 + 'px;"></div>');
                div_day.append(pill_box);
                if (type == 'HAS_NO_PLAN') {
                    var add = $('<div class="z_toAddDrug z_poaR"></div>')
                        .append($('<p>药盒为空&nbsp;&nbsp;点击添加药物</p>'))
                        .append($('<a href=""><img src="img/z_btnAdd.png" alt="" width="158"/></a>').attr('ng-click', "addMedicine()"));
                    pill_box.append(add);
                } else if (type == 'HAS_PLAN') {
                    var wait = $('<div class="z_waitingClock"><img src="img/z_waitingClock.png" width="85" alt=""/><p>您设置的第一次吃药提醒<br/>时间是<span>' + d + '</span></p></div>');
                    pill_box.append(wait);
                }
                //一天的普通消息（如微信分享、微信回复、测量血压、心率等数据）
                var common_messages = [];
                var div_common_messages = this.get_other_message(common_messages);
                //绑定其他消息id
                div_common_messages.attr('id', ymd + '_common_message');
                div_day.append(div_common_messages);
                return div_day;
            },
            /**
             * 获取空的div
             */
            get_empty_day: function (ymd) {
                //年月日转日期
                var d = new Date(ymd);
                //一天dom
                var div_day = $('<div class="z_diaryWrap"></div>').attr('id', ymd);
                //日期标题 如3月17日 星期四
                var h_date = $('<h2></h2>').addClass('z_date')
                    .append($('<span><span>').html(date2str(d, 'MM月dd日'))
                        .append($('<span></span>').html(week[d.getDay()])));
                //加入日期dom
                div_day.append(h_date);
                return div_day;
            },
            /**
             * 获取药盒背景图
             * @param type 药盒状态（如打开、关闭、点亮）根据此参数拼入样式
             * @returns {*|jQuery|HTMLElement}
             */
            get_bottle_back: function (type) {
                return $('<div class="bottle ' + type + 'Bott" style="width:{{(screenWidth-30)*138/690}}px; height:{{(screenWidth-30)*20/69}}px;"></div>');
            },
            /**
             * 获取药瓶
             * @param plan_mes 针对一个人的计划服药消息
             * @param ymd 服用日期
             * @param time 时段 0：凌晨 1：上午 2：下午 3：晚上
             * @returns {*}
             */
            get_bottle: function (plan_mes, ymd, time) {
                console.group("获取药瓶---");
                console.log("信息", plan_mes);
                var bottle = null;
                var bucket = plan_mes[desc[time]];
                //取出该药盒所在时段的最低限制时间如6、12、18、24
                var t = time - 1 >= 0 ? b[time - 1] : 0;
                // 药盒处理逻辑
                if (bucket.length > 0) {
                    //如果是今天
                    console.log('判断是否是今天', today, ymd);
                    if (today == ymd) {
                        //本地时间计算未到达服用时间药物标志
                        for (var i in bucket) {
                            console.log(bucket);
                            var o = bucket[i];
                            var h = parseInt(o.alarmTime.split(":")[0]);
                            var m = parseInt(o.alarmTime.split(":")[1]);
                            console.log('药物服用时间', h, m, '当前时间', nh, nMin);
                            //如果是今天并且时间未到达
                            if (nh < h || nh == h && nMin < m) {
                                o.take = 4;
                            }
                        }
                        console.log('当前小时', nh, t);
                        if (nh < t) {
                            bottle = this.get_bottle_back('closed');
                            var wait = $('<img src="img/z_wait.png" alt="" class="z_wait" style="width:{{(screenWidth-30)*54/690}}px; margin-left:-{{(screenWidth-30)*27/690}}px;"/>');
                            bottle.append(wait);
                        } else {
                            var take = this.get_meds(ymd, bucket);
                            var at = bucket[0].alarmTime.split(':');
                            var mH = parseInt(at[0]);
                            var mM = parseInt(at[1]);
                            if (this.is_now_bucket(nh, time)) {
                                console.log('正处于当前时段');
                                //正处于当前时段
                                if (take.num == take.eatnum) {
                                    //全部吃完
                                    bottle = this.get_bottle_back('eat');
                                } else {
                                    console.log('小时数对比', nh, mH);
                                    console.log('分钟数对比', nMin, mM);
                                    if (nh > mH || nh == mH && nMin >= mM) {
                                        //第一个药物提醒时间到达
                                        bottle = this.get_bottle_back('open');
                                    } else {
                                        //第一个药物提醒时间未到
                                        bottle = this.get_bottle_back('light');
                                    }
                                    for (var l in take.ms) {
                                        bottle.append(take.ms[l]);
                                    }
                                }
                            } else {
                                if (take.num == take.eatnum) {
                                    bottle = this.get_bottle_back('eat');
                                } else {
                                    bottle = this.get_bottle_back('open');
                                    for (var l in take.ms) {
                                        bottle.append(take.ms[l]);
                                    }
                                }
                            }

                        }
                    } else {
                        var take = this.get_meds(ymd, bucket);
                        if (take.eatnum == take.num) {
                            bottle = this.get_bottle_back('eat');
                        } else if (plan_mes.self) {
                            console.log("自己的");
                            bottle = this.get_bottle_back('open');
                            for (var l in take.ms) {
                                bottle.append(take.ms[l]);
                            }
                        } else {
                            bottle = this.get_bottle_back('closed');
                            for (var l in take.ms) {
                                bottle.append(take.ms[l]);
                            }
                        }
                        //    bottle.attr('ng-click', 'todayDrug("' + ymd + '","' + plan_mes.self + '", ' + plan_mes.toUser.id + ',' + time + ')');
                    }
                    bottle.attr('ng-click', 'todayDrug("' + ymd + '","' + plan_mes.self + '", ' + plan_mes.toUser.id + ',' + time + ', $event)');
                } else {
                    bottle = this.get_bottle_back('empty');
                }
                var bottle_id = ymd + '_' + (plan_mes.toUser.id ? plan_mes.toUser.id : 'self') + '_' + desc[time];
                bottle.attr('id', bottle_id);
                console.groupEnd();
                return bottle;
            },
            /**
             * 获取其他消息dom
             * @param mes 消息
             * @returns {*|jQuery|HTMLElement}
             */
            get_other_message: function (mes) {
                var divm = $('<div class="z_sysMessage"></div>');
                var m = null;
                var item = null;
                for (var i in mes) {
                    console.log('获取普通消息');
                    m = mes[i];
                    if (m.type == 1) {
                        //血压
                        item = this.get_bp_item(m);
                    } else if (m.type == 2) {
                        item = this.get_hr_item(m);
                    } else if (m.type == 3) {
                        item = this.get_bs_item(m);
                    } else if (m.type == 4) {
                        item = this.get_ox_item(m);
                    } else if (m.type == 5) {
                        //体检报告
                        item = this.get_report_item(m);
                    } else if (m.type == 6) {
                        //微信分享
                        item = this.get_wechat_share_item_002(m);
                    } else if (m.type == 7) {
                        //微信回复
                        item = this.get_wechat_share_item_002(m);
                    } else if (m.type == 8) {
                        //未检测体征数据
                        item = this.get_no_check_item(m);
                    }
                    divm.append(item);
                }
                return divm;
            },
            /**
             * 获取空的其他消息
             */
            get_empty_common_message: function (ymd) {
                var divm = $('<div class="z_sysMessage"></div>').attr('id', ymd + '_common_message');
                return divm;
            },
            /**
             * 获取血压dom
             * @param mes 血压消息体
             * @returns {*|jQuery|HTMLElement}
             */
            get_bp_item: function (mes) {
                var div = $('<div class="z_poaR"></div>');
                var item = $('<ion-item class="g_item"></ion-item>');
                div.append(item);
                var img = $('<img src="img/g_q.png" height="35" class="g_heart_img">');
                item.append(img);
                var title = $('<span class="g_span1"></span>').html(mes.title);
                item.append(title);
                var data = $('<a></a>').html(mes.SSY + '/' + mes.SZY).append($('<span class="g_span2">mmH/g</span>'));
                var level = null;
                //只分正常异常以便提示框样式简单
                level = $('<span class="g_span3"></span>');
                var g_span3_span = $('<span></span>').html(mes.level);
                level.append(g_span3_span);
                var z_div = $('<div style="text-align:center;"></div>');
                z_div.append(data);
                z_div.append(level);
                item.append(z_div);
                if (mes.level == '正常') {
                    level.addClass('g_span4');
                    // level = $('<span class="g_span3"></span>').html(mes.level);
                } else {
                    //level = $('<span class="g_span3"></span>').html('异常');
                    level.addClass('g_span3');
                    var consult = $('<a class="z_toConsult">咨询</a>');
                    consult.attr('ng-click', 'goConsult();$event.stopPropagation();');
                    item.append(consult);
                }
                var desc = $('<p class="g_p" style="background: #73d6b5;"></p>').html(mes.desc);
                item.append(desc);
                item.attr('ng-click', "health(" + mes.type + ");$event.stopPropagation();");
                var interval = $('<span class="z_heaTime"></span>').html(mes.interval);
                div.append(interval);
                return div;
            },
            /**
             * 获取心率列表项
             * @param mes
             * @returns {*|jQuery|HTMLElement}
             */
            get_hr_item: function (mes) {
                var item = $('<ion-item class="g_item"></ion-item>');
                var img = $('<img src="img/g_heart.png" height="35" class="g_heart_img">');
                item.append(img);
                var title = $('<span class="g_span1"></span>').html(mes.title);
                item.append(title);
                var data = $('<a></a>').html(mes.ml).append($('<span class="g_span2">次/分钟</span>'));
                var level = null;
                level = $('<span class="g_span3"></span>');
                var g_span3_span = $('<span></span>').html(mes.level);
                level.append(g_span3_span);
                var z_div = $('<div style="text-align:center;"></div>');
                z_div.append(data);
                z_div.append(level);
                item.append(z_div);
                if (mes.level == '正常') {
                    level.addClass('g_span4');
                } else {
                    var consult = $('<a class="z_toConsult">咨询</a>');
                    consult.attr('ng-click', 'goConsult();$event.stopPropagation();');
                    item.append(consult);
                    level.addClass('g_span3');
                }
                item.attr('ng-click', "health(3);$event.stopPropagation();");
                var desc = $('<p class="g_p" style="background: #73d6b5;"></p>').html(mes.desc);
                item.append(desc);
                return item;
            },
            get_admire_dom: function (mes) {
                var item = $('<a class="z_home3" style="height:{{screenWidth*178/690+25}}px;"></a>');
                var title = $('<h2 class="f12">消息通知</h2>').html(mes.title);
                item.append(title);
                var content = $('<p class="f12 z_shareMess"></p>').html(mes.content);
                item.append(content);
                var interval = $('<span></span>').html(mes.interval);
                item.append(interval);
                return item;
            },
            /**
             * 获取微信回复dom
             * @param mes 消息体
             */
            get_wechat_reply_item: function (mes) {
                var item = $('<a class="z_home4" style="height:{{screenWidth*178/690+25}}px;"></a>');
                var content = $('<p class="f12"></p>').html(mes.content);
                item.append(content);
                var interval = $('<span></span>').html(mes.interval);
                item.append(interval);
                //点击进入查看微信分享
                item.attr('on-tap', "look_share('" + mes.relation + "')");
                return item;
            },
            /**
             * 获取微信分享item
             * @param mes 消息体
             */
            get_wechat_share_item: function (mes) {
                var item = $('<a class="z_home3" style="height:{{screenWidth*178/690+25}}px;"></a>');
                var title = $('<h2></h2>').html('分享消息');
                item.append(title);
                var str_content = null;
                if (mes.content.length > 20) {
                    str_content = mes.content.substr(0, 17) + '...';
                } else {
                    str_content = mes.content;
                }
                var content = $('<p class="f12 z_shareMess"></p>').html(str_content);
                item.append(content);
                var interval = $('<span></span>').html(mes.interval);
                item.append(interval);
                return item;
            },
            /**
             * 获取合并了消息回复人之后的微信分享item
             * @param mes 消息体
             */
            get_wechat_share_item_002: function (mes) {
                if (typeof(mes.replyUsers) == 'string') {
                    mes.replyUsers = eval("('" + mes.replyUsers + "')");
                    if (typeof(mes.replyUsers) == 'string') {
                        mes.replyUsers = eval("(" + mes.replyUsers + ")");
                    }
                }
                if (mes.replyUsers && mes.replyUsers.length > 0) {
                    var item = $('<a class="z_home3On" style="height:{{screenWidth*249/690+25}}px;"></a>');
                    var title = $('<h2></h2>').html('分享消息');
                    item.append(title);
                    var str_content = null;
                    if (mes.content.length > 20) {
                        str_content = mes.content.substr(0, 17) + '...';
                    } else {
                        str_content = mes.content;
                    }
                    var content = $('<p class="f12 z_shareMess"></p>').html(str_content);
                    item.append(content);
                    var interval = $('<span class="z_sendTime"></span>').html(mes.interval);
                    item.append(interval);
                    var users = $('<div class="z_encPeople clearfix" style="height:{{screenWidth*90/690}}px; width: 100%;"></div>');
                    item.append(users);
                    var count = $('<div class="fL f12" style="height:{{screenWidth*90/690}}px; line-height:{{screenWidth*90/690}}px; padding-left: 10px;"><span>' + mes.replyUsers.length + '</span>人鼓励</div>');
                    users.append(count);
                    var headers = $('<div style="overflow: hidden; width: {{screenWidth-150}}px; height:{{(screenWidth*90/690)}}px;"></div>');
                    users.append(headers);
                    for (var i in mes.replyUsers) {
                        var user = mes.replyUsers[i];
                        var header = $('<div class="fL z_addHeadWrap" style="overflow: hidden; height:{{(screenWidth*90/690)*0.5}}px; width: {{(screenWidth*90/690)*0.5}}px; margin: 0; margin: {{(screenWidth*90/690)*0.25}}px 0 0 {{(screenWidth*90/690)*0.25}}px;"></div>');
                        headers.append(header);
                        var img = $('<img width="100%" height="100%" style="margin: 0 auto;" alt=""/>').attr('src', user.wechatHeader);
                        header.append(img);
                    }
                    var total = ($rootScope.screenWidth * 90 / 690) * 0.75 * mes.replyUsers.length;
                    console.log(total);
                    var show = $rootScope.screenWidth - 150;
                    console.log(show);
                    if (total > show) {
                        var more = $('<div class="fL z_addHeadWrap" style="overflow: hidden; height:{{(screenWidth*90/690)*0.5}}px; width: {{(screenWidth*90/690)*0.5}}px; margin: 0; margin: {{(screenWidth*90/690)*0.25}}px 0 0 {{(screenWidth*90/690)*0.25}}px; position: absolute; right: 25px; top: 0;"></div>');
                        users.append(more);
                        var more_img = $('<img src="img/z_encMore.png" width="100%" height="100%" style="margin: 0 auto;" alt=""/>');
                        more.append(more_img);
                    }
                } else {
                    item = this.get_wechat_share_item(mes);
                }
                //点击进入查看微信分享
                item.attr('on-tap', "look_share('" + mes.relation + "')");
                item.attr('id', mes.ymd + '_share_' + mes.relation);
                return item;
            },
            /**
             * 获取几天没测量dom
             * @param mes 消息体
             */
            get_no_check_item: function (mes) {
                var item = $('<a class="z_home5" style="height:{{screenWidth*158/690+25}}px;"></a>');
                var title = $('<h2 class="f12"></h2>').html(mes.title);
                item.append(title);
                var content = $('<p class="f12"></p>').html(mes.content);
                item.append(content);
                var interval = $('<span></span>').html(mes.interval);
                item.append(interval);
                return item;
            },
            get_ox_item: function (mes) {
                var div = $('<div class="z_poaR"></div>');
                var item = $('<ion-item class="g_item"></ion-item>');
                div.append(item);
                var img = $('<img src="img/g_tube.png" height="35" class="g_heart_img">');
                item.append(img);
                var title = $('<span class="g_span1"></span>').html(mes.title);
                item.append(title);
                var level = null;
                //只分正常异常以便提示框样式简单
                level = $('<span class="g_span3"></span>');
                var g_span3_span = $('<span></span>').html(mes.level);
                level.append(g_span3_span);
                var data = $('<a></a>').html(mes.xy).append($('<span class="g_span2">%</span>'));
                var z_div = $('<div style="text-align:center;"></div>');
                z_div.append(data);
                z_div.append(level);
                item.append(z_div);
                if (mes.level == '正常') {
                    level.addClass('g_span4');
                } else {
                    var consult = $('<a class="z_toConsult">咨询</a>');
                    consult.attr('ng-click', 'goConsult();$event.stopPropagation();');
                    item.append(consult);
                }
                var desc = $('<p class="g_p" style="background: #73d6b5;"></p>').html(mes.desc);
                item.append(desc);
                item.attr('ng-click', "health(2);$event.stopPropagation();");
                var interval = $('<span class="z_heaTime"></span>').html(mes.interval);
                div.append(interval);
                return div;
            },
            get_bs_item: function (mes) {
                var div = $('<div class="z_poaR"></div>');
                var item = $('<ion-item class="g_item"></ion-item>');
                div.append(item);
                var img = $('<img src="img/g_water.png" height="35" class="g_heart_img">');
                item.append(img);
                var title = $('<span class="g_span1"></span>').html(mes.title);
                item.append(title);
                var data = $('<a></a>').html(mes.bs).append($('<span class="g_span2">mmol/L</span>'));
                var level = null;
                //只分正常异常以便提示框样式简单
                level = $('<span class="g_span3"></span>');
                var g_span3_span = $('<span></span>').html(mes.level);
                level.append(g_span3_span);
                var z_div = $('<div style="text-align:center;"></div>');
                z_div.append(data);
                z_div.append(level);
                item.append(z_div);
                if (mes.level == '正常') {
                    level.addClass('g_span4');
                } else {
                    var consult = $('<a class="z_toConsult">咨询</a>');
                    consult.attr('ng-click', 'goConsult();$event.stopPropagation();');
                    item.append(consult);
                    level.addClass('g_span3');
                }
                var desc = $('<p class="g_p" style="background: #73d6b5;"></p>').html(mes.desc);
                item.append(desc);
                item.attr('ng-click', "health(0);$event.stopPropagation();");
                var interval = $('<span class="z_heaTime"></span>').html(mes.interval);
                div.append(interval);
                return div;
            },

            /**
             * 体检报告
             */
            get_report_item: function (mes) {
                var item = $('<a class="z_home2 f15" style="height:' + report_item_height + 'px;" ng-click="scan_report()"></a>').append($('<span></span>').html('测试'));
                return item;
            },
            //处理闹铃触发对象对应的dom元素
            deal_alarm_trigger: function (ymd, data) {
                //alert('处理闹钟触发');
                //alert(JSON.stringify(data));
                //判断触发对象是list或者是object
                if (data instanceof Array) {
                    //alert('闹铃列表');
                    this.deal_alarm_list(ymd, data);
                } else {
                    this.deal_alarm(ymd, data);
                }
            },
            //处理闹铃提醒列表
            deal_alarm_list: function (ymd, list) {
                //alert('处理闹钟列表');
                for (var i in list) {
                    //alert(i);
                    //alert('单个闹铃对象' + JSON.stringify(list[i]));
                    this.deal_alarm(ymd, list[i]);
                }
            },
            //处理闹铃提醒对象
            deal_alarm: function (ymd, alarm) {
                //alert('处理单个闹钟对象dom');
                //闹铃计划对象
                var plan = alarm.plan;
                //闹铃具体时刻对象
                var at = alarm.at;
                //拼接药瓶id
                var bottle_id = ymd + '_' + (plan.toUser && plan.toUser.id ? plan.toUser.id : 'self') + '_' + this.get_at_time_desc(at.time);
                //alert(bottle_id);
                var bottle = $('#' + bottle_id);
                //alert('更换药瓶状态');
                if (bottle.hasClass('closedBott')) {
                    //删除等待图片
                    bottle.children('img').remove();
                    //删除关闭药盒样式
                    bottle.removeClass('closedBott');
                    //添加开口盒子样式
                    bottle.addClass('openBott');
                }
            },
            //处理服药刷新dom
            deal_take_medicine: function (ymd, planId, time, toUser) {
                //药品拼接id
                var med_id = ymd + '_' + planId + '_' + time;
                //服用标志拼接id
                var flag_id = med_id + '_take';
                //更换服用图片
                $('#' + flag_id).attr('src', 'img/z_select.png');
            }
        }
    }
);