var pagX = 0;
angular.module('Drug', ['FileUtil'])
    .service('drugService', function ($http, $q, $rootScope, $ionicNativeTransitions) {
        return {
            codeSearch: function (code) {
                var q = $q.defer();
                var params = {
                    token: $rootScope.token,
                    code: code
                };
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/codeSearch.htm",
                    params: params,
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },
            updateWeixinShare: function (p_token, p_title, p_desc, p_imgUrl, p_isQQ) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/weixinShare/updateWeixinShare.htm",
                    params: {
                        apptoken: p_token,
                        title: p_title,
                        desc: p_desc,
                        imgUrls: p_imgUrl,
                        isqq: p_isQQ
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            deleteWeixinShare: function (p_shareid) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/weixinShare/deleteWeixinShare.htm",
                    params: {
                        shareid: p_shareid
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            updateWeixinReplyUser: function (p_shareid) {
                //alert(p_imgUrl);
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/weixinShare/updateWeiXinReplyUser.htm",
                    params: {
                        shareid: p_shareid
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);

                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            searchMedicine: function (medicineName, page) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/medicine/search.htm",
                    params: {
                        keyword: medicineName,
                        page: page
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },

            delayPlanList: function (planidList, minute) {
                var today_date = new Date();
                var list = [];
                for (var i in planidList) {
                    list.push(planidList[i].plan.id);
                    console.log(planidList[i].plan.id);
                }
                var q = $q.defer();
                var today_day = date2str(today_date, 'yyyy-MM-dd hh:mm:ss');
                console.log("推迟时间", planidList[0].at.time)
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/plan/plandelay/addArray.htm",
                    params: {
                        token: $rootScope.token,
                        phoneLocalTime: today_day,
                        planidList: list,
                        minute: minute,
                        time: planidList[0].at.time,
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        console.log(result);
                        q.resolve(result);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;

            },


            /**
             * 服药推迟 将用户的推迟时间，id 计划id等记录在数据库中，此方法支持单次存储数据库
             * @param planid
             * @param minute
             * @returns {.watchAcceleration.promise|*|promise|c.promise|AnimateRunner.promise|td.g.promise}
             */
            delayPlan: function (time, planid, minute) {
                var today_date = new Date();
                var q = $q.defer();
                var today_day = date2str(today_date, 'yyyy-MM-dd hh:mm:ss');
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/plan/plandelay/add.htm",
                    params: {
                        token: $rootScope.token,
                        phoneLocalTime: today_day,
                        minute: minute,
                        planId: planid,
                        time: time
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        console.log(result);
                        q.resolve(result);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;

            },

            //添加用药计划(liushangqing)
            addDrugPlan: function (toUserId, step, beginTime, remarkId, takeDay, medicineColor, medicineShape, unit, remarkTime, dosage, medicineName, kitAppearance, term, takeTime, remarkText, manufacture) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/medicine/plan/add.htm",
                    params: {
                        token: $rootScope.token,
                        toUser: toUserId,
                        beginTime: beginTime,
                        remarkId: remarkId,
                        remarkTime: remarkTime,
                        takeDay: takeDay,
                        medicineColor: medicineColor,
                        medicineShape: medicineShape,
                        unit: unit,
                        dosage: dosage,
                        medicineName: medicineName,
                        kitAppearance: kitAppearance,
                        step: step,
                        term: term,
                        takeTime: takeTime,
                        remarkText: remarkText,
                        manufacture: manufacture
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        console.log(result);
                        q.resolve(result);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },
            //获取药片禁忌信息
            getMedicineForbid: function (medicineName) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/query/forbidden.htm",
                    params: {
                        medicineName: medicineName
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },
            /**
             * 添加提醒用户
             * @param {Object} form 参数表单
             */
            add: function (form) {
                var q = $q.defer();
                var params = {
                    token: $rootScope.token
                };
                //非空属性过滤
                for (var key in form) {
                    if (form[key] != null) {
                        params[key] = form[key];
                    }
                }
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/alarm/user/add.htm",
                    params: params,
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },
            /**
             * 添加有备注图片更新的方式
             * @param {Object} form 表单
             */
            addWithFile: function (form) {
                var q = $q.defer();
                var imageData = form.header;
                var options = new FileUploadOptions();
                options.fileKey = "file"; //用于设置参数，对应form表单里控件的name属性，这是关键，废了一天时间，完全是因为这里，这里的参数名字，和表单提交的form对应
                options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
                //如果是图片格式，就用image/jpeg，其他文件格式上官网查API
                options.mimeType = "image/jpeg";
                //options.mimeType = "multipart/form-data";
                // 这两个参数修改了，后台就跟普通表单页面post上传一样 enctype="multipart/form-data"
                var uri = encodeURI($rootScope.reqUrl + "/patient/user/alarm/user/add.htm");
                options.chunkedMode = false;
                var params = new Object();
                params.fileAddPic = imageData;
                params.token = $rootScope.token;
                //非空属性过滤
                for (var key in form) {
                    if (form[key] != null) {
                        params[key] = form[key];
                    }
                }
                options.params = params;
                var ft = new FileTransfer();
                ft.upload(imageData, uri, function (result) {
                    var res = eval('(' + result.response + ')');
                    var files = res.data;
                    var ret = files[0];
                    q.resolve(ret);
                }, null, options);
                return q.promise;
            },
            /**
             * 获取提醒用户列表
             */
            getUser: function () {
                if (!$rootScope.token) //未登陆跳到登陆页面
                {
                    $ionicNativeTransitions.stateGo('g_load', {backUrl: 'g_load'}, {
                        "type": "slide",
                        "direction": "left",
                        "duration": 500
                    });
                    return false;
                }
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/alarm/user/find.htm",
                    params: {
                        token: $rootScope.token
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },
            /**
             * 建立医患关系
             * @param doctorId
             * @returns {*}
             */
            createRelation: function (inviteCode) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/relation/create.htm",
                    params: {
                        token: $rootScope.token,
                        inviteCode: inviteCode,
                        platform: $rootScope.os,
                        deviceId: $rootScope.deviceId
                    },
                    timeout: 5000
                };
                $http(req).success(function (result) {
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }, function (e) {
                    console.log(e);
                    q.reject(e);
                });
                return q.promise;
            },
            /**
             * 获取国药准字号码
             * @param imageUrl
             * @returns {*}
             */
            getWordByImage: function (base64Image) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/medicine/getWordByImage.htm",
                    params: {
                      base64Image: base64Image
                    },
                  timeout: 8000
                };
                $http(req).success(function (result) {
                    console.log(result);
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }, function (e) {
                    console.log(e);
                    q.reject(e);
                });
                return q.promise;
            },
            /**
             * 获取国药准字号码
             * @param imageUrl
             * @returns {*}
             */
            getWordByBase64Image: function (base64Image) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: "http://apis.baidu.com/idl_baidu/baiduocrpay/idlocrpaid",
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded',
                        'apikey': '6cd81e2960970f4f1ab63408744d267f'
                    },
                    data: {
                        fromdevice: 'pc',
                        clientip: '10.10.10.0',
                        detecttype: 'LocateRecognize',
                        languagetype: 'CHN_ENG',
                        imagetype: '1',
                        image: base64Image,
                        version: 'v1',
                        sizetype: 'small'
                    },
                    transformRequest: function (obj) {
                        var str = [];
                        for (var p in obj) {
                            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                        }
                        return str.join("&");
                    }
                };
                $http(req).success(function (result) {
                    console.log(result);
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }, function (e) {
                    console.log(e);
                    q.reject(e);
                });
                return q.promise;
            },
            /**
             * 根据国药准字搜药
             * @param word
             * @returns {*}
             */
            searchByWord: function (word) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/medicine/searchByWord.htm",
                    params: {
                        word: word
                    },
                    timeout: 50000
                };
                $http(req).success(function (result) {
                    if (result) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result);
                    }
                }, function (e) {
                    console.log(e);
                    q.reject(e);
                });
                return q.promise;
            },
            queryArticle: function (classId) {
                var q = $q.defer();
                var req = {
                    method: 'get',
                    url: $rootScope.reqUrl + "/article/query.htm",
                  params: {
                    classId: classId
                  },
                    timeout: 5000
                };
                $http(req).success(function (result) {
                    if (result) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result);
                    }
                }, function (e) {
                    console.log(e);
                    q.reject(e);
                });
                return q.promise;
            },
          queryWonderfulActivityService: function (classId,start,count) {
            var q = $q.defer();
            var req = {
              method: 'get',
              url: $rootScope.reqUrl + "/article/articalOrWonderfulActivityQuery.htm",
              params: {
                token: $rootScope.token,
                classId: classId,
                start: start,
                count: count
              },
              timeout: 5000
            };
            $http(req).success(function (result) {
              if (result) {
                q.resolve(result.data);
              } else {
                q.reject(result);
              }
            }, function (e) {
              console.log(e);
              q.reject(e);
            });
            return q.promise;
          },
          queryAllArticleService:function () {
            var q = $q.defer();
            var req = {
              method: 'get',
              url: $rootScope.reqUrl + "/article/queryAllArticle.htm",
              params: {
                token: $rootScope.token
              },
              timeout: 5000
            };
            $http(req).success(function (result) {
              if (result) {
                q.resolve(result.data);
              } else {
                q.reject(result);
              }
            }, function (e) {
              console.log(e);
              q.reject(e);
            });
            return q.promise;
          },
          queryCollectActivityService:function () {
            var q = $q.defer();
            var req = {
              method: 'get',
              url: $rootScope.reqUrl + "/article/queryCollectArticle.htm",
              params:{
                token: $rootScope.token
              },
              timeout: 5000
            };
            $http(req).success(function (result) {
              if (result) {
                q.resolve(result.data);
              } else {
                q.reject(result);
              }
            }, function (e) {
              console.log(e);
              q.reject(e);
            });
            return q.promise;
          },
          addThumbsUpNumService:function(articleOrActivity){
            var q = $q.defer();
            var req = {
              method: 'get',
              url: $rootScope.reqUrl + "/article/addThumbsUp.htm",
              params:{
                token: $rootScope.token,
                articleId: articleOrActivity.id
              },
              timeout: 5000
            };
            $http(req).success(function (result) {
              if (result) {
                q.resolve(result.data);
              } else {
                q.reject(result);
              }
            }, function (e) {
              console.log(e);
              q.reject(e);
            });
            return q.promise;
          },
          obtainThumbs:function(articleOrActivity){
            var q = $q.defer();
            var req = {
              method: 'get',
              url: $rootScope.reqUrl + "/article/obtainThumbsUp.htm",
              params:{
                token: $rootScope.token,
                articleId: articleOrActivity
              },
              timeout: 5000
            };
            $http(req).success(function (result) {
              if (result) {
                q.resolve(result.data);
              } else {
                q.reject(result);
              }
            }, function (e) {
              console.log(e);
              q.reject(e);
            });
            return q.promise;
          },

          obtainCollectService:function(articleOrActivity){
            var q = $q.defer();
            var req = {
              method: 'get',
              url: $rootScope.reqUrl + "/article/obtainCollect.htm",
              params:{
                token: $rootScope.token,
                articleId: articleOrActivity
              },
              timeout: 5000
            };
            $http(req).success(function (result) {
              if (result) {
                q.resolve(result.data);
              } else {
                q.reject(result);
              }
            }, function (e) {
              console.log(e);
              q.reject(e);
            });
            return q.promise;
          },

          addCollectArticleService:function(collectArticle){
            var q = $q.defer();
            var req = {
              method: 'get',
              url: $rootScope.reqUrl + "/article/addCollectArticle.htm",
              params:{
                token: $rootScope.token,
                articleId: collectArticle.id
              },
              timeout: 5000
            };
            $http(req).success(function (result) {
              if (result) {
                q.resolve(result.data);
              } else {
                q.reject(result);
              }
            }, function (e) {
              console.log(e);
              q.reject(e);
            });
            return q.promise;
          },
          addScanNum:function(activity){
            var q = $q.defer();
            var req = {
              method: 'get',
              url: $rootScope.reqUrl + "/article/addScanNum.htm",
              params:{
                token: $rootScope.token,
                articleId: activity.id
              },
              timeout: 5000
            };
            $http(req).success(function (result) {
              if (result) {
                q.resolve(result.data);
              } else {
                q.reject(result);
              }
            }, function (e) {
              console.log(e);
              q.reject(e);
            });
            return q.promise;
          },
          queryNewsStatus:function(news){
            var q = $q.defer();
            var req = {
              method: 'get',
              url: $rootScope.reqUrl + "/article/queryNews.htm",
              params:{
                token: $rootScope.token,
                articleId: news
              },
              timeout: 5000
            };
            $http(req).success(function (result) {
              if (result) {
                q.resolve(result.data);
              } else {
                q.reject(result);
              }
            }, function (e) {
              console.log(e);
              q.reject(e);
            });
            return q.promise;
          },
          addShareNumService:function (article) {
            var q = $q.defer();
            var req = {
              method: 'get',
              url: $rootScope.reqUrl + "/article/addShareNum.htm",
              params:{
                token: $rootScope.token,
                articleId: article
              },
              timeout: 5000
            };
            $http(req).success(function (result) {
              if (result) {
                q.resolve(result.data);
              } else {
                q.reject(result);
              }
            }, function (e) {
              console.log(e);
              q.reject(e);
            });
            return q.promise;
          }
        }
    })
    //药品外观服务
    .
    factory('Surface', function () {
        var shapes = [
            {en: 'ampoule', zh: '针剂'},
            {en: 'apple', zh: '苹果'},
            {en: 'barrel', zh: '桶状'},
            {en: 'bear', zh: '熊'},
            {en: 'bowtie', zh: '领结'},
            {en: 'bullet', zh: '弹丸'},
            {en: 'capsule', zh: '胶囊'},
            {en: 'circle', zh: '圆'},
            {en: 'clover', zh: '四叶草'},
            {en: 'diamond', zh: '菱形'},
            {en: 'double_circle', zh: '双圆'},
            {en: 'drop', zh: '滴'},
            {en: 'eightsided', zh: '八边'},
            {en: 'fivesided', zh: '五边'},
            {en: 'four_rectangles', zh: '四片'},
            {en: 'foursided', zh: '四边'},
            {en: 'grain', zh: '粉'},
            {en: 'heart', zh: '心'},
            {en: 'infusion', zh: '点滴'},
            {en: 'inhaler', zh: '吸入'},
            {en: 'injection', zh: '注射'},
            {en: 'kidney', zh: '肾'},
            {en: 'modified_rectangle', zh: '矩形改'},
            {en: 'nasalspray', zh: '鼻喷'},
            {en: 'ointment', zh: '膏'},
            {en: 'oval', zh: '椭圆'},
            {en: 'patchcircle', zh: '圆贴'},
            {en: 'patchround', zh: '贴'},
            {en: 'peanut', zh: '花生'},
            {en: 'pen_injection', zh: '笔'},
            {en: 'pieces', zh: '堆'},
            {en: 'rectangle', zh: '长方'},
            {en: 'round', zh: '片'},
            {en: 'sevensided', zh: '七边'},
            {en: 'shield', zh: '盾'},
            {en: 'sixsided', zh: '六边'},
            {en: 'spray', zh: '喷雾'},
            {en: 'square', zh: '正方'},
            {en: 'suppository', zh: '栓'},
            {en: 'tablespoon', zh: '勺'},
            {en: 'tablet', zh: '双片'},
            {en: 'tear', zh: '液滴'},
            {en: 'trapeze', zh: '秋千'},
            {en: 'triangle', zh: '三角'},
            {en: 'ushape', zh: 'U型'}
        ];
        var colors = [
            {rgb: 'ffffff', zh: '白'},
            {rgb: 'fff000', zh: '淡黄'},
            {rgb: 'ffcc00', zh: '深黄'},
            {rgb: 'ff7800', zh: '橙'},
            {rgb: 'ff2a00', zh: '浅红'},
            {rgb: 'ff00a2', zh: '粉'},
            {rgb: 'fc7c7c', zh: '红'},
            {rgb: 'f6f2c9', zh: '奶白'},
            {rgb: 'defe7e', zh: '黄绿'},
            {rgb: 'bed17d', zh: '棕绿'},
            {rgb: 'b573f3', zh: '紫'},
            {rgb: '020000', zh: '黑'},
            {rgb: '10420e', zh: '绿'},
            {rgb: '706f6f', zh: '灰'},
            {rgb: '85d281', zh: '浅绿'},
            {rgb: '8a79f7', zh: '蓝绿'},
            {rgb: '7eb1fe', zh: '深蓝'},
            {rgb: '6c3311', zh: '棕'},
            {rgb: '4c639d', zh: '淡蓝'},
            {rgb: '0aa0a2', zh: '青'}
        ];
        return {
            /**
             * 根据索引获取形状
             */
            getShape: function (i) {
                return shapes[i];
            },
            /**
             * 根据索引获取颜色
             */
            getColor: function (i) {
                return colors[i];
            },
            /**
             * 根据英文获取对象
             */
            getShapeByEn: function (en) {
                var shape = {
                    index: 0,
                    obj: {}
                };
                for (var i = 0; i < shapes.length; i++) {
                    if (en == shapes[i].en) {
                        shape.obj = shapes[i];
                        shape.index = i;
                        break;
                    }
                }
                return shape;
            },
            /**
             * 根据色值获取颜色对象
             */
            getColorByRgb: function (title) {
                var color = {
                    index: 0,
                    obj: {}
                };
                for (var i = 0; i < colors.length; i++) {
                    if (title == colors[i].rgb) {
                        color.obj = colors[i];
                        color.index = i;
                        break;
                    }
                }
                return color;
            },

            /**
             * 根据中文获取性状索引
             */
            getShapeByZh: function (zh) {
                var index = 0;
                for (var i = 0; i < shapes.length; i++) {
                    if (zh == shapes[i].zh) {
                        index = i;
                        break;
                    }
                }
                return index;
            },

            /**
             * 根据中文获取颜色索引
             */
            getColorByZh: function (zh) {
                var index = 0;
                for (var i = 0; i < colors.length; i++) {
                    if (zh == colors[i].zh) {
                        index = i;
                        break;
                    }
                }
                return index;
            }
        }
    })
    .controller('RemindEditCtrl', function ($scope, $cacheFactory, $ionicNativeTransitions, $stateParams) {

        $scope.confirm = function () {
            /**
             * 返回
             */
            $scope.goBack = function () {
                //取出回退页面跳转参数
                var param = $cacheFactory.get($stateParams.backUrl);
                var sp = null;
                //如果不在页面参数则设置为空串
                if (param) {
                    sp = param.get('stateParams');
                    if (!sp) {
                        sp = {};
                    }
                } else {
                    sp = {};
                }
                $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                    "type": "slide",
                    "direction": "right",
                    "duration": 500
                });
            };

        };


    })
    //加药控制器
    .controller('AddDrugCtrl', function ($scope, $state, $cacheFactory, $stateParams, $ionicNativeTransitions, $cordovaBarcodeScanner, drugService, imageUtil, $rootScope, WebSql, $timeout, $ionicPopup, $ionicScrollDelegate, $ionicLoading) {
        //接受药盒页面传来的toUser
        var toUser = $stateParams.toUser;
        console.log("toUser:" + toUser);
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);

        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }
        //服药计划缓存
        var plan_cache = $cacheFactory.get('plan');
        if (!plan_cache) {
            plan_cache = $cacheFactory('plan');
        }
        $scope.show = {
            num: 10
        };
        /**
         * 初始化用户缓存
         */
        var likUser = user_cache.get('likUser');
        if (!likUser) {
            likUser = {
                toUser: '',
                userName: '我',
                headImg: $rootScope.user.headImg,
                gender: $rootScope.user && $rootScope.user.gender == 1 ? '男' : '女'
            },
                user_cache.put('likUser', likUser);
        }
        if (!$rootScope.user.gender) {
            likUser.gender = null;
        }
        console.log($rootScope.user.gender);
        if (likUser.userName == '我') {
            likUser.headImg = $rootScope.user.headImg;
        }
        $scope.likUser = likUser;
        console.log(likUser);
        //编辑标志（决定页面的某个表单收缩和展开）
        var flag = plan_cache.get('flag');
        /**
         * displayId 取值说明 1显示药品搜索结果列表
         * 2代表用药历史记录
         * 3代表药物详情
         * 4代表说明也不显示
         */
        if (!flag) {
            flag = {
                displayId: 3,
                isSearch: false,
                clickFlag: false,
                show_dosage: false
            };
        }
        $scope.flag = flag;
        var medicineInfo = plan_cache.get('medicineInfo');
        if (!medicineInfo) {
            medicineInfo = {
                medicineName: null, //药物名称
                medicineUnit: '药片',  //药物单位
                kitAppearance: null,    //药盒外观图片
                medicineCount: null,      //药盒外观图片
                medicineImgSrc: 'img/shape_color/ffffff/circle_ffffff.png', //药品形状图片
                medicineShape: '圆',
                medicineColor: '白',
                medicineDosage: '',
                manufacture: ''
            }
        }
        $scope.form = medicineInfo;
        /**
         * 缓存获取用户列表
         */
        var users = user_cache.get('alarm_users');
        if (!users) {
            drugService.getUser().then(function (data) {
                user_cache.put('alarm_users', data.list);
                $scope.users = data.list;
            }, function (error) {
            });
        } else {
            $scope.users = users;
        }
        /**
         * 设置使用者
         */
        $scope.setToUser = function (id) {
            $scope.flag.clickFlag = true;
            if (id == '' || id == null) {
                $scope.likUser.userName = '我';
                $scope.likUser.toUser = id;
                $scope.likUser.headImg = $rootScope.user.headImg;
                console.info('头像', $scope.likUser.headImg);
                if (!$rootScope.user.gender) {
//                    console.info("无默认性别，给个男性");
                    $scope.likUser.gender = '男';
                } else {
                    $scope.likUser.gender = $rootScope.user.gender == 1 ? '男' : '女';
                }

            } else {
                $scope.likUser.toUser = id;
                for (var i = 0; i < $scope.users.length; i++) {
                    if ($scope.users[i].id == id) {
                        $scope.likUser.userName = $scope.users[i].name;
                        $scope.likUser.headImg = $scope.users[i].header;
                        $scope.likUser.gender = $scope.users[i].gender;
                        break;
                    }
                }
            }
            console.info("$scope.likUser.gender:", $scope.likUser.gender);

            //将关联用户添加缓存
            user_cache.put('likUser', $scope.likUser);
            if ($scope.form.medicineName) {
                $scope.flag.displayId = 3;
                $scope.flag.isSearch = true;
            } else {
                WebSql.getTakeMedicine($rootScope.user.userId).then(function (data) {
                    if (data.length <= 0) {
                        $scope.flag.displayId = 4;
                        return;
                    }
                    $scope.flag.displayId = 2;
                    $scope.takeMedicine = data.splice(0, 10);
                    $scope.flag.isSearch = true;
                }, function (error) {

                });
            }
        };
        //每次进入该页面时，判断药品名称是否存在
        if ($scope.form.medicineName == "" || $scope.form.medicineName == null) {
            $scope.flag.isSearch = false;
            $scope.flag.displayId = 2;
        }
        //判断是否查找过历史用药记录
        if (!$scope.flag.isSearch) {
            WebSql.getTakeMedicine($rootScope.user.userId).then(function (data) {
                if (data.length <= 0) {
                    $scope.flag.displayId = 4;
                    return;
                }
                $scope.flag.displayId = 2;
                $scope.takeMedicine = data.splice(0, 10);
                $scope.flag.isSearch = true;
            }, function (error) {
            });
        }
        /**
         * 点击历史用药记录
         * @param index
         */
        $scope.likHistoryMedicine = function (index) {
            $scope.flag.clickFlag = true;
            $scope.show.num = 10;
            $scope.flag.displayId = 3;
            $scope.form = $scope.takeMedicine[index];
            /*            $scope.form.medicineName = $scope.takeMedicine[index].medicineName;
             $scope.form.medicineImgSrc = $scope.takeMedicine[index].medicineImgSrc;
             $scope.form.medicineCount = $scope.takeMedicine[index].medicineCount;
             $scope.form.medicineUnit = $scope.takeMedicine[index].medicineUnit;
             $scope.form.medicineColor = $scope.takeMedicine[index].medicineColor;
             $scope.form.medicineShape = $scope.takeMedicine[index].medicineShape;
             $scope.form.medicineId = $scope.takeMedicine[index].medicineId;
             $scope.form.kitAppearance = $scope.takeMedicine[index].kitAppearance;*/
        };
        $scope.delMedicineInfo = function (index, medicineName) {
            $scope.takeMedicine.splice(index, 1);
            WebSql.delMedicineInfo($rootScope.user.userId, medicineName);
        };

        /**
         * 滚动到顶部
         */
        $scope.scrollTop = function () {
            $ionicScrollDelegate.$getByHandle('small').scrollTop();
        };
        /**
         *查询药物
         */
        $scope.searchMedicineList = new Array();
        var page = 0;

        $scope.searchMedicine = function (remain) {
            if (!remain) {
                $scope.searchMedicineList = []; //清空上次
                page = 0;
                $scope.scrollTop();
            }
            $scope.isHasMore = true;
            $scope.flag.clickFlag = true;
            $scope.show.num = 10;
            if ($scope.form.medicineName == "" || $scope.form.medicineName == null) {
                $scope.flag.displayId = 4; //什么也不显示
                $scope.flag.isSearch = true;
                return;
            }

            drugService.searchMedicine($scope.form.medicineName, page).then(function (data) {
                console.log('搜索结果:', data);
                page = page + 1;
//                $scope.searchMedicineList = [];
                if (data.list.length <= 0) {
                    $scope.isHasMore = false;
                    $scope.flag.displayId = 3;  //查询的药品在药品库里面没有
                    $scope.flag.isSearch = true;
                    $scope.form.medicineShape = '圆';
                    $scope.form.medicineColor = '白';
                    return;
                }
                $scope.flag.displayId = 1;
                var time = 5;
                if (data.list.length < 5) {
                    time = data.list.length;
                }
                var obj = new Object();
                for (var i = 0; i < time; i++) {
//                    obj.name = data.list[i].name;
                    for (var j = 0; j < data.list[i].child.length; j++) {
//                        obj.name = data.list[i].name;
                        obj.name = data.list[i].child[j].name;
                        obj.standard = data.list[i].child[j].standard;
                        obj.manufacture = data.list[i].child[j].manufacture;
                        obj.medicineShape = data.list[i].child[j].shape;
                        obj.medicineColor = data.list[i].child[j].color;
                        obj.medicineUnit = data.list[i].child[j].dosage;
                        obj.medicineImgSrc = data.list[i].child[j].url === "null" ? null : data.list[i].child[j].url;
                        $scope.searchMedicineList.push(obj);
//                        if ($scope.searchMedicineList.length > 4) {
//                            return;
//                        }
                        obj = new Object();
                    }
                }
                console.log($scope.searchMedicineList);
                $scope.$broadcast('scroll.infiniteScrollComplete');
                // $scope.takeMedicine = data.list.splice(0, 5);   //取查询数据的5条
            }, function (error) {
                $scope.flag.displayId = 3;  //查询药品失败
                $scope.flag.isSearch = true;
                $scope.form.medicineShape = '圆';
                $scope.form.medicineColor = '白';
                return;
            })
        };

        $scope.loadMore = function () {
            $scope.searchMedicine(true);
        }


        /**
         * 点击查询药品列表
         * @param index
         */
        $scope.likSearchMedicine = function (index) {
            $scope.flag.clickFlag = true;
            $scope.flag.displayId = 3;
            $scope.flag.isSearch = true;
            $scope.form.medicineName = $scope.searchMedicineList[index].name;
            $scope.form.medicineId = $scope.searchMedicineList[index].id;
//            $scope.form.medicineCount = $scope.searchMedicineList[index].medicineCount === "null" ? '1' : $scope.searchMedicineList[index].medicineCount;
            if ($scope.searchMedicineList[index].medicineCount && $scope.searchMedicineList[index].medicineCount != 'null') {
                $scope.form.medicineCount = $scope.searchMedicineList[index].medicineCount;
            } else {
                $scope.form.medicineCount = 1;
            }
//            $scope.form.medicineUnit = $scope.searchMedicineList[index].medicineUnit === "null" ? '药片' : $scope.searchMedicineList[index].medicineUnit;
            if ($scope.searchMedicineList[index].medicineUnit && $scope.searchMedicineList[index].medicineUnit != 'null') {
                $scope.form.medicineUnit = $scope.searchMedicineList[index].medicineUnit;
            } else {
                $scope.form.medicineUnit = '药片'
            }


            $scope.form.medicineImgSrc = $scope.searchMedicineList[index].medicineImgSrc ? $scope.searchMedicineList[index].medicineImgSrc : 'img/shape_color/ffffff/circle_ffffff.png';
            $scope.form.kitAppearance = null;
            if ($scope.searchMedicineList[index].medicineImgSrc) {
                $scope.form.medicineShape = $scope.searchMedicineList[index].medicineShape;
                $scope.form.medicineColor = $scope.searchMedicineList[index].medicineColor
            } else {
                $scope.form.medicineShape = '圆';
                $scope.form.medicineColor = '白';
            }
            $scope.form.manufacture = $scope.searchMedicineList[index].manufacture;
            //$scope.form.medicineShape = $scope.searchMedicineList[index].medicineShape === "null" ? '圆' : $scope.searchMedicineList[index].medicineShape;
            //$scope.form.medicineColor = $scope.searchMedicineList[index].medicineColor === "null" ? '白' : $scope.searchMedicineList[index].medicineColor;
        };
        //用户不想添加自己的药品
        $scope.paneClick = function () {
            $scope.searchMedicineList = [];
            if ($scope.form.medicineName) {
                $scope.flag.displayId = 3;
                $scope.flag.isSearch = true;
            }
        };
        $scope.showUser = function (userName) {
            $scope.flag.clickFlag = true;
            var tempDisplayId = $scope.flag.displayId;
            $scope.flag.displayId = 0;
            if (userName == '我') {
                $scope.likUser.toUser = '';

            } else {
                for (var i = 0; i < $scope.users.length; i++) {
                    if ($scope.users[i].name == userName) {
                        $scope.likUser.toUser = $scope.users[i].id;
                        break;
                    }
                }
            }
            $timeout(function () {
                $(window).bind('click', function (e) {
                    $scope.flag.displayId = tempDisplayId;
                    $timeout(function () {
                        $(window).unbind('click');
                    }, 1);
                });
            }, 1);
            //$scope.form.medicineName = '';
        };
        /**
         * 跳转添加提醒用户
         */
        $scope.addUser = function () {
            $ionicNativeTransitions.stateGo('g_my_information', {
                backUrl: 'add_drug'
            }, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        };
        /**
         *删除历史记录
         */
        $scope.deleteHistoryMedicine = function () {
            WebSql.deleteTakeMedicine();
            $scope.takeMedicine = [];
            $scope.flag.displayId = 4;
        };

        /**
         * 剂量设置
         */
        $scope.dosage = function () {
            plan_cache.put('flag', $scope.flag);
            plan_cache.put('medicineInfo', $scope.form);
            $ionicNativeTransitions.stateGo('drug_dosage', {backUrl: 'add_drug'}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        };

        /**
         * 外观跳转
         */
        $scope.surface = function () {
            $("input").blur();
            plan_cache.put('flag', $scope.flag);
            plan_cache.put('medicineInfo', $scope.form);
            $timeout(function () {
                $ionicNativeTransitions.stateGo('drug_surface', {backUrl: 'add_drug'}, {
                    "type": "slide",
                    "direction": "left",
                    "duration": 500
                });
            }, 400)
        };

        var freqForm = plan_cache.get('freq');
        if (!freqForm) {
            freqForm = {
                number: 3,
                desc: '一天三次',
                beginTime: date2str(new Date(), 'yyyy-MM-dd'),
                freqInfo: getFreqInfo(3)
            };
            plan_cache.put("freq", freqForm);
        }
        $scope.freqForm = freqForm;
        /**
         * 药品扫描
         */
        $scope.scan = function () {
            $scope.flag.clickFlag = true;
            $cordovaBarcodeScanner
                .scan()
                .then(function (barcodeData) {
                    if (!barcodeData.cancelled) {
                        //扫描到文本
                        //TODO 可以具体判断条形码类型如 EAN_13形式 取出方式barcodeData.format
                        drugService.codeSearch(barcodeData.text).then(function (data) {
                            $scope.flag.displayId = 3;
                            $scope.flag.isSearch = true;
                            $scope.form.medicineName = data.name;
                            $scope.form.medicineUnit = data.dosage;
                            if (data.url != 'null') {
                                $scope.form.medicineImgSrc = data.url;
                            } else {
                                $scope.form.medicineImgSrc = 'img/shape_color/ffffff/circle_ffffff.png';
                            }
                            if (data.intdosage.length > 1) {
                                $scope.flag.show_dosage = true;
                                $scope.form.medicineDosage = data.intdosage;
                            } else {
                                $scope.flag.show_dosage = false;
                                $scope.form.medicineCount = data.intdosage;
                            }
                            if (data.timesForDay && data.timesForDay != 'null') {
                                $scope.freqForm.number = data.timesForDay;
                                $scope.freqForm.desc = $rootScope.freqDesc[data.timesForDay];
                                $scope.freqForm.freqInfo = getFreqInfo(data.timesForDay);
                            }
                            $scope.form.kitAppearance = data.imgUrl;
                        }, function (error) {
                            $scope.scanDiloge = $ionicPopup.show({
                                template: '<div class="z_addSuc" style="text-align: center;">未搜索到该药品!</div>',
                                scope: $scope
                            });
                            $timeout(function () {
                                $(window).bind('click', function (e) {
                                    $scope.scanDiloge.close();
                                    $(window).unbind('click');
                                });
                            }, 100);
                        });
                    }
                }, function (error) {
                    // 扫描失败
                });
        };

        /**
         * 通过选择图片
         */
        $scope.selectImageByPic = function () {
            imageUtil.imagePick($rootScope.screenWidth, $rootScope.screenHeight).then(function (data) {
                if (!data) {
                    return;
                }
                imageUtil.uploadImages(data, "/message/image/uploadImg.htm", $rootScope.token).then(function (ret) {
                    if (ret.status == 1) {
                        $scope.form.kitAppearance = ret.url;
                    }
                }, function (error) {
                })
            }, function (error) {

            });
        };

        /**
         * 通过照相机
         */
        $scope.selectImageByCamera = function () {
            imageUtil.takePhoto($rootScope.screenWidth, $rootScope.screenHeight, Camera.DestinationType.FILE_URI).then(function (data) {
                if (!data) {
                    return;
                }
                imageUtil.uploadImages(data, "/message/image/uploadImg.htm", $rootScope.token).then(function (ret) {
                    if (ret.status == 1) {
                        $scope.form.kitAppearance = ret.url;
                    }
                }, function (error) {
                })
            }, function (error) {

            });
        };

        /**
         * 加药提醒标识
         */
        var scanRemind = localStorage.getItem("scanRemind");
        console.log(scanRemind);
        if (scanRemind == 0) {
            $("#scanRemind").css("display", "block");
            localStorage.setItem("scanRemind", 1);
        }

        /**
         * 将图片地址转为base64位编码格式
         * @param img
         */
        $scope.getBase64Image = function(img) {
          var canvas = document.createElement("canvas");
          canvas.width = img.width;
          canvas.height = img.height;
          var ctx = canvas.getContext("2d");
          ctx.drawImage(img, 0, 0, img.width, img.height);
          var ext = img.src.substring(img.src.lastIndexOf(".")+1).toLowerCase();
          var dataURL = canvas.toDataURL("image/"+ext);
          return dataURL;
        }

        /**
         * 通过图片获取国药准字号
         */
        $scope.getGyzzByImage = function () {
            $("#scanRemind").css("display", "none");
            $("#scanFail").css("display", "none");
            //隐藏图片
            $("#drug_header").css({"display":"block"});
            $("#drug_medicine").css({"display":"block"});
            $("#drug_gyzz").css({"display":"none"});
            imageUtil.takePhotoGyzz($rootScope.screenWidth, $rootScope.screenHeight,
              Camera.DestinationType.DATA_URL).then(function (base64Image) {
                // if (!base64Image) {
                //     return;
                // }
                $("#scanMake").css("display", "block"); //正在识别提示

                $("#drug_header").css({"display":"none"});
                $("#drug_medicine").css({"display":"none"});
                $("#drug_gyzz").css({"display":"block"});
                $(".g_img").attr("src", "data:image/jpeg;base64," + base64Image);
                $("#drug_content").css({"top":"0px"});
                $("#g_gyzz").css({"display":"none"});

                drugService.getWordByImage(base64Image).then(function (data) {
                    $scope.word = data.word;
                    $("#scanMake").css("display", "none"); //关闭正在识别提示
                    if(!$scope.word){
                      $("#scanMake").css("display", "none");
                      $("#scanFail").css("display", "block");
                    }else{
                      $("#g_gyzz").css({"display":"block"});
                      $("#g_focus").val($scope.word);
                      setTimeout(function(){
                        $("#g_focus").focus()/*光标获取*/
                      },100);
                    }
                }, function (err) {
                  $("#scanMake").css("display", "none"); //关闭正在识别提示
                  $("#scanFail").css("display", "block");
                })
            }, function (error) {
                // $ionicLoading.hide();  //隐藏加载
                $("#scanMake").css("display", "none");
                $("#scanFail").css("display", "block");
            });
        };

      /**
       * 通过用户手动输入获取国药准字号
       */
      $scope.getGyzzByUser = function () {
        $("#scanRemind").css("display", "none");
        $("#scanFail").css("display", "none");

        $("#g_gyzz").css({"display":"block"});
        $("#g_focus").val();
        setTimeout(function(){
          $("#g_focus").focus()/*光标获取*/
        },100);
      };


      /**
       * 通过图片获取国药准字号
       */
      $scope.searchByGyzz = function () {

        $("#drug_header").css({"display":"block"});
        $("#drug_medicine").css({"display":"block"});
        $("#drug_gyzz").css({"display":"none"});
        $("#drug_content").css({"top":"44px"});

        $scope.word = $("#g_focus").val();
        console.log($scope.word);
        if ($scope.word && $scope.word != null) {
          // $scope.ucword = ucfirst($scope.word[0]);
          // console.log("转为大写：" + $scope.ucword);
          drugService.searchByWord($scope.word).then(function (drugList) {
//                                $ionicLoading.hide();  //隐藏加载
            $("#scanMake").css("display", "none");
            console.log(drugList);
            if (drugList.length > 0) {
              if (drugList.length == 1) {
                var drugs = drugList[0];
                console.log(drugs);
                $scope.flag.displayId = 3;
                $scope.flag.isSearch = true;
                $scope.form.medicineName = drugs.name;
//                                    $scope.form.medicineUnit = drugs.dosage;
                $scope.form.standard = drugs.standard;
                if (drugs.url != 'null') {
                  $scope.form.medicineImgSrc = drugs.url;
                } else {
                  $scope.form.medicineImgSrc = 'img/shape_color/ffffff/circle_ffffff.png';
                }
                if (drugs.dosage && drugs.dosage != 'null') {
                  $scope.form.medicineUnit = drugs.dosage;
                } else {
                  $scope.form.medicineUnit = '药片';
                }
                if (Number(drugs.intdosage) > 0) {
                  $scope.flag.show_dosage = true;
                  $scope.form.medicineCount = drugs.intdosage;
                } else {
                  $scope.flag.show_dosage = false;
                  $scope.form.medicineCount = 1;
                }
                if (drugs.timesForDay && drugs.timesForDay != 'null') {
                  $scope.freqForm.number = drugs.timesForDay;
                  $scope.freqForm.desc = $rootScope.freqDesc[drugs.timesForDay];
                  $scope.freqForm.freqInfo = getFreqInfo(drugs.timesForDay);
                }
              } else {
                console.log("进入搜索选项" + drugList);
                $scope.flag.displayId = 1;
                var obj = new Object();
                for (var j = 0; j < drugList.length; j++) {
                  obj.name = drugList[j].name;
                  obj.standard = drugList[j].standard;
                  obj.manufacture = drugList[j].manufacture;
                  obj.medicineShape = drugList[j].shape;
                  obj.medicineColor = drugList[j].color;
                  obj.medicineCount = drugList[j].intdosage === "" ? '1' : drugList[j].intdosage;
                  obj.medicineUnit = drugList[j].dosage === "null" ? '药片' : drugList[j].dosage;
                  obj.medicineImgSrc = drugList[j].url === "null" ? null : drugList[j].url;
                  $scope.searchMedicineList.push(obj);
                  obj = new Object();
                }
                console.log($scope.searchMedicineList);
              }
            } else {
              ErrorShow("未找到该药品");
            }
          })
        } else {
//                            $ionicLoading.hide();  //隐藏加载
//           $("#scanMake").css("display", "none");
//           $("#scanFail").css("display", "block");
            ErrorShow("未找到该药品");
        }
      }

        /**
         * 下一步
         * * 将页面的参数添加到缓存中
         */
        $scope.nextStep = function (type) {
            $("input").blur();
            if ($scope.flag.displayId == 2) {
                $scope.flag.isSearch = false;
            }
            if ($scope.flag.displayId == 3) {
                $scope.flag.isSearch = true;
            }
            if ($scope.flag.displayId == 3 && type == 'go') {
                return;
            }
            if (!$scope.form.medicineName) {
                $scope.show.num = 0;
                return;
            }
            if ($scope.flag.displayId != 3) {
                $scope.flag.displayId = 3;
                return;
            }
            var medicineList = user_cache.get("plans");
            for (var i = 0; i < medicineList.length; i++) {
                if (!$scope.likUser.toUser) {     //自己
                    if (!medicineList[i].toUser && medicineList[i].medicineName == $scope.form.medicineName) {
                        $scope.show.num = 1;
                        return;
                    }
                } else {  //他人
                    if (medicineList[i].toUser == $scope.likUser.toUser && medicineList[i].medicineName == $scope.form.medicineName) {
                        $scope.show.num = 1;
                        return;
                    }
                }
            }
            plan_cache.put('flag', $scope.flag);
            plan_cache.put('medicineInfo', $scope.form);
            plan_cache.put("freq", $scope.freqForm);
            $timeout(function () {
                $ionicNativeTransitions.stateGo('drug_remind', {backUrl: 'add_drug'}, {
                    "type": "slide",
                    "direction": "left",
                    "duration": 500
                });
            }, 400)
        };
        $scope.showFlag = false;
        /**
         * 返回
         */
        $scope.goBack = function () {
            console.info("goback---");
            //取出回退页面跳转参数
            $("input").blur();
            plan_cache.removeAll();
            user_cache.remove("remind");
          // var s = $cacheFactory.get("add_drug");
          var s = $cacheFactory.get($stateParams.backUrl);
            var p = s.get("stateParams");
            $timeout(function () {
              console.debug("sp---:", p);
                if ($scope.flag.clickFlag = true) {
                    $scope.showFlag = true;
                    return;
                }
              $ionicNativeTransitions.stateGo($stateParams.backUrl, p, {
                    "type": "slide",
                    "direction": "right",
                    "duration": 500
                });
            }, 400)
        };

        $scope.goBack1 = function () {
            //取出回退页面跳转参数
            $scope.showFlag = false;
            $("input").blur();
            plan_cache.removeAll();
            user_cache.remove("remind");
          var s = $cacheFactory.get($stateParams.backUrl);
            var p = s.get("stateParams");
          $ionicNativeTransitions.stateGo($stateParams.backUrl, p, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
        $scope.goOn = function () {
            $scope.showFlag = false;
        }

        $scope.goClose = function (str) {
            if ("remind" == str) {
                $("#scanRemind").css("display", "none");
            } else {
                $("#scanFail").css("display", "none");
            }
        }

        /**
         * 收到物理返回键按钮事件
         */
        $rootScope.$on('HARDWARE_BACK', function () {
            $scope.goBack();
        });

        /**
         * 手动解绑window点击事件
         */
        document.addEventListener("backbutton", function () {
            $(window).unbind('click');
        }, false);

        //收到删除用户的广播
        $rootScope.$on('delFriendSuccess', function () {
            console.log("收到删除用户的广播  ");
            $scope.users = user_cache.get('alarm_users');
            var temp = false;
            for (var i = 0; i < $scope.users.length; i++) {
                if ($scope.users[i].name == $scope.likUser.userName) {
                    temp = true;
                }
            }
            if (!temp) {
                $scope.likUser = {
                    toUser: '',
                    userName: '我',
                    headImg: $rootScope.user.headImg,
                    gender: $rootScope.user && $rootScope.user.gender == 1 ? '男' : '女'
                };
                user_cache.put("likUser", $scope.likUser);
            }
        });
    })
    .
    controller('DrugRemindCtrl', function ($scope, $state, $stateParams, $rootScope, $cacheFactory, $ionicNativeTransitions, $cordovaMedia, fileUtil, $sce, $timeout) {
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);

        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }
        //服药计划缓存
        var plan_cache = $cacheFactory.get('plan');
        if (!plan_cache) {
            plan_cache = $cacheFactory('plan');
        }
        var form = user_cache.get('remind');
        if (!form) {
            form = {
                remarkTimeDesc: null,
                remarkUrl: null,
                remarkTime: null,
                remarkId: null,
                showRemind: 0,
                remarkText: null
            };
        }
        $scope.form = form;
        /**
         * 回退的时候判断文本内容是否存在
         */
        if ($scope.form.remarkText) {
            $scope.form.showRemind = 0;
            $(".z_voice").css('background-image', 'url(img/z_speakOff.png)');
        }
        var freqForm = plan_cache.get('freq');
        if (!freqForm) {
            freqForm = {
                number: 3,
                desc: '一天三次',
                beginTime: date2str(new Date(), 'yyyy-MM-dd'),
                freqInfo: getFreqInfo(3)
            };
            plan_cache.put("freq", freqForm);
        }
        $scope.freqForm = freqForm;
        $timeout(function () {
            for (var i = 0; i < 10; i++) {
                $('#zz_setFreqTime_' + i).mobiscroll().time({
                    theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
                    mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
                    display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
                    lang: 'zh',        // Specify language like: lang: 'pl' or omit setting to use default
                    steps: {
                        minute: 5,
                        second: 5,
                        zeroBased: true
                    },
                    cancelText: '取消',
                    setText: '确定'
                });
            }
        }, 1000);
        $scope.setFreqTime = function (index) {
            $('#zz_setFreqTime_' + index).trigger('click');
        };
        var cycleForm = plan_cache.get('cycle');
        if (!cycleForm) {
            cycleForm = {
                type: '每天',
                takeDay: 1,
                desc: '每天'
            };
            plan_cache.put("cycle", cycleForm);
        }
        $scope.cycleForm = cycleForm;

        /**
         * 设置周期
         */
        $scope.period = function () {
            $("input").blur();
            $timeout(function () {
                $ionicNativeTransitions.stateGo('drug_cycle', {backUrl: 'drug_remind'}, {
                    "type": "slide",
                    "direction": "left",
                    "duration": 500
                });
            }, 400)
        };


        /**
         * 设置用药频率
         */
        $scope.setFreq = function (number) {
            $("input").blur();
            $timeout(function () {
                $ionicNativeTransitions.stateGo('drug_frequency', {backUrl: 'drug_remind'}, {
                    "type": "slide",
                    "direction": "left",
                    "duration": 500
                });
            }, 400)
        };
        /**
         * 设置服药开始时间
         */
        var currYear = new Date().getFullYear();
        $('#zz_beginTime').mobiscroll().date({
            theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
            mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
            dateFormat: 'yyyy-mm-dd',
            display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
            lang: 'zh',        // Specify language like: lang: 'pl' or omit setting to use default
            startYear: currYear - 1, //开始年份
            endYear: currYear + 1 //结束年份
        });
        /**
         * 编辑药品提醒时钟
         */
        $scope.remindEdit = function () {
            $ionicNativeTransitions.stateGo('remind_edit', {backUrl: 'drug_remind'}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        };

        //媒体对象
        var media = null;
        //录音文件存储路径
        var remarkSrc = null;
        //录音时间计算变量
        var startTime = null;

        /**
         * 开始录音
         */
        $scope.startRecord = function () {
            if ($scope.form.remarkText) {
                return;
            }
            $("#zz_msg_voice").css("display", "block");
            $("#zz_cancel").css("display", "none");
            $("#zz_exit").css("display", "none");
            $("#zz_show_voice").css("display", "block");
            //开始监听录音的声音的分贝
            /*change_db();*/
            remarkSrc = new Date().getTime() + ".amr";
            remarkSrc = window.devicePath + 'HealthPatient/audio/' + remarkSrc;
            media = $cordovaMedia.newMedia(remarkSrc);
            startTime = new Date().getTime();
            media.startRecord();
        };

        /**
         * 停止录音
         */
        $scope.stopRecord = function () {
            $("#zz_msg_voice").css("display", "none");
            /*stop_db();*/
            media.stopRecord();
            media.release();
            //计算录音时差
            var audioTime = new Date().getTime() - startTime;
            if (audioTime < 1000) {
                return;
            }
            audioTime = Math.floor(audioTime / 1000);
            $scope.form.remarkTimeDesc = changeTimeType(audioTime);
            fileUtil.upload(remarkSrc, "audio", "/patient/user/file/upload.htm", $rootScope.token).then(function (data) {
                $scope.form.remarkTime = audioTime;
                $scope.form.remarkUrl = $sce.trustAsResourceUrl(data.url);
                $scope.form.remarkId = data.fileId;
                $('#zz_remarkText').css('display', 'none');
                $scope.form.showRemind = 1;
            }, function (error) {
            });
        };
        $scope.remarkPlay = function () {
            $("#zz_remark")[0].play();
        };

        /**
         * 保存用药计划
         */
        $scope.save = function () {
            $("input").blur();
            user_cache.put("remind", $scope.form);
            $timeout(function () {
                $ionicNativeTransitions.stateGo('drug_confirm', {backUrl: 'drug_remind'}, {
                    "type": "slide",
                    "direction": "left",
                    "duration": 500
                });
            }, 400)
        };

        /**
         * 返回
         */
        $scope.goBack = function () {
            $("input").blur();
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $timeout(function () {
                $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                    "type": "slide",
                    "direction": "right",
                    "duration": 500
                });
            }, 400)
        };
        /**
         * 收到物理返回键按钮事件
         */
        $rootScope.$on('HARDWARE_BACK', function () {
            $scope.goBack();

        });
        $scope.isEnter = function () {
            if ($scope.form.remarkText) {
                $(".z_voice").css('background-image', 'url(img/z_speakOff.png)');
                var count = $scope.form.remarkText.replace(/[^\x00-\xff]/g, "**").length;
                if (count > 70) {
                    $scope.form.remarkText = $scope.form.remarkText.substr(0, 70);
                }
            } else {
                $(".z_voice").css('background-image', 'url(img/z_speakOn.png)');
            }
        };
    })
    //用药频率设置（一天几次）
    .controller('DrugFreqCtrl', function ($scope, $state, $stateParams, $cacheFactory, $ionicNativeTransitions, $rootScope) {
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);

        var plan_cache = $cacheFactory.get('plan');
        if (!plan_cache) {
            plan_cache = $cacheFactory('plan');
        }

        var form = plan_cache.get('freq');
        if (!form) {
            form = {
                number: 3,
                desc: '一天三次',
                freqInfo: getFreqInfo(3)
            };
        }
        $scope.form = form;

        /**
         * 设置服药频率
         * @param number 一天次数
         */
        $scope.setFreq = function (number) {
            $scope.form.number = number;
            $scope.form.desc = $rootScope.freqDesc[number];
            plan_cache.put("freq", $scope.form);
        };

        /**
         * 加次数
         */
        $scope.add = function () {
            if ($scope.form.number < 10) {
                $scope.form.number++;
            }
        };

        /**
         * 减次数
         */
        $scope.sub = function () {
            if ($scope.form.number > 1) {
                $scope.form.number--;
            }
        };

        /**
         * 保存用药计划
         */
        $scope.confirm = function () {
            $scope.form.desc = $rootScope.freqDesc[$scope.form.number];
            $scope.form.freqInfo = getFreqInfo($scope.form.number);
            plan_cache.put('freq', $scope.form);
            //取出回退页面跳转参数
            var param = $cacheFactory.get('drug_remind');
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo('drug_remind', sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };

        /**
         * 返回
         */
        $scope.goBack = function () {
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
    })
    //剂量控制器
    .controller('DrugDosageCtrl', function ($scope, $state, $stateParams, $cacheFactory, $ionicNativeTransitions) {
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);
        //服药计划缓存
        var plan_cache = $cacheFactory.get('plan');
        if (!plan_cache) {
            plan_cache = $cacheFactory('plan');
        }
        var medicineInfo = plan_cache.get('medicineInfo');
        if (!medicineInfo.medicineUnit) {
            medicineInfo.medicineUnit = '单位';
        }
        if (!medicineInfo.medicineCount) {
            medicineInfo.medicineCount = 1;
        }
        $scope.form = medicineInfo;
        //   $scope.form.medicineUnit = plan_cache.get('medicineUnit');
        /**
         * 设置单位
         */
        $scope.unit = function () {
            plan_cache.put('medicineInfo', $scope.form);
            $ionicNativeTransitions.stateGo('drug_unit', {backUrl: 'drug_dosage'}, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };

        /**
         * 保存用药计划
         */
        $scope.confirm = function () {
            //取出回退页面跳转参数
            var param = $cacheFactory.get('drug_remind');
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo('drug_remind', sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };

        /**
         * 编辑药品提醒时钟
         */
        $scope.remindEdit = function () {
            $ionicNativeTransitions.stateGo('remind_edit', {backUrl: 'drug_remind'}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        };

        /**
         * 返回
         */
        $scope.goBack = function () {
            //获取输入的数量
            plan_cache.put('medicineInfo', $scope.form);
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
    })
    .controller('DrugUnitCtrl', function ($scope, $state, $stateParams, $cacheFactory, $ionicNativeTransitions, $timeout) {

        var plan_cache = $cacheFactory.get('plan');
        if (!plan_cache) {
            plan_cache = $cacheFactory('plan');
        }

        var medicineInfo = plan_cache.get('medicineInfo');
        if (!medicineInfo.medicineUnit) {
            medicineUnit = '药片';
        }
        $scope.form = medicineInfo;

        /**
         * 设置单位
         */

        $scope.setUnit = function (medicineUnit) {
            $scope.form.medicineUnit = medicineUnit;
            plan_cache.put('medicineInfo', $scope.form);
            $timeout(function () {
                $scope.goBack();
            }, 1000);
        };
        $scope.confirm = function () {
            plan_cache.put('medicineInfo', $scope.form);
            $scope.goBack();
        };

        /**
         * 返回
         */
        $scope.goBack = function () {
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
    })
    .controller('DrugCycleCtrl', function ($scope, $state, $stateParams, $cacheFactory, $ionicNativeTransitions, $rootScope, $timeout) {
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);

        //计划缓存
        var plan_cache = $cacheFactory.get('plan');
        if (!plan_cache) {
            plan_cache = $cacheFactory('plan');
        }

        var form = plan_cache.get('cycle');
        if (!form) {
            form = {
                type: '每天',
                takeDay: '1'
            }
        }
        $scope.form = form;
        /**
         * 设置一周哪些天服药
         */
        $scope.setWeekDay = function () {
            $ionicNativeTransitions.stateGo('drug_week', {backUrl: 'drug_cycle'}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        };

        /**
         * 设置服药周期
         * @param type 周期类型
         */
        $scope.setPeriod = function (type) {
            // $scope.form.type = null;
            $scope.form.type = type;
        };
        /**
         * 加次数
         */
        $scope.add = function () {
            $scope.form.takeDay++;
        };

        /**
         * 减次数
         */
        $scope.sub = function () {
            if ($scope.form.takeDay > 1) {
                $scope.form.takeDay--;
            }
        };

        $scope.confirm = function () {
            $("input").blur();
            if ($scope.form.type == '单日') {
                $scope.form.desc = '单日';
            } else if ($scope.form.type == '每天') {
                $scope.form.desc = '每天';
            } else if ($scope.form.type == '连续') {
                if (!$scope.form.takeDay) {
                    $scope.form.takeDay = 1;
                }
                $scope.form.desc = $scope.form.type + $scope.form.takeDay + '天';
            }
            plan_cache.put('cycle', $scope.form);
            //取出回退页面跳转参数
            var param = $cacheFactory.get('drug_remind');
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $timeout(function () {
                $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                    "type": "slide",
                    "direction": "right",
                    "duration": 500
                });
            }, 400);
        };

        /**
         * 返回
         */
        $scope.goBack = function () {
            $("input").blur();
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $timeout(function () {
                $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                    "type": "slide",
                    "direction": "right",
                    "duration": 500
                });
            }, 400);
        };
    })

/**
 * 药物确认提交（liushangqing)
 */
    .controller('DrugConfirmCtrl', function ($scope, $state, $stateParams, $cacheFactory, $ionicNativeTransitions, $rootScope, drugService, WebSql, $ionicPopup, $timeout, fileUtil, $cordovaMedia, $sce) {
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);
        var plan_cache = $cacheFactory.get('plan');
        var medicineInfo = plan_cache.get('medicineInfo');  //药品信息
        if (!plan_cache) {
            //alert("plan_cache不存在");
            return false;
        }
        var user_cache = $cacheFactory.get('user');
        $scope.form = medicineInfo;
        var remind = user_cache.get("remind");
        var cycle = plan_cache.get("cycle");
        if (!cycle) {
            // alert("cycle缓存不存在");
            return false;
        }
        $scope.cycle = cycle;
        if (!remind) {
            //alert("remind缓存不存在");
            return false;
        }
        $scope.remind = remind;
        var freqForm = plan_cache.get('freq');
        if (!freqForm) {
            // alert("freq缓存不存在");
            return false;
        }
        $scope.remindTime = '';
        var takeTime = '';
        //获取提醒时间
        console.log(freqForm.freqInfo);
        for (var i = 0; i < freqForm.freqInfo.length; i++) {
            $scope.remindTime = $scope.remindTime + freqForm.freqInfo[i].freqTime + ' ';
            takeTime = takeTime + freqForm.freqInfo[i].freqTime + ',';
            /*            if (freqForm.freqInfo[i].freqTime.substring(0, 1) == '上' || freqForm.freqInfo[i].freqTime.substring(0, 1) == '中') {
             takeTime = takeTime + freqForm.freqInfo[i].freqTime.substr(2, freqForm.freqInfo[i].freqTime.length) + ',';
             } else {
             var temp = parseInt(freqForm.freqInfo[i].freqTime.substring(2, 4)) + 12;
             var tempStr = freqForm.freqInfo[i].freqTime.replace(freqForm.freqInfo[i].freqTime.substring(2, 4), temp);
             takeTime = takeTime + tempStr.substr(2, tempStr.length) + ',';
             }*/
        }
        //媒体对象
        var media = null;
        //录音文件存储路径
        var remarkSrc = null;
        //录音时间计算变量
        var startTime = null;

        /**
         * 开始录音
         */
        $scope.startRecord = function () {
            if ($scope.remind.remarkText) {
                return;
            }
            $("#zz_msg_voice").css("display", "block");
            //$("#zz_cancel").css("display", "none");
            $("#zz_show_voice").css("display", "block");
            remarkSrc = new Date().getTime() + ".amr";
            remarkSrc = window.devicePath + 'HealthPatient/audio/' + remarkSrc;
            media = $cordovaMedia.newMedia(remarkSrc);
            startTime = new Date().getTime();
            media.startRecord();
        };

        /**
         * 停止录音
         */
        $scope.stopRecord = function () {
            $("#zz_msg_voice").css("display", "none");
            media.stopRecord();
            //计算录音时差
            var audioTime = new Date().getTime() - startTime;
            if (audioTime < 1000) {
                return;
            }
            audioTime = Math.floor(audioTime / 1000);
            $scope.remind.remarkTimeDesc = changeTimeType(audioTime);
            fileUtil.upload(remarkSrc, "audio", "/patient/user/file/upload.htm", $rootScope.token).then(function (data) {
                $scope.remind.remarkTime = audioTime;
                $scope.remind.remarkUrl = $sce.trustAsResourceUrl(data.url);
                $scope.remind.remarkId = data.fileId;
                $scope.remind.showRemind = 1;

            }, function (error) {
            });
        };
        $scope.remarkPlay = function () {
            $("#zz_remark")[0].play();
        };
        var step = 0;
        var term = getType(cycle.type);
        var likUser = user_cache.get("likUser");
        $scope.likUser = likUser;
        var toUserId = likUser.toUser;
        $scope.userName = likUser.userName;
        var beginTime = freqForm.beginTime;
        var takeDay = cycle.takeDay;
        var remarkId = $scope.remind.remarkId;
        var remarkTime = $scope.remind.remarkTime;
        var remarkText = $scope.remind.remarkText;
        if (!remarkTime && !remarkText) {
            $scope.remind.showRemind = 0;
        } else if (remarkTime) {
            $scope.remind.showRemind = 1;
        } else {
            $scope.remind.showRemind = 2;
            $(".z_voice").css('background-image', 'url(img/z_speakOff.png)');
        }
        var medicineColor = medicineInfo.medicineColor;
        var medicineShape = medicineInfo.medicineShape;  //药品外观中文名称
        var medicineUrl = medicineInfo.medicineImgSrc;
        var unit = medicineInfo.medicineUnit;  //服药单位
        var medicineId = medicineInfo.medicineId;
        var dosage = medicineInfo.medicineCount;  //剂量
        var medicineName = medicineInfo.medicineName;
        var kitAppearance = medicineInfo.kitAppearance;  //药盒外观
        var manufacture = medicineInfo.manufacture;     //药厂名称
        console.log("toUser:" + toUserId + "\n" + "step:" + step + "\n" + "term:" + term + "\n" + "takeTime:" + takeTime + "\n"
                + "beginTime:" + beginTime + "\n" + "remarkId:" + remarkId + "\n" + "remarkTime:" + remarkTime + "\n" + "takeDay:" + takeDay + "\n" + "medicineColor:" + medicineColor
                + "\n" + "medicineShape:" + medicineShape + "\n" + "unit:" + unit + "\n" + "dosage:" + dosage + "\n"
                + "medicineName:" + medicineName + "\n" + "KitAppearance:" + kitAppearance + "\n"
        );
        var addTime = 0;
        $scope.postDrugPlan = function () {
            drugService.addDrugPlan(toUserId, step, beginTime, remarkId,
                takeDay, medicineColor, medicineShape, unit, remarkTime,
                dosage, medicineName, kitAppearance, term, takeTime, remarkText, manufacture).then(function (data) {
                    addTime = new Date().getTime();
                    WebSql.insertTakeMedicine($rootScope.user.userId, medicineId, medicineName, dosage, unit, medicineShape, kitAppearance, "", medicineUrl, medicineColor);
                    plan_cache.destroy();
                    user_cache.remove("remind");
                    $scope.addMedicine = $ionicPopup.show({
                        template: '<div class="z_addSucc">已经成功添加！</div>',
                        scope: $scope
                    });
                    $scope.$emit('addMedicineSuccess', {plan: data.data});
                    var s = $cacheFactory.get("add_drug");
                    var p = s.get("stateParams");
                    $timeout(function () {
                        $scope.addMedicine.close();
                        $ionicNativeTransitions.stateGo(p.backUrl, {}, {
                            "type": "slide",
                            "direction": "right",
                            "duration": 500
                        });
                    }, 1500);
                }, function (error) {
                    addTime = new Date().getTime();
                    $scope.remindDiloge = $ionicPopup.show({
                        template: '<div class="z_addSuc" style="text-align: center;">请检查您的网络,5s后再试</div>',
                        scope: $scope
                    });
                    $("#zz_save").attr("disabled", true);
                    $timeout(function () {
                        $scope.remindDiloge.close();
                    }, 600);
                    $timeout(function () {
                        $("#zz_save").attr("disabled", false);
                    }, 5000);
                    return;
                });
        };
        /**
         * 获取禁忌信息
         */
        drugService.getMedicineForbid(medicineName).then(function (data) {
            if (!data.data.forbid) {
                $scope.showId = 0;
                return;
            } else {
                $scope.medicineForbid = data.data.forbid;
                $scope.showId = 1;
            }

        }, function (error) {

        });
        /**
         * 回到时间提醒页面
         */
        $scope.goBackRemind = function () {
            user_cache.put('remind', $scope.remind);
            $ionicNativeTransitions.stateGo('drug_remind', {backUrl: 'add_drug'}, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
        /**
         * 回到添加药物页面
         */
        $scope.goBackAddDrug = function () {
            user_cache.put('remind', $scope.remind);
            var s = $cacheFactory.get("add_drug");
            var p = s.get("stateParams");
            $ionicNativeTransitions.stateGo('add_drug', {backUrl: p.backUrl}, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };

        /**
         * 返回
         */
        $scope.goBack = function () {
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
        /**
         * 收到物理返回键按钮事件
         */
        $rootScope.$on('HARDWARE_BACK', function () {
            $scope.goBack();
        });
        $scope.isEnter = function () {
            if ($scope.remind.remarkText) {
                $(".z_voice").css('background-image', 'url(img/z_speakOff.png)');
                var count = $scope.form.remarkText.replace(/[^\x00-\xff]/g, "**").length;
                if (count > 70) {
                    $scope.form.remarkText = $scope.form.remarkText.substr(0, 70);
                }
            } else {
                $(".z_voice").css('background-image', 'url(img/z_speakOn.png)');
            }
        };
        $scope.goAddDrug = function () {

        }
    }
)

    //药品外观设置(形状)
    .
    controller('DrugSurfaceCtrl', function ($scope, $state, $stateParams, $cacheFactory, $ionicNativeTransitions, $ionicScrollDelegate, Surface, $timeout, $rootScope, $window) {
        var url = "";
        var colorZh = null;
        var shapeZh = null;
        var colorEn = null;
        var shapeEn = null;
        var colorLeft = 0;
        var shapeLeft = 0;
        var preIndex = 3;
        var preIndex2 = 3;
        var mcolor = 0;    //颜色在数组中的索引
        var mshape = 6;   //形状在数组中的索引
        //声明一个缓存，用来存放位置信息
        var cache = $cacheFactory.get('drugSurfaceCache');
        if (!cache) {
            cache = $cacheFactory('drugSurfaceCache');
        }

        var plan_cache = $cacheFactory.get('plan');        //存放药品外观的缓存
        var medicineInfo = {};
        if (plan_cache) {
            medicineInfo = plan_cache.get('medicineInfo');
            mcolor = Surface.getColorByZh(medicineInfo.medicineColor);
            mshape = Surface.getShapeByZh(medicineInfo.medicineShape);
            console.log("颜色索引：" + mcolor + "\n" + "性状索引：" + mshape);
        }
        if (mcolor != null && mshape != null) {
            $timeout(function () {
                $ionicScrollDelegate.$getByHandle('shape').scrollBy(mshape * 55, 0);
                $ionicScrollDelegate.$getByHandle('color').scrollBy(mcolor * 53, 0);
                mcolor = null;
                mshape = null;
            });
        } else if (cache.get('colorLeft') && cache.get('shapeLeft')) {
            colorLeft = cache.get('colorLeft');
            shapeLeft = cache.get('shapeLeft');
            $timeout(function () {
                $ionicScrollDelegate.$getByHandle('shape').scrollBy(shapeLeft, 0);
                $ionicScrollDelegate.$getByHandle('color').scrollBy(colorLeft, 0);
            });
        } else {
            $timeout(function () {
                $ionicScrollDelegate.$getByHandle('shape').scrollBy(160, 0);
                $ionicScrollDelegate.$getByHandle('color').scrollBy(160, 0);
            });
        }

        var plan_cache = $cacheFactory.get('plan');
        if (!plan_cache) {
            plan_cache = $cacheFactory('plan');
        }

        var preEle = $("#shapeResult li:eq(0) img");
        var preSrc = preEle.attr("src");
        var preClass = "large";

        //监听性状滑动
        $scope.shape_scroll = function () {
            var shapeLength = $ionicScrollDelegate.$getByHandle('shape').getScrollPosition().left;
            var colorLength = $ionicScrollDelegate.$getByHandle('color').getScrollPosition().left;
            var sindex = Math.ceil(shapeLength / 55.5);
            preIndex = sindex;
            var cindex = Math.ceil(colorLength / 53.7);
            shapeEn = Surface.getShape(sindex).en;
            colorEn = Surface.getColor(cindex).rgb;
            shapeZh = Surface.getShape(sindex).zh;
            colorZh = Surface.getColor(cindex).zh;
            url = "img/shape_color/" + colorEn + "/" + shapeEn + "_" + colorEn + ".png";
            plan_cache.put("shapeEn", shapeEn);
            plan_cache.put("colorEn", colorEn);
            plan_cache.put("shapeZh", shapeZh);
            plan_cache.put("colorZh", colorZh);
            var nEle = $("#shapeResult li:eq(" + sindex + ") img");
            if (nEle != preEle) {
                preEle.attr("src", preSrc);
                preEle.removeClass("large");
                preSrc = nEle.attr("src");
                preClass = nEle.attr("class");
                nEle.attr("src", url);
                nEle.addClass("large");
                preEle = nEle;
            }
            cache.put('colorLeft', colorLength);
            cache.put('shapeLeft', shapeLength);
            //   $("#testimg").attr("src", url);
        };
        //点击让形状滑动
        var shape_result = document.getElementById("shapeResult");
        shape_result.onclick = function (e) {
            var element = getEleFromPoint(e);
            if (element.nodeName !== 'IMG') {
                return;
            }
            var src = element.src;
            var index = src.lastIndexOf("/") + 1;
            var end = src.lastIndexOf("_");
            var rs = src.substring(index, end);  //得到shape英文
            var sObj = Surface.getShapeByEn(rs);
            console.log(sObj);
            shape_en = sObj.obj.en;
            $ionicScrollDelegate.$getByHandle('shape').scrollBy(55 * (sObj.index - preIndex), 0);
            preIndex = sObj.index;
            //放到缓存，供其他页面使用
            plan_cache.put("shapeEn", shape_en);
            plan_cache.put("colorEn", colorEn);
            plan_cache.put("shapeZh", sObj.obj.zh);
            plan_cache.put("colorZh", colorZh);
        };

        //点击让颜色滑动
        var color_result = document.getElementById("colorResult");
        color_result.onclick = function (e) {
            var element = getEleFromPoint(e);
            if (element.nodeName === 'SPAN') {
                var title = element.title;
                color_en = title;
                var color = Surface.getColorByRgb(title);
                $ionicScrollDelegate.$getByHandle('color').scrollBy(53 * (color.index - preIndex2), 0);
                preIndex2 = color.index;
                //放到缓存，供其他页面使用
                plan_cache.put("shapeEn", shapeEn);
                plan_cache.put("colorEn", color_en);
                plan_cache.put("shapeZh", shapeZh);
                plan_cache.put("colorZh", color.obj.zh);
            }

        };


        //监听颜色滑动
        $scope.color_scroll = function () {
            var shapeLength = $ionicScrollDelegate.$getByHandle('shape').getScrollPosition().left;
            var colorLength = $ionicScrollDelegate.$getByHandle('color').getScrollPosition().left;
            var sindex = Math.ceil(shapeLength / 55.5);
            var cindex = Math.ceil(colorLength / 53.7);
            preIndex2 = cindex;
            shapeEn = Surface.getShape(sindex).en;
            colorEn = Surface.getColor(cindex).rgb;
            shapeZh = Surface.getShape(sindex).zh;
            colorZh = Surface.getColor(cindex).zh;
            url = "img/shape_color/" + colorEn + "/" + shapeEn + "_" + colorEn + ".png";
            plan_cache.put("shapeEn", shapeEn);
            plan_cache.put("colorEn", colorEn);
            plan_cache.put("shapeZh", shapeZh);
            plan_cache.put("colorZh", colorZh);
            var nEle = $("#shapeResult li:eq(" + sindex + ") img");
            if (nEle != preEle) {
                preEle.attr("src", preSrc);
                preEle.removeClass("large");
                preSrc = nEle.attr("src");
                preClass = nEle.attr("class");
                nEle.attr("src", url);
                nEle.addClass("large");
                preEle = nEle;
            }
            cache.put('colorLeft', colorLength);
            cache.put('shapeLeft', shapeLength);
//            console.log(cache.get('colorLeft'));
            //$("#testimg").attr("src", url);
        };

        $scope.confirm = function () {
            console.log(plan_cache.get('flag'));
            var medicineInfo = plan_cache.get('medicineInfo');
            $scope.form = medicineInfo;
            $scope.form.medicineColor = colorZh;
            $scope.form.medicineShape = shapeZh;
            $scope.form.medicineImgSrc = url;
            plan_cache.put("medicineInfo", $scope.form);
            $scope.goBack();
        };

        /**
         * 返回
         */
        $scope.goBack = function () {
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
        /**
         * 收到物理返回键按钮事件
         */
        $rootScope.$on('HARDWARE_BACK', function () {
            $scope.goBack();
        });
    })
    .controller('DrugShareCtrl', function ($scope, $state, $stateParams, $rootScope, imageUtil, $ionicActionSheet, drugService, fileUtil, Mes, $ionicNativeTransitions, $cacheFactory, $ionicSlideBoxDelegate, $ionicLoading) {
        $scope.showFlag = false;
        $scope.imgFlag = false; //缩放图片显示与否
        $scope.canShared = false;
        /*QQ.setOptions({
         appId: 'nnn',
         appName: 'TestQQ',
         appKey: 'xxx'
         });*/
        console.log('value:' + document.getElementById("sharetitle").value);
        $scope.showimg = false;
        $scope.imgurl = "img/z_illed.jpg";
        $scope.selectImageByCamera = function () {
            imageUtil.takePhoto(400, 400, Camera.DestinationType.FILE_URI).then(function (data) {
                $ionicLoading.show({
//                    templateUrl: 'uploadImg_loading.html'
                    template: '正在上传......'
                });
                imageUtil.uploadImages(data, "/message/image/uploadImg.htm", $rootScope.token).then(function (ret) {
                    if (ret.status == 1) {
                        $scope.showimg = true;
                        $scope.imgurl = ret.url;
                        $scope.canShared = false;
                        $ionicLoading.hide();
                    }
                    $ionicLoading.hide();
                }, function (e) {
                    $ionicLoading.hide();
                    $scope.canShared = true;
                    ErrorShow("图片上传失败");

                })

            }, function (e) {
                $ionicLoading.hide();
            });
        };

        $scope.selectImageByPic = function () {
            imageUtil.imagePick($rootScope.screenWidth, $rootScope.screenHeight).then(function (data) {
                console.info("imageUtil.imagePick...");
                $ionicLoading.show({
//                    templateUrl: 'uploadImg_loading.html'
                    template: '正在上传...'
                });
                if (data) {
                    imageUtil.uploadImages(data, "/message/image/uploadImg.htm", $rootScope.token).then(function (ret) {
                        console.info("uploadImages...")
                        if (ret.status == 1) {
                            $scope.showimg = true;
                            $scope.imgurl = ret.url;
                            $scope.canShared = false;
                            $ionicLoading.hide();
                        }
                    }, function (e) {
                        $ionicLoading.hide();
                        $scope.canShared = true;
                        ErrorShow("图片上传失败");
                    })
                } else {
                    $ionicLoading.hide();
                }

            }, function (e) {
                console.info("未选择图片...")
                $ionicLoading.hide();
            });
        }

        $scope.getthisvalue = function (a) {
            document.getElementById("sharetitle").value = a;

        }

        /*$scope.shareViaWechat = function (p_scene, title, desc, url, thumb, shareid) {
         // 创建消息体
         var msg = {
         message: {
         title: title,
         description: desc,
         thumb: thumb,
         media: {
         type: Wechat.Type.WEBPAGE,
         webpageUrl: url
         }
         },
         scene: p_scene
         }
         Wechat.share(msg, function () {
         var type = p_scene == Wechat.Scene.TIMELINE ? 0 : 1;
         //微信分享成功回调
         $scope.imgurl = "img/z_illed.jpg";
         Mes.addWechatShare(type, shareid).then(function (data) {
         $scope.goBack();
         }, function (error) {
         //alert(error);
         });
         }, function (reason) {
         alert('取消');
         drugService.deleteWeixinShare(shareid).then(function (ret) {
         if (ret.status == true) {
         console.log('取消分享删除成功');
         } else {
         //插入失败，另作处理
         }
         }, function (error) {
         });
         });
         };*/

        $scope.shareWechat = function (p_scene) {
            Wechat.isInstalled(function (installed) {
                if (installed) {
                    var title = document.getElementById("sharetitle").value;
                    if (title == null || title.length == 0) {
                        title = "天阴再久也会晴，生病再难受也会好。";
                    }
                    //测试库链接
                    var url = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + $rootScope.reqwxAppid + "&redirect_uri=" + $rootScope.reqUrlshare + "device/selectshoucang.do&response_type=code&scope=snsapi_userinfo&state=";
                    //正式库链接：
                    //var url = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx3fb4be70de453b37&redirect_uri=http://wx.sinoicity.com/device/selectshoucang.do&response_type=code&scope=snsapi_userinfo&state=";
                    var desc = title;
                    var thumb = $rootScope.reqUrl + "/app/img/healthpatient.png";
                    drugService.updateWeixinShare($rootScope.token, title, desc, $scope.imgurl, 0).then(function (ret) {
                        if (ret.status == true) {
                            url = url + ret.shareid;
                            var msg = {
                                message: {
                                    title: title,
                                    description: desc,
                                    thumb: thumb,
                                    media: {
                                        type: Wechat.Type.WEBPAGE,
                                        webpageUrl: url
                                    }
                                },
                                scene: p_scene
                            }
                            Wechat.share(msg, function () {
                                var type = p_scene == Wechat.Scene.TIMELINE ? 0 : 1;
                                //微信分享成功回调
                                $scope.imgurl = "img/z_illed.jpg";
                                Mes.addWechatShare(type, ret.shareid).then(function (data) {
                                    $scope.goBack();
                                }, function (error) {
                                    //alert(error);
                                });
                            }, function (reason) {
                                drugService.deleteWeixinShare(ret.shareid).then(function (ret) {
                                    if (ret.status == true) {
                                        console.log('取消分享删除成功');
                                    } else {
                                        //插入失败，另作处理
                                    }
                                }, function (error) {
                                });
                            });
                        } else {
                            //插入失败，另作处理
                        }
                    }, function (error) {
                        //alert(error);
                    });
                } else {
                    ErrorShow("您还没安装微信喔");
                    return;
                }

            }, function (e) {
                console.error(e);
            });


        };

        //分享到QQ
        $scope.qqShare = function () {
          YCQQ.checkClientInstalled(function () {
                var title = document.getElementById("sharetitle").value;
                if (title == null || title.length == 0) {
                    title = "天阴再久也会晴，生病再难受也会好。";
                }
                var args = {};
                //正式库链接
                var reqUrlQQ = '';
                if ($rootScope.reqQQAppid == '101327838') {
                    reqUrlQQ = 'wx.sinoicity.cn';//测试库
                } else {
                    reqUrlQQ = 'wx.sinoicity.com';//正式库
                }
                args.url = "https://graph.qq.com/oauth/show?which=ConfirmPage&display=pc&response_type=code&client_id=" + $rootScope.reqQQAppid + "&redirect_uri=http%3A%2F%2F" + reqUrlQQ + "%2Fdevice%2FshareToQQ.do%3FshareId%3D";
                //测试库链接
                //额，还没有
                args.title = title;
                args.description = "我生病啦，求安慰啊，呜呜呜";
                args.imageUrl = "http://appdemo.sinoicity.com:8080/HealthMonitor/app/img/healthpatient.png";
                args.appName = "心常态";
                drugService.updateWeixinShare($rootScope.token, title, args.description, $scope.imgurl, 1).then(function (ret) {
                    if (ret.status == true) {
                        args.url = args.url + ret.shareid + "&scope=get_user_info";
                      YCQQ.shareToQQ(function () {
                            console.log("进如sharetoQQ方法");
                            $scope.imgurl = "img/z_illed.jpg";
                            Mes.addWechatShare(2, ret.shareid).then(function (data) {
                                $scope.goBack();
                            }, function (error) {
                                //alert(error);
                            });
                        }, function (failReason) {
                            //alert(failReason);
                            drugService.deleteWeixinShare(ret.shareid).then(function (ret) {
                                if (ret.status == true) {
                                    console.log('取消分享删除成功');
                                } else {
                                    //插入失败，另作处理
                                }
                            }, function (error) {
                            });
                        }, args);
                    } else {
                        //插入失败，另作处理

                    }
                }, function (error) {
                    //alert(error);
                });
            }, function () {
                ErrorShow('请安装QQ客户端');
            });

        };

        $scope.showtankuang = function () {
            $scope.showFlag = true;
        }

        $scope.goOn = function () {
            $scope.showFlag = false;
        }

        //分享到朋友圈
        $scope.weiboShare = function () {
            $scope.shareWechat(Wechat.Scene.TIMELINE);
        };

        //分享给微信好友
        $scope.weixinShare = function () {
            $scope.shareWechat(Wechat.Scene.SESSION);
        };

        $scope.goBack = function () {
            $scope.imgFlag = false; //大图显示与否
            $scope.showFlag = false;
            $scope.imgurl = "img/z_illed.jpg";
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            document.getElementById("sharetitle").value = '';
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            //$ionicNativeTransitions.stateGo(sp = {}?'tab.home':$stateParams.backUrl, sp, {
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
        /**
         * 收到物理返回键按钮事件
         */
            // $rootScope.$on('HARDWARE_BACK', function () {
            //     $scope.goBack();
            // });
        document.addEventListener('backbutton', function () {
            $scope.goBack();
        }, false);
        /**
         * 看大图
         */
        $scope.viewBigImg = function () {
            $ionicSlideBoxDelegate.$getByHandle('imghandle').enableSlide(false);
            $scope.imgFlag = true;
        }

        $scope.hideImg = function () {
            $scope.imgFlag = false;
        }
    })
  .
    controller('hisDrugCtrl', function ($scope, $rootScope, $stateParams, $cacheFactory, $state, $ionicNativeTransitions) {

        //得到上一个页面传过来的参数
        $scope.image = "data:image/jpg;base64," + $stateParams.image;
        $scope.word = $stateParams.word;

    });


