angular.module('Ecg', [])

    .factory('EcgService', function ($http, $q, $rootScope) {
        // Might use a resource here that returns a JSON array
        return {
            //获取ecg各项指标
            getEcgData: function (ecgData) {
                var q = $q.defer();
                var req = {
                    method: 'POST',
                    url: $rootScope.reqUrl + "/healthdevice/analysisEcg.htm",
                    params: {
                        ecgData: ecgData
                    },
                    timeout: 10000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //上传ECG数据
            upLoadEcgData: function (ecgData, object) {
                var testtime = object.testTime.split(":");
                var time = parseInt(testtime[0]) * 60 + parseInt(testtime[1]);
                var q = $q.defer();
                var req = {
                    method: 'POST',
                    url: $rootScope.reqUrl + "/healthdevice/addEcgData.htm",
                    params: {
                        ecgData: ecgData,
                        token: $rootScope.token,
                        hrData: parseInt(object.xinLv),
                        af: object.fangChan == '无' ? 0 : 1,
                        pvc: parseInt(object.shiZao),
                        pac: parseInt(object.fangZao),
                        testTime: time, //测量时长
                        sportDes: object.sport,     //运动描述
                        feelDesc: object.look,  //表情描述
                        remark: object.remark
                    },
                    timeout: 10000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
          upLoadEcgDataAll: function (ecgData, ecgGear, startTime, count) {//上传二挡，三挡的心电数据
            var q = $q.defer();
            var req = {
              method: 'POST',
              url: $rootScope.reqUrl + "/healthdevice/addEcgSchemaData.htm",
              params: {
                ecgData: ecgData,
                token: $rootScope.token,
                ecgGear: ecgGear,
                startTime: startTime,
                count: count
              },
              timeout: 10000
            };
            $http(req).success(function (result) {
              if (result.status) {
                console.log("上传成功");
                q.resolve(result);
              } else {
                q.reject(result);
              }
            }).error(function (result) {
              q.reject("网络异常");
            });
            return q.promise;
          },
            //上传ECG数据
            getEcgDetail: function (number, userId) {
                var q = $q.defer();
                var req = {
                    method: 'POST',
                    url: $rootScope.reqUrl + "/healthdevice/getEcgDetail.htm",
                    params: {
                        runningNumber: number,
                        token: $rootScope.token,
                        userId: userId
                    },
                    timeout: 10000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            }
        };
    })

    .controller('TextController', function ($scope, $ionicNativeTransitions, $stateParams, $timeout, $interval, EcgService, $ionicPopup, $rootScope) {
        var address = $stateParams.address;
        $scope.Ecg = new Array();
        var intervalFlag = true;
        $("#zz_title_xt").html("正在连接");
        $scope.scan_for_connect = function () {
            bluetoothle.startScan(function (data) {//扫描
                if (data.status == 'scanResult') {
                    if (data.address == address) {//判断下扫描的地址是已配对的设备地址  一一对应
                        bluetoothle.stopScan(function () {
                            console.log("停止扫描成功1");
                        }, function () {
                        });
                        bluetoothle.connect(function (data) {
                            if (data.status == 'connected') {
                                $("#zz_title_xt").html("已连接");
                                bluetoothle.discover(function (data) {//发现设备的UUID
                                    bluetoothle.subscribe(function (data) {//接收终端传来的数据
                                        if (data.status == 'subscribed ') {
                                            console.log(" subscribed ");
                                        }
                                        if (data.status == 'subscribedResult') {
                                            $("#zz_title_xt").html("正在测量");
                                            if (intervalFlag) {
                                                $scope.interTime();
                                                intervalFlag = false;
                                            }
                                            var check_data = bluetoothle.encodedStringToBytes(data.value);
                                            var string = bluetoothle.bytesToString(check_data);
                                            var a = strToHexCharCode(string);
                                          if (a == '0xaaaa09080000000000c801002e') {  //数据传输结束标志
                                                $("#zz_title_xt").html("测量完成");
                                                $scope.$emit("ecg_stop");
                                                $interval.cancel(inter);
                                            } else if (a.indexOf('0b07') > 0) {
                                                var str = a.substr(a.indexOf('0b07') + 4, 20);
                                                var arr = stringToChar4To10(str);
                                                $scope.Ecg = $scope.Ecg.concat(arr);
                                                Convert16Scale(arr);
                                            }
                                        }
                                    }, function (e) {
                                        $("#zz_title_xt").html("测量完成");
                                        if ($scope.Ecg.length > 0) {
                                            $scope.$emit("ecg_stop");
                                        }
                                        $interval.cancel(inter);
                                    }, {
                                        "address": address,
                                        "service": 'FE70',//ffe0
                                        "characteristic": 'FE71',//ffe1
                                        "isNotification": true
                                    });
                                }, function () {
                                }, {
                                    "address": address
                                });
                            }
                        }, function () {//蓝牙连接失败
                            console.log("蓝牙连接失败");
                            //最终关闭蓝牙 close
                            bluetoothle.close(function () {
                                $scope.scan_for_connect();
                                console.log("蓝牙连接失败+close连接成功");
                            }, function () {
                                console.log("蓝牙连接失败+close连接失败");
                            }, {
                                "address": address
                            });
                        }, {
                            "address": address
                        });
                    }
                }
            }, function () {
                //alert("蓝牙扫描失败");
            }, {
                "services": [
                ],
                "allowDuplicates": false,
                "scanMode": bluetoothle.SCAN_MODE_LOW_LATENCY,
                "matchMode": bluetoothle.MATCH_MODE_AGGRESSIVE,
                "matchNum": bluetoothle.MATCH_NUM_MAX_ADVERTISEMENT,
                "callbackType": bluetoothle.CALLBACK_TYPE_ALL_MATCHES
            });
        };
        $scope.blue_scan = function () {
            bluetoothle.isScanning(function (data) {//判断蓝牙是否处于扫描状态
                if (data.isScanning) {
                    bluetoothle.stopScan(function () {
                        $scope.scan_for_connect();
                    }, function () {
                    });
                } else {
                    $scope.scan_for_connect();
                }
            });
        };
        //判断蓝牙是否初始化
        $scope.blue_isInit = function () {
            $scope.Ecg = new Array();
            bluetoothle.isInitialized(function (data) {
                if (data.isInitialized) {//如果蓝牙已经初始化
                    //判断蓝牙是否启用
                    bluetoothle.isEnabled(function (data) {
                        if (data.isEnabled) {
                            bluetoothle.isConnected(function (data) {
                                if (data.isConnected) {
                                    bluetoothle.disconnect(function () {
                                        $scope.blue_scan();
                                    }, function () {
                                    }, {
                                        "address": address
                                    });
                                } else {
                                    $scope.blue_scan();
                                }

                            }, function () {
                                bluetoothle.close(function () {
                                    console.log("蓝牙连接失败+close连接成功");
                                }, function () {
                                }, {
                                    "address": address
                                });
                                $scope.blue_scan();
                            }, {
                                "address": address
                            });

                        } else {
                            bluetoothle.enable(function () {//开启蓝牙
                            }, function () {
                            });
                            $timeout(function () {
                                //由于开启蓝牙成功的方法中不执行其他逻辑，所以采用延迟方法
                                $scope.blue_scan();
                            }, 3000);
                        }
                    });
                } else {
                    bluetoothle.initialize(function () {//初始化
                        //判断蓝牙是否启用
                        bluetoothle.isEnabled(function (data) {
                            if (data.isEnabled) {
                            } else {
                                bluetoothle.enable(function () {//开启蓝牙
                                }, function () {
                                });
                            }
                        });
                        $timeout(function () {//由于开启蓝牙成功的方法中不执行其他逻辑，所以采用延迟方法
                            $scope.blue_scan();
                        }, 3000);
                    }, function () {
                    }, {
                        "request": true,
                        "statusReceiver": false
                    });
                }
            });
        };
        $scope.form = {
            sport: '常规',
            look: '十分开心',
            remark: null,
            fangChan: '无',
            shiZao: 0,
            xinLv: 0,
            fangZao: 0,
            testM: 0,
            testS: 0,
            testTime: '00:00',
            hr: '0'
        }
        $scope.getEcgDate = function () {
            if ($scope.Ecg) {
                var ecgData = $scope.Ecg.join(",");
                EcgService.getEcgData(ecgData).then(function (res) {
                    //同步相应的数据
                    if (res.status == 1) {
                        $scope.form.xinLv = res.Hrate;
                        if (res.af == 0) {
                            $scope.form.fangChan = '无';
                        } else {
                            $scope.form.fangChan = '有';
                        }
                        $scope.form.shiZao = res.pvc;
                        $scope.form.fangZao = res.pac;
                    }
                }, function (error) {
                })
            }
        }
        /**
         * 测量时间
         */
        var inter;
        var sendCount = 0;
        $scope.interTime = function () {
            inter = $interval(function () {
                //每隔一秒钟去请求服务器查询各项数据
                if (sendCount > 10) {
                    $scope.getEcgDate();
                    sendCount = 0;
                }
                sendCount++;
                $scope.form.testS++;
                if ($scope.form.testM < 10) {
                    if ($scope.form.testS < 60) {
                        if ($scope.form.testS < 10) {
                            $scope.form.testTime = "0" + $scope.form.testM + ":0" + $scope.form.testS;
                        } else {
                            $scope.form.testTime = "0" + $scope.form.testM + ":" + $scope.form.testS;
                        }
                    } else {
                        $scope.form.testS = 0;
                        $scope.form.testM++;
                        $scope.form.testTime = "0" + $scope.form.testM + ":00";
                    }
                } else {
                    if ($scope.form.testS < 60) {
                        if ($scope.form.testS < 10) {
                            $scope.form.testTime = $scope.form.testM + ":0" + $scope.form.testS;
                        } else {
                            $scope.form.testTime = $scope.form.testM + ":" + $scope.form.testS;
                        }
                    } else {
                        $scope.form.testS = 0;
                        $scope.form.testM++;
                        $scope.form.testTime = $scope.form.testM + ":00";
                    }
                }
            }, 1000);
        };
        drawecg("ecg_background", "ecg_line");
        ecg();
        if (window.cordova) {
            $scope.blue_isInit();
        }
        /**
         * 切换测量时刻
         */
        $scope.sport = [true, false, false, false, false];
        var tempTop = null;
        $scope.clickSport = function (top) {
            if (top == tempTop) {
                return;
            } else {
                $scope.sport = [false, false, false, false, false];
                $scope.sport[top] = !$scope.sport[top];
            }
            tempTop = top;
        }
        /**
         * 切换表情
         */
        $scope.look = [true, false, false, false, false];
        var tempEnd = null;
        $scope.clickLook = function (end) {
            if (end == tempEnd) {
                return;
            } else {
                $scope.look = [false, false, false, false, false];
                $scope.look[end] = !$scope.look[end];
            }
            tempEnd = end;
        }
        //收到数据传输完成的广播
        var sportArray = ['常规', '休息', '运动前', '运动后', '最大'];
        var lookArray = ['十分开心', '心情愉悦', '一脸茫然', '心情失落', '十分沮丧'];
        $scope.$on('ecg_stop', function (evt) {
            $interval.cancel(inter);
            //显示测量东西
            $("#zz_foot").css("display", "block");
            $scope.$apply();
            //关闭连接
            $scope.cutblue();
        })
        $scope.cutblue = function () {
            if (window.cordova) {
                bluetoothle.disconnect(function () {
                }, function () {
                }, {
                    "address": address
                });
                bluetoothle.close(function () {
                }, function () {
                }, {
                    "address": address
                });
            }
        }
        /**
         * 点击保存
         */
        var saveTime = null;
        $scope.saveEcgData = function () {
            $interval.cancel(inter);
            $scope.cutblue();
            if (saveTime && new Date().getTime() - saveTime < 5000) {
                ErrorShow("操作太频繁了");
                return;
            }
            saveTime = new Date().getTime();
            for (var i = 0; i < $scope.sport.length; i++) {
                if ($scope.sport[i] == true) {
                    $scope.form.sport = sportArray[i];
                    break;
                }
            }
            for (var i = 0; i < $scope.look.length; i++) {
                if ($scope.look[i] == true) {
                    $scope.form.look = lookArray[i];
                    break;
                }
            }
            var ecgStr = $scope.Ecg.join(",");
            if ($scope.Ecg.length == 0) {
                ErrorShow("还未测量哦");
                return;
            }
            //上传数据
            EcgService.upLoadEcgData(ecgStr, $scope.form).then(function (res) {
                $scope.saveEcg = $ionicPopup.show({
                    template: '<div class="z_addSucc">保存成功！</div>',
                    scope: $scope
                });
                $timeout(function () {
                    $scope.saveEcg.close();
                    $rootScope.$broadcast("saveEcgSuccess");
                    $ionicNativeTransitions.stateGo('tab.health', {}, {
                        "type": "slide",
                        "direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
                        "duration": 400 // in milliseconds (ms), default 400
                    });
                }, 2000)
            }, function (error) {
                ErrorShow("网络异常");
            })
        }

        /**
         * 回到健康页面
         */
        $scope.goBack = function () {
            $interval.cancel(inter);
            $scope.cutblue();
            $ionicNativeTransitions.stateGo('tab.health', {}, {
                "type": "slide",
                "direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
                "duration": 400 // in milliseconds (ms), default 400
            });
        }
    })
    .controller('ecgDetailController', function ($http, $scope, $ionicNativeTransitions, $stateParams, $timeout, $interval, EcgService, $rootScope, $ionicScrollDelegate, $ionicGesture) {
        console.log(JSON.parse($stateParams.ecg));
        $scope.Ecg = JSON.parse($stateParams.ecg);
        $scope.form = {
            sport: '',
            look: '',
            remark: '无',
            fangChan: $scope.Ecg.AF,
            shiZao: $scope.Ecg.PVC,
            xinLv: parseInt($scope.Ecg.ECGHR) % 100,
            fangZao: $scope.Ecg.PAC,
            testTime: $scope.Ecg.ECGTIME,
            time: $scope.Ecg.time,
            hr: parseInt(parseInt($scope.Ecg.ECGHR) / 100)
        }
        var userId = $stateParams.userId;
        var ecgData = new Array();
        var arr = $scope.Ecg.ECGTIME.split(":");
        var time = parseInt(arr[0]) * 60 + parseInt(arr[1]);
        console.log("");
        time = Math.round(time / 60);
        $scope.getEcgDetail = function () {
            $("#zz_loadecg").css('display', 'block');
//            drawecg("detail_bg_ecg", "detail_line_ecg", time);
//            ecg();
            $("#zz_loadecg").css('display', "none");
            EcgService.getEcgDetail($scope.Ecg.number, userId).then(function (res) {
                console.log("心电图获取结果为：", res);
                if (res.status == 1) {
                    $scope.form.sport = res.sport;
                    $scope.form.look = res.feel;
                    $scope.form.testTime = getTestTime(res.testTime);
                    if (res.remark) {
                        $scope.form.remark = res.remark
                    }
//                    ecgData = res.ecgData.split(",");
//                    for (var i = 0; i < ecgData.length; i = i + 4) {
//                        var arr = [ecgData[i], ecgData[i + 1], ecgData[i + 2], ecgData[i + 3]];
//                        Convert16Scale(arr);
//                    }
                    //一整张心电图的像素长度以及图片的地址
                    $scope.ecgRes = {
                        Length: res.imgUrl[0],
                        imgUrl_1: res.imgUrl[1],
                        imgUrl_2: res.imgUrl[2],
                        imgUrl_3: res.imgUrl[3]
                    }
                    if (res.imgUrl) {
                        document.getElementById("image1").src = res.imgUrl[1];
                        document.getElementById("image2").src = res.imgUrl[2];
                        document.getElementById("image3").src = res.imgUrl[3];
                    }

                  console.log("心电图片地址!!!!!!!!!!!!!", res.imgUrl[1], res.imgUrl[2], res.imgUrl[3]);
                }
            }, function (error) {
                ErrorShow("网络异常");
            })
        }

        /**
         * 回到健康页面
         */
        $scope.goBack = function () {
            $ionicNativeTransitions.stateGo('tab.health', {}, {
                "type": "slide",
                "direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
                "duration": 400 // in milliseconds (ms), default 400
            });
        };
        var canvas = document.getElementById("detail_bg_ecg");
        $scope.ecgWidth = (7200 * time) / 100;
        $scope.range = {
            value: 0
        }

        var tempValue = $rootScope.screenWidth * 0.1;
        $ionicGesture.on('touchmove', function (e) {
            if (tempValue > e.changedTouches[0].clientX) {
                $ionicScrollDelegate.$getByHandle('detail_ecg').scrollBy(-$scope.ecgWidth, 0)
            } else {
                $ionicScrollDelegate.$getByHandle('detail_ecg').scrollBy($scope.ecgWidth, 0)
            }
            tempValue = e.changedTouches[0].clientX;
        }, angular.element(document.getElementById('zz_move_ecg')));
        $scope.scroll = function () {
            var left = $ionicScrollDelegate.$getByHandle('detail_ecg').getScrollPosition().left;
            $scope.range.value = Math.ceil((left / $scope.ecgRes.Length) * 100);
            $scope.$apply();
        }
        var intervalEcg = $interval(function () {
            if (document.readyState == "complete") {
//                   $("#zz_move_ecg").css("width",time * 7200);
//                $("#zz_detail_2").css("width", time * 7200);
                $interval.cancel(intervalEcg);
                $scope.getEcgDetail();
            }
        }, 1000)


    })
