angular.module('Filter', [])
    .filter('limit', function () {
        /**
         * param input 过滤内容
         * param length 过滤长度
         * return 过滤后内容
         */
        return function (input, length) {
            var ret = "";
            if (!input) {
                return ret;
            }
            var contentLength = input.length;
            if (contentLength > length) {
                ret = input.substr(0, length);
                ret = ret + "...";
            } else {
                ret = input;
            }
            return ret;
        }
    })

    .filter('to_trusted', function ($sce) {
        /**
         * 信任url
         */
        return function (text) {
            return $sce.trustAsResourceUrl(text);
        }
    })
    .filter('toFix', function () {
        /**
         * 保留2位精度
         */
        return function (data) {
            return parseFloat(data).toFixed(2);
        }
    })
    .filter('clear', function () {
        /**
         * 地址去掉逗号
         */
        return function (data) {
            return data.replace(",", "");
        }
    })
    .filter('sum', function () {
        /**
         * 求商品总件数
         */
        return function (data, list) {
            var number = 0;
            for (var i = 0; i < list.length; i++) {
                number += parseInt(list[i].productNumber);
            }
            return number;
        }
    })

  .filter('getDate', function () {
    /**
     * 地址去掉逗号
     */
    return function (data) {
      return date2str(new Date(data), 'yyyy/MM/dd hh:mm');
    }
  })

  .filter('getDateCn', function () {
    /**
     * 地址去掉逗号
     */
    return function (data) {
      data = parseInt(data);
      return date2str(new Date(data), 'yyyy年MM月dd日 hh:mm');
    }
  });










