angular.module('Health', ['Ecg'])

  .factory('healthService', function ($http, $q, $rootScope, $timeout, $cacheFactory) {
    // Might use a resource here that returns a JSON array
    return {
      //获取血压,血糖、心率、血氧数据
      healthindex: function (t_token, t_healthindex, self, userId, page) {
        var count = 7;
        if (t_healthindex == 'stepnum') {
          count = 8;
        }
        var q = $q.defer();
        var req = {
          method: 'GET',
          url: $rootScope.reqUrl + "/patient/user/healthData.htm",
          params: {
            token: t_token,
            healthIndex: t_healthindex,
            self: self,
            userId: userId,
            page: page,
            count: count
          },
          timeout: 5000
        };
        $http(req).success(function (result) {
          if (result.status) {
            q.resolve(result);
          } else {
            q.reject(result);
          }
        }).error(function (result) {
          q.reject("网络异常");
        });
        return q.promise;
      },
      userVerify: function (phone, code) {
        var q = $q.defer();
        var req = {
          method: 'GET',
          url: $rootScope.reqUrl + "/patient/user/alarm/user/verify.htm",
          params: {
            token: $rootScope.token,
            telephone: phone,
            vcode: code
          },
          timeout: 5000
        };
        $http(req).success(function (result) {
          //console.log("查询结果->" + JSON.stringify(result));
          if (result.status) {
            q.resolve(result);
          } else {
            q.reject(result);
          }
        }).error(function (result) {
          q.reject("网络异常");
        });
        return q.promise;
      }
    };

  })

  .controller('healthController', function ($scope, $rootScope, healthService, $state, $ionicNativeTransitions, $ionicSlideBoxDelegate, $timeout, buletoothService, drugService, DeviceData, $cacheFactory, $stateParams, userService, Loading, $ionicScrollDelegate, EcgService, $ionicPopup, $timeout) {
    $scope.width = 10;
    if ($rootScope.token) {
      Loading.show("running_woman", '健康');
    }
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    //定义健康大缓存
    var health_cache = $cacheFactory.get('health');
    if (!health_cache) {
      health_cache = $cacheFactory('health');
    }
    var self = true;        //默认查找自己的
    $scope.systemUserId = null;      //绑定用户的Id
    /**
     * 收到后台推送血压数据的广播
     */
    $rootScope.$on('CHECK_BP', function () {
      if ($scope.setIndexNull('bp')) {
        $scope.getData('bp', null, 1);
      }
    });
    $rootScope.$on('CHECK_BMI', function () {
      if ($scope.setIndexNull('bmi')) {
        $scope.getData('bmi', null, 1);
      }
    });
    /**
     * 收到后台推送血糖数据的广播
     */
    $rootScope.$on('CHECK_BS', function () {
      if ($scope.setIndexNull('XT1') && $scope.setIndexNull('XT2')) {
        $scope.getData('XT1', null, 1);
      }
    });
    /**
     * 收到后台推送心率数据的广播
     */
    $rootScope.$on('CHECK_HR', function () {
      if ($scope.setIndexNull('hr')) {
        $scope.getData('hr', null, 1);
      }
    });
    /**
     * 收到后台推送血氧数据的广播
     */
    $rootScope.$on('CHECK_OX', function () {
      if ($scope.setIndexNull('ox')) {
        $scope.getData('ox', null, 1);
      }
    });
    /**
     * 收到步数数据的广播
     */
    $rootScope.$on('CHECK_STEPNUM', function () {
      $scope.connect_flag = 4;
      $timeout(function () {
        $scope.connect_flag = 1;
        $scope.$apply();
        if ($scope.setIndexNull('stepnum')) {
          $scope.getData('stepnum', null, 1);
        }
      }, 1500)
    });
    /**
     * 收到睡眠数据的广播
     */
    $rootScope.$on('CHECK_SLEEP', function () {
      $scope.connect_flag = 4;
      $timeout(function () {
        if ($scope.setIndexNull('sleep')) {
          $scope.connect_flag = 1;
          $scope.$apply();
          $scope.getData('sleep', null, 1);
        }
      }, 1500);
    });
    /**
     * 上传数据失败
     */
    $rootScope.$on('CHECK_FAIL', function (evt, data) {
      $scope.connect_flag = 1;
      if ($scope.setIndexNull(data.type)) {
        $scope.getData(data.type, null, 1);
      }
    });
    /**
     * 设置刻度显示标记
     */
    $scope.flag = {
      index: 'bs'
    }
    $scope.latestData = new Object();
    console.log("健康报表token=" + $rootScope.token);
    //全局缓存
    var user_cache = $cacheFactory.get('user');
    if (!user_cache) {
      user_cache = $cacheFactory('user');
    }
    var alarm_users = user_cache.get('alarm_users');
    var systemUserId = user_cache.get('systemUserId');
    if (!systemUserId) {
      systemUserId = null;
      user_cache.put('systemUserId', systemUserId);
    }
    $scope.systemUserId = systemUserId;      //绑定用户的Id

    /**
     * 侧边栏点击事件
     */
    $scope.bindClick = function () {
      $timeout(function () {
        var div = $(".div");
        $('.btn').unbind('click');
        $(".btn").click(function () {
          if (div.hasClass("dest")) {
            div.removeClass("dest").animate({right: 0, top: 0}, 200);
            $(".tabs").animate({right: 0}, 200);
            $(".g_text2").animate({right: 0}, 200);
          } else {
            div.addClass("dest").animate({right: 80, top: 50}, 200);
            $(".tabs").animate({right: 80}, 200);
            $(".g_text2").animate({right: 80}, 200);
          }
        });
        var a = function () {
          div.removeClass("dest").animate({right: 0, top: 0}, 200);
          $(".tabs").animate({right: 0}, 200);
          $(".g_text2").animate({right: 0}, 200);
        };
        $(".g_xy_content3").unbind('click');
        $(".g_xy_content3").click(a);
        $(".tabs").unbind('click');
        $(".tabs").click(a);
        $(".z_title").unbind('click');
        $(".z_title").click(a);
        $(".g_top").click(a);
        $(".g_slide_img[bind=3]").unbind('click');
        $(".g_slide_img[bind=3]").click(a);
      }, 2000);
    };
    $scope.users = alarm_users;
    if (!alarm_users) {
      drugService.getUser().then(function (data) {
        user_cache.put('alarm_users', data.list);
        $scope.users = data.list;
      }, function (error) {
      });
    }
    /**
     * 接收添加用户成功的广播并刷新该页面用户的列表。
     */
    $rootScope.$on('addUserSuccess', function () {
      console.log("收到添加用户成功的广播");
      $scope.users = user_cache.get('alarm_users');
      console.log($scope.users);
      $scope.bindClick();
    });
    //收到删除用户的广播
    $rootScope.$on('delFriendSuccess', function () {
      console.log("收到删除用户的广播  ");
      $scope.users = user_cache.get('alarm_users');
      console.log($scope.users);
      $scope.bindClick();
    });
    $scope.bindClick();

    /**
     * 添加成员
     */
    $scope.addUser = function () {
      $ionicNativeTransitions.stateGo('g_my_information', {backUrl: 'tab.health'}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    };
    /**
     * 购买产品
     */
    $scope.buy = function () {
      $ionicNativeTransitions.stateGo('g_my_product', {backUrl: 'tab.health'}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    };
    // $scope.latestData.titleName = '血糖';
    $scope.showBlue = true;
    $scope.getData = function (index, id, page) {
      $("#zz_chose a").removeClass("g_nav_chose");
      if (index == 'XT1' || index == 'XT2') {
        $("#zz_bs").addClass("g_nav_chose");
        $("#XT1").css("display", "block");
        $("#XT2").css("display", "block");
        $("#hr").css("display", "none");
        $("#ox").css("display", "none");
        $("#bmi").css("display", "none");
        $("#bp").css("display", "none");
        $("#stepnum").css("display", "none");
        $("#sleep").css("display", "none");
        $("#ecg").css("display", "none");
      } else {
        $("#zz_" + index).addClass("g_nav_chose");
        $("#XT1").css("display", "none");
        $("#XT2").css("display", "none");
        $("#hr").css("display", "none");
        $("#ox").css("display", "none");
        $("#bmi").css("display", "none");
        $("#bp").css("display", "none");
        $("#stepnum").css("display", "none");
        $("#sleep").css("display", "none");
        $("#ecg").css("display", "none");
        $("#" + index).css("display", "block");
      }
      if (index == 'stepnum') {
        $("#zz_stepnum_tab").css("display", "block");
        $("#zz_sleep_tab").css("display", "none");
        $("#zz_enter_tab").css("display", "none");
      } else if (index == 'sleep') {
        $("#zz_stepnum_tab").css("display", "none");
        $("#zz_sleep_tab").css("display", "block");
        $("#zz_enter_tab").css("display", "none");
      } else if (index == 'ecg') {
        $("#zz_stepnum_tab").css("display", "none");
        $("#zz_sleep_tab").css("display", "none");
        $("#zz_enter_tab").css("display", "none");
      } else {
        $("#zz_stepnum_tab").css("display", "none");
        $("#zz_sleep_tab").css("display", "none");
        $("#zz_enter_tab").css("display", "block");
      }
      if (!id) {
        $scope.showBlue = true;
        $("#zz_health_enter").removeClass("g_other_r");
        self = true;
        $scope.systemUserId = id;
      } else {
        self = false;
        $scope.systemUserId = id;
        $scope.showBlue = false;
        $("#zz_health_enter").addClass("g_other_r");
      }
      user_cache.put("systemUserId", $scope.systemUserId);
      if (!index) {
        index = 'XT1';
      }
      if (index == 'ecg') {
        $scope.moreData = true;
        $("#zz_disNum").css("display", "none");
        $("#zz_number").css("display", "none");
        if ($scope.ecgData.length == 0) {
          $("#ecg").css("display", "none");
          $("#zz_xd_disnum").css("display", "block");
        }
        if (!$scope.systemUserId) {
          $("#zz_xt_text").css("display", "block");
          $("#zz_xt_text_ecg").css("display", "block");
        } else {
          $("#zz_xt_text").css("display", "none");
          $("#zz_xt_text_ecg").css("display", "none");
        }
        $scope.latestData.titleName = changeName(index, $scope.systemUserId, $scope.users)
      } else {
        $scope.moreData = false;
        $("#zz_xd_disnum").css("display", "none");
        $("#zz_xt_text").css("display", "none");
        $("#zz_xt_text_ecg").css("display", "none");
        if (!$scope[index + '_' + page]) {
          $scope[index + '_' + page] = new Object();
          console.log("准备请求发数据");
          healthService.healthindex($rootScope.token, index, self, $scope.systemUserId, page).then(function (data) {
            $scope.$broadcast('scroll.refreshComplete');
            Loading.hide('running_woman', "健康");
            // $scope.$emit('REFRESH_SUCCESS');
            // cache.put('network_error', false);
            if (!$scope.latestData) {
              $scope.latestData = new Object();
            }
            $scope[index + '_' + page].datas = data;
            if (data.page == 1) {
              if (!$scope['XT2_1'] && data.healthIndex == 'XT1') {
                $scope.getData('XT2', $scope.systemUserId, 1);
              }
              if (data.data.length > 0) {
                $("#zz_disNum").css("display", "none");
                $("#zz_number").css("display", "block");
                $scope.latestData.examTime = date2str(new Date(data.data[0].examTime), 'yyyy年MM月dd日 hh:mm');
                $scope.latestData.datas = $scope[index + '_' + page].datas;
                if (data.healthIndex == 'XT2') {
                  if ($scope['XT1_1'].datas.data.length > 0 &&
                    $scope[index + '_' + page].datas.data[0].examTime > $scope['XT1_1'].datas.data[0].examTime) {
                    $scope.latestData.examTime = date2str(new Date(data.data[0].examTime), 'yyyy年MM月dd日 hh:mm');
                    getTdata(data);
                    getShowSite(data);
                  } else if ($scope['XT1_1'].datas.data.length <= 0) {
                    $scope.latestData.examTime = date2str(new Date(data.data[0].examTime), 'yyyy年MM月dd日 hh:mm');
                    getTdata(data);
                    getShowSite(data);
                  }
                } else {
                  getTdata(data);
                  getShowSite(data);
                }
                $scope[index + '_' + page].examTime = $scope.latestData.examTime;
              } else {
                if (data.healthIndex == 'XT2' && $scope["XT1_1"].data.data.length > 0) {

                } else {
                  $("#zz_number").css("display", "none");
                  $("#zz_disNum").css("display", "block");
                }
              }
            }
            $scope.latestData.data = data;
            if (data.healthIndex != 'XT2') {
              $scope.latestData.page = data.page;
              $scope.latestData.healthIndex = data.healthIndex;
              console.log($scope.latestData.healthIndex)
              if (data.healthIndex == 'stepnum') {
                $scope.latestData.total = data.total;
                $scope.latestData.kcal = geKcal(data);
                $scope.latestData.km = getKm(data);
                getTdata(data);
                getShowSite(data);
                if (data.data.length > 0) {
                  $scope.latestData.examTime = date2str(new Date(data.data[0].createTime), 'yyyy年MM月dd日 hh:mm');
                }
              } else {
                $scope.latestData.total = Math.ceil(data.total / 7);
                $scope.latestData.time = getTime(data);
              }
            } else {
              $scope.latestData.page1 = data.page;
              $scope.latestData.healthIndex1 = data.healthIndex;
              $scope.latestData.total1 = Math.ceil(data.total / 7);
              $scope.latestData.time1 = getTime(data);
            }
            $scope[index + '_' + page].data = $scope.latestData.data;
            $scope.latestData.titleName = changeName(data.healthIndex, $scope.systemUserId, $scope.users);
            $scope[index + '_' + page].titleName = $scope.latestData.titleName;
            if (index != 'sleep') {
              myCharts(data);
            } else {
              if (data.data.length > 0) {
                $scope.latestData.examTime = getSleepTime(data.data[0].examTime);
              }
              $scope.latestData.sleepData = getSleepDate(data);
              $scope.latestData.deepData = getDeepData(data);
              $scope.latestData.total = data.total;
              getTdata(data);
              getShowSite(data);
            }
          }, function (error) {
            Loading.hide('running_woman', "健康");
            // cache.put('network_error', true);
            // if ($state.current.name == 'tab.health') {
            //     var index = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
            //     health_cache.put('index', index);
            //     $state.go('network_error', {backUrl: 'tab.health', broadcast_name: 'GET_HEALTH'});
            // } else {
            //     $scope.$emit("GET_HEALTH_ERROR");
            // }
          });
        } else {
          if ($scope[index + '_1'].datas.data.length > 0) {
            $("#zz_number").css("display", "block");
            $("#zz_disNum").css("display", "none");
            if (index == 'XT1' || index == 'XT2') {
              if ($scope['XT2_1'].datas.data.length > 0 && $scope['XT2_1'].datas.data[0].examTime > $scope['XT1_1'].datas.data[0].examTime) {
                $scope.latestData.datas = $scope['XT2_1'].datas;
                $scope.latestData.examTime = $scope['XT2_1'].examTime;
                getTdata($scope['XT2_1'].datas);
                getShowSite($scope['XT2_1'].datas);
              } else {
                $scope.latestData.datas = $scope['XT1_1'].datas;
                $scope.latestData.examTime = $scope['XT1_1'].examTime;
                getTdata($scope['XT1_1'].datas);
                getShowSite($scope['XT1_1'].datas);
              }
            } else if (index != 'stepnum') {
              $scope.latestData.datas = $scope[index + '_1'].datas;
              $scope.latestData.examTime = $scope[index + '_1'].examTime;
              getTdata($scope[index + '_1'].datas);
              getShowSite($scope[index + '_1'].datas);
            }
          } else if (index == 'XT1' && $scope['XT2_1'].datas.data.length > 0) {
            $scope.latestData.datas = $scope['XT2_1'].datas;
            $scope.latestData.examTime = $scope['XT2_1'].examTime;
            getTdata($scope['XT2_1'].datas);
            getShowSite($scope['XT2_1'].datas);
          } else {
            $("#zz_disNum").css("display", "block");
            $("#zz_number").css("display", "none");
          }
          $scope.latestData.titleName = $scope[index + '_1'].titleName;
          var data = $scope[index + '_' + page].datas;
          if (data.healthIndex != 'XT2') {
            $scope.latestData.page = data.page;
            $scope.latestData.healthIndex = data.healthIndex;
            if (data.healthIndex == 'stepnum') {
              $scope.latestData.total = data.total;
              $scope.latestData.kcal = geKcal(data);
              $scope.latestData.km = getKm(data);
              if (data.data.length > 0) {
                getTdata(data);
                getShowSite(data);
                $scope.latestData.examTime = date2str(new Date(data.data[0].createTime), 'yyyy年MM月dd日 hh:mm');
              }
            } else {
              $scope.latestData.total = Math.ceil(data.total / 7);
              $scope.latestData.time = getTime(data);
            }
          } else {
            $scope.latestData.page1 = data.page;
            $scope.latestData.healthIndex1 = data.healthIndex;
            $scope.latestData.total1 = Math.ceil(data.total / 7);
            $scope.latestData.time1 = getTime(data);
          }
          if (index != 'sleep') {
            myCharts($scope[index + '_' + page].datas);
          } else {
            $scope.latestData.sleepData = getSleepDate(data);
            $scope.latestData.deepData = getDeepData(data);
            $scope.latestData.total = data.total;
            if (data.data.length > 0) {
              $scope.latestData.examTime = getSleepTime(data.data[0].examTime);
            }
            getTdata(data);
            getShowSite(data);
          }
        }
      }
    };

    /**
     * 跳转到详情页面
     * @param index
     */
    $scope.goHealth = function (index) {
      $ionicNativeTransitions.stateGo(index, {backUrl: 'tab.health', index: index}, {
        "type": "slide",
        "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
        "duration": 400 // in milliseconds (ms), default 400
      });
    };
    var healthArray = ['XT1', 'bp', 'ox', 'hr', 'bmi', 'stepnum', 'sleep', 'ecg'];
    /**
     * 左右滑动面板
     * @param index
     */
    $scope.devicetype = [0, 1, 2, 5, 3, 4, 4, 7];//心率type5 修改为体脂3
    $scope.clickTabPage = function (index) {
      $("#zz_more1").css("display", "none");
      $("#zz_more2").css("display", "none");
      console.log("选了第几个选项", index);
      $ionicScrollDelegate.$getByHandle('zz_content').scrollTop(true);
      if (healthArray[index] == 'hr') {
        $("#zz_t1").css("display", "none");
        $("#zz_t2").css("display", "none");
        $("#zz_t3").css("display", "none");
        $("#zz_t4").css("display", "none");
        $("#zz_t5").css("display", "none");
        $("#zz_t6").css("display", "none");
      } else {
        $("#zz_t1").css("display", "block");
        $("#zz_t2").css("display", "block");
        $("#zz_t3").css("display", "block");
        $("#zz_t4").css("display", "block");
        $("#zz_t5").css("display", "block");
        $("#zz_t6").css("display", "block");
      }
      $scope.flag.index = healthArray[index];
      $scope.getData(healthArray[index], $scope.systemUserId, 1);
      buletoothService.PlaceSearchHistory.findByType($scope.devicetype[index]).then(function (data) {
        console.log(data);
        // alert("设备名：" + index);//0：血糖  1：血压  2：血氧   3：心率--5  4:体重--3  5:
        if (data) {
          $scope.connect_flag = 1;
          address = data.placeAddress;
          if (data.placeType == $scope.devicetype[index]) {
            bluetoothle.isInitialized(function (data) {
              if (data.isInitialized) {//如果蓝牙已经初始化
                //判断蓝牙是否启用
                bluetoothle.isEnabled(function (data) {
                  if (data.isEnabled) {
                    if (index != 5 && index != 6) {
                      bluetoothle.isConnected(function (data) {
                        if (data.isConnected) {
                          $scope.connect_flag = 3;
                          $scope.$apply();
                        }
                      }, function () {
                      }, {
                        "address": address
                      });
                    }
                  }
                });
              }
            });
          }
          $scope.index_news = index;
        } else {
          $scope.connect_flag = 0;
          $scope.$apply();
          /*                    $scope.latestData.tData = getTdata($scope.latestData.datas);
           $scope.latestData.array = getShowSite($scope.latestData.datas);*/

        }
      }, function (error) {
        $scope.connect_flag = 0;
      });
      /*            $("#zz_chose a").removeClass("g_nav_chose");
       $("#zz_" + healthArray[index]).addClass("g_nav_chose");*/
    };
    $scope.clickTabPage(0);

    //设备连接状态默认为未配设备 0:未配 1:正在连接 2:已连接 3:断开连接
    $scope.connect_flag = 0;
    var address = null;
    var suuid = null;
    var uuid = null;
    var service = null;
    var server_uuid = ['fe30', 'fe20', 'fe10', "temp", 'FE80'];//根据页面显示顺序1，血糖，2血压，3血氧，4心率 fe60 //将4改为体脂 数据
    var character_uuid = ['fe31', 'fe21', 'fe11', "temp", 'FE81'];//同上
    var suuid_eq = null;
    var uuid_eq = null;
    var up_msg = [];
    var up_true = [];
    var flag = false;
    var upFlag = true;
    $scope.scan_for_connect = function () {
      //alert("开始扫描")
      var index = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      bluetoothle.startScan(function (data) {//扫描
        console.log(JSON.stringify(data));
        if (data.status == 'scanResult') {
          if (data.address == address) {//判断下扫描的地址是已配对的设备地址  一一对应
            bluetoothle.stopScan(function () {
              console.log("停止扫描成功1");
            }, function () {
              //                    alert("蓝牙停止扫描失败");
            });
            bluetoothle.connect(function (data) {
              console.log("蓝牙连接成功" + address + ",data.status ==" + data.status);
              if (data.status == 'connected') {
                $scope.connect_flag = 3;
                //蓝牙回调函数中无法改变界面状态时要加入如下代码强制刷新
                $scope.$apply();
                bluetoothle.discover(function (data) {//发现设备的UUID
                  console.log("discover", data);
                  console.log(" discover ");
                  var services = data.services;
                  suuid_eq = server_uuid[$scope.index_news];//获取设备的蓝牙协议serveruuid；;
                  uuid_eq = character_uuid[$scope.index_news];//获取设备的蓝牙协议 character uuid
                  var len = services.length;
                  for (var l = 0; l < len; l++) {//遍历，将需要的协议uuid提取出来
                    if (services[l].uuid.toLowerCase() == suuid_eq.toLowerCase()) {
                      service = services[l];
                      suuid = service.uuid;
                      for (var z = 0; z < service.characteristics.length; z++) {
                        if (service.characteristics[z].uuid.toLowerCase() == uuid_eq.toLowerCase()) {
                          uuid = service.characteristics[z].uuid;
                          break;
                        }
                      }
                      break;
                    }
                  }
                  console.log("discover end", suuid + "," + uuid);
                  bluetoothle.subscribe(function (data) {//接收终端传来的数据
                    console.log("subscribe", data);
                    var Str = null;
                    var xbStr = null;
                    var nlStr = null;
                    var tz_user = $rootScope.user;
                    var ht = tz_user.stature;
                    var send_flag = false;
                    if (data.status == 'subscribed ') {
                      console.log(" subscribed ");
                    }
                    //  alert("接收终端传来的数据"+JSON.stringify(data));
                    if (data.status == 'subscribedResult') {
                      var index_tizhi = 0;
                      console.log("subscribedResult ", data);
                      console.log(JSON.stringify(bluetoothle.encodedStringToBytes(data.value)));
                      var check_data = bluetoothle.encodedStringToBytes(data.value);
                      console.log("原始字符串", bluetoothle.bytesToHex(check_data));
                      var string = bluetoothle.bytesToString(check_data);
                      var a = strToHexCharCode(string);
                      console.log("a", a);
                      if (check_data.length == 0) {
                        //                                     alert("没有数据 return");
                        return;
                      }
                      console.log(JSON.stringify(check_data));

                      if ($scope.index_news == 1) {//血压
                        var ssy = check_data['8'] * 256 + check_data['9'];
                        var szy = check_data['10'];
                        var mb = check_data['11'];
                        up_msg = [];
                        up_msg.push(ssy);
                        up_msg.push(szy);
                        up_msg.push(mb);
                        flag = true;
                      } else if ($scope.index_news == 2) {
                        if (check_data['8'] != 0 && check_data['9'] != 0) {
                          if (check_data['8'] != up_msg[0] || check_data['9'] != up_msg[1]) {
                            up_msg = [];
                            up_msg.push(check_data['8']);
                            up_msg.push(check_data['9']);
                            flag = true;
                          }
                        }

                      } else if ($scope.index_news == 4) {
                        if (check_data['3'] == 4) {
                          flag = false;
                          index_tizhi = index_tizhi + 1;
                          console.log("体脂称发送体重数据次数", index_tizhi);
                          if (tz_user.gender == '1') {
                            xbStr = '00';
                          } else {
                            xbStr = '01';
                          }
                          if (up_msg.length != 0) {
                            up_msg = [];
                          }
                          nlStr = tz_user.age.toString(16);
                          if (nlStr.length < 2) {
                            nlStr = "0" + nlStr;
                          }
                          Str = "1001" + xbStr + nlStr + parseInt(ht).toString(16);
                          if (index_tizhi == 1 && !send_flag) {
                            console.log("APP向体脂称发的数据", Str, index_tizhi, send_flag);
                            send_flag = true;
                            sendCommand(Str, data.address, "FE80", "29F11080-75B9-11E2-8BF6-0002A5D5C51B");
                          }
//                                                    if(index_tizhi==2){
//                                                        alert("请让皮肤与体脂称充分接触,为保证测量准确,请脱掉袜子进行测量")
//                                                    }
                          var ton = (check_data['8'] * 256 + check_data['9']) / 10;
                          up_msg.push(ton);
//                                                    console.log("数组添加的第一个数据,是体重", up_msg);
                        } else if (check_data['3'] == 9) {
                          if (check_data['8'] == 0) {
                            up_msg.push((check_data['9'] * 256 + check_data['10']));
                          } else if (check_data['8'] == 1) {
                            up_msg.push((check_data['9'] * 256 + check_data['10']));
                          } else if (check_data['8'] == 2) {
                            up_msg.push((check_data['9'] * 256 + check_data['10']));
                          } else if (check_data['8'] == 3) {
                            up_msg.push((check_data['9'] * 256 + check_data['10']));
                          } else if (check_data['8'] == 4) {
                            up_msg.push((check_data['9'] * 256 + check_data['10']) / 10);
                            if (up_msg[0] == up_msg[1]) {
                              //alert("体重：" + up_msg[0] + "体脂" + up_msg[1] + "水分" + up_msg[2] + "肌肉" + up_msg[3] + "基础代谢" + up_msg[4] + "骨骼" + up_msg[5]);
                              up_msg = [];
                              console.log("无效数据清空");
                            } else {
                              up_true.push(up_msg[0]);
                              up_true.push(up_msg[1]);
                              up_true.push(up_msg[2]);
                              up_true.push(up_msg[3]);
                              up_true.push(up_msg[4]);
                              up_true.push(up_msg[5]);
                              if (up_msg.length >= 6) {
                                up_msg = up_true.slice(0, 6);
                                up_msg.push($rootScope.user.stature * 10);
                                flag = true;
                                up_true = [];
                              }
                            }
                            console.log("有效数据内容", up_msg);
                          }
                        }
                      } else if ($scope.index_news == 0) {  //血糖数据
                        var a = parseInt(check_data['9']);
                        up_msg = [];
                        up_msg.push(a);
                        flag = true;
                      }
                      if (flag && upFlag) {
                        flag = false;
                        upFlag = false;
                        //TODO 网络上传
                        DeviceData.uploadBp($scope.index_news, up_msg).then(function (data) {
                          up_msg = [];
                          console.log('上传数据成功');
                          ErrorShow("上传数据成功");
                          $scope.connect_flag = 4;
                          $scope.disconnect_flag[index] = false;
                          bluetoothle.disconnect(function () {
                            bluetoothle.close(function () {
                              console.log("上传数据失败+关闭蓝牙Success");
                            }, function () {
                              console.log("上传数据失败+关闭蓝牙Fail");
                            }, {
                              "address": address
                            });
                          }, function () {
                            console.log("上传数据成功+断开连接Fail");
                          }, {
                            "address": address
                          });
                          $timeout(function () {
                            upFlag = true;
                            $scope.connect_flag = 1;
                            $scope.latestData.tData = getTdata($scope.latestData.datas);
                            $scope.latestData.array = getShowSite($scope.latestData.datas);
                            $scope.$apply();
                          }, 3000)
                        }, function (error) {
                          //                   alert('上传数据失败');

                          ErrorShow("上传数据失败");
                          upFlag = true;
                          $scope.connect_flag = 1;
                          $scope.$apply();
                          $scope.latestData.tData = getTdata($scope.latestData.datas);
                          $scope.latestData.array = getShowSite($scope.latestData.datas);
                          // 最终关闭蓝牙 close
                          bluetoothle.close(function () {
                            console.log("上传数据失败+关闭蓝牙Success");
                          }, function () {
                            console.log("上传数据失败+关闭蓝牙Fail");
                          }, {
                            "address": address
                          });
                        });
                      }
                    }
                  }, function () {
                    console.log("连接断开导致数据获取失败，蓝牙转转转");
                    $timeout(function () {
                      upFlag = true;
                      $scope.connect_flag = 1;
                      $scope.$apply();
                      $scope.latestData.tData = getTdata($scope.latestData.datas);
                      $scope.latestData.array = getShowSite($scope.latestData.datas);

                    }, 2500);
                    console.log("连接地址", address);
                    bluetoothle.close(function (data) {
                      console.log("数据错误+关闭蓝牙Success", JSON.stringify(data));
                    }, function () {
                      console.log("数据错误+关闭蓝牙Fail");
                    }, {
                      "address": address
                    });
                    /*$timeout(function () {
                     $scope.blue_scan();
                     }, 1000);*/
                  }, {
                    "address": address,
                    "service": suuid,//ffe0
                    "characteristic": uuid,//ffe1
                    "isNotification": true
                  });
                }, function () {
                  //                            alert("蓝牙UUID获取失败");
                }, {
                  "address": address
                });
              } else {  //蓝牙未连接
                $scope.connect_flag = 1;
                $scope.latestData.tData = getTdata($scope.latestData.datas);
                $scope.$apply();
              }
            }, function () {//蓝牙连接失败
              console.log("蓝牙连接失败");
              //最终关闭蓝牙 close
              bluetoothle.close(function () {
                $scope.scan_for_connect();
                console.log("蓝牙连接失败+close连接成功");
              }, function () {
                console.log("蓝牙连接失败+close连接失败");
              }, {
                "address": address
              });
            }, {
              "address": address
            });
          }
        }
      }, function () {
        //alert("蓝牙扫描失败");
      }, {
        "services": [],
        "allowDuplicates": false,
        "scanMode": bluetoothle.SCAN_MODE_LOW_LATENCY,
        "matchMode": bluetoothle.MATCH_MODE_AGGRESSIVE,
        "matchNum": bluetoothle.MATCH_NUM_MAX_ADVERTISEMENT,
        "callbackType": bluetoothle.CALLBACK_TYPE_ALL_MATCHES
      });
    };
    //定义一个全局变量用来标志各个指标与点击蓝牙图标的
    $scope.disconnect_flag = [true, true, true, true];

    $scope.blue_scan = function () {
      bluetoothle.isScanning(function (data) {//判断蓝牙是否处于扫描状态
        //alert("扫描状态：" + JSON.stringify(data));
        if (data.isScanning) {
          bluetoothle.stopScan(function () {
            //alert("为了连接已配对设备而停止扫描成功");
            $scope.scan_for_connect();
          }, function () {
            //                     alert("为了连接已配对设备而蓝牙停止扫描失败");
          });
        } else {
          $scope.scan_for_connect();
        }
      });

    };

    $scope.index_news = 0;
    /**
     * 切换指标标签
     * @param index     指标参数
     * @param id        用户id
     */
    $scope.selectSlide = function (index, id) {
      $("#zz_more1").css("display", "none");
      $("#zz_more2").css("display", "none");
      $scope.systemUserId = id;
      $scope.clickTabPage(index);
    };
    //跳转到去配对的页面
    $scope.goPair = function () {
      var index = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      if ($scope.connect_flag == 0) {//跳转到去配对的页面
        $ionicNativeTransitions.stateGo('g_my_equipment', {backUrl: 'tab.health'}, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        });
      }
    };
    //开始测量
    $scope.startMeasure = function () {
      $("#zz_number").css("display", "block");
      $("#zz_disNum").css("display", "none");
      var index = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      $scope.connect_flag = 2;
      $scope.disconnect_flag[index] = true;
      //判断蓝牙是否初始化
      bluetoothle.isInitialized(function (data) {
        if (data.isInitialized) {//如果蓝牙已经初始化
          //判断蓝牙是否启用
          bluetoothle.isEnabled(function (data) {
            if (data.isEnabled) {
              bluetoothle.isConnected(function (data) {
                if (data.isConnected) {
                  bluetoothle.disconnect(function () {
                  }, function () {
                  }, {
                    "address": address
                  });
                } else {
                  $scope.blue_scan();
                }

              }, function () {
                bluetoothle.close(function () {
                  console.log("蓝牙连接失败+close连接成功");
                }, function () {
                }, {
                  "address": address
                });
                $scope.blue_scan();
              }, {
                "address": address
              });

            } else {
              bluetoothle.enable(function () {//开启蓝牙
              }, function () {
              });
              $timeout(function () {
                //由于开启蓝牙成功的方法中不执行其他逻辑，所以采用延迟方法
                $scope.blue_scan();
              }, 3000);
            }
          });
        } else {
          bluetoothle.initialize(function () {//初始化
            //判断蓝牙是否启用
            bluetoothle.isEnabled(function (data) {
              if (data.isEnabled) {
              } else {
                bluetoothle.enable(function () {//开启蓝牙
                }, function () {
                });
              }
            });
            $timeout(function () {//由于开启蓝牙成功的方法中不执行其他逻辑，所以采用延迟方法
              $scope.blue_scan();
            }, 3000);
          }, function () {
          }, {
            "request": true,
            "statusReceiver": false
          });
        }
      });
    };
    /**
     * 获取亲朋信息
     * @param id
     */
    var sendMsgTime = null;
    $scope.getMyFamilyInfo = function (id, bind) {
      //未绑定的用户
      if (bind == 0) {
        $("#zz_t1").css("display", "none");
        $("#zz_t2").css("display", "none");
        $("#zz_t5").css("display", "none");
        $("#zz_t6").css("display", "none");
        $rootScope.healthConfirm.user_bind(id, $scope.users); //未绑定用户
      } else if (bind == 1) {
        $("#zz_t1").css("display", "none");
        $("#zz_t2").css("display", "none");
        $("#zz_t5").css("display", "none");
        $("#zz_t6").css("display", "none");
        $rootScope.healthConfirm.user_verify(id, $scope.users);//未验证用户
        sendMsgTime = new Date().getTime();
      } else if (bind == 2) {
        $("#zz_t1").css("display", "none");
        $("#zz_t2").css("display", "none");
        $("#zz_t5").css("display", "none");
        $("#zz_t6").css("display", "none");
        //验证中   10分钟之内让用户跳转到输入验证码的页面
        if (new Date().getTime() - sendMsgTime > 10 * 60 * 1000) {
          $rootScope.healthConfirm.user_verify(id, $scope.users);
        } else {
          $rootScope.healthConfirm.enter_check_code(id, $scope.users);
        }
      } else if (id == $scope.systemUserId) {
        return;
      } else {
        if (id) {
          $("#zz_t1").css("display", "none");
          $("#zz_t2").css("display", "none");
          $("#zz_t3").css("display", "none");
          $("#zz_t4").css("display", "none");
          $("#zz_t5").css("display", "none");
          $("#zz_t6").css("display", "none");
        } else {
          $("#zz_t1").css("display", "block");
          $("#zz_t2").css("display", "block");
          $("#zz_t3").css("display", "block");
          $("#zz_t4").css("display", "block");
          $("#zz_t5").css("display", "block");
          $("#zz_t6").css("display", "block");
        }
        //Loading.show('running_woman',"健康");
        $scope.systemUserId = id;
        var index = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
        if ($scope.setIndexNull('all')) {
          $scope.getData(healthArray[index], $scope.systemUserId, 1);
          if (healthArray[index]) {
            $scope.moreData = true;
            $scope.ecgData = new Array();
            $scope.ecgPage = 0;
            $scope.getMoreEcg('ecg', $scope.systemUserId, self);
          }
        }
      }

    };
    /**
     * 收到登录的广播
     */
    $rootScope.$on('login', function () {
      user_cache = $cacheFactory.get('user');
      alarm_users = user_cache.get("alarm_users");
      if (!alarm_users) {
        drugService.getUser().then(function (data) {
          user_cache.put('alarm_users', data.list);
          $scope.users = data.list;
        }, function (error) {
        });
      }
      $scope.bindClick();
      $scope.systemUserId = null;
      var index = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      if ($scope.setIndexNull('all')) {
        $scope.getData(healthArray[index], $scope.systemUserId, 1);
      }
    });
    /**
     * 收到注销的广播
     * @type {Object}
     */
    $rootScope.$on('logout', function () {
      $scope.users = null;
      $scope.setIndexNull('all');
    });
    /**
     * 跳转到手工录入页面
     * @type {string[]}
     */
    var enterArray = ['g_xt_enter', 'g_xueya_enter', 'g_xueyang_enter', 'g_xinlv_enter', 'g_bmi_enter'];
    $scope.goHealthEnter = function () {
      if ($scope.systemUserId) {
        return;
      }
      var index = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      $ionicNativeTransitions.stateGo(enterArray[index], {backUrl: 'tab.health'}, {
        "type": "slide",
        "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
        "duration": 400 // in milliseconds (ms), default 400
      });
    };
    /**
     * 跳转到报告页面
     * @type {string[]}
     */
    var reportArray = ['g_xt_report', 'g_xueya_report', 'g_xueyang_report', 'g_xinlv_report'];
    $scope.goReport = function () {
      var index = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      $ionicNativeTransitions.stateGo(reportArray[index], {backUrl: 'tab.health'}, {
        "type": "slide",
        "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
        "duration": 400 // in milliseconds (ms), default 400
      });
    };

    $rootScope.$on('LOOK_HEALTH', function (evt, data) {
      $scope.selectSlide(data.type, data.userId);
    });
    /**
     * 跳转到聊天页面
     */
    $scope.goChat = function () {
      $ionicNativeTransitions.stateGo('doctor_consult', {backUrl: 'tab.health'}, {
        "type": "slide",
        "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
        "duration": 400 // in milliseconds (ms), default 400
      });
    };
    /**
     *收到重新刷新页面的广播
     */
    $rootScope.$on('REFRESH', function () {
      console.log('监听刷新健康广播');
      var index = health_cache.get('index');
      if ($scope.setIndexNull(healthArray[index])) {
        $scope.getData(healthArray[index], $scope.systemUserId, 1);
      }
      //加载亲朋用户
      if (!$scope.users) {
        drugService.getUser().then(function (data) {
          user_cache.put('alarm_users', data.list);
          $scope.users = data.list;
        }, function (error) {
        });
      }
    });
    $scope.form = {
      load: false
    }
    $scope.loadMore = function () {
      $scope.form.load = true;
      var index = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      console.log(index)
      if (index == 0) {
        if ($scope.setIndexNull(healthArray[index]) && $scope.setIndexNull("XT2")) {
          $scope.clickTabPage(index);
        }
      } else {
        if ($scope.setIndexNull(healthArray[index])) {
          $scope.clickTabPage(index);
          if (healthArray[index] == 'ecg') {
            $scope.ecgData = new Array();
            $scope.getMoreEcg('ecg', $scope.systemUserId, self);
          }
        }
      }
    };
    $scope.$on('scroll.refreshComplete', function () {
      $scope.form.load = false;
    });
    //收到配对成功的广播
    $rootScope.$on("pairSuccess", function (event, args) {
      console.log("收到了配对广播", args.type);
      var s = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      var index = null;
      for (var i = 0; i < healthArray.length; i++) {
        if (i == s) {
          index = i;
        }
      }
      if (index == args.type) {
        $scope.clickTabPage(args.type);
      } else {
        $timeout(function () {
          $scope.selectSlide(args.type, $scope.systemUserId);
        }, 2000)
      }
    });
    //收到取消配对的广播
    $rootScope.$on("cancelPair", function (event, args) {
      console.log("收到了取消配对广播", args.type);
      var s = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      var index = null;
      for (var i = 0; i < healthArray.length; i++) {
        if (i == s) {
          index = i;
        }
      }
      if (index == args.type) {
        $scope.clickTabPage(args.type);
      } else {
        $timeout(function () {
          $scope.selectSlide(args.type, $scope.systemUserId);
        }, 2000)
      }
    });
    //显示更多条目
    $scope.showMore = function () {
      $ionicScrollDelegate.$getByHandle('zz_content').scrollTop(true);
      $("#zz_more1").css("display", "block");
      $("#zz_more2").css("display", "block");
      $(".g_text2").css("display", "none");
    };
    //关闭条目
    $scope.closeMore = function () {
      $("#zz_more1").css("display", "none");
      $("#zz_more2").css("display", "none");
      var index1 = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      if (index1 == 7) {
        $(".g_text2").css("display", "block");
      }
    };
    //录入身高
    $scope.enterHeight = function () {
      $("#updateuserST").html("请输入身高");
      $("#inputvalue").val($scope.user.stature);
      $("#updateuserDW").html("cm");
      $("#updateuserinfo").css("display", "block");
      $("#updateclose").click(function () {
        $("#updateuserinfo").css("display", "none");
      });
      $("#updateOK").click(function () {
        var value = $("#inputvalue").val();
        console.log("身高!!!!!!!!!!!========", value);
        $rootScope.user.stature = value;
        console.log("全局数据", $rootScope.user);
        userService.update($rootScope.user.name, $rootScope.gender, $rootScope.user.date, $rootScope.user.stature, $rootScope.weight).then(function (d) {
          console.log("进入更新用户数据的服务", d);
          $("#updateOK").unbind("click");
          $scope.$emit("USER_MODIFY", $rootScope.user); //此广播是为了传给首页
          $ionicNativeTransitions.stateGo('tab.health', {}, {
            "type": "slide",
            "direction": "right",
            "duration": 500
          });
          // $rootScope.user.name = $scope.user.name;
        }, function (e) {
          console.log(e);
        });
        $("#updateuserinfo").css("display", "none");
      });
    };
    /**
     * 右滑功能
     * @param index
     * @param page
     * @param total
     */
    $scope.right = function (index, page, total) {
      console.log(page, total, index);
      if (page < total) {
        page = page + 1;
        if (page > 3) {
          return;
        }
        $scope.getData(index, $scope.systemUserId, page);
      }
    }
    /**
     * 左滑功能
     * @param index
     * @param page
     * @param total
     */
    $scope.left = function (index, page, total) {
      console.log(page, total, index);
      if (page > 1) {
        page = page - 1;
        $scope.getData(index, $scope.systemUserId, page);
      }
      // $scope.getData('XT1', $scope.systemUserId, 1);
    }
    /**
     * 设置为空
     * @param index
     */
    $scope.setIndexNull = function (index) {
      if (index == 'ecg') {
        $scope.ecgData = new Array();
        $scope.ecgPage = 0;
        return true;
      }
      if (index == 'all') {
        $scope.ecgData = new Array();
        $scope.ecgPage = 0;
        for (var o in healthArray) {
          for (var i = 1; i < 4; i++) {
            if ($scope[healthArray[o] + '_' + i]) {
              $scope[healthArray[o] + '_' + i] = null;
            }
          }
        }
      } else {
        for (var i = 1; i < 4; i++) {
          if ($scope[index + '_' + i]) {
            $scope[index + '_' + i] = null;
          }
        }
      }
      return true;
    }
    /**
     * 跳转到详细数据页面
     */
    $scope.goDetail = function (index, backUrl) {
      var index1 = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      var type = 'bs';
      if (index1 == 0) {
        type = "bs";
      } else {
        type = healthArray[index1];
      }
      $ionicNativeTransitions.stateGo(index, {backUrl: backUrl, type: type}, {
        "type": "slide",
        "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
        "duration": 600// in milliseconds (ms), default 400
      });
    };
    /**
     * 手环同步数据  步数
     */
    $scope.a = [1, 2];
    var uploadTimeTemp = null;
    $scope.startUpload = function () {
      $("#zz_number").css("display", "block");
      $("#zz_disNum").css("display", "none");
      var index = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      if (index == 5) { //运动 0不上传，1上传心率，2上传步数，3上传睡眠
        $rootScope.uploadFalg = 2;
      } else if (index == 6) {
        $rootScope.uploadFalg = 3;
        uploadTimeTemp = new Date().getTime();
        $rootScope.uploadTime = uploadTimeTemp;
        $timeout(function () {
          if (uploadTimeTemp == $rootScope.uploadTime) {
            ErrorShow("没有睡眠数据");
            $rootScope.uploadFalg = 1;
            $rootScope.$broadcast("CHECK_FAIL", {type: 'sleep'});
          }
        }, 3000)
      }
      buletoothService.PlaceSearchHistory.findByType($scope.devicetype[index]).then(function (data) {
        if (data) {
          var address = data.placeAddress;
          //判断手环是否连接
          bluetoothle.isConnected(function (data) {
            if (data.isConnected) {
              $scope.connect_flag = 3;
              $scope.$apply();
              var timeStr = setWristTime();
              bluetoothle.write(function (data) {
                  console.log("发送成功");
                }, function (e) {
                  console.log(e);
                  console.log("发送失败");
                },
                {
                  "value": timeStr,
                  "service": '0001',
                  "characteristic": '0002',
                  "type": "read",
                  "address": address
                });
            }
          }, function () {    //手环未连接
            $("#zz_mask").css("display", "block");
            $("#zz_band").css("display", "block");
            $rootScope.strapAddress = address;
          }, {
            "address": address
          });
        }
      }, function (error) {
        $scope.connect_flag = 0;
      })
    }
    var tempType = null, tempIndex = null;
    $scope.clickToolTips = function (type, index, data) {
      console.log(index, data.length);
      if (tempType && tempIndex) {
        $("#zz_" + tempType + "_" + tempIndex).css("display", "none");
        $("#zz_" + type + "_" + index).css("display", "block");
        if (data.length - index < 5 && data.length - index > 0) {
          $("#zz_" + type + "_" + index).css("margin-left", "-80px");
          $("#zz_" + type + "_" + index).addClass("g_sleep_r");
        }
      } else {
        if (data.length - index < 5 && data.length - index > 0) {
          $("#zz_" + type + "_" + index).css("margin-left", "-80px");
          $("#zz_" + type + "_" + index).addClass("g_sleep_r");
        }
        $("#zz_" + type + "_" + index).css("display", "block");
      }
      tempType = type;
      tempIndex = index;
    };
    //点击空白区域隐藏导航栏
    $("#zz_more1").bind('click', function () {
      $("#zz_more1").css("display", "none");
      $("#zz_more2").css("display", "none");
      var index1 = $('#zz_chose a[class="g_nav_chose"]').attr('remark');
      if (index1 == 7) {
        $(".g_text2").css("display", "block");
      }
    })
    /**
     * 跳转到ECG目录
     */
    $scope.goTestECG = function () {
      if (address == null) {
        $ionicNativeTransitions.stateGo('g_my_equipment', {backUrl: 'tab.health'}, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        });
      } else {
        $ionicNativeTransitions.stateGo('g_xd_text', {backUrl: 'tab.health', address: address}, {
          "type": "slide",
          "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
          "duration": 400 // in milliseconds (ms), default 400
        });
      }
    };
    /**
     * 同步心电数据
     */

    $scope.synchronousECGData = function () {//二挡，三挡的心电
      //连接蓝牙
      if ($scope.connect_flag == 0) {//蓝牙未配对,跳转到蓝牙配对
        $ionicNativeTransitions.stateGo('g_my_equipment', {backUrl: 'tab.health'}, {
          "type": "slide",
          "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
          "duration": 400 // in milliseconds (ms), default 400
        });
      } else {
        //输入测量时间弹窗
        $("#updateuserST").html("请输入测量时间");
        $("#inputvalue").val("");
        $("#updateuserDW").html("");
        $("#updateuserinfo").show();
        $("#updateclose").click(function () {
          $("#updateuserinfo").hide();
        });

        $("#updateOK").click(function () {
          $scope.time_value = $("#inputvalue").val();
          if ($scope.time_value) {
            $("#updateuserinfo").hide();
            uploadBluetoothData();
          } else {

          }

        });


        //时间弹框
        $('#inputvalue').mobiscroll().datetime({
          theme: 'jqm',     // Specify theme like: theme: 'ios' or omit setting to use default
          mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
          dateFormat: 'yy-mm-dd',
          timeFormat: 'hh:mm:ss',
          display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
          lang: 'zh',
          // hourText:'Hours',// Specify language like: lang: 'pl' or omit setting to use default
          maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), new Date().getHours(), new Date().getMinutes())
        });
        //蓝牙传数据并上传ecg数据
        uploadBluetoothData = function () {
          var ecgData = new Array();
          var flag_num = 0;
          var flag_tap = 0;
          console.log("同步心电数据");
          //判断蓝牙是否初始化
          bluetoothle.isInitialized(function (data) {
            if (data.isInitialized) {//如果蓝牙已经初始化
              //判断蓝牙是否启用
              bluetoothle.isEnabled(function (data) {
                if (data.isEnabled) {
                  bluetoothle.isConnected(function (data) {
                    if (data.isConnected) {
                      bluetoothle.disconnect(function () {
                      }, function () {
                      }, {
                        "address": address
                      });
                    } else {
                      blue_scan();
                    }

                  }, function () {
                    bluetoothle.close(function () {
                      console.log("蓝牙连接失败+close连接成功");
                    }, function () {
                    }, {
                      "address": address
                    });
                    blue_scan();
                  }, {
                    "address": address
                  });

                } else {
                  bluetoothle.enable(function () {//开启蓝牙
                  }, function () {
                  });
                  $timeout(function () {
                    //由于开启蓝牙成功的方法中不执行其他逻辑，所以采用延迟方法
                    blue_scan();
                  }, 3000);
                }
              });
            } else {
              bluetoothle.initialize(function () {//初始化
                //判断蓝牙是否启用
                bluetoothle.isEnabled(function (data) {
                  if (data.isEnabled) {
                  } else {
                    bluetoothle.enable(function () {//开启蓝牙
                    }, function () {
                    });
                  }
                });
                $timeout(function () {//由于开启蓝牙成功的方法中不执行其他逻辑，所以采用延迟方法
                  blue_scan();
                }, 3000);
              }, function () {
              }, {
                "request": true,
                "statusReceiver": false
              });
            }
          });

          //开始扫描蓝牙
          blue_scan = function () {
            bluetoothle.isScanning(function (data) {//判断蓝牙是否处于扫描状态
              //alert("扫描状态：" + JSON.stringify(data));
              if (data.isScanning) {
                bluetoothle.stopScan(function () {
                  //alert("为了连接已配对设备而停止扫描成功");
                  scan_for_connect();
                }, function () {
                  //                     alert("为了连接已配对设备而蓝牙停止扫描失败");
                });
              } else {
                scan_for_connect();
              }
            });

          };

          //蓝牙配对成功，连接蓝牙
          console.log("同步心电数据,蓝牙已配对");
          scan_for_connect = function () {
            bluetoothle.startScan(function (data) {//扫描
              console.log(data);
              if (data.status == 'scanResult') {
                if (data.address == address) {//判断下扫描的地址是已配对的设备地址  一一对应
                  bluetoothle.stopScan(function () {
                    console.log("停止扫描成功1");
                  }, function () {
                  });
                  bluetoothle.connect(function (data) {
                    console.log("蓝牙开始连接");
                    if (data.status == 'connected') {
                      console.log("心电设备已连接");
                      //上传进度条
                      loading = $ionicPopup.show({
                        template: '<div class="g_ttt"><div class="graphbox"><div class="graphbox2" id="graphbox2"></div></div><a class="g_a" id="zz_Progress">0%</a></div>'
                      });
                      bluetoothle.discover(function (data) {//发现设备的UUID
                        console.log("蓝牙发现设备", data);
                        bluetoothle.subscribe(function (data) {//接收终端传来的数据
                          console.log(" subscribe ", data);
                          if (data.status == 'subscribed') {
                            console.log(" subscribed ");
                            //发送字符D，同步设备数据
                            sendCommand("D", data.address, 'FE70', 'FE71');
                          }
                          if (data.status == 'subscribedResult') {
                            var check_data = bluetoothle.encodedStringToBytes(data.value);
                            var string = bluetoothle.bytesToString(check_data);
                            var a = strToHexCharCode(string);
                            console.log("心电设备传来的数据strToHexCharCode", a);
                            if (a.substring(10, 24) == '00000000000000' && a.substring(28, 30) == '01') {  //数据传输开始标志
                              console.log("第一个数据包");
                              if (a.substring(26, 28) == '02') {
                                //判断是否不同的档位的数据
                                if (flag_num < 7 && flag_tap == 3) {
                                  ErrorShow("上传失败");
                                  bluetoothle.close(function () {
                                    loading.close();
                                    console.log("蓝牙连接失败+close连接成功");
                                  }, function () {
                                    console.log("蓝牙连接失败+close连接失败");
                                  }, {
                                    "address": address
                                  });
                                  return;
                                }
                                console.log("进入=========================");
                                flag_tap = 2;
                                if (flag_num >= 8) {
                                  ErrorShow("上传成功");
                                  //最终关闭蓝牙 close
                                  bluetoothle.close(function () {
                                    loading.close();
                                    console.log("蓝牙连接失败+close连接成功");
                                  }, function () {
                                    loading.close();
                                    console.log("蓝牙连接失败+close连接失败");
                                  }, {
                                    "address": address
                                  });
                                  return;
                                }
                              } else if (a.substring(26, 28) == '03') {
                                //判断是否不同的档位的数据
                                if (flag_num < 32 && flag_tap == 2) {
                                  ErrorShow("上传失败");
                                  bluetoothle.close(function () {
                                    loading.close();
                                    console.log("蓝牙连接失败+close连接成功");
                                  }, function () {
                                    loading.close();
                                    console.log("蓝牙连接失败+close连接失败");
                                  }, {
                                    "address": address
                                  });
                                  return;
                                }
                                flag_tap = 3;
                                if (flag_num >= 32) {
                                  ErrorShow("上传成功");
                                  //最终关闭蓝牙 close
                                  bluetoothle.close(function () {
                                    loading.close();
                                    console.log("蓝牙连接失败+close连接成功");
                                  }, function () {
                                    loading.close();
                                    console.log("蓝牙连接失败+close连接失败");
                                  }, {
                                    "address": address
                                  });
                                  return;
                                }
                              }
                            } else if (parseInt(a.substring(10, 24)) > 0) {
                              var str = a.substr(a.indexOf('0b07') + 4, 20);
                              var arr = stringToChar4To10(str);
                              ecgData = ecgData.concat(arr);
                            } else if (a.substring(28, 30) == '00' && a.substring(10, 24) == '00000000000000') {
                              if (a == '0xaaaa0b0700000000000000c8ff002d') {//每条数据的最后一个包
                                ErrorShow("上传成功");
                                loading.close();
                                //最终关闭蓝牙 close
                                bluetoothle.close(function () {

                                  console.log("蓝牙连接失败+close连接成功");
                                }, function () {
                                  loading.close();
                                  console.log("蓝牙连接失败+close连接失败");
                                }, {
                                  "address": address
                                });
                                return;
                              }
                              //执行上传数据上传
                              str = ecgData.join(",");
                              console.log("======>", str);
                              // var str = "1234,1234,1234,1234,1234,1234,1234,1234,1234,1234,1234,1234,1234,1234,1234,1234,1234,1234,1234,1234"
                              EcgService.upLoadEcgDataAll(str, flag_tap, $scope.time_value, flag_num + 1);
                              str = "";
                              flag_num = flag_num + 1;
                              console.log("数据条数", flag_num, flag_tap);
                              if (flag_tap = 2) {
                                $("#graphbox2").css("width", (100 / 8) * (flag_num ) + '%');
                                $("#zz_Progress").text((100 / 8) * (flag_num ) + '%');
                                if ((100 / 8) * flag_num > 98) {
                                  $timeout(function () {
                                    loading.close();
                                  }, 500);
                                }
                              } else if (flag_tap = 3) {
                                $("#graphbox2").css("width", (100 / 32) * (flag_num ) + '%');
                                $("#zz_Progress").text((100 / 32) * (flag_num ) + '%');
                                if ((100 / 32) * flag_num > 98) {
                                  $timeout(function () {
                                    loading.close();
                                  }, 500);
                                }
                              }
                            }


                            // 0xaaaa0b0700000000000000c8020131  开始数据包

                          }

                        }, function (e) {
                        }, {
                          "address": address,
                          "service": 'FE70',//ffe0
                          "characteristic": 'FE71',//ffe1
                          "isNotification": true
                        });

                      }, function () {
                      }, {
                        "address": address
                      });
                    }
                  }, function () {//蓝牙连接失败
                    console.log("蓝牙连接失败");
                    //最终关闭蓝牙 close
                    bluetoothle.close(function () {
                      scan_for_connect();
                      console.log("蓝牙连接失败+close连接成功");
                    }, function () {
                      console.log("蓝牙连接失败+close连接失败");
                    }, {
                      "address": address
                    });
                  }, {
                    "address": address
                  });
                }
              }
            }, function () {
              //alert("蓝牙扫描失败");
            }, {
              "services": [],
              "allowDuplicates": false,
              "scanMode": bluetoothle.SCAN_MODE_LOW_LATENCY,
              "matchMode": bluetoothle.MATCH_MODE_AGGRESSIVE,
              "matchNum": bluetoothle.MATCH_NUM_MAX_ADVERTISEMENT,
              "callbackType": bluetoothle.CALLBACK_TYPE_ALL_MATCHES
            });
          };
        }
      }

    }
    /**
     * 跳转到心电详细
     */
    $scope.goEcgDetail = function (ecg) {
      $ionicNativeTransitions.stateGo('g_xindian', {
        backUrl: 'tab.health',
        ecg: JSON.stringify(ecg),
        userId: $scope.systemUserId
      }, {
        "type": "slide",
        "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
        "duration": 400 // in milliseconds (ms), default 400
      });
    }
    /**
     * 接收到保存心电成功的广播
     */
    $rootScope.$on('saveEcgSuccess', function () {
      console.log("收到了广播")
      $scope.moreData = true;
      $scope.ecgData = new Array();
      $scope.ecgPage = 0;
      $scope.getMoreEcg('ecg', $scope.systemUserId, self);
    })
    /**
     * 上拉加载心电数据
     */
    $scope.moreData = false;
    $scope.ecgPage = 0;
    $scope.ecgData = new Array();
    $scope.getMoreEcg = function (index, id, self) {
      if ($scope.systemUserId) {
        self = false;
      } else {
        self = true;
      }
      $scope.ecgPage = $scope.ecgPage + 1;
      healthService.healthindex($rootScope.token, 'ecg', self, $scope.systemUserId, $scope.ecgPage).then(function (data) {
        $scope.form.load = false;
        $scope.$broadcast('scroll.infiniteScrollComplete');
        if (data.data.length == 0) {
          $scope.moreData = false;
          if ($scope.ecgPage == 1) {
            $("#ecg").css("display", "none");
            $("#zz_xd_disnum").css("display", "block");
          }
        } else {
          $("#ecg").css("display", "block");
          $("#zz_xd_disnum").css("display", "none");
          $scope.ecgData = $scope.ecgData.concat(getEcgData(data));
          $scope.ecgPage = data.page;

          console.log("healthEcgData:",$scope.ecgData.concat(getEcgData(data)));
        }
      }, function (error) {
        $scope.form.load = false;
        $scope.moreData = false;
        ErrorShow("网络异常");
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
    }

  });
