angular.module('HealthData', [])

    .factory('healthDataService', function ($http, $q, $rootScope) {
        // Might use a resource here that returns a JSON array
        return {
            //获取血压,血糖、心率、血氧数据
            getHealData: function (t_userId, t_dataType, t_page, t_count) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/weixin/user/dataQuery.htm",
                    params: {
                        userId: t_userId,
                        dataType: t_dataType,
                        page: t_page,
                        count: t_count,
                        method: 'queryPage'
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    //console.log("查询结果->" + JSON.stringify(result));
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            }
        };
    })

    .controller('healthBpController', function ($scope, $ionicNativeTransitions, healthDataService, $rootScope, $cacheFactory, $stateParams, enterService, $cordovaToast, $ionicGesture) {
        $scope.flag = new Object();
        $scope.flag.moreData = true;
        $scope.pageSize = 0;
        $scope.bpData = [];
        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }
        var alarm_users = user_cache.get('alarm_users');
        var userId = user_cache.get('systemUserId');
        if (!userId) {
            $scope.userId = $rootScope.user.userId;
        } else {
            $scope.userId = userId;
        }
        $scope.pageCount = 10;
        $scope.loadMore = function (index) {
            if (angular.isUndefined(index)) {
                $scope.pageSize = 0;
            } else {
                $scope.pageSize = $scope.pageSize + 1;
            }
            healthDataService.getHealData($scope.userId, index, $scope.pageSize, $scope.pageCount).then(function (data) {
                if (data.data.length == 0) {
                    $scope.flag.moreData = false;
                } else {
                    $scope.bpData = $scope.bpData.concat(getHealAllData(index, data, $rootScope.user.stature));
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }, function (error) {
            })
        };
        $scope.loadMore($stateParams.type);
        var backUrl = $stateParams.backUrl;
        $scope.goBack = function () {
            $ionicNativeTransitions.stateGo(backUrl, {}, {
                "type": "slide",
                "direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
                "duration": 300// in milliseconds (ms), default 400
            });
        };
        /**
         * 收到物理返回键按钮事件
         */
        $rootScope.$on('HARDWARE_BACK', function () {
            $scope.goBack();
        });
        /**
         * 删除数据
         */
        $scope.delHealthData = function (dataType, number) {
            enterService.postHealthData(dataType, "del", number).then(function () {
                console.log(dataType, number);
                console.log($scope.bpData);
                for (var i = 0; i < $scope.bpData.length; i++) {
                    var o = $scope.bpData[i];
                    if (o.number == number) {
                        console.log(o);
                        $scope.bpData.splice(i, 1);
                        $scope.pageCount--;
                    }
                }
                $cordovaToast.showShortBottom('删除成功');
                $scope.$emit(getEmitName(dataType));
            }, function (e) {
                $cordovaToast.showShortBottom('网络异常');
            })
        }
    })
    .controller('healthReportController', function ($scope, $ionicNativeTransitions, $rootScope) {
        var container = document.getElementById('container1');
        var hhh = $(document).height();
        var hh = hhh + 22;
        console.log('一屏高度', hh);
        $scope.goBack = function () {
            console.log("跳转健康页面");
            $ionicNativeTransitions.stateGo('tab.health', {}, {
                "type": "slide",
                "direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
                "duration": 300// in milliseconds (ms), default 400
            });
        };
        //向上滑动回调  4屏
        var i = 1;
        $scope.up_callback = function () {
            if (i == 4) {
                i = 3;
            }
            $('#container1').animate({top: -hh * (i++)}, 400);
        };
        //向上滑动回调  5屏
        $scope.up_callback2 = function () {
            if (i == 5) {
                i = 4;
            }
            $('#container1').animate({top: -hh * (i++)}, 400);
        };
        //向下滑动回调
        $scope.down_callback = function () {
            if (i == 1) {
                container.style.top = 1 + "px";
            }
            else {
                $('#container1').animate({top: -hh * (i - 2)}, 400);
                i = i - 1;
            }
        };
        /**
         * 收到物理返回键按钮事件
         */
        $rootScope.$on('HARDWARE_BACK', function () {
            $scope.goBack();
        });

    });

