angular.module('HealthDetail', [])

    .factory('healthDetailService', function ($http, $q, $rootScope) {
        // Might use a resource here that returns a JSON array
        return {
            //获取血压,血糖、心率、血氧数据
            healthindex: function (t_token, t_healthindex, t_timeCategory, self, userId) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/healthindex.htm",
                    params: {
                        token: t_token,
                        healthIndex: t_healthindex,
                        timeCategory: t_timeCategory,
                        self: self,
                        userId: userId
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    //console.log("查询结果->" + JSON.stringify(result));
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            }
        };

    })


    .controller('healthDetailController', function ($scope, healthDetailService, $state, $stateParams, $ionicNativeTransitions, $rootScope, $cacheFactory, Loading) {
        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }
        var self = true;
        $scope.systemUserId = user_cache.get('systemUserId');

        $scope.latestData = new Object();
        $scope.latestData.titleName = '血压';
        $scope.getData = function (index, evt, timeCategory) {
            if (evt) {
                $("#zz_" + index + "  a").removeClass("g_xz_color");
                $(evt.target).addClass("g_xz_color");
            }
            $("#" + index + "_Day").css("display", "none");
            $("#" + index + "_Week").css("display", "none");
            $("#" + index + "_Month").css("display", "none");
            $("#" + index + "_Year").css("display", "none");
            $("#" + index + "_" + timeCategory).css("display", "block");
            if ($scope.systemUserId) {    //判断是否查询亲朋用户
                console.log($scope.systemUserId);
                $scope[index + '_' + timeCategory] = null;
                self = false;
            } else {
                // $scope[index + '_' + timeCategory] = null;
                self = true;
            }
            if (!$scope[index + '_' + timeCategory]) {
                //Loading.show('running_woman',"",true);
                $scope[index + '_' + timeCategory] = new Object();
                healthDetailService.healthindex($rootScope.token, index, timeCategory, self, $scope.systemUserId).then(function (data) {
                        Loading.hide('running_woman', "健康");
                        $scope.latestData.titleName = changeName(data.healthIndex);
                        $scope[index + '_' + timeCategory].titleName = $scope.latestData.titleName;
                        $scope[index + '_' + timeCategory].nData = getNdata(data);
                        $scope[index + '_' + timeCategory].tickData = getTickData(data);
                        $("#xy_" + index + "_" + timeCategory).highcharts({
                                chart: {
                                },
                                title: {
                                    text: ''
                                },
                                subtitle: {
                                    text: ''
                                },
                                xAxis: {
                                    categories: getDetailX(data.timeCategory),
                                    labels: {
                                        style: {
                                            'fontSize': setFontSize(data.timeCategory)
                                        }
                                    },
                                    tickLength: null,
                                    lineWidth: 0.02,
                                    fontColor: '#423c40'
                                },
                                yAxis: {
                                    max: $scope[index + '_' + timeCategory].tickData[0],
                                    min: $scope[index + '_' + timeCategory].tickData[1],
                                    gridLineWidth: 0.2,
                                    tickInterval: Math.abs($scope[index + '_' + timeCategory].tickData[2]),
                                    tickPositions: getTickPost(data),
                                    labels: {
                                        formatter: function () {
                                            return this.value.toFixed(getFixedNum(data.healthIndex));
                                        }
                                    },
                                    title: {
                                        text: ''
                                    },
                                    plotBands: [
                                        {
                                            from: $scope[index + '_' + timeCategory].nData[0],               // 标示区开始值
                                            to: $scope[index + '_' + timeCategory].nData[1],                 // 标示区结束值
                                            label: {              // 标示区文字标签配置，详见API
                                            },
                                            color: '#defde9',            // 标示区背景颜色
                                            borderWidth: 1,        // 标示区边框宽度
                                            borderColor: null        // 标示区边框颜色
                                        },
                                        {
                                            from: $scope[index + '_' + timeCategory].nData[2],               // 标示区开始值
                                            to: $scope[index + '_' + timeCategory].nData[3],                 // 标示区结束值
                                            label: {              // 标示区文字标签配置，详见API
                                            },
                                            color: '#ffede0',            // 标示区背景颜色
                                            borderWidth: 1,        // 标示区边框宽度
                                            borderColor: null       // 标示区边框颜色
                                        }
                                    ]
                                },
                                exporting: {
                                    enabled: false
                                },
                                credits: {
                                    enabled: false
                                },
                                tooltip: {
                                    borderRadius: 8,             // 边框圆角
                                    borderWidth: 1,               // 边框宽度
                                    shadow: false,               // 是否显示阴影
                                    animation: false,               // 是否启用动画效果
                                    enabled: true,
                                    formatter: function () {
                                        return getToolTips(this.x, timeCategory, data);
                                    }
                                },
                                plotOptions: {
                                    series: {
                                        connectNulls: true,
                                        color: getColor(data.healthIndex),
                                        lineWidth: setLineWidth(data.healthIndex),
                                        pointWidth: 3,
                                        marker: {
                                            radius: 3,
                                            lineColor: getColor(data.healthIndex),
                                            lineWidth: 1,
                                            fillColor: "#fff",
                                            symbol: 'circle'//曲线点类型："circle", "square", "diamond", "triangle","triangle-down"，默认是"circle"
                                        }
                                    },
                                    columnrange: {
                                        dataLabels: {
                                            enabled: false,
                                            formatter: function () {
                                                return this.y + '°C';
                                            },
                                            style: {
                                                'fontSize': '10px',
                                                'fontWeight': 'normal'
                                            }
                                        },
                                        enableMouseTracking: true
                                    },
                                    scatter: {
                                        dataLabels: {
                                            enabled: false,
                                            style: {
                                                'fontSize': '10px',
                                                'fontWeight': 'normal'
                                            }
                                        },
                                        enableMouseTracking: false
                                    },
                                    line: {
                                        dataLabels: {
                                            enabled: true,
                                            style: {
                                                'fontSize': '10px',
                                                'fontWeight': 'normal'
                                            }
                                        },
                                        enableMouseTracking: false
                                    }
                                },
                                legend: {
                                    enabled: false
                                },
                                series: [
                                    {
                                        type: changeType(data.healthIndex),
                                        name: changeName(data.healthIndex),
                                        data: getDetailY(data),
                                        color: getColor(data.healthIndex)
                                    },
                                    {
                                        type: "scatter",
                                        name: '舒张压',
                                        data: getSsy(data),
                                        color: '#F4922F'
                                    },
                                    {
                                        type: "scatter",
                                        name: '收缩压',
                                        data: getSzy(data),
                                        color: '#F4922F'
                                    }
                                ]
                            }
                        );
                        if (data.healthIndex == 'bp') {
                            $("#xy_" + index + "_" + timeCategory + "_mb").highcharts({
                                chart: {
                                },
                                title: {
                                    text: ''
                                },
                                subtitle: {
                                    text: ''
                                },
                                xAxis: {
                                    categories: getDetailX(data.timeCategory),
                                    labels: {
                                        style: {
                                            'fontSize': setFontSize(data.timeCategory)
                                        }
                                    },
                                    tickLength: null,
                                    lineWidth: 0.02,
                                    fontColor: '#423c40'
                                },
                                yAxis: {
                                    max: 200,
                                    min: 40,
                                    gridLineWidth: 0.2,
                                    tickInterval: 20,
                                    tickPositions: getTickPost(data),
                                    labels: {
                                        formatter: function () {
                                            return this.value.toFixed(getFixedNum(data.healthIndex));
                                        }
                                    },
                                    title: {
                                        text: ''
                                    },
                                    plotBands: [
                                        {
                                            from: 60,               // 标示区开始值
                                            to: 100,                 // 标示区结束值
                                            label: {              // 标示区文字标签配置，详见API
                                            },
                                            color: '#defde9',            // 标示区背景颜色
                                            borderWidth: 1,        // 标示区边框宽度
                                            borderColor: null        // 标示区边框颜色
                                        }
                                    ]
                                },
                                exporting: {
                                    enabled: false
                                },
                                credits: {
                                    enabled: false
                                },
                                plotOptions: {
                                    series: {
                                        connectNulls: true,
                                        color: getColor(data.healthIndex),
                                        lineWidth: 1,
                                        marker: {
                                            radius: 3,
                                            lineColor: getColor(data.healthIndex),
                                            lineWidth: 1,
                                            fillColor: "#fff",
                                            symbol: 'circle'//曲线点类型："circle", "square", "diamond", "triangle","triangle-down"，默认是"circle"
                                        }
                                    },
                                    line: {
                                        dataLabels: {
                                            enabled: true,
                                            style: {
                                                'fontSize': '10px',
                                                'fontWeight': 'normal'
                                            }
                                        },
                                        enableMouseTracking: false
                                    }
                                },
                                legend: {
                                    enabled: false
                                },
                                series: [
                                    {
                                        type: 'line',
                                        name: changeName(data.healthIndex),
                                        data: getMbData(data)
                                    }
                                ]
                            });
                        } else if (data.healthIndex == 'bs') {
                            $scope.xt2 = getTickData(data, 'XT2');
                            $("#xy_" + index + "_" + timeCategory + "_XT2").highcharts({
                                chart: {
                                },
                                title: {
                                    text: ''
                                },
                                subtitle: {
                                    text: ''
                                },
                                xAxis: {
                                    categories: getDetailX(data.timeCategory),
                                    labels: {
                                        style: {
                                            'fontSize': setFontSize(data.timeCategory)
                                        }
                                    },
                                    tickLength: null,
                                    lineWidth: 0.02,
                                    fontColor: '#423c40'
                                },
                                yAxis: {
                                    max: $scope.xt2[0],
                                    min: $scope.xt2[1],
                                    gridLineWidth: 0.2,
                                    tickInterval: Math.abs($scope.xt2[2]),
                                    tickPositions: getTickPost1(data),
                                    labels: {
                                        formatter: function () {
                                            return this.value.toFixed(getFixedNum(data.healthIndex));
                                        }
                                    },
                                    title: {
                                        text: ''
                                    },
                                    plotBands: [
                                        {
                                            from: 4.4,               // 标示区开始值
                                            to: 8.0,                 // 标示区结束值
                                            label: {              // 标示区文字标签配置，详见API
                                            },
                                            color: '#defde9',            // 标示区背景颜色
                                            borderWidth: 1,        // 标示区边框宽度
                                            borderColor: null        // 标示区边框颜色
                                        }/*,
                                         {
                                         from: $scope[index + '_' + timeCategory].nData[2],               // 标示区开始值
                                         to: $scope[index + '_' + timeCategory].nData[3],                 // 标示区结束值
                                         label: {              // 标示区文字标签配置，详见API
                                         },
                                         color: '#fefaf7',            // 标示区背景颜色
                                         borderWidth: 1,        // 标示区边框宽度
                                         borderColor: null       // 标示区边框颜色
                                         }*/
                                    ]
                                },
                                exporting: {
                                    enabled: false
                                },
                                credits: {
                                    enabled: false
                                },
                                /*                                                                tooltip: {
                                 backgroundColor: '#FCFFC5',   // 背景颜色
                                 borderColor: getColor(data.healthIndex),         // 边框颜色
                                 borderRadius: 10,             // 边框圆角
                                 borderWidth: 0,               // 边框宽度
                                 shadow: false,               // 是否显示阴影
                                 animation: false,               // 是否启用动画效果
                                 enabled: true,
                                 style: {
                                 'fontSize': '12px',
                                 'fontWeight': 'normal'
                                 },
                                 formatter: function () {
                                 return  '时间:' + getDataTime(changeNum(this.x), data) + '<br/>' + '<span>' + this.series.name + ':' + this.y + '</span>' +
                                 '<p style="font-size:10px;">' + getUnit(data.healthIndex) + '</p>';
                                 }
                                 },*/
                                plotOptions: {
                                    series: {
                                        connectNulls: true,
                                        color: getColor(data.healthIndex),
                                        lineWidth: 1,
                                        marker: {
                                            radius: 3,
                                            lineColor: getColor(data.healthIndex),
                                            lineWidth: 1,
                                            fillColor: "#fff",
                                            symbol: 'circle'//曲线点类型："circle", "square", "diamond", "triangle","triangle-down"，默认是"circle"
                                        }
                                    },
                                    line: {
                                        dataLabels: {
                                            enabled: true,
                                            style: {
                                                'fontSize': '10px',
                                                'fontWeight': 'normal'
                                            }
                                        },
                                        enableMouseTracking: false
                                    }
                                },
                                legend: {
                                    enabled: false
                                },
                                series: [
                                    {
                                        type: 'line',
                                        name: changeName(data.healthIndex),
                                        data: getXT2Data(data)
                                    }
                                ]
                            });
                        } else if (data.healthIndex == 'bmi') {
                            $scope.tzTick = getTickData(data, 'TZ');
                            $("#xy_" + index + "_" + timeCategory + "_tz").highcharts({
                                chart: {
                                },
                                title: {
                                    text: ''
                                },
                                subtitle: {
                                    text: ''
                                },
                                xAxis: {
                                    categories: getDetailX(data.timeCategory),
                                    labels: {
                                        style: {
                                            'fontSize': setFontSize(data.timeCategory)
                                        }
                                    },
                                    tickLength: null,
                                    lineWidth: 0.02,
                                    fontColor: '#423c40'
                                },
                                yAxis: {
                                    max: $scope.tzTick[0],
                                    min: $scope.tzTick[1],
                                    gridLineWidth: 0.2,
                                    tickInterval: Math.abs($scope.tzTick[2]),
                                    tickPositions: getTickPost(data),
                                    labels: {
                                        formatter: function () {
                                            return this.value.toFixed(getFixedNum(data.healthIndex));
                                        }
                                    },
                                    title: {
                                        text: ''
                                    },
                                    plotBands: [
                                        {
                                            from: 4.4,               // 标示区开始值
                                            to: 8.0,                 // 标示区结束值
                                            label: {              // 标示区文字标签配置，详见API
                                            },
                                            color: '#defde9',            // 标示区背景颜色
                                            borderWidth: 1,        // 标示区边框宽度
                                            borderColor: null        // 标示区边框颜色
                                        }
                                    ]
                                },
                                exporting: {
                                    enabled: false
                                },
                                credits: {
                                    enabled: false
                                },
                                plotOptions: {
                                    series: {
                                        connectNulls: true,
                                        color: getColor(data.healthIndex),
                                        lineWidth: 1,
                                        marker: {
                                            radius: 3,
                                            lineColor: getColor(data.healthIndex),
                                            lineWidth: 1,
                                            fillColor: "#fff",
                                            symbol: 'circle'//曲线点类型："circle", "square", "diamond", "triangle","triangle-down"，默认是"circle"
                                        }
                                    },
                                    line: {
                                        dataLabels: {
                                            enabled: true,
                                            style: {
                                                'fontSize': '10px',
                                                'fontWeight': 'normal'
                                            }
                                        },
                                        enableMouseTracking: false
                                    }
                                },
                                legend: {
                                    enabled: false
                                },
                                series: [
                                    {
                                        type: 'line',
                                        name: changeName(data.healthIndex),
                                        data: getTZData(data)
                                    }
                                ]
                            });
                        }
                    },
                    function (error) {
                        Loading.hide('running_woman', "健康");
                    });
            }
            else {
                // $scope.latestData.examTime = $scope[index].examTime;
                //  $scope.latestData.tData = $scope[index].tData;
                //  $scope.latestData.SsyData = $scope[index + '_' + timeCategory].SsyData;
                // console.log($scope.latestData.SsyData);
                // $scope.latestData.SzyData = $scope[index + '_' + timeCategory].SzyData;
            }
        }
        ;
        var index1 = getIndex($state.current.name);
        $scope.getData(index1, "", "Week");
        $scope.goBack = function () {
            // $state.go($stateParams.backUrl);
            $ionicNativeTransitions.stateGo('tab.health', {}, {
                "type": "slide",
                "direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
                "duration": 600// in milliseconds (ms), default 400
            });
        };
        /**
         * 跳转到详细数据页面
         */
        $scope.goDetail = function (index, backUrl) {
            $ionicNativeTransitions.stateGo(index, {backUrl: backUrl}, {
                "type": "slide",
                "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
                "duration": 600// in milliseconds (ms), default 400
            });
        };
        $scope.form = {
            showEnter: true
        };
        /**
         * 判断是否是亲朋，不可录入
         */
        if ($scope.systemUserId) {
            $scope.form.showEnter = false;
        } else {
            $scope.form.showEnter = true;
        }
        /**
         * 跳转到录入页面
         */
        $scope.goEnter = function (index, backUrl) {
            $ionicNativeTransitions.stateGo(index, {backUrl: backUrl}, {
                "type": "slide",
                "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
                "duration": 600// in milliseconds (ms), default 400
            });
        };
        /**
         * 收到物理返回键按钮事件
         */
        $rootScope.$on('HARDWARE_BACK', function () {
            $scope.goBack();
        });
    })
;