var dy = 80;
var gy = 120;
angular.module('HealthEnter', [])
    .factory('enterService', function ($http, $q, $rootScope) {
        // Might use a resource here that returns a JSON array
        return {
            //上传健康数据
            postHealthData: function (dataType, method, id, itemCodes, values, remark, time) {
                var q = $q.defer();
                // alert($rootScope.token);
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/open/data/manage.htm",
                    /* url: "localhost:8080/HealthMonitor" + "/open/data/manage.htm",*/
                    params: {
                        token: $rootScope.token,
                        dataType: dataType,
                        method: method,
                        id: id,
                        itemCodes: itemCodes,
                        values: values,
                        remark: remark,
                        time: time
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            }
        };
    })
/**
 * 血糖手工录入
 */
    .controller('xtenterController', function ($scope, $timeout, $state, $ionicScrollDelegate, $cacheFactory, enterService, $rootScope, $cordovaToast) {
        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }
        var self = true;
        $scope.systemUserId = user_cache.get('systemUserId');
        if ($scope.systemUserId)  //只能为自己录入数据
        {
            return false;
        }
        $scope.form = {
            nowDate: date2str(new Date(), 'yyyy-MM-dd'),
            nowTime: date2str(new Date(), 'hh:mm'),
            flag: "XT1",
            button_clicked: false
        },
            $('#zz_enterDate').mobiscroll().date({
                theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
                mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
                dateFormat: 'yyyy-mm-dd',
                display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
                lang: 'zh',     // Specify language like: lang: 'pl' or omit setting to use default
                maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate())
            });
        $scope.selectDate = function () {
            $("#zz_enterDate").trigger('click');
        };

        $('#zz_enterTime').mobiscroll().time({
            theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
            mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
            display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
            lang: 'zh',       // Specify language like: lang: 'pl' or omit setting to use default
            maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), new Date().getHours(), new Date().getMinutes())
        });
        $scope.selectTime = function () {
            $("#zz_enterTime").trigger('click');
        };

        var z = 1;  //血糖值
        $timeout(function () {
            $ionicScrollDelegate.$getByHandle('xuetang').scrollBy(88.142222, 0);
        }, 100);
        $("#xtz").text(z);  //页面加载赋初值
        //减少血糖数量
        $scope.less_add = function () {
            $("#xt_less").attr("src", "img/g_lessen.png");
        };
        $scope.lessen = function () {
            $("#xt_less").attr("src", "img/g_lessen_up.png");
            $ionicScrollDelegate.$getByHandle('xuetang').scrollBy(-4.4071111, 0); //向左滚动
        };

        //增加血糖数量
        $scope.xinlv_add = function () {
            $("#xt_plus").attr("src", "img/g_add_down.png");
        };
        $scope.add = function () {
            $("#xt_plus").attr("src", "img/g_add.png");
            $ionicScrollDelegate.$getByHandle('xuetang').scrollBy(4.4071111, 0); //向右滚动
        };
        //滑动改变值
        $scope.scroll = function () {
            /*
             console.log($ionicScrollDelegate.$getByHandle('xuetang').getScrollPosition().left);
             console.log(((($ionicScrollDelegate.$getByHandle('xuetang').getScrollPosition().left)/42.9167)+1).toFixed(1));*/
            z = ((($ionicScrollDelegate.$getByHandle('xuetang').getScrollPosition().left) / 44.071111) + 1).toFixed(1);
            $("#xtz").text(z);
        };

        //选择进食时间
        $scope.selectItem = function (str) {
            $scope.form.flag = str;
        };

        //提交数据
        var dataType = "bs"; //血糖
        var method = "add";
        var id = null;  //流水号
        var remark = "";
        $scope.postData = function (flag) {
            if (flag) {
                $scope.form.button_clicked = true;
                $timeout(function () {
                    $scope.form.button_clicked = false;
                }, 3000);
            } else {
                $("#zz_health_post").attr("disabled", true);
                $timeout(function () {
                    $("#zz_health_post").attr("disabled", false);
                }, 3000);
            }
            var values = parseFloat($("#xtz").text()).toFixed(1);
            var itemCodes = $scope.form.flag;//早餐前
            var dates = $scope.form.nowDate;
            var times = $scope.form.nowTime;
            console.log("values:" + values + "\n" + "itemcode:" + itemCodes);
            var temper = dates + " " + times;
            var d = new Date(temper.replace(/-/g, "/"));
            d.setSeconds(new Date().getSeconds());
            var time = d.getTime();
            enterService.postHealthData(dataType, method, id, itemCodes, values, remark, time).then(function (d) {
                console.log(d);
                $cordovaToast.showShortBottom('提交成功').then(function (success) {
                    // success
                }, function (error) {
                    // error
                });
                $rootScope.$emit("CHECK_BS");  //发送广播
                $state.go("tab.health");

            }, function (e) {
                console.log(e);
                ErrorShow(e.error);
            });
        }

    })

/**
 * 血压手工录入
 */
    .controller('xyenterController', function ($scope, $timeout, $ionicScrollDelegate, $cacheFactory, enterService, $state, $rootScope, $cordovaToast) {
        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }
        $timeout(function () {
            $ionicScrollDelegate.$getByHandle('xycontent').scrollBy(0, 200);
        });
        $scope.systemUserId = user_cache.get('systemUserId');
        if ($scope.systemUserId)  //只能为自己录入数据
        {
            return false;
        }
        $scope.form = {
            nowDate: date2str(new Date(), 'yyyy-MM-dd'),
            nowTime: date2str(new Date(), 'hh:mm'),
            flag: "XT1",
            button_clicked: false
        }
        $('#zz_enterDate').mobiscroll().date({
            theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
            mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
            dateFormat: 'yyyy-mm-dd',
            display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
            lang: 'zh',        // Specify language like: lang: 'pl' or omit setting to use default
            maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate())
        });
        $scope.selectDate = function () {
            $("#zz_enterDate").trigger('click');
        };

        $('#zz_enterTime').mobiscroll().time({
            theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
            mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
            display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
            lang: 'zh',        // Specify language like: lang: 'pl' or omit setting to use default
            maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), new Date().getHours(), new Date().getMinutes())
        });
        $scope.selectTime = function () {
            $("#zz_enterTime").trigger('click');
        };

        /**
         * 高压调节
         */
            //手指按下事件
        $scope.gDown = function () {
            console.log("按下");
            $("#xt2").attr("src", "img/g_lessen.png");
        };
        $timeout(function () {
            $ionicScrollDelegate.$getByHandle('gxueya').scrollBy(287.464266, 0);
            $ionicScrollDelegate.$getByHandle('dxueya').scrollBy(191.642844, 0);
            $ionicScrollDelegate.$getByHandle('maibo').scrollBy(95.9641786, 0);
        }, 100)
        //var z=60;  //收缩压值
        $("#xyz").text(gy);  //页面加载赋初值
        //减少血糖数量
        $scope.glessen = function () {
            $("#xt2").attr("src", "img/g_lessen_up.png");
            $ionicScrollDelegate.$getByHandle('gxueya').scrollBy(-4.7910711, 0); //向左滚动
        };

        //增加血糖数量
        $scope.gaddDown = function () {
            console.log("按下");
            $("#xt3").attr("src", "img/g_add_down.png");
        };
        $scope.gadd = function () {
            $("#xt3").attr("src", "img/g_add.png");
            $ionicScrollDelegate.$getByHandle('gxueya').scrollBy(4.7910711, 0); //向右滚动
        };
        //滑动改变值
        $scope.scroll = function () {
//            console.log($ionicScrollDelegate.$getByHandle('gxueya').getScrollPosition().left);
//            console.log(((($ionicScrollDelegate.$getByHandle('gxueya').getScrollPosition().left)/47.910711)*10+60).toFixed(0));
            gy = ((($ionicScrollDelegate.$getByHandle('gxueya').getScrollPosition().left) / 47.910711) * 10 + 60).toFixed(0);
            /*console.log("低压："+dy+"\n"+"高压："+gy);*/
            /* if(gy<dy){
             // ErrorShow("收缩压不能低于舒张压");
             $ionicScrollDelegate.$getByHandle('gxueya').scrollBy(4.7910711*(dy-gy), 0); //向右滚动
             $("#xyz").text(gy);
             return false;
             }*/
            $("#xyz").text(gy);
            $("#dxy").text(dy);
        }

        /**
         * 低压调节
         */
            //鼠标按下事件
        $scope.dmouseDown = function () {
            console.log("按下");
            $("#dyj").attr("src", "img/g_lessen.png");
        }
        //var dz=40;  //舒张压值
        $("#dxy").text(dy);  //页面加载赋初值
        //减少低压数量
        $scope.dlessen = function () {
            $("#dyj").attr("src", "img/g_lessen_up.png");
            $ionicScrollDelegate.$getByHandle('dxueya').scrollBy(-4.7910711, 0); //向左滚动
            $("#dxy").text(dy);
        }

        //增加低压数量
        $scope.dypmouseDown = function () {
            console.log("按下");
            $("#dyp").attr("src", "img/g_add_down.png");
        }
        $scope.dadd = function () {
            $("#dyp").attr("src", "img/g_add.png");
            $ionicScrollDelegate.$getByHandle('dxueya').scrollBy(4.7910711, 0); //向右滚动
        };
        //滑动改变值
        $scope.dscroll = function () {
            console.log($ionicScrollDelegate.$getByHandle('dxueya').getScrollPosition().left);
            // console.log(((($ionicScrollDelegate.$getByHandle('dxueya').getScrollPosition().left)/47.910711)*10+40).toFixed(0));
            dy = ((($ionicScrollDelegate.$getByHandle('dxueya').getScrollPosition().left) / 47.910711) * 10 + 40).toFixed(0);
            // console.log("低压："+dy+"\n"+"高压："+gy);
            /* if(dy>=gy){
             console.log("低压："+dy+"\n"+"高压："+gy);
             // ErrorShow("舒张压不能高于收缩压");
             $ionicScrollDelegate.$getByHandle('gxueya').scrollBy(4.7910711*(dy-gy), 0); //向右滚
             gy=dy;
             $("#xyz").text(gy);
             return false;
             }*/
            $("#dxy").text(dy);
            $("#xyz").text(gy);
        }

        /**
         * 脉搏调节
         */

        var mo = 40;  //舒张压值
        $("#mb").text(mo);  //页面加载赋初值
        //减少脉搏数量
        //鼠标按下事件
        $scope.mmouseDown = function () {
            $("#mbless").attr("src", "img/g_lessen.png");
        }
        $scope.mlessen = function () {
            $("#mbless").attr("src", "img/g_lessen_up.png");
            $ionicScrollDelegate.$getByHandle('maibo').scrollBy(-4.7910711, 0); //向左滚动
        }

        //增加脉搏数量
        $scope.addDown = function () {
            $("#mbadd").attr("src", "img/g_add_down.png");
        }
        $scope.madd = function () {
            $("#mbadd").attr("src", "img/g_add.png");
            $ionicScrollDelegate.$getByHandle('maibo').scrollBy(4.7910711, 0); //向右滚动
        };
        //滑动改变值
        $scope.mscroll = function () {
            /*  console.log($ionicScrollDelegate.$getByHandle('maibo').getScrollPosition().left);
             console.log(((($ionicScrollDelegate.$getByHandle('maibo').getScrollPosition().left)/47.910711)*10+40).toFixed(0));*/
            mo = ((($ionicScrollDelegate.$getByHandle('maibo').getScrollPosition().left) / 47.910711) * 10 + 40).toFixed(0);
            $("#mb").text(mo);
        }
        //提交数据
        var dataType = "bp"; //血压
        var method = "add";
        var id = null;  //流水号
        var remark = "";
        $scope.postData = function (flag) {
            if (flag) {
                $scope.form.button_clicked = true;
                $timeout(function () {
                    $scope.form.button_clicked = false;
                }, 3000);
            } else {
                $("#zz_health_post").attr("disabled", true);
                $timeout(function () {
                    $("#zz_health_post").attr("disabled", false);
                }, 3000);
            }
            var xyz = parseInt($("#xyz").text()); //高压
            var dxy = parseInt($("#dxy").text());  //低压
            var mb = parseInt($("#mb").text());  //脉搏
            var values = xyz + "," + dxy + "," + mb;
            console.log("血压数据：" + values);
            var itemCodes = "SSY,SZY,MB";
            var dates = $scope.form.nowDate;
            var times = $scope.form.nowTime;
            console.log("values:" + values + "\n" + "itemcode:" + itemCodes);
            var temper = dates + " " + times;
            var d = new Date(temper.replace(/-/g, "/"));
            d.setSeconds(new Date().getSeconds());
            var time = d.getTime();
            console.log(time);
            console.log("上传血压数据");
            //判断录入数据是否合法
            if (xyz <= dxy) { //如果高压小于低压
                console.log(xyz, dxy);
                ErrorShow("低压不能高于高压值");
                return;
            }
            //判断脉搏值合法性
            if (mb < 40 || mb > 180) {
                ErrorShow("脉搏值应在40~180之间");
                return false;
            }
            enterService.postHealthData(dataType, method, id, itemCodes, values, remark, time).then(function (d) {
                console.log(d);
                dy = 40;
                gy = 60;
                $cordovaToast.showShortBottom('提交成功').then(function (success) {
                    // success
                }, function (error) {
                    // error
                });
                $rootScope.$emit("CHECK_BP");  //发送广播
                $state.go("tab.health");
            }, function (e) {
                console.log(e);
                ErrorShow(e.error);
            });
        }

    })

/**
 * 血氧手工录入
 */
    .controller('xueyangController', function ($scope, $timeout, $ionicScrollDelegate, $cacheFactory, enterService, $state, $rootScope, $cordovaToast) {
        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }
        $scope.systemUserId = user_cache.get('systemUserId');
        if ($scope.systemUserId)  //只能为自己录入数据
        {
            return false;
        }
        $scope.form = {
            nowDate: date2str(new Date(), 'yyyy-MM-dd'),
            nowTime: date2str(new Date(), 'hh:mm'),
            flag: "XT1",
            button_clicked: false
        },
            $('#zz_enterDate').mobiscroll().date({
                theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
                mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
                dateFormat: 'yyyy-mm-dd',
                display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
                lang: 'zh',        // Specify language like: lang: 'pl' or omit setting to use default
                maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate())
            });
        $scope.selectDate = function () {
            $("#zz_enterDate").trigger('click');
        };

        $('#zz_enterTime').mobiscroll().time({
            theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
            mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
            display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
            lang: 'zh',       // Specify language like: lang: 'pl' or omit setting to use default
            maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), new Date().getHours(), new Date().getMinutes())
        });
        $scope.selectTime = function () {
            $("#zz_enterTime").trigger('click');
        };

        var z = 80;  //血氧值
        $timeout(function () {  //向右滚动5单位
            $ionicScrollDelegate.$getByHandle('xueyang').scrollBy(24.25, 0);
        }, 100);
        $("#xyang").text(z);  //页面加载赋初值
        //减少数量
        $scope.xueyangless = function () {
            $("#xyang_less").attr("src", "img/g_lessen.png");
        }
        $scope.lessen = function () {
            $("#xyang_less").attr("src", "img/g_lessen_up.png");
            $ionicScrollDelegate.$getByHandle('xueyang').scrollBy(-4.85, 0); //向左滚动
        }

        //增加数量
        $scope.xyangdown = function () {
            $("#xyang_plus").attr("src", "img/g_add_down.png");
        }
        $scope.add = function () {
            $("#xyang_plus").attr("src", "img/g_add.png");
            $ionicScrollDelegate.$getByHandle('xueyang').scrollBy(4.85, 0); //向右滚动
        };
        //滑动改变值
        $scope.scroll = function () {
            // console.log($ionicScrollDelsssssegate.$getByHandle('xueyang').getScrollPosition().left);
            /*console.log(((($ionicScrollDelegate.$getByHandle('xueyang').getScrollPosition().left)/48.5)*10+80).toFixed(0));*/
            z = ((($ionicScrollDelegate.$getByHandle('xueyang').getScrollPosition().left) / 48.5) * 10 + 80).toFixed(0);
            $("#xyang").text(z);
        }

        //选择进食时间
        $scope.selectItem = function (str) {
            $scope.form.flag = str;
        }

        //提交数据
        var dataType = "ox"; //血氧
        var method = "add";
        var id = null;  //流水号
        var remark = "";
        $scope.postData = function (flag) {
            if (flag) {
                $scope.form.button_clicked = true;
                $timeout(function () {
                    $scope.form.button_clicked = false;
                }, 3000);
            } else {
                $("#zz_health_post").attr("disabled", true);
                $timeout(function () {
                    $("#zz_health_post").attr("disabled", false);
                }, 3000);
            }
            var values = parseFloat($("#xyang").text()).toFixed(0);
            var itemCodes = "XY"; //血氧
            var dates = $scope.form.nowDate;
            var times = $scope.form.nowTime;
            console.log("values:" + values + "\n" + "itemcode:" + itemCodes);
            var temper = dates + " " + times;
            var d = new Date(temper.replace(/-/g, "/"));
            d.setSeconds(new Date().getSeconds());
            var time = d.getTime();
            console.log("上传血糖数据");
            /*if(z<80||z>100)
             return false;*/
            enterService.postHealthData(dataType, method, id, itemCodes, values, remark, time).then(function (d) {
                console.log(d);
                $cordovaToast.showShortBottom('提交成功').then(function (success) {
                    // success
                }, function (error) {
                    // error
                });
                $rootScope.$emit("CHECK_OX");  //发送广播
                $state.go("tab.health");
            }, function (e) {
                console.log(e);
                ErrorShow(e.error);
            });
        }

    })

/**
 * 心率手工录入
 */
    .controller('xlenterController', function ($scope, $timeout, $ionicScrollDelegate, $cacheFactory, enterService, $state, $rootScope, $cordovaToast) {
        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }
        $scope.systemUserId = user_cache.get('systemUserId');
        if ($scope.systemUserId)  //只能为自己录入数据
        {
            return false;
        }
        $scope.form = {
            nowDate: date2str(new Date(), 'yyyy-MM-dd'),
            nowTime: date2str(new Date(), 'hh:mm'),
            flag: "XT1",
            button_clicked: false
        },
            $('#zz_enterDate').mobiscroll().date({
                theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
                mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
                dateFormat: 'yyyy-mm-dd',
                display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
                lang: 'zh',        // Specify language like: lang: 'pl' or omit setting to use default
                maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate())
            });
        $scope.selectDate = function () {
            $("#zz_enterDate").trigger('click');
        };

        $('#zz_enterTime').mobiscroll().time({
            theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
            mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
            display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
            lang: 'zh',        // Specify language like: lang: 'pl' or omit setting to use default
            maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), new Date().getHours(), new Date().getMinutes())
        });
        $scope.selectTime = function () {
            $("#zz_enterTime").trigger('click');
        };

        var z = 40;  //血氧值
        $("#xinlv").text(z);  //页面加载赋初值
        $timeout(function () {
            $ionicScrollDelegate.$getByHandle('xinlv').scrollBy(95.9641786, 0);
        }, 100)
        //减少心率数量
        $scope.lessdown = function () {
            $("#xinlv_less").attr("src", "img/g_lessen.png");
        }
        $scope.lessen = function () {
            $("#xinlv_less").attr("src", "img/g_lessen_up.png");
            $ionicScrollDelegate.$getByHandle('xinlv').scrollBy(-4.79820893, 0); //向左滚动
        }

        //增加心率数量
        $scope.adddown = function () {
            $("#xinlv_plus").attr("src", "img/g_add_down.png");
        }
        $scope.add = function () {
            $("#xinlv_plus").attr("src", "img/g_add.png");
            $ionicScrollDelegate.$getByHandle('xinlv').scrollBy(4.79820893, 0); //向右滚动
        };
        //滑动改变值
        $scope.scroll = function () {
//          console.log($ionicScrollDelegate.$getByHandle('xinlv').getScrollPosition().left);
//            console.log(((($ionicScrollDelegate.$getByHandle('xinlv').getScrollPosition().left)/47.9820893)*10+40).toFixed(0));
            z = ((($ionicScrollDelegate.$getByHandle('xinlv').getScrollPosition().left) / 47.9820893) * 10 + 40).toFixed(0);
            $("#xinlv").text(z);
        }

        //选择进食时间
        $scope.selectItem = function (str) {
            $scope.form.flag = str;
        }

        //提交数据
        var dataType = "hr"; //心率
        var method = "add";
        var id = null;  //流水号
        var remark = "";
        $scope.postData = function (flag) {
            if (flag) {
                $scope.form.button_clicked = true;
                $timeout(function () {
                    $scope.form.button_clicked = false;
                }, 3000);
            } else {
                $("#zz_health_post").attr("disabled", true);
                $timeout(function () {
                    $("#zz_health_post").attr("disabled", false);
                }, 3000);
            }
            var values = parseFloat($("#xinlv").text()).toFixed(0);
            var itemCodes = "XL"; //心率
            var dates = $scope.form.nowDate;
            var times = $scope.form.nowTime;
            console.log("values:" + values + "\n" + "itemcode:" + itemCodes);
            var temper = dates + " " + times;
            var d = new Date(temper.replace(/-/g, "/"));
            d.setSeconds(new Date().getSeconds());
            var time = d.getTime();
            /*  if(z<40||z>180){
             return false;
             }*/
            console.log("上传心率数据");
            enterService.postHealthData(dataType, method, id, itemCodes, values, remark, time).then(function (d) {
                console.log(d);
                $cordovaToast.showShortBottom('提交成功').then(function (success) {
                    // success
                }, function (error) {
                    // error
                });
                $rootScope.$emit("CHECK_HR");  //发送广播
                $state.go("tab.health");
            }, function (e) {
                console.log(e);
                ErrorShow(e.error);
            });
        }

    })
/**
 * bmi手工录入
 */
    .controller('bmienterController', function ($scope, $timeout, $ionicScrollDelegate, $cacheFactory, enterService, $state, $rootScope, $cordovaToast) {
        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }
        $timeout(function () {
            $ionicScrollDelegate.$getByHandle('xycontent').scrollBy(0, 200);
        });
        $scope.systemUserId = user_cache.get('systemUserId');
        if ($scope.systemUserId)  //只能为自己录入数据
        {
            return false;
        }
        $scope.form = {
            nowDate: date2str(new Date(), 'yyyy-MM-dd'),
            nowTime: date2str(new Date(), 'hh:mm'),
            flag: "XT1",
            button_clicked: false
        },
            $('#zz_enterDate').mobiscroll().date({
                theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
                mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
                dateFormat: 'yyyy-mm-dd',
                display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
                lang: 'zh',        // Specify language like: lang: 'pl' or omit setting to use default
                maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate())
            });
        $scope.selectDate = function () {
            $("#zz_enterDate").trigger('click');
        };

        $('#zz_enterTime').mobiscroll().time({
            theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
            mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
            display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
            lang: 'zh',        // Specify language like: lang: 'pl' or omit setting to use default
            maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), new Date().getHours(), new Date().getMinutes())
        });
        $scope.selectTime = function () {
            $("#zz_enterTime").trigger('click');
        };
        /**
         * 身高调节
         */
            //手指按下事件
        $scope.gDown = function () {
            console.log("按下");
            $("#xt2").attr("src", "img/g_lessen.png");
        };

        var sg = 160;  //身高压值
        var tz = 50;  //体重初值
        $("#xyz").text(sg);  //页面加载赋初值
        $timeout(function () {  //向右滚动5单位
            $ionicScrollDelegate.$getByHandle('gxueya').scrollBy(527.017821, 0);
            $ionicScrollDelegate.$getByHandle('dxueya').scrollBy(133, 0);
        }, 100);
        //减少血糖数量
        $scope.glessen = function () {
            $("#xt2").attr("src", "img/g_lessen_up.png");
            $ionicScrollDelegate.$getByHandle('gxueya').scrollBy(-4.7910711, 0); //向左滚动
        };

        //增加血糖数量
        $scope.gaddDown = function () {
            console.log("按下");
            $("#xt3").attr("src", "img/g_add_down.png");
        };
        $scope.gadd = function () {
            $("#xt3").attr("src", "img/g_add.png");
            $ionicScrollDelegate.$getByHandle('gxueya').scrollBy(4.7910711, 0); //向右滚动
        };
        //滑动改变值
        $scope.scroll = function () {
//            console.log($ionicScrollDelegate.$getByHandle('gxueya').getScrollPosition().left);
//            console.log(((($ionicScrollDelegate.$getByHandle('gxueya').getScrollPosition().left)/47.910711)*10+60).toFixed(0));
            console.log("滑动值", ((($ionicScrollDelegate.$getByHandle('gxueya').getScrollPosition().left) / 44) * 10 + 40));
            sg = ((($ionicScrollDelegate.$getByHandle('gxueya').getScrollPosition().left) / 44) * 10 + 40).toFixed(0);
            /*console.log("低压："+dy+"\n"+"高压："+gy);*/
            /* if(gy<dy){
             // ErrorShow("收缩压不能低于舒张压");
             $ionicScrollDelegate.$getByHandle('gxueya').scrollBy(4.7910711*(dy-gy), 0); //向右滚动
             $("#xyz").text(gy);
             return false;
             }*/
            $("#xyz").text(sg);
            $("#dxy").text(tz);
        }

        /**
         * 体重调节
         */
            //鼠标按下事件
        $scope.dmouseDown = function () {
            console.log("按下");
            $("#dyj").attr("src", "img/g_lessen.png");
        }

        $("#dxy").text(tz);  //页面加载赋初值
        //减少低压数量
        $scope.dlessen = function () {
            $("#dyj").attr("src", "img/g_lessen_up.png");
            $ionicScrollDelegate.$getByHandle('dxueya').scrollBy(-4.45, 0); //向左滚动
            $("#dxy").text(dz);
        }

        //增加低压数量
        $scope.dypmouseDown = function () {
            console.log("按下");
            $("#dyp").attr("src", "img/g_add_down.png");
        }
        $scope.dadd = function () {
            $("#dyp").attr("src", "img/g_add.png");
            $ionicScrollDelegate.$getByHandle('dxueya').scrollBy(4.45, 0); //向右滚动
        };
        //滑动改变值
        $scope.dscroll = function () {
            console.log($ionicScrollDelegate.$getByHandle('dxueya').getScrollPosition().left);
            // console.log(((($ionicScrollDelegate.$getByHandle('dxueya').getScrollPosition().left)/47.910711)*10+40).toFixed(0));
            tz = ((($ionicScrollDelegate.$getByHandle('dxueya').getScrollPosition().left) / 44.5) * 10 + 20).toFixed(0);
            // console.log("低压："+dy+"\n"+"高压："+gy);
            /* if(dy>=gy){
             console.log("低压："+dy+"\n"+"高压："+gy);
             // ErrorShow("舒张压不能高于收缩压");
             $ionicScrollDelegate.$getByHandle('gxueya').scrollBy(4.7910711*(dy-gy), 0); //向右滚
             gy=dy;
             $("#xyz").text(gy);
             return false;
             }*/
            $("#dxy").text(tz);
            $("#xyz").text(sg);
        }
        $scope.postData = function (flag) {
            if (flag) {
                $scope.form.button_clicked = true;
                $timeout(function () {
                    $scope.form.button_clicked = false;
                }, 3000);
            } else {
                $("#zz_health_post").attr("disabled", true);
                $timeout(function () {
                    $("#zz_health_post").attr("disabled", false);
                }, 3000);
            }
            var xyz = parseInt($("#xyz").text()); //身高
            var dxy = parseInt($("#dxy").text());  //体重
            var values = xyz + "," + dxy;
            console.log("BMI数据：" + values);
            var itemCodes = "SG,TZ";
            var dates = $scope.form.nowDate;
            var times = $scope.form.nowTime;
            console.log("values:" + values + "\n" + "itemcode:" + itemCodes);
            var temper = dates + " " + times;
            var d = new Date(temper.replace(/-/g, "/"));
            d.setSeconds(new Date().getSeconds());
            var time = d.getTime();
            console.log(time);
            console.log("上传bmi数据");
            enterService.postHealthData("bmi", "add", null, itemCodes, values, "", time).then(function (d) {
                console.log(d);
                dy = 40;
                gy = 60;
                $rootScope.user.stature = xyz;
                $cordovaToast.showShortBottom('提交成功').then(function (success) {
                    // success
                }, function (error) {
                    // error
                });
                $rootScope.$emit("CHECK_BMI");  //发送广播
                $state.go("tab.health");
            }, function (e) {
                console.log(e);
                ErrorShow(e.error);
            });
        }

    })



