angular.module('Hospital', ['MY_MAP'])

    .factory('nearbyHospitalService', function ($q) {
        var dataBase = null;
        return {
            init: function () {
                dataBase = openDatabase("healthPatient", "1.0", "心常态", 4096 * 1024, function () {
                    dataBase.transaction(function (tx) {
                        //医院搜索历史
                        tx.executeSql(
                            "create table if not exists place_search_history (name TEXT, address TEXT, type TEXT, lat TEXT, lng TEXT)",
                            [],
                            function (tx, result) {
                                console.log(" table place_search_history success");
                            },
                            function (tx, error) {
                            });
                    });
                });
            },
            PlaceSearchHistory: {
                deleteByName: function (history) {
                    var q = $q.defer();
                    dataBase.transaction(function (tx) {
                        tx.executeSql(
                            "delete from place_search_history where name=?", [history.placeName],
                            function (tx, result) {
                            },
                            function (tx, error) {
                                q.reject("error");
                            }
                        );
                    });
                },
                insert: function (history) {
                    var q = $q.defer();
                    dataBase.transaction(function (tx) {
                            tx.executeSql("insert into place_search_history values(?,?,?,?,?)",
                                [history.placeName + '', history.placeAddress + '', history.placeType + '', history.placeLat + '', history.placeLng + ''],
                                function () {
                                },
                                function (tx, error) {
                                });
                        }, function () {
                            q.reject("error");
                        }
                    );
                },
                find: function (num) {
                    var q = $q.defer();
                    var historys = [];
                    dataBase.transaction(function (tx) {
                        tx.executeSql(
                            "select * from place_search_history order by rowid desc limit ?", [num],
                            function (tx, result) {
                                var length = result.rows.length;
                                for (var i = 0; i < length; i++) {
                                    var h = new Object();
                                    h.placeName = result.rows.item(i)["name"];
                                    h.placeAddress = result.rows.item(i)["address"];
                                    h.placeType = result.rows.item(i)["type"];
                                    h.placeLat = result.rows.item(i)["lat"];
                                    h.placeLng = result.rows.item(i)["lng"];
                                    historys.push(h);
                                }
                                q.resolve(historys);
                            },
                            function (tx, error) {
                                q.reject("get medicines from database error");
                            }
                        );
                    });
                    return q.promise;
                },
                clear: function () {
                    dataBase.transaction(function (tx) {
                            tx.executeSql("delete from place_search_history",
                                [],
                                function () {
                                },
                                function (tx, error) {
                                });
                        }, function () {
                            q.reject("error");
                        }
                    );
                }
            }

        }
    })
    .directive("appMap", function ($rootScope, MY_MAP) {
        return {
            restrict: "E",
            replace: true,
            template: '<div id="map" style="height:' + ($rootScope.screenHeight - 44) + 'px"></div>',
            scope: {
                center: "=",        // Center point on the map (e.g. <code>{ latitude: 10, longitude: 10 }</code>).
                markers: "=",       // Array of map markers (e.g. <code>[{ lat: 10, lon: 10, name: "hello" }]</code>).
                width: "@",         // Map width in pixels.
                height: "@",        // Map height in pixels.
                zoom: "@",          // Zoom level (one is totally zoomed out, 25 is very much zoomed in).
                zoomControl: "@",   // Whether to show a zoom control on the map.
                scaleControl: "@",   // Whether to show scale control on the map.
                address: "@",
                type: "=" //类型 医院或是药店
            },
            link: function (scope, element, attrs) {
                scope.page = 1;
                var map = new AMap.Map("map", {
                    resizeEnable: true
                });
                $(".amap-copyright").css("display", "none");
                $(".amap-logo").css("display", "none");
                map.setZoom(13);
                map.setCenter(MY_MAP.get_pos());
                MY_MAP.search(scope.type, 1).then(function (data) {
                    console.log(data);
                    var list = data.list;
                    for (var i in list) {
                        var o = list[i];
                        var e = document.createElement("div");
                        e.setAttribute("class", "locate");
                        e.innerHTML = parseInt(i)+1;
                        var marker = new AMap.Marker({
                            map: map,
                            position: [o.location.lng, o.location.lat],
                            content: e,
                            extData: list[i]
                        });
                        marker.on('click', function (e) {
                            scope.$emit("scanDetail", e.target.Ae.extData);
                        });
                    }
                    scope.$emit("searchOK", data);
                }, function (error) {
                });

//                placeSearch.searchNearBy(scope.type, np, 100000, function (status, result) {
//                    console.log(result);
//                    if (result.info == 'OK') {
//                        var list = result.poiList.pois;
//                        for (var i = 0; i < list.length; i++) {
//                            var o = list[i];
//                            var e = document.createElement("div");
//                            e.setAttribute("class", "locate");
//                            e.innerHTML = i;
//                            var marker = new AMap.Marker({
//                                map: map,
//                                position: [o.location.lng, o.location.lat],
//                                content: e,
//                                extData: list[i]
//                            });
//                            marker.on('click', function (e) {
//                                scope.$emit("scanDetail", e.target.Ae.extData);
//                            });
//                        }
//                        map.setCenter(new AMap.LngLat(np[0], np[1] - 0.02));
//                    }
//                    scope.$emit("searchOK", result);
//                });
//
//                scope.$on('search', function (event, data) {
//                    placeSearch = new AMap.PlaceSearch({
//                        pageIndex: data.pageNow,
//                        pageSize: data.pageSize
//                    });
//                    placeSearch.searchNearBy(data.keyword, np, 5000, function (status, result) {
//                        if (result.info == 'OK') {
//                            map.clearMap();
//                            map.setZoom(13);
//                            var list = result.poiList.pois;
//                            for (var i = 0; i < list.length; i++) {
//                                var o = list[i];
//                                var e = document.createElement("div");
//                                e.setAttribute("class", "locate");
//                                e.innerHTML = i + 1;
//                                var marker = new AMap.Marker({
//                                    map: map,
//                                    position: [o.location.lng, o.location.lat],
//                                    content: e,
//                                    extData: list[i]
//                                });
//                                marker.on('click', function (e) {
//                                    scope.$emit("scanDetail", e.target.Ae.extData);
//                                });
//                            }
//                        }
//                        scope.$emit("searchOK", result);
//                    });
//                });
//                scope.$on('searchMore', function (event, data) {
//                    placeSearch = new AMap.PlaceSearch({
//                        type: '医疗',
//                        pageIndex: data.pageNow,
//                        pageSize: data.pageSize
//                    });
//                    placeSearch.searchNearBy(data.keyword, np, 5000, function (status, result) {
//                        if (result.info == 'OK') {
//                            scope.$emit("searchMoreOK", {result: result.poiList});
//                        }
//                    });
//                });
//                scope.$on('zoomMap', function (event, data) {
//                    map.setZoom(data.level);
//                    if (data.type == 'big') {
//                        map.setCenter(new AMap.LngLat(np[0], np[1]));
//                    } else {
//                        map.setCenter(new AMap.LngLat(np[0], np[1] - 0.02));
//                        $('#map').css('z-index', 0);
//                    }
//                });

                scope.$on('SHOW_LIST', function (evt, data) {
                    map.setZoom(13);
                    $('#map').css('height', $rootScope.screenHeight - 44).css('z-index', 0);
                });

                scope.$on('ENLARGE_MAP', function (evt, data) {
                    map.setZoom(14);
                    $('#map').css('height', $rootScope.screenHeight - 44).css('z-index', 3);
                });
            }
        }

    })

    .controller('nearbyHospitalController', function ($rootScope, $scope, $cacheFactory, nearbyHospitalService, $ionicNativeTransitions, $state, $ionicModal, $timeout, $ionicScrollDelegate, $stateParams, MY_MAP) {
      console.log("返回地址:",$stateParams.backUrl);
      var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('special_back', true);

        $scope.$on($state.current.name + '_HARDWARE_BACK', function (evt, data) {
            if ($scope.detailModal.isShown()) {
                $scope.detailModal.hide();
            } else {
                $scope.goBack();
            }
        });

        $scope.hide_detail = function () {
            $scope.detailModal.hide();
        };

        var delegate = null;
        //传入参数
        var type = $stateParams.type;
        $scope.myparam = {type: type};

        var get_delegate = function () {
            if (!delegate) {
                var ins = $ionicScrollDelegate.$getByHandle('search_result_content_handle')._instances;
                for (var i = ins.length - 1; i >= 0; i--) {
                    if (ins[i].$$delegateHandle == 'search_result_content_handle') {
                        delegate = ins[i];
                        break;
                    }
                }
            }
            return delegate;
        };

        //页面参数
        $scope.param = {
            form: {keyword: type, pageNow: 1, pageSize: 10},
            data: {list: [], history: [], keyword: type, count: 0},
            flag: {big: false, click: false}
        };
        //医院搜索历史modal
        $ionicModal.fromTemplateUrl('hospitalInput.html', {
            scope: $scope,
            animation: 'slide-in-left'
        }).then(function (modal) {
            $scope.modal = modal;
        });
        //打开医院搜索历史模态框
        $scope.openModal = function () {
            console.log('11111111111111');
            var d = $scope.param.data;
            console.log(d);
            nearbyHospitalService.PlaceSearchHistory.find(10).then(function (data) {
                d.history = data;
            }, function (error) {
                console.log('111eeeeeee');
            });
            $scope.modal.show();
            console.log('eeeeeee');
        };
        /**
         * 关闭医院搜索历史模态框
         */
        $scope.closeModal = function () {
            $scope.modal.hide();
        };
        //医院详情模态框加载
        $ionicModal.fromTemplateUrl('hospitalDetail.html', {
            scope: $scope,
            animation: 'slide-in-left'
        }).then(function (modal) {
            console.log('11111111111');
            $scope.detailModal = modal;
        });
        /**
         * 打开医院详情模态框
         */
        $scope.openDetailModal = function () {
            console.log('22222222222222');
            $scope.detailModal.show();
        };
        /**
         * 关闭医院详情模态框
         */
        $scope.closeDetailModal = function () {
            $scope.detailModal.hide();
        };
        //离开页面时清除搜索历史模态框
        $scope.$on('$destroy', function () {
            $scope.modal.remove();
        });
        /**
         * 搜索关键词
         */
        $scope.search = function () {
            var form = $scope.param.form;
            if (form.keyword) {
                var history = new Object();
                history.placeName = form.keyword;//关键词
                history.placeType = 1;//1:模糊 2:精确
                history.placeAddress = '';//地址
                history.placeLat = '';//纬度
                history.placeLng = '';//精度
                nearbyHospitalService.PlaceSearchHistory.deleteByName(history);
                nearbyHospitalService.PlaceSearchHistory.insert(history);
                $scope.modal.hide();
                $scope.$broadcast("search", form);
            } else {
                //TODO 关键词为空反馈
            }
        };
        /**
         * 通过历史查询
         * @param h
         */
        $scope.searchByHistory = function (h) {
            var form = $scope.param.form;
            form.keyword = h.placeName;
            form.pageNow = 1;
            $scope.modal.hide();
            $scope.$broadcast("search", form);
            if (h.placeType == 2) {
                nearbyHospitalService.PlaceSearchHistory.insert(h);
            }
        };
        /**
         * 查找更多
         */
        $scope.searchMore = function () {
            var form = $scope.param.form;
            form.pageNow++;
            $scope.$broadcast("searchMore", form);
        };
        $scope.$on('searchMoreOK', function (event, p_data) {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            var data = $scope.param.data;
            data.list = data.list.concat(p_data.result.pois);
            $scope.$apply();
        });

        $scope.scroll_callback = function () {
            console.log(111111111);
            var top = delegate.getScrollPosition().top;
            if (top < 400) {
                $('#keyword_input').css('display', 'block');
            } else {
                $('#keyword_input').css('display', 'none');
            }
            if (top > $rootScope.screenHeight - 44) {
                $('.hos_header').css('display', 'block');
            } else {
                $('.hos_header').css('display', 'none');
            }
        };
        /**
         * 清除历史记录
         */
        $scope.clearHistory = function () {
            var d = $scope.param.data;
            d.history = [];
            nearbyHospitalService.PlaceSearchHistory.clear();
        };
        //搜索成功显示列表
        $scope.$on("searchOK", function (event, p_data) {
            $scope.param.data.list = p_data.list;
            $scope.param.data.count = p_data.count;
            //2016-9-23
            if(p_data.count>=10){
                $scope.param.data.count=10;
            }
            //2016-9-23
            var d = get_delegate();
            d.scrollTo(0, 344, true);
            $('#search_result_content').css('z-index', '2');
            $('#map').css('z-index', '0');
        });
        //查看详情插入历史记录
        $scope.$on('scanDetail', function (p_event, p_data) {
            console.log('eeeeeeeeeeeeeeeeeeee');
            console.log(p_data);
            var history = new Object();
            history.placeName = p_data.name;
            history.placeAddress = p_data.address;
            history.placeLat = p_data.location.lat;
            history.placeLng = p_data.location.lng;
            history.placeType = 2;
            nearbyHospitalService.PlaceSearchHistory.insert(history);
        });
        $scope.scanDetail = function (p_poid, p_distance) {
            console.log(p_poid);
            var placeSearch = new AMap.PlaceSearch();  //构造地点查询类
            //详情查询
            placeSearch.getDetails(p_poid, function (status, result) {
                if (status === 'complete' && result.info === 'OK') {
                    var poiArr = result.poiList.pois;
                    $scope.poiDetail = poiArr[0];
                    $scope.poiDetail.distance = p_distance;
                    console.log($scope.poiDetail);
                }
            });
            $scope.detailModal.show();
        };
        //设置z-index
        $scope.setZIndex = function (id, n) {
            $("#" + id).css("z-index", n);
        };
        //清空关键词
        $scope.clearKeyword = function () {
            $scope.param.form.keyword = '';
        };
        $scope.setContentZIndex = function (n) {
            var flag = $scope.param.flag;
            console.log(flag);
            //如果是大地图点击按钮
            if (flag.big) {
                console.log('1');
                $('#search_result_content').css('z-index', n);
            }
        };

        /**
         * 向上滑动列表的层级变高
         */
        $scope.listShow=function(){
            $('#map').css('z-index', 0);
//           $('#map').addClass(".z_index0");
//            $('#map').trigger("tap");
        }

        /**
         * 返回函数
         */
        $scope.goBack = function () {
            console.log("回退");
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, $stateParams.backUrl, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };

        /**
         * 放大地图
         */
        $scope.enlarge_map = function () {
            var d = get_delegate();
            d.scrollTop(true);
            $scope.$broadcast('ENLARGE_MAP');
        };

        $scope.show_list = function () {
            var delegate = get_delegate();
            delegate.scrollTo(0, 344, true);
            $scope.$broadcast('SHOW_LIST');
        };

        $scope.scrollComplete = function () {
            var flag = $scope.param.flag;
            //不是通过点击触发
            if (!flag.click) {
                var p = delegate.getScrollPosition();
                //接近底部
                if (p.top < 150) {
                    if (!flag.big) {
                        //自上滑下
                        flag.big = !flag.big;
                        $scope.$broadcast('zoomMap', {level: 14, type: 'big'});
                    } else {
                    }
                    delegate.scrollTop(true);
                    $('#search_result_content').css('z-index', '0');
                } else if (p.top < 550) {
                    if (flag.big) {
                        flag.big = !flag.big;
                        $scope.$broadcast('zoomMap', {level: 13, type: 'small'});
                        $('#search_result_content').css('z-index', '2');
                    } else {
                    }
                    delegate.scrollTo(0, 344, true);
                }
            } else {
                flag.click = false;
            }
        };

        /**
         * 手动搜索地图
         * @type {string}
         */
        $scope.searchByName = function () {
            var name = $scope.param.form.keyword;
            MY_MAP.search(name, 1).then(function (data) {
                console.log("搜索结果：", data);
                $scope.param.data.list = data.list;
                $scope.param.data.count = data.count;
                //2016-9-23
                if(data.count>=10){
                    $scope.param.data.count=10;
                }
                //2016-9-23
                $scope.param.data.keyword = name;
            }, function (error) {
                console.log(error);
                ErrorShow("未搜到结果");
            });
        }
    }
)
;
