angular.module('MY_MAP', [])

    .factory('MY_MAP', function ($http, $q, $cordovaGeolocation, $rootScope) {

        var long = 114.35051;
        var lat = 30.536834;
        var word_map = {};
        var range = 5000;

        /**
         * 关键字搜索
         * @param key 关键字
         * @param pre_load 预加载
         * @constructor
         */
        function MapWord(key, pre_load) {
            this.key = key;
            this.index = 1;
            this.size = 10;
            this.data = [];
            this.count = 0;
            this.get_search = function () {
                return new AMap.PlaceSearch({
                    pageIndex: this.index,
                    pageSize: this.size
                });
            };
            this.get_data = function (page) {
                //console.log('获取数据' + page);
                var q = $q.defer();
                if (this.index > page) {
                    var ret = this.data.slice((page - 1) * this.size, page * this.size);
                    var d = {
                        list: ret,
                        count: this.count
                    };
                    q.resolve(d);
                } else {
                    var search = this.get_search();
                    var p_this = this;
                    search.searchNearBy(this.key, [long, lat], range, function (status, result) {
                        if (result.info == 'OK') {
                            var d_l = result.poiList.pois;
                            p_this.data = p_this.data.concat(d_l);
                            p_this.index++;
                            p_this.count = result.poiList.count;
                            var d = {
                                list: d_l,
                                count: p_this.count
                            };
                            q.resolve(d);
                        } else {
                            q.reject('ERROR');
                        }
                    });
                }
                return q.promise;
            };
            if (pre_load) {
                this.get_data(1).then(function (data) {
                    console.log('初始化', data);
                }, function (error) {
                });
            }
        }

        return  {
            //初始化
            init: function () {
                //获取地理位置
                if (window.AMap) {
                    /*var posOptions = {timeout: 2000, enableHighAccuracy: false};*/
                    if (window.cordova) {
                        document.addEventListener("deviceready", function () {
                            baidu_location.getCurrentPosition(function (d) {
//                            alert(JSON.stringify(d));
                              /*console.log("位置坐标为:",d.latitude);
                              console.log("位置坐标为:",d.lontitude);*/

                                lat = d.latitude;
                                long = d.lontitude;

                                $rootScope.lontitude = d.lontitude;
                                $rootScope.latitude = d.latitude;

//                           alert("long:"+long+"lat:"+lat);
                                AMap.service(["AMap.PlaceSearch"], function () {
                                    var store = new MapWord('药店', true);
                                    word_map[store.key] = store;
                                    var hospital = new MapWord('医院', true);
                                    word_map[hospital.key] = hospital;
                                });
                            }, function (e) {
                                //alert(JSON.stringify(e));
                                ErrorShow("定位服务未打开");
                            });

                        });

                    } else {
                        AMap.service(["AMap.PlaceSearch"], function () {
                            var store = new MapWord('药店', true);
                            word_map[store.key] = store;
                            var hospital = new MapWord('医院', true);
                            word_map[hospital.key] = hospital;
                        });
                    }
                }
            },

            /**
             * 获取数据
             * @param key 关键字
             * @param page 分页数
             * @ returns{*}
             */
            search: function (key, page) {
                var q = $q.defer();
                var obj = word_map[key];
                console.log(word_map);
                if (!obj) {
                    obj = new MapWord(key, false);
                    word_map[obj.key] = obj;
                }
                obj.get_data(page).then(function (data) {
                    console.log('search', data);
                    q.resolve(data);
                }, function (error) {
                    q.reject(error);
                });
                return q.promise;
            },

            //获取高德地图点坐标
            get_pos: function () {
                return new AMap.LngLat(long, lat);
            }
        }
    });
