/**
 * 用户消息模块
 */
angular.module('Message', [])
    .factory('Mes', function ($rootScope, $http, $q, $cacheFactory) {
        //页面展示数据量
        var count = 5;
        //网络请求数据量
        var network_count = 30;
        return {
            find: function (start, count) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/message/query.htm",
                    params: {
                        token: $rootScope.token,
                        start: start,
                        count: count
                    },
                    timeout: 5000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                        if (start == 1) {
                            localStorage.setItem('mes', JSON.stringify(result.data));
                        }
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    if (start == 1) {
                        var mes = localStorage.getItem('mes');
                        if (mes) {
                            q.resolve(eval("(" + mes + ")"));
                        } else {
                            q.reject('ERROR');
                        }
                    } else {
                        q.reject('ERROR');
                    }
                });
                return q.promise;
            },
            /**
             * 添加微信分享
             * @param type 分享类型
             * @param shareId 分享id
             * @returns {*}
             */
            addWechatShare: function (type, shareId) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/message/wechat/shareCallback.htm",
                    params: {
                        token: $rootScope.token,
                        type: type,
                        shareId: shareId
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject('ERROR');
                });
                return q.promise;
            },
            //从缓存中查询一天的消息
            findOneDayMesByYmd: function (ymd) {
                var ret = null;
                //获取消息一级缓存
                var mes_cache = $cacheFactory.get('mes');
                //获取消息二级缓存
                var all_mes = mes_cache.get('all');
                for (var i in all_mes) {
                    if (ymd == all_mes[i].ymd) {
                        ret = all_mes[i];
                        break;
                    }
                }
                return ret;
            },
            //预加载请求方法
            get: function (start) {
                var q = $q.defer();
                var ret_list = [];
                //取出消息缓存
                var mes_cache = $cacheFactory.get('mes');
                if (!mes_cache) {
                    mes_cache = $cacheFactory('mes');
                }
                //取出全部消息列表
                var list = mes_cache.get('test_all');
                console.log(list);
                if (!list) {
                    list = [];
                }
                console.log('预加载数据长度', list.length);
                var end = start + count - 1;
                if (end <= list.length) {
                    //预加载数据满足
                    console.log('预加载数据满足查询条件');
                    ret_list = list.slice(start - 1, start - 1 + count);
                    q.resolve(ret_list);
                } else {
                    //网络预加载数据
                    console.log('预加载数据未满足查询条件');
                    this.find(list.length + 1, network_count).then(function (data) {
                        if (data.list.length > 0) {
                            list = list.concat(data.list);
                            ret_list = list.slice(start - 1, start - 1 + count);
                            //结果存放缓存
                            mes_cache.put('test_all', list);
                        }
                        q.resolve(ret_list);
                    }, function (error) {
                        q.reject(error);
                    });
                }
                return q.promise;
            }
        }
    });