angular.module('Mine', ['Filter', 'File', 'Wallet'])
//被调用对象
  .factory('buletoothService', function ($http, $rootScope, $q) {
    //这个是下方的表格元素
    var dataBlue = null;
    //创建蓝牙数据库(4个参数分别是 数据库名,版本号，数据库的描述，数据库大小)
    //  var db = openDatabase("blueToothDateBase", "1.0", "心常态", 4096 * 1024);
    return {
      //创建蓝牙数据库 type 0健康盒子、1 血压、2 血氧、3 体脂、4 血糖、5心率
      initBTooth: function () {
        console.log('vvvvvvvvv');
        //4个参数分别是 数据库名,版本号，数据库的描述，数据库大小
        dataBlue = openDatabase("bTooth", "1.0", "蓝牙", 4096 * 1024, function () {
          dataBlue.transaction(function (tx) {
            //蓝牙信息表
            //                    console.log('eeeeeeeee');
            tx.executeSql(
              //  type
              "CREATE TABLE IF NOT EXISTS bluetooth_information (name TEXT, address TEXT, type TEXT,imgUrl TEXT)",
              [],
              function (tx, result) {
                console.log(" table place_search_history success");
              },
              function (tx, error) {
                console.log(error);
              });
          });
        });
      },

      PlaceSearchHistory: {
        /**
         * 向表中插入蓝牙信息
         */
        insert: function (bluetooth) {
          /*alert("插入设备类型："+bluetooth.type);*/
          var q = $q.defer();
          dataBlue.transaction(function (tx) {
              //先判断设备信息是否已经存储
              tx.executeSql("SELECT * FROM bluetooth_information WHERE type = ?",
                [bluetooth.type + ''],
                function (tx, result) {
                  var length = result.rows.length;
                  // alert("搜索出的设备数量："+length);
                  if (length == 0) {
                    //没有该设备类型的配对信息执行插入操作
                    tx.executeSql("INSERT INTO bluetooth_information VALUES(?,?,?,?)",
                      [bluetooth.blueName + '', bluetooth.blueAddress + '', bluetooth.blueType + '', bluetooth.blueImg + ''],
                      function () {
                      },
                      function (tx, error) {
                      });
                  } else {
                    //TODO
                  }
                },
                function (tx, error) {
                });
            }, function () {
              q.reject("error");
            }
          );
        },
        /**
         * 删除蓝牙信息
         */
        deleteByType: function (type) {
          var q = $q.defer();
          dataBlue.transaction(function (tx) {
            tx.executeSql(
              "DELETE FROM bluetooth_information WHERE type=?", [type + ''],
              function (tx, result) {
              },
              function (tx, error) {
                q.reject("error");
              }
            );
          });
        },
        /**
         * 查找蓝牙信息
         */
        find: function () {
          var q = $q.defer();
          var bluetooths = [];
          dataBlue.transaction(function (tx) {
            tx.executeSql(
              "SELECT * FROM bluetooth_information", [],
              function (tx, result) {
                var length = result.rows.length;
                //这里不要给数组赋值长度
                //          alert("搜索出设备数量2："+length);
                for (var i = 0; i < length; i++) {
                  var h = new Object();
                  h.placeName = result.rows.item(i)["name"];
                  h.placeAddress = result.rows.item(i)["address"];
                  h.placeType = result.rows.item(i)["type"];
                  h.placeLat = result.rows.item(i)["imgUrl"];
                  bluetooths.push(h);
                }
                q.resolve(bluetooths);
              },
              function (tx, error) {
                q.reject("get bluetooth from database error");
              }
            );
          });
          return q.promise;
        },
        /**
         * 通过type（血压、血糖、血氧、心率）来查询不同类型蓝牙设备的数据
         */
        findByType: function (type) {
          var q = $q.defer();
          var bluetooths = [];
          dataBlue.transaction(function (tx) {
            var h = null;
            tx.executeSql(
              "SELECT * FROM bluetooth_information WHERE type=?", [type + ''],
              function (tx, result) {
                var length = result.rows.length;
                //这里不要给数组赋值长度
                //                         alert("搜索出设备数量："+length);
                for (var i = 0; i < length; i++) {
                  h = new Object();
                  h.placeName = result.rows.item(i)["name"];
                  h.placeAddress = result.rows.item(i)["address"];
                  h.placeType = result.rows.item(i)["type"];
                  h.placeLat = result.rows.item(i)["imgUrl"];

                }
                q.resolve(h);
              },
              function (tx, error) {
                q.reject("get bluetooth from database error");
              }
            );
          });
          return q.promise;
        }
      },

      //扫描心常泰健康盒子
      codeSearch: function (code) {
        var q = $q.defer();
        var params = {
          token: $rootScope.token,
          barCode: code,
          //isbind: 1
        };
        var req = {
          method: 'GET',
          url: $rootScope.reqUrl + "/box/healthdevice/appHealthBoxBind.htm",
          params: params,
          timeout: 10000
        };
        $http(req).success(function (result) {
          if (result.status == 1) {
            q.resolve(result);
          } else {
            q.reject(result.message);
          }
        }).error(function (result) {
          q.reject("ERROR");
        });
        return q.promise;
      }

    }

  }).controller('MyInformationCtrl', function ($scope, $state, $stateParams, $ionicNativeTransitions, $cacheFactory, userService, $rootScope, $cordovaContacts, drugService) {
  // alert($stateParams.userId);
  $scope.friend = {};
  $scope.friend_cache = {};
  var saveFlag = false;
  var users = null;
  //出生日期
  var currentYear = new Date().getFullYear();
  var currentMonth = new Date().getMonth() + 1;
  var currentDay = new Date().getDate();
  $scope.friend.birthday = currentYear + "年" + currentMonth + "月" + currentDay + "日";  //给生日赋默认值
  $('#z_birth').mobiscroll().date({
    theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
    mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
    dateFormat: 'yyyy年mm月dd日',
    display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
    lang: 'zh',      // Specify language like: lang: 'pl' or omit setting to use default
    startYear: currentYear - 100,
    endYear: currentYear
  });


  //页面跳转参数存储
  var cache = $cacheFactory.get($state.current.name);
  if (!cache) {
    cache = $cacheFactory($state.current.name);
  }
  cache.put('stateParams', $stateParams);
  //服药计划缓存
  var plan_cache = $cacheFactory.get('plan');
  if (!plan_cache) {
    plan_cache = $cacheFactory('plan');
  }

  //全局缓存
  var user_cache = $cacheFactory.get('user');
  if (!user_cache) {
    user_cache = $cacheFactory('user');
  }
  var alarm_users = user_cache.get('alarm_users');
  console.log("alrmusers:", alarm_users);
  if (!alarm_users) {
    drugService.getUser().then(function (data) {
      user_cache.put('alarm_users', data.list);
      users = data.list;
    }, function (error) {
    });
  }

  var likUser = user_cache.get('likUser');
  $scope.likUser = likUser;
  if (!$scope.likUser) {
    $scope.likUser = {};
  }

  users = alarm_users;
  $scope.flag = {deleting: false};
  $scope.genderFlag = {man: true, female: false, show: '男'};  //性别样式用
  //获取亲朋详细信息
  var userId = $stateParams.userId;

  /**
   * 取出个人信息
   */
  for (var i in alarm_users) {
    if (alarm_users[i].id == userId) {
      var obj = clone(alarm_users[i]);
      console.log("克隆对象：", obj);
      $scope.friend = obj;
      console.log("friend:", $scope.friend);
      $scope.friend_cache = alarm_users[i];
      console.log("$scope.friend:", $scope.friend);
      //回显性别
      if ($scope.friend.gender == '女') {
        $scope.genderFlag.show = '女';
        $scope.genderFlag.man = false;
        $scope.genderFlag.female = true;
      } else {
        $scope.genderFlag.show = '男';
        $scope.genderFlag.man = true;
        $scope.genderFlag.female = false;
      }
      break;
    }
  }
  var birth_ = $scope.friend.birthday;
  if (birth_) {
    if (birth_.indexOf('-') != -1) {
      var birth = $scope.friend.birthday.split("-");
      $scope.friend.birthday = birth[0] + "年" + birth[1] + "月" + birth[2] + "日";
      console.log($scope.friend.birthday);
    }
  }

  console.log("birthday:", $scope.friend.birthday);

  /**
   * 获取性别
   */
  $scope.getGender = function (str) {
    if (str == '男') {
      $scope.genderFlag.man = true;
      $scope.genderFlag.female = false;
      $scope.genderFlag.show = '男';
    } else {
      $scope.genderFlag.man = false;
      $scope.genderFlag.female = true;
      $scope.genderFlag.show = '女';
    }
  };

  /**
   * 保存(添加好友)
   */
  $scope.save = function () {
    saveFlag = true;
    var f = $scope.friend;
    console.log("f:", f.telephone);
    var token = $rootScope.token;
    var phone = f.telephone;
    if (userId) {
      phone = f.telephone.replace(/\s+/g, "");
    }
    var name = f.name;
    var gender = $scope.genderFlag.show;
    var birthday = f.birthday;
    var id = $stateParams.userId;
    var errorFlag = false;
    console.log("id是否存在:", id);
    for (var i in users) {
      if (users[i].telephone == phone && !id) {
        errorFlag = true;
      }
    }
    if (errorFlag) {
      ErrorShow("不能重复添加");
      return false;
    }
    console.log(phone, name);
    if (!phone || !name) {
      ErrorShow("手机号和称呼不能为空");
      return false;
    }

    if (phone == $rootScope.user.phone) {
      ErrorShow("不能添加自己");
      return false;
    }

    //改变缓存中的内容
    console.log("缓存绑定：", $scope.friend_cache);
    $scope.friend_cache.telephone = phone;
    $scope.friend_cache.gender = gender;
    $scope.friend_cache.birthday = birthday;
    $scope.friend_cache.name = name;

    console.log("保存前的alrmusers:", users);
    userService.addFriend(token, phone, name, gender, birthday, id, $scope.friend.stature, $scope.friend.weight).then(function (data) {
      console.log(data);
      $scope.likUser.toUser = data.data.id;
      $scope.likUser.userName = data.data.name;
      $scope.likUser.headImg = data.data.header;
      $scope.likUser.gender = data.data.gender;
      console.log($scope.likUser);
      user_cache.put('likUser', $scope.likUser);
      if (!id) {
        users.push(data.data);
        user_cache.put('alarm_users', users);
      } else {
        for (var j in users) {
          var o = users[j];
          if (o.id == data.data.id) {
            users[j] = data.data;
            break;
          }
        }
        user_cache.put('alarm_users', users);
      }
      //alert(JSON.stringify($scope.users));
      $scope.$emit("addUserSuccess");
      $scope.$emit("USER_MODIFY", data.data); //此广播是为了传给首页
      //取出回退页面跳转参数
      var param = $cacheFactory.get($stateParams.backUrl);
      var sp = null;
      //如果不在页面参数则设置为空串
      if (param) {
        sp = param.get('stateParams');
        if (!sp) {
          sp = {};
        }
      } else {
        sp = {};
      }
      $("#updateOK").unbind("click");
      $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });

    }, function (error) {
      console.log(error);
      ErrorShow("网络异常");
    });
  };

  /**
   * 调用通讯录
   */
  $scope.getbook = function () {
    $cordovaContacts.pickContact().then(function (contactPicked) {
      $scope.friend.name = contactPicked.displayName;  //通讯录用户名
      var tel = contactPicked.phoneNumbers[0].value;  //通讯录手机号
      $scope.friend.telephone = tel.replace(/\s+/g, "");

    });
  };

  /**
   * 获得焦点清空文字
   */
  $scope.focus = function () {
    $scope.friend.phone = "";
    $scope.friend.telephone = "";
  }

  $scope.chfocus = function () {
    $scope.friend.name = "";
  }

  /**
   * 删除弹框
   */
  $scope.del = function () {
    // alert(userId);
    /*$("#delwin").show();
     $("#zz").show();*/
    $scope.flag.deleting = true;
  };

  $scope.confirm = function () {
    $("#updateOK").unbind("click");
    $scope.flag.deleting = false;
    userService.deleteFriend(userId).then(function (data) {
      console.log(data);
      var systemUserId = null;
      for (var i = 0; i < users.length; i++) {
        if (users[i].id == userId) {
          systemUserId = users[i].systemUserId;
          users.splice(i, 1);
          user_cache.put("alarm_users", users);
          console.log(user_cache.get('alarm_users'));
          break;
        }
      }
      $scope.$emit('delFriendSuccess', {systemUserId: systemUserId});
      $ionicNativeTransitions.stateGo('g_my_friends', {}, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    }, function (error) {

    });
  };

  $scope.cancel = function () {
    /* $("#delwin").hide();
     $("#zz").hide();*/
    $scope.flag.deleting = false;
  };

  var temp = 0;
  $scope.selectST = function (d) {
    if (d == 1) {
      temp = 1;
      $("#updateuserST").html("请输入身高");
      $("#inputvalue").val($scope.friend.stature);
      $("#updateuserDW").html("cm");
    } else if (d == 2) {
      temp = 2;
      $("#updateuserST").html("请输入体重");
      $("#inputvalue").val($scope.friend.weight);
      $("#updateuserDW").html("kg");
    }
    $("#updateuserinfo").show();
    $("#updateclose").click(function () {
      $("#updateuserinfo").hide();
    });
    $("#updateOK").click(function () {
      var value = $("#inputvalue").val();
      if (temp == 1) {
        $scope.friend.stature = value;
        $("#setstature").html(value);
      } else if (temp == 2) {
        $scope.friend.weight = value;
        $("#setweight").html(value);
      }
      $("#updateuserinfo").hide();
    });
  }


  /**
   * 返回
   */
  $scope.goBack = function () {
    $("#updateOK").unbind("click");
    console.log("回退");
    //若没点击保存，页面参数复位
    /*  if(!saveFlag)  //若没保存
     {
     $scope.friend.birthday=bithLast; //生日恢复
     $scope.getGender(gender_);  //性别恢复
     $scope.friend.name=name_;
     $scope.friend.telephone=phone_;
     }*/

    //取出回退页面跳转参数
    var param = $cacheFactory.get($stateParams.backUrl);
    var sp = null;
    //如果不在页面参数则设置为空串
    if (param) {
      sp = param.get('stateParams');
      if (!sp) {
        sp = {};
      }
    } else {
      sp = {};
    }
    $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };
}).controller('MyFriendsCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory, userService, $rootScope, drugService) {
  //页面跳转参数存储
  var cache = $cacheFactory.get($state.current.name);
  if (!cache) {
    cache = $cacheFactory($state.current.name);
  }
  cache.put('stateParams', $stateParams);
  //亲朋缓存
  var user_cache = $cacheFactory.get('user');
  if (!user_cache) {
    user_cache = $cacheFactory('user');
  }
  var alarm_users = user_cache.get('alarm_users');

  /**
   * 获取用户列表
   */
  $scope.getUserList = function () {
    drugService.getUser().then(function (data) {
      $scope.users = data.list;
      user_cache.put("alarm_users", data.list);
    }, function (error) {
      $scope.$emit("LOAD_MYFRIEND");
      $state.go('network_error', {backUrl: 'g_my_friends', broadcast_name: 'LOAD_MYFRIEND'});
    });
  }

  $scope.getUserList();

  /**
   * 接受删除好友广播，刷新列表
   */
  $rootScope.$on('delFriendSuccess', function () {
    console.log("收到删除好友广播");
    /*drugService.getUser().then(function (data) {
     $scope.users = data.list;
     }, function (error) {
     });*/
    $scope.getUserList();
  });
  /**
   * 接受添加好友广播，刷新列表
   */
  $rootScope.$on('addUserSuccess', function () {
    console.log("收到添加好友广播");
    /* drugService.getUser().then(function (data) {
     $scope.users = data.list;
     }, function (error) {
     });*/
    $scope.getUserList();
  });


  //跳转到添加页面
  $scope.addUser = function (id) {
    console.log(id);
    console.log("添加页面");
    $ionicNativeTransitions.stateGo('g_my_information', {backUrl: 'g_my_friends', userId: id}, {
      "type": "slide",
      "direction": "left",
      "duration": 500
    });
  };

  /**
   * 返回
   */
  $scope.goBack = function () {
    console.log("回退");
    /*//取出回退页面跳转参数
     var param = $cacheFactory.get($stateParams.backUrl);
     var sp = null;
     //如果不在页面参数则设置为空串
     if (param) {
     sp = param.get('stateParams');
     if (!sp) {
     sp = {};
     }
     } else {
     sp = {};
     }*/
    $ionicNativeTransitions.stateGo("tab.mine", {}, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };
})
//我的钱包
  .controller('MyWalletCtrl', function ($scope, $rootScope, $stateParams, $state, $ionicNativeTransitions, walletService, $ionicSlideBoxDelegate) {
    walletService.getUserBalance().then(function (data) {
      $scope.balanceData = data;
      $scope.balance = data.data.balance;
    }, function (error) {
      console.log(error);
      ErrorShow("网络异常");
    })
    $scope.withdrawDepositAliPay = function () {
      if ($rootScope.userType == 6) {
        $rootScope.userType = '';
        $ionicNativeTransitions.stateGo('g_load', {backUrl: 'tab.mine'}, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        });
      } else {
        $ionicNativeTransitions.stateGo('g_withdrawCash', {backUrl: 'myWallet.html', balance: $scope.balance}, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        })
      }
    }
    $scope.goBack = function () {
      $ionicNativeTransitions.stateGo('tab.mine', {}, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };
    // $scope.obtainAliPayAccount = function () {
    //   walletService.obtainAliPayAllAccount().then(function (data) {
    //       $scope.aliPayAccount = data;
    //     $ionicSlideBoxDelegate.update();
    //   },function (error) {
    //     console.log(error);
    //     ErrorShow("网络异常");
    //   })
    // }
    // $scope.obtainAliPayAccount();
  })
  //提现到支付宝
  .controller('MyWithdrawCashCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, $rootScope, walletService, $timeout) {
    console.log("$stateParams.alipayData", $stateParams.alipayDataName, $stateParams.alipayDataId);
    if ($stateParams.balance) {
      $scope.withDrawBalance = $stateParams.balance;
    } else {
      walletService.getUserBalance().then(function (data) {
        $scope.withDrawBalance = data.data.balance;
      }, function (error) {
        console.log(error);
        ErrorShow("网络异常");
      });
    }
    $scope.confirmWithdrawDeposit = function () {
      walletService.withdrawDeposit().then(function (data) {
        $scope.status = data;
      }, function (error) {
        console.log(error);
        ErrorShow("网络异常");
      })
    }
    $scope.allWithdrawCash = function () {
      if ($scope.withDrawBalance != 0) {
        $("#withdrawDeposit").val($scope.withDrawBalance);
        $("#confirmCashBut").attr("class", "button button-block g_submit g_zhuxiao");
        $("#confirmCashBut").attr("disabled", false);
      } else {
        $("#withdrawDeposit").val($scope.withDrawBalance);
        $("#confirmCashBut").attr("disabled", true);
      }
    }
    $("#confirmCashBut").attr("class", "button button-block g_submit g_zhuxiao z_gray");
    $("#withdrawDeposit").bind('input propertychange', function () {
      if (0 < $("#withdrawDeposit").val() && $("#withdrawDeposit").val() <= parseFloat($scope.withDrawBalance)) {
        $("#confirmCashBut").attr("class", "button button-block g_submit g_zhuxiao");
        $("#confirmCashBut").attr("disabled", false);
      } else if ($("#withdrawDeposit").val() <= 0 || $("#withdrawDeposit").val() > parseFloat($scope.withDrawBalance || $("#withdrawDeposit").val() == undefined)) {
        $("#confirmCashBut").attr("class", "button button-block g_submit g_zhuxiao z_gray");
        $("#confirmCashBut").attr("disabled", true);
      }
    });
    //创建支付宝数据对象
    $scope.aliPaydata = {
      name: null,
      id: null
    };
    //确定用户是否绑定支付宝
    if (!$stateParams.alipayDataName) {
      walletService.obtainAliPayAllAccount().then(function (data) {
        console.log("确定用户是否绑定支付宝", data.passcards.length);
        // if (data.passcards.length == 0){//如果存在，将添加绑定支付宝账号选项隐藏
        //   alert("dfadf");
        //   $("#addAlipayBound").css("display","inline");
        // }

        for (var i = 0; i < data.passcards.length; i++) {
          if (data.passcards[i].default) {
            $scope.aliPaydata = data.passcards[i];
          }
        }
      }, function (error) {
        console.log(error);
        ErrorShow("网络异常");
      });
    } else {
      $scope.aliPaydata.name = $stateParams.alipayDataName;
      $scope.aliPaydata.id = $stateParams.alipayDataId;
    }

    //确认提现到支付宝
    $scope.submitDrwaCash = function () {
      if (!($scope.aliPaydata.name == null && $scope.aliPaydata.id == null)) {
        //提示“正在提现”
        $(".z_payingDiv").css("display", "inline");
        //提交提现服务
        walletService.withdrawDeposit($("#withdrawDeposit").val(), $scope.aliPaydata.id).then(function (data) {
          console.log("确认提现到支付宝", data, $scope.aliPaydata.id, $("#withdrawDeposit").val());
          if (data.status) {//收到回复后提示提现成功
            $timeout(function () {
              $(".z_textDiv p").text("申请提现成功，3个工作日内到账");
              $(".z_payingDiv").css("display", "none");
              $(".z_textDiv").css("display", "block");
              $timeout(function () {
                $(".z_textDiv").css("display", "none");
                $ionicNativeTransitions.stateGo('g_myWallet', {}, {
                  "type": "slide",
                  "direction": "left",
                  "duration": 500
                });
              }, 1000);
            }, 1000);

          } else {
            $(".z_textDiv p").text("提现失败");
            $timeout(function () {
              $(".z_payingDiv").css("display", "none");
            }, 1000);
          }
        }, function (error) {
          console.log(error);
          ErrorShow("网络异常");
          $(".z_textDiv p").text("提现失败");
          $timeout(function () {
            $(".z_payingDiv").css("display", "none");
          }, 1000);
        });
      } else {
        $(".z_textDiv p").text("请绑定支付宝");
        $(".z_textDiv").css("display", "block");
        $timeout(function () {
          $(".z_textDiv").css("display", "none");
        }, 1000);
      }
    }
    //金额输入
    $("#withdrawDeposit").keyup(function () {
      var txt = $(this).val();
      var indexstr;
      if (txt.indexOf(".") == -1) {
        indexstr = txt.length;
      } else {
        indexstr = txt.indexOf(".");
      }
      console.log("valmatch", txt.length, indexstr, txt.length - txt.indexOf(".") + 1);
      if ((txt.length - indexstr + 1) >= 2) {
        var len = txt.indexOf(".") + 1 + 2;
        $(this).val(txt.substr(0, len));
      }
    })

    function formatMN(e) {
      this.value = this.value.replace(/[^\d\.\-]/g, "");
      $(this).attr("data-oral", parseFloat(e.target.value.replace(/[^\d\.-]/g, "")));
      //$("#moneyNum").attr("data-oral")获取未格式化的金额
    }

    $scope.checkMoney = function(event){
      if ((event.keyCode < 48 || event.keyCode > 57) && event.keyCode != 46 || /\.\d\d$/.test(value))event.returnValue = false
     }
    $scope.addAliPayAccount1 = function () {
      //console.log("添加支付宝方法");
      $ionicNativeTransitions.stateGo('load_AlipayBound', {
        backUrl: 'g_withdrawCash',
        existAliPayAccount: $scope.manageAliPayAccount
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    }
    $scope.goBack = function () {
      $ionicNativeTransitions.stateGo('g_myWallet', {}, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };
  })
  //选择支付宝
  .controller('ChooseAlipayCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, walletService) {
    walletService.obtainAliPayAllAccount().then(function (data) {
      console.log("选择支付宝", data);
      $scope.alipayDatas = data.passcards;
    }, function (error) {
      console.log(error);
      ErrorShow("网络异常");
    });
    $scope.chooseAliPage = function (alipayData) {
      $ionicNativeTransitions.stateGo('g_withdrawCash', {
        alipayDataName: alipayData.name,
        alipayDataId: alipayData.id
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    }
  })
  //管理支付宝
  .controller('manageAlipayCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, walletService, $ionicSlideBoxDelegate, $ionicPopup, $timeout) {
    $scope.obtainAliPayAccount = function () {
      walletService.obtainAliPayAllAccount().then(function (data) {
        console.log("支付宝账号：", data.passcards);
        $scope.manageAliPayAccount = data.passcards;
        for (var i = 0; i < $scope.manageAliPayAccount.length; i++) {
          if ($scope.manageAliPayAccount[i].default == true) {
            $scope.defaultAliPayAccount = $scope.manageAliPayAccount[i];
          }
        }
        $ionicSlideBoxDelegate.update();
      }, function (error) {
        console.log(error);
        ErrorShow("网络异常");
      })
    }
    $scope.obtainAliPayAccount();
    $scope.addAliPayAccount = function () {
      //console.log("添加支付宝方法");
      $ionicNativeTransitions.stateGo('load_AlipayBound', {
        backUrl: 'manageAlipay',
        existAliPayAccount: $scope.manageAliPayAccount
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    }
    $scope.otherDefaultAccount = null;
    $scope.setAlipayDefaultAccount = function (account) {
      $scope.otherDefaultAccount = account;
      if ($scope.defaultAliPayAccount.id != account.id) {
        walletService.setAlipayDefault(account.id).then(function (data) {
          if (data.status) {
            account.default = true;
            $scope.defaultAliPayAccount.default = false;
            $scope.defaultAliPayAccount = account;
          }
        }, function (error) {
          console.log(error);
          ErrorShow("网络异常");
        })
      }
    }

  })
  //零钱明细
  .controller('changeDetailsCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, walletService) {
    $scope.orderStatus = ["失败", "待处理", "进行中", "已完成"];
    walletService.selectRecordList().then(function (data) {
      console.log("零钱明细", data);
      if (data.status) {
        $scope.records = data.data.records;
      }

    }, function (error) {
      console.log(error);
      ErrorShow("网络异常");
    });
    $scope.toBillingdDetails = function (record) {
      $ionicNativeTransitions.stateGo('billingDetails', {backUrl: 'changeDetails', record: JSON.stringify(record)}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    }
  })
  //账单详情
  .controller('billingDetailsCtrl', function ($scope, $stateParams) {
    $scope.orderStatus = ["已取消", "待处理", "进行中", "已完成"];
    $scope.record = JSON.parse($stateParams.record);
    //时间处理，在原有的时间上加3天
    var orderTime = new Date($scope.record.orderTime);
    orderTime.setDate(orderTime.getDate() + 3);
    $scope.orderTime = date2str(orderTime, "yyyy-MM-dd hh:mm:ss");
  })

  .controller('MyMusicCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory, $cordovaVibration, $rootScope, $timeout) {

    //页面跳转参数存储
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    cache.put('stateParams', $stateParams);

    $scope.flag = {zhendong: true, ring: true};
    if ($rootScope.sound.audio) {
      $scope.flag.ring = true;
    } else {
      $scope.flag.ring = false;
    }
    if ($rootScope.sound.zhendong) {
      $scope.flag.zhendong = true;
    } else {
      $scope.flag.zhendong = false;
    }

    //振动开关
    $scope.zhendong = function () {
      if (window.cordova) {
        $cordovaVibration.vibrate(200);
      }

      if ($scope.flag.zhendong) {
        $scope.flag.zhendong = false;
        console.log("关");
        $rootScope.sound.zhendong = false;
      } else {
        console.log("开");
        $scope.flag.zhendong = true;
        $rootScope.sound.zhendong = true;
      }
      $scope.$emit("RESET_ALARM");
      localStorage.setItem("sound", JSON.stringify($rootScope.sound)); //铃声设置存入本地
    }
    //响铃开关
    $scope.ring = function () {
      if ($scope.flag.ring) {
        console.log("关");
        $scope.flag.ring = false;
        $rootScope.sound.audio = false;
      } else {
        console.log("开");
        $scope.flag.ring = true;
        $rootScope.sound.audio = true;
      }
      $scope.$emit("RESET_ALARM");
      localStorage.setItem("sound", JSON.stringify($rootScope.sound)); //铃声设置存入本地
    }

    /**
     * 返回
     */
    $scope.goBack = function () {
      console.log("回退");
      //取出回退页面跳转参数
      var param = $cacheFactory.get($stateParams.backUrl);
      var sp = null;
      //如果不在页面参数则设置为空串
      if (param) {
        sp = param.get('stateParams');
        if (!sp) {
          sp = {};
        }
      } else {
        sp = {};
      }
      $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };
  })

  /**
   * 我的铃声设置
   */
  .controller('MyMusicSetCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory, $rootScope) {

    //页面跳转参数存储
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    cache.put('stateParams', $stateParams);

    var sound_cache = $cacheFactory.get("sound_cache");
    if (!sound_cache) {
      sound_cache = $cacheFactory("sound_cache");
    }
    //播放
    $scope.form = {sound_index: $rootScope.sound.index};
    $scope.play = function (index, str, show) {
      $scope.form.sound_index = index;
      /*var myMedia = new Media("http://appdemo.sinoicity.com:8080/HealthMonitor/ring.mp3");
       myMedia.play();*/
      var preUrl = sound_cache.get("preUrl");
      if (preUrl) {
        $("#sound_" + preUrl)[0].load();
      }
      $("#sound_" + index)[0].play();
      console.log(parseInt($("#sound_" + index)[0].duration) + '：秒');
      sound_cache.put("preUrl", index);  //将选中的放入缓存
      $rootScope.sound.ring = 'file://sound/' + str; //引用
      $rootScope.sound.url = str;
      $rootScope.sound.show = show;            //页面显示
      $rootScope.sound.index = index;
      $rootScope.sound.duration = parseInt($("#sound_" + index)[0].duration); //铃声时长
      //通知闹铃
      $scope.$emit("RESET_ALARM");
      //---更改首页铃声--
      var musicUrl = $("#sound_" + index).attr("src");
      $("#music").attr("src", musicUrl);
      //---更改首页铃声--
      localStorage.setItem("sound", JSON.stringify($rootScope.sound)); //铃声设置存入本地
      console.log('设置的铃声', $rootScope.sound.ring);
    }

  })
  .controller('MySetCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory, userService, $rootScope, imageUtil, fileUtil, $timeout, FileServer, walletService) {
    if ($rootScope.user.card) {
      $scope.card = true;
    }
    var user = { //比对对象
      gender: $rootScope.user.gender,
      name: $rootScope.user.name,
      date: $rootScope.user.date,
      headImg: $rootScope.user.headImg,
      stature: $rootScope.user.stature,
      weight: $rootScope.user.weight
    };
    //页面跳转参数存储
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    cache.put('special_back', true);
    $scope.$on($state.current.name + '_HARDWARE_BACK', function () {
      $scope.goBack();
    });
    cache.put('stateParams', $stateParams);
    //出生日期
    $('#sz_birth').mobiscroll().date({
      theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
      mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
      dateFormat: 'yyyy-mm-dd',
      display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
      lang: 'zh',        // Specify language like: lang: 'pl' or omit setting to use default
      maxDate: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate())
    });


    /*
     if (!headImg)  //如果头像不存在取本地缓存
     {
     headImg = localStorage.getItem("headImg");
     }*/
    var tempImg = "";  //上传用的图片参数
    var headImg = $rootScope.user.headImg;  //页面上显示用的
    $scope.user = {headImg: $rootScope.user.headImg};
    $rootScope.stature = $rootScope.user.stature;
    $rootScope.weight = $rootScope.user.weight;
    /**
     * 选择性别
     */
    $scope.selectGender = function (str) {
      if (str == '1') {
        $rootScope.gender = '1';
        $scope.user.show = '男';
      } else if (str == '0') {
        $rootScope.gender = '0';
        $scope.user.show = '女';
      } else {
        $scope.user.show = "";
      }
    }
    /**
     * 修改电话号码
     */
    $scope.changePhone = function () {
      $ionicNativeTransitions.stateGo('g_my_changephone', {backUrl: 'g_my_set'}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });

    }

    /**
     * 修改密码
     */
    $scope.changePassword = function () {
      $ionicNativeTransitions.stateGo('g_my_changemessage', {backUrl: 'g_my_set'}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    };


    /**
     * 获取我的信息
     */
    $scope.myinfo = function () {
      userService.getProfile($rootScope.token).then(function (d) {
        $rootScope.user.headImg = d.headImg;
      }, function (e) {

      });
    }

    /**
     * 拍照
     */
    $scope.selectImageByCamera = function () {
      imageUtil.takePhoto($rootScope.screenWidth, $rootScope.screenHeight, Camera.DestinationType.FILE_URI).then(function (data) {
        $scope.user.headImg = data;
        tempImg = data;
        headImg = data;
      }, function (err) {
        ErrorShow("图片读取失败");
      });
    };

    /**
     * 取出本地照片
     */
    $scope.selectImageByPic = function () {
      imageUtil.pickOne($rootScope.screenWidth, $rootScope.screenHeight).then(function (data) {
        //data = data.split("?")[0];
        $scope.user.headImg = data;
        headImg = data;
        tempImg = data.split("?")[0];
      }, function (err) {
        ErrorShow("图片读取失败");
      });
    };


    /**
     * 弹出是否保存框
     */
    $scope.saveOrNot = function () {
      $("#myset_zz").show();
      $("#myset").show();
    };

    /*    $scope.cancel = function () {
     $("#ZHEZHAO").show();
     $("#box_msg").hide();
     };*/
    /*  $("#myset_cancel").click(function () {
     $("#myset_zz").hide();
     $("#myset").hide();
     });*/

    $scope.cancel = function () {
      $("#updateOK").unbind("click");
      $("#myset_zz").hide();
      $("#myset").hide();
      $ionicNativeTransitions.stateGo('tab.mine', {}, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });

    }

    $("#myset_confirm").click(function () {
      $scope.save();
      $("#myset_zz").hide();
      $("#myset").hide();
    });

    /**
     * 保存
     */
    $scope.save = function () {
      //保存图片
      if (tempImg) {
        imageUtil.uploadImages(tempImg, "/open/user/uploadHeadImg.htm?type=file", $rootScope.token).then(function (ret) {
          var Img = FileServer.saveHeadImg(ret.headImg, $rootScope.user.phone);
          localStorage.setItem($rootScope.user.phone, Img);
        }, function (error) {
          ErrorShow("头像上传失败");
        });
      }

      $rootScope.user.headImg = headImg;

      if ($rootScope.name.length > 5) {
        ErrorShow("姓名控制在5个字符以内");
        return;
      }
      $rootScope.user.gender = $rootScope.gender;
      $rootScope.user.name = $rootScope.name;
      $rootScope.user.date = $rootScope.date;
      $rootScope.user.stature = $rootScope.stature;
      $rootScope.user.weight = $rootScope.weight;
      if (!$rootScope.user.date) {
        $rootScope.user.date = "1970-2-3";
      }
      var birthday = $rootScope.user.date;
      console.log($rootScope.user.name + "\n" + $rootScope.gender + "\n" + birthday);
      userService.update($rootScope.user.name, $rootScope.gender, birthday, $rootScope.stature, $rootScope.weight).then(function (d) {
        console.log(d);
        $("#updateOK").unbind("click");
        $scope.$emit("USER_MODIFY", $rootScope.user); //此广播是为了传给首页
        $ionicNativeTransitions.stateGo('tab.mine', {}, {
          "type": "slide",
          "direction": "right",
          "duration": 500
        });
        // $rootScope.user.name = $scope.user.name;
      }, function (e) {
        console.log(e);
      });

    };
    //判断是否有支付宝账号
    walletService.obtainAliPayAllAccount().then(function (data) {
      if (data.status) {
        for (var i = 0; i < data.passcards.length; i++) {
          if (data.passcards[i].default) {
            $rootScope.aliPay = data.passcards[i].id;
          }
        }

      }
    }, function (e) {
      ErrorShow("网络异常");
    });


    var temp = 3;

    $scope.selectST = function (d) {
      if (d == 1) {
        temp = 1;
        $("#updateuserST").html("请输入身高");
        $("#inputvalue").val(user.stature);
        $("#updateuserDW").html("cm");
      } else if (d == 2) {
        temp = 2;
        $("#updateuserST").html("请输入体重");
        $("#inputvalue").val(user.weight);
        $("#updateuserDW").html("kg");
      }
      $("#updateuserinfo").show();
      $("#updateclose").click(function () {
        $("#updateuserinfo").hide();
      });
      $("#updateOK").click(function () {
        var value = $("#inputvalue").val();
        if (temp == 1) {
          $rootScope.stature = value;
          $("#setstature").html(value);
        } else if (temp == 2) {
          $rootScope.weight = value;
          $("#setweight").html(value);
        }
        $("#updateuserinfo").hide();
      });
    }
    //我的信息   急救卡 修改
    $scope.to_my_card = function (type) {
      //页面 信息里面应该有是否是会员的 状态值
      //如果是会员直接跳转到 急救卡的信息
      //如果不是会员,则跳转到 支付页面 g_pay.html
      //支付成功后 注册

      $ionicNativeTransitions.stateGo("g_card2", {backUrl: 'g_my_set'}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });


    }

    /**
     * 返回
     */
    $scope.goBack = function () {
      if ($rootScope.gender != user.gender || $rootScope.date != user.date || $rootScope.name != user.name || $scope.user.headImg != user.headImg) {
        $scope.saveOrNot();
        return;
      } else {
        $("#updateOK").unbind("click");
        console.log("回退");
        $timeout(function () {
          $(window).unbind('click');
        }, 100);
        //取出回退页面跳转参数
        var param = $cacheFactory.get($stateParams.backUrl);
        var sp = null;
        //如果不在页面参数则设置为空串
        if (param) {
          sp = param.get('stateParams');
          if (!sp) {
            sp = {};
          }
        } else {
          sp = {};
        }
        $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
          "type": "slide",
          "direction": "right",
          "duration": 500
        });
      }
    };
  }).controller('ChangeMessageCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory, userService, $rootScope, $cordovaToast) {

  //页面跳转参数存储
  var cache = $cacheFactory.get($state.current.name);
  if (!cache) {
    cache = $cacheFactory($state.current.name);
  }
  cache.put('stateParams', $stateParams);

  console.log("重设密码");
  $scope.resetform = {pwd: "", rpwd: "", flag: false, showFlag: false, show: ""};
  $scope.showPwd = function (num) {
    if (num == 1) {
      $scope.resetform.showFlag = true;
      $(".cc").attr("type", "text");
    } else {
      $scope.resetform.showFlag = false;
      $(".cc").attr("type", "password");
    }
  }

  /**
   * 完成
   */
  $scope.complete = function () {
    console.log("pwd---------" + $scope.resetform.pwd);
    console.log("pwd---------" + $scope.resetform.rpwd);
    if (!checkPassword2($scope.resetform.pwd) || !checkPassword2($scope.resetform.rpwd)) {
      $scope.resetform.flag = true;
      $scope.resetform.show = "密码格式为6-16位字符";
      return false;
    } else if ($scope.resetform.pwd != $scope.resetform.rpwd) {
      $scope.resetform.flag = true;
      $scope.resetform.show = "两次密码输入不一致";
      return false;
    } else {
      console.log($scope.resetform);
      var phone = $rootScope.user.phone;
      console.log(phone);
      var password = $scope.resetform.pwd;
      console.log(password);
      userService.modifyPwd(phone, password).then(function (data) {
        if (data.status) {
          console.log("重置密码成功！");
          if (window.cordova) {
            $cordovaToast.showShortBottom('密码修改成功').then(function (success) {
              // success
            }, function (error) {
              // error
            });
          }
          localStorage.removeItem("password");
          $state.go("g_load");
        } else {
          console.log("重置密码失败");
          return false;
        }
      }, function (error) {
        console.log(error);
      });

    }
    $ionicNativeTransitions.stateGo('g_my_set', {backUrl: 'tab.mine'}, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };


  $scope.focus = function () {
    $scope.resetform.flag = false;
    $scope.resetform.show = "";
  }
  /**
   * 返回
   */
  $scope.goBack = function () {
    console.log("回退");
    //取出回退页面跳转参数
    var param = $cacheFactory.get($stateParams.backUrl);
    var sp = null;
    //如果不在页面参数则设置为空串
    if (param) {
      sp = param.get('stateParams');
      if (!sp) {
        sp = {};
      }
    } else {
      sp = {};
    }
    $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };
}).controller('ChangePhoneCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory, userService, $rootScope, $interval, $timeout, $cordovaToast) {
  var user_cache = $cacheFactory.get('user');
  if (!user_cache) {
    user_cache = $cacheFactory('user');
  }
  //服药计划缓存
  var plan_cache = $cacheFactory.get('plan');
  if (!plan_cache) {
    plan_cache = $cacheFactory('plan');
  }

  var userType = "";
  console.log('上个页面传过来的参数：', $stateParams.userType);
  if ($stateParams.userType == 'visitor' || $rootScope.userType == 6 || !$rootScope.user.phone) {
    console.log("userType:", $stateParams.userType);
    userType = 'visitor';
  }

  $scope.form = {phone: "", vcode: "", errflag: false, show: "", title: '修改'};
  if (userType) {
    $scope.form.title = "绑定";
  }
  var usage = "ChangeMobile";
  var token = $rootScope.token;
  console.log(token);
  $scope.flag = {send: false, time: 60};
  $scope.timer = function () {
    $scope.flag.time--;
  }

  $scope.focus = function () {
    $scope.form.errflag = false;
  }

  $scope.getCode = function () {
    $scope.flag.time = 60;
    if (!checkPhone($scope.form.phone)) {
      return false;
    }
    userService.getVcode($scope.form.phone, usage).then(function (data) {
      console.log(data);
      $scope.flag.send = true;
      $scope.verifyInterval = $interval(function () {
        $scope.flag.time--;
      }, 1000);
      $timeout(function () {
        if (angular.isDefined($scope.verifyInterval)) {
          $interval.cancel($scope.verifyInterval);
        }
        $scope.flag.send = false;
      }, 60000);
    }, function (e) {
      $scope.form.errflag = true;
      $scope.form.show = e.error;
      // ErrorShow(e.error);
      console.log(e.error);
    });

  }

  /**
   * 完成
   */
  $scope.complete = function () {
    if (!checkPhone($scope.form.phone)) {
      return false;
    }
    console.log(userType);
    userService.changePhone(token, $scope.form.vcode, $scope.form.phone, userType).then(function (result) {
      console.log(result);
      if (result.status == 1) {
        if (userType) {
          if (window.cordova) {
            $cordovaToast.showShortBottom('手机号绑定成功').then(function (success) {
              // success
            }, function (error) {
              // error
            });
          }
          console.log("手机号绑定成功");
          //如果是游客绑定了
          $rootScope.userType = '';
          $rootScope.user.phone = $scope.form.phone;
          $rootScope.user.name = "";
          $rootScope.name = "";
          $scope.$emit('bindPhoneSuccess');
          $ionicNativeTransitions.stateGo('tab.mine', {}, {
            "type": "slide",
            "direction": "left",
            "duration": 500
          });
        } else {
          if (window.cordova) {
            $cordovaToast.showShortBottom('修改成功').then(function (success) {
              // success
            }, function (error) {
              // error
            });
          }
          console.log("手机号修改成功");
          //----
          //注销操作
          $rootScope.token = null;
          $rootScope.userId = null;
          $rootScope.user = null;
          $rootScope.url = null;
          localStorage.removeItem("token");
          user_cache.destroy();
          plan_cache.destroy();
          $scope.$emit('logout');


          $ionicNativeTransitions.stateGo('g_load', {backUrl: 'tab.mine'}, {
            "type": "slide",
            "direction": "left",
            "duration": 500
          });
        }


      } else {
        $scope.form.errflag = true;
        $scope.form.show = result.error;
      }
      /* $ionicNativeTransitions.stateGo('g_my_set', {backUrl: 'tab.mine'}, {
       "type": "slide",
       "direction": "right",
       "duration": 500
       });*/
    }), function (e) {
      ErrorShow("网络异常");
      console.log(error);
      //ErrorShow(e.error);
    }

  };

  /**
   * 返回
   */
  $scope.goBack = function () {
    console.log("回退");
    //取出回退页面跳转参数
    var param = $cacheFactory.get($stateParams.backUrl);
    var sp = null;
    //如果不在页面参数则设置为空串
    if (param) {
      sp = param.get('stateParams');
      if (!sp) {
        sp = {};
      }
    } else {
      sp = {};
    }
    $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };
}).controller('MyCompleteInfoCtrl', function ($rootScope, $scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory, buletoothService, $cordovaBarcodeScanner, userService, $interval, $timeout) {
  console.log("$stateParams.backUrl", $stateParams.backUrl);
  $scope.flagsend = false;
  var userphoneb = true;
  var usergenderb = true;
  var userbirthb = false;
  var uservcodeb = true;
  var userstatureb = true;
  $scope.showtimeplugins = function () {
    $('#userbirthvalue').mobiscroll().date({
      theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
      mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
      dateFormat: 'yyyy-mm-dd',
      display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
      lang: 'zh'        // Specify language like: lang: 'pl' or omit setting to use default
    });
  }

  $scope.showtimeplugins();
  if ($stateParams.phone == 'true') {
    $scope.showuserphone = true;
    userphoneb = false;
    uservcodeb = false;
  } else {
    $scope.showuserphone = false;
  }
  if ($stateParams.gender == 'true') {
    $scope.showusergender = true;
    usergenderb = false;
  } else {
    $scope.showusergender = false;
  }
//        if ($stateParams.birth == 'true') {
//            $scope.showuserbirth = true;
//            if (document.getElementById('userbirthtr').style.display == 'none') {
//                document.getElementById('userbirthtr').style.display = 'block';
//            }
//            userbirthb = false;
//        } else {
//            $scope.showuserbirth = false;
//        }
  $scope.showuserbirth = false;
  if ($stateParams.stature == 'true') {
    $scope.showuserstature = true;
    userstatureb = false;
  } else {
    $scope.showuserstature = false;
  }
  $scope.type00 = false;
  //血压
  $scope.type01 = false;
  var deaddress = '';
  var healthhezi = '123456';
  $scope.type02 = false;
  $scope.type03 = false;
  $scope.type04 = 0;
  $scope.type05 = false;
  $scope.type07 = false;
  $("#userbirthvalue").mobiscroll().date({
      theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
      mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
      dateFormat: 'yyyy-mm-dd',
      display: 'bottom', // Specify display mode like: display: 'bottom' or omit setting to use default
      lang: 'zh'        // Specify language like: lang: 'pl' or omit setting to use default
    },
    console.log(123)
  );
  buletoothService.PlaceSearchHistory.find().then(function (data) {
    var bluetooth = data;
    //         alert("aa："+bluetooth.length);
    for (var i = 0; i < bluetooth.length; i++) {
      //        alert(bluetooth[i].placeType);
      if (bluetooth[i].placeType == 0) {
        $scope.type00 = true;
      } else if (bluetooth[i].placeType == 1) {
        $scope.type01 = true;
        deaddress = bluetooth[i].placeAddress;
      } else if (bluetooth[i].placeType == 2) {
        $scope.type02 = true;
        deaddress = bluetooth[i].placeAddress;
      } else if (bluetooth[i].placeType == 3) {
        $scope.type03 = true;
        deaddress = bluetooth[i].placeAddress;
      } else if (bluetooth[i].placeType == 5) {
        $scope.type05 = true;
        deaddress = bluetooth[i].placeAddress;
      }
    }
  }, function (error) {
    //console.log('111eeeeeee');
  });

  $scope.selectGender = function (str) {
    if (str == '1') {
      $rootScope.gender = '1';
    } else {
      $rootScope.gender = '0';
      // $scope.user.gender='0';
    }
  }
  //倒计时
  $scope.timeStart = function () {
    $scope.flagsend = true;
    $scope.completeIntervel = $interval(function () {
      $scope.flagtime--;
    }, 1000);
    $timeout(function () {
      if (angular.isDefined($scope.completeIntervel)) {
        $interval.cancel($scope.completeIntervel);
      }
      $scope.flagsend = false;
    }, 60000);
  }

  $scope.getVcode = function () {
    var usage = 'BindMobile';
    $scope.flagtime = 60;
    var phone = $('#userphonevalue').val();
    if (!checkPhone(phone)) {
      return false;
    }
    userService.getVcode(phone, usage).then(function (data) {
      console.log("获取验证码...", usage);
      if (data.status == 1) {
        $scope.timeStart();
      }
    }, function (e) {
      console.log(e.error.indexOf('已经注册'));
      if (e.error.indexOf('已经注册') != -1)    //已经注册则去修改密码
      {
        ErrorShow("手机号已注册");
      } else {
        ErrorShow(e.error);
      }
    });
    console.log("注册手机号-----" + phone);
  };

  $scope.toequipment = function () {
    var phone = null;
    var gender = null;
    var birth = null;
    var stature = null;
    if ($scope.showuserphone) {
      phone = $('#userphonevalue').val();
      if (checkPhone(phone)) {
        userphoneb = true;
      } else {
        userphoneb = false;
      }
    }
    ;

    if ($scope.showusergender) {
      gender = $rootScope.gender;
      if (gender != null && gender != '') {
        usergenderb = true;
      } else {
        $("#ERROR").text("请选择性别");
        $("#ERROR").show();
        setTimeout('cancelZZ()', 1000);
        usergenderb = false;
      }
    }
    ;
    if (!$scope.showuserbirth) {
      birth = $('#userbirthvalue').val();
      if (birth != null && birth != '') {
        userbirthb = true;
      } else {
        $("#ERROR").text("请填写出生日期");
        $("#ERROR").show();
        setTimeout('cancelZZ()', 1000);
        userbirthb = false;
      }
    }
    if ($scope.showuserstature) {
      stature = $('#userstaturevalue').val();
      if (stature != null && stature != '') {
        userstatureb = true;
      } else {
        $("#ERROR").text("请确定身高");
        $("#ERROR").show();
        setTimeout('cancelZZ()', 1000);
        userstatureb = false;
      }
    }
    ;
    if ($scope.showuserphone) {
      var usage = 'BindMobile';
      var vcode = $('#vcode').val();
      userService.verify(phone, usage).then(function (data) {
        //alert(data.CheckNum);
        if (data.CheckNum == vcode || vcode == 'zjlh') {
          console.log("用户输入跟系统验证码一致！");
          if (userphoneb && usergenderb && userbirthb && userstatureb) {
            $rootScope.user.stature = stature;
            $rootScope.user.date = birth;
            $scope.updatemes(phone, gender, birth, stature);
            $scope.$apply();
          }
        } else {
          console.log("验证码错误！");
          $("#ERROR").text("验证码错误");
          $("#ERROR").show();
          setTimeout('cancelZZ()', 1000);
          uservcodeb = false;
          return false;
        }
      }, function (error) {
        //$state.go("tab.home");
        $("#ERROR").text(error.error);
        $("#ERROR").show();
        setTimeout('cancelZZ()', 1000);
        return false;
      });
    } else {
      if (userphoneb && usergenderb && userbirthb && userstatureb) {
        $rootScope.user.stature = stature;
        $rootScope.user.date = birth;
        $scope.updatemes(phone, gender, birth, stature);
        $scope.$apply();
      }
    }
  }

  $scope.updatemes = function (phone, gender, birth, stature) {
    var eee = $stateParams.type;
    userService.updatecompletmes($rootScope.token, phone, gender, birth, stature).then(function (data) {
      if (data.status == true) {
        if ($scope.showuserphone) {
          $rootScope.userType = '';
          $rootScope.user.phone = phone;
          $rootScope.user.name = "";
          $rootScope.name = "";
        }
        if ($scope.showuserstature) {
          $rootScope.user.stature = stature;
          $rootScope.user.date = birth;
          $scope.$apply();
        }
        if (eee == 5) {
          $scope.mySearch();
        } else if (eee == 1) {
          $scope.myXue($scope.type01);
        } else if (eee == 2) {
          $scope.myOX($scope.type02);
        } else if (eee == 4) {
          $scope.myWatch($scope.type04);
        } else if (eee == 0) {
          $scope.myXueTang($scope.type00);
        } else if (eee == 3) {
          $scope.myTizhi($scope.type03);
        } else if (eee == 7) {
          $scope.myECG($scope.type07);
        } else if (eee > 9) {
          var gotovaluei = (eee - 10);
          var enterArray = ['g_xt_enter', 'g_xueya_enter', 'g_xueyang_enter', 'g_xinlv_enter'];
          $ionicNativeTransitions.stateGo(enterArray[gotovaluei], {backUrl: 'tab.health'}, {
            "type": "slide",
            "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
            "duration": 400 // in milliseconds (ms), default 400
          });
        } else if (eee == 8) {
          $ionicNativeTransitions.stateGo($rootScope.z_completeInfoindex, {backUrl: $rootScope.z_completeInfohbackUrl}, {
            "type": "slide",
            "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
            "duration": 600// in milliseconds (ms), default 400
          });
        }
      } else {
        ErrorShow("修改失败");
      }
    }, function (error) {
      //console.log('111eeeeeee');
    });
  }

  //页面跳转参数存储
  var cache = $cacheFactory.get($state.current.name);
  if (!cache) {
    cache = $cacheFactory($state.current.name);
  }
  cache.put('stateParams', $stateParams);
  /*
   我的血压计页面
   */

  $scope.myXue = function (a) {
    //根据我的设备页面中，判断设备是否配对  未配对的设备点击时则跳转到开启蓝牙扫描等页面，已配对的设备再次点击后跳到配对设备信息页面
    if (a) {
      $ionicNativeTransitions.stateGo('g_my_eqone', {
        backUrl: 'g_my_equipment',
        yaoqingma: $scope.showuserphone,
        backUrlFather: 'tab.mine',
        type: 1,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: $scope.showuserphone,
          type: 1,
          backUrlFather: 'tab.mine'
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }


  };
  /*
   我的血氧计页面
   */
  var backUrlFather1 = $stateParams.backUrl;
  $scope.myOX = function (x) {
    console.log("myOx", $stateParams.backUrl);
    //根据我的设备页面中，判断设备是否配对  未配对的设备点击时则跳转到开启蓝牙扫描等页面，已配对的设备再次点击后跳到配对设备信息页面
    if (x) {
      $ionicNativeTransitions.stateGo('g_my_eqone', {
        backUrl: 'g_my_equipment',
        yaoqingma: $scope.showuserphone,
        type: 2,
        backUrlFather: $stateParams.backUrl,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: $scope.showuserphone,
          backUrlFather: backUrlFather1,
          type: 2
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }

  };
  //我的手环
  $scope.myWatch = function (x) {
    if (x) {
      $ionicNativeTransitions.stateGo('z_wristStrap', {
        backUrl: 'g_my_equipment',
        yaoqingma: $scope.showuserphone,
        backUrlFather: $stateParams.backUrl,
        type: 4,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: $scope.showuserphone,
          backUrlFather: $stateParams.backUrl,
          type: 4
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }
  };
  /*
   我的体脂称页面
   */
  $scope.myTizhi = function (x) {
    if (x) {
      $ionicNativeTransitions.stateGo('g_my_eqone', {
        backUrl: 'g_my_equipment',
        yaoqingma: $scope.showuserphone,
        backUrlFather: $stateParams.backUrl,
        type: 3,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: $scope.showuserphone,
          backUrlFather: $stateParams.backUrl,
          type: 3
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }
  };

  /*
   我的健康盒子扫一扫页面
   */
  $scope.mySearch = function () {
    $cordovaBarcodeScanner
      .scan()
      .then(function (barcodeData) {
        var qr_data = barcodeData.text;
        if (!barcodeData.cancelled) {
          //TODO 1、判断连接设备为健康盒子
          //2、跳转页面，弹窗
          $ionicNativeTransitions.stateGo('g_my_eqone', {
            backUrl: 'g_my_equipment',
            yaoqingma: $scope.showuserphone,
            type: 5,
            qrdata: qr_data
          }, {
            "type": "slide",
            "direction": "left",
            "duration": 500
          });
        }
      }, function (error) {
        // 扫描失败
        //                   alert("扫描失败");
      });
  };
  $scope.myXueTang = function (x) {
    //根据我的设备页面中，判断设备是否配对  未配对的设备点击时则跳转到开启蓝牙扫描等页面，已配对的设备再次点击后跳到配对设备信息页面
    if (x) {
      $ionicNativeTransitions.stateGo('g_my_eqone', {
        backUrl: 'g_my_equipment',
        yaoqingma: false,
        type: 0,
        backUrlFather: $stateParams.backUrl,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: false,
          backUrlFather: backUrlFather1,
          type: 0
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }
  };
  /**
   * 完成
   */
  $scope.complete = function () {
    $ionicNativeTransitions.stateGo('g_my_equipment', {backUrl: 'tab.mine', yaoqingma: 'true'}, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };

  /**
   * 返回
   */
  $scope.goBack = function () {
    console.log("回退");
    //取出回退页面跳转参数
    var param = $cacheFactory.get($stateParams.backUrl);
    var sp = null;
    //如果不在页面参数则设置为空串
    if (param) {
      sp = param.get('stateParams');
      if (!sp) {
        sp = {};
      }
    } else {
      sp = {};
    }
    $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };

}).controller('MyEquipmentCtrl', function ($rootScope, $scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory, buletoothService, $cordovaBarcodeScanner, userService) {
  //查血压数据库
  //盒子
  var cache = $cacheFactory.get($state.current.name);
  if (!cache) {
    cache = $cacheFactory($state.current.name);
  }
  cache.put('special_back', true);
  cache.put('stateParams', $stateParams);
  console.log("$stateParams.backUrl", $stateParams.backUrl);
  var biaoji;
  $scope.type00 = false;
  //血压
  $scope.type01 = false;
  var deaddress = '';
  var healthhezi = '123456';
  $scope.type02 = false;
  $scope.type03 = false;
  $scope.type04 = 0;
  $scope.type05 = false;
  $scope.type07 = false;
  buletoothService.PlaceSearchHistory.find().then(function (data) {
    for (var i = 0; i < data.length; i++) {
      //        alert(bluetooth[i].placeType);
      if (data[i].placeType == 0) {
        $scope.type00 = true;
        deaddress = data[i].placeAddress;
      } else if (data[i].placeType == 1) {
        $scope.type01 = true;
        deaddress = data[i].placeAddress;
      } else if (data[i].placeType == 2) {
        $scope.type02 = true;
        deaddress = data[i].placeAddress;
      } else if (data[i].placeType == 3) {
        $scope.type03 = true;
        deaddress = data[i].placeAddress;
      } else if (data[i].placeType == 7) {
        $scope.type07 = true;
        deaddress = data[i].placeAddress;
      } else if (data[i].placeType == 5) {
        $scope.type05 = true;
      } else if (data[i].placeType == 4) {
        $scope.type04 = 1;
        var address = data[i].placeAddress;
        bluetoothle.isInitialized(function (success) {
          if (success.isInitialized) {//如果蓝牙已经初始化
            //判断蓝牙是否启用
            bluetoothle.isEnabled(function (datas) {
              if (datas.isEnabled) {
                bluetoothle.isConnected(function (data1) {
                  if (data1.isConnected) {
                    console.log("手环已经连接");
                    $scope.type04 = 2;
                    $scope.$apply();
                  }
                }, function (e) {
                  console.log("手环未连接", e);
                }, {
                  "address": address
                });
              }
            });
          }
        });
      }
    }
  }, function (error) {
    //console.log('111eeeeeee');
  });

  $scope.showcomplet = function (eee) {
    var showuserphone = false;
    var showusergender = false;
    var showuserbirth = false;
    var showuserstature = false;
    userService.checkcompletmes($rootScope.token).then(function (data) {
      console.log("用户信息是否完整！！！！！！！！！！！！！！！！！！！！！", data.userphone);
      if (data.status == true) {
        if (data.showtanchuang == true || $rootScope.user.stature == null || $rootScope.user.stature == "") {
          if (data.userphone != null) {
            showuserphone = data.userphone;
          } else {
            showuserphone = true;
          }
          if (data.usergender != null) {
            showusergender = data.usergender;
          } else {
            showusergender = true;
          }
          if (data.userbirth != null) {
            showuserbirth = data.userbirth;
          } else {
            showuserbirth = true;
          }
          if ($rootScope.user.stature != null && $rootScope.user.stature != "") {
            showuserstature = $rootScope.user.stature;
          } else {
            showuserstature = true;
          }
          $ionicNativeTransitions.stateGo('z_completeInfo', {
            backUrl: $stateParams.backUrl,
            phone: showuserphone,
            birth: showuserbirth,
            gender: showusergender,
            stature: showuserstature,
            type: eee
          }, {
            "type": "slide",
            "direction": "left",
            "duration": 500
          });
        } else {
          if (eee == 5) {
            $scope.mySearch();
          } else if (eee == 1) {
            $scope.myXue($scope.type01);
          } else if (eee == 2) {
            $scope.myOX($scope.type02);
          } else if (eee == 4) {
            $scope.myWatch($scope.type04);
          } else if (eee == 0) {
            $scope.myXueTang($scope.type00);
          } else if (eee == 3) {
            $scope.myTizhi($scope.type03);
          } else if (eee == 7) {
            $scope.myECG($scope.type07);
          }
        }
      }
    }, function (error) {
      //console.log('111eeeeeee');
    });
  }

  //页面跳转参数存储
  var cache = $cacheFactory.get($state.current.name);
  if (!cache) {
    cache = $cacheFactory($state.current.name);
  }
  cache.put('stateParams', $stateParams);
  /*
   我的血压计页面
   */

  $scope.myXue = function (a) {
    //根据我的设备页面中，判断设备是否配对  未配对的设备点击时则跳转到开启蓝牙扫描等页面，已配对的设备再次点击后跳到配对设备信息页面
    if (a) {
      $ionicNativeTransitions.stateGo('g_my_eqone', {
        backUrl: 'g_my_equipment',
        yaoqingma: false,
        backUrlFather: $stateParams.backUrl,
        type: 1,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: false,
          type: 1,
          backUrlFather: $stateParams.backUrl
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }
  };
  /*
   我的血氧计页面
   */
  var backUrlFather1 = $stateParams.backUrl;
  $scope.myXueTang = function (x) {
    console.log("myOx", $stateParams.backUrl);
    //根据我的设备页面中，判断设备是否配对  未配对的设备点击时则跳转到开启蓝牙扫描等页面，已配对的设备再次点击后跳到配对设备信息页面
    if (x) {
      $ionicNativeTransitions.stateGo('g_my_eqone', {
        backUrl: 'g_my_equipment',
        yaoqingma: false,
        type: 0,
        backUrlFather: $stateParams.backUrl,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: false,
          backUrlFather: backUrlFather1,
          type: 0
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }
  };
  /*
   我的血糖计页面
   */
  $scope.myOX = function (x) {
    console.log("我的血糖", $stateParams.backUrl);
    //根据我的设备页面中，判断设备是否配对  未配对的设备点击时则跳转到开启蓝牙扫描等页面，已配对的设备再次点击后跳到配对设备信息页面
    if (x) {
      $ionicNativeTransitions.stateGo('g_my_eqone', {
        backUrl: 'g_my_equipment',
        yaoqingma: false,
        type: 2,
        backUrlFather: $stateParams.backUrl,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: false,
          backUrlFather: backUrlFather1,
          type: 2
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }
  };
  /*
   我的心电页面
   */
  $scope.myECG = function (x) {
    console.log("我的心电", $stateParams.backUrl);
    //根据我的设备页面中，判断设备是否配对  未配对的设备点击时则跳转到开启蓝牙扫描等页面，已配对的设备再次点击后跳到配对设备信息页面
    if (x) {
      $ionicNativeTransitions.stateGo('g_my_eqone', {
        backUrl: 'g_my_equipment',
        yaoqingma: false,
        type: 7,
        backUrlFather: $stateParams.backUrl,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: false,
          backUrlFather: backUrlFather1,
          type: 7
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }
  };
  //我的手环
  $scope.myWatch = function (x) {
    if (x) {
      $ionicNativeTransitions.stateGo('z_wristStrap', {
        backUrl: 'g_my_equipment',
        yaoqingma: $scope.showuserphone,
        backUrlFather: $stateParams.backUrl,
        type: 4,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: $scope.showuserphone,
          backUrlFather: $stateParams.backUrl,
          type: 4
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }
  };

  /*
   我的体脂称页面
   */
  $scope.myTizhi = function (x) {
    console.log("体脂称角标", x);
    if (x) {
      $ionicNativeTransitions.stateGo('g_my_eqone', {
        backUrl: 'g_my_equipment',
        yaoqingma: false,
        backUrlFather: $stateParams.backUrl,
        type: 3,
        address: deaddress
      }, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    } else {
      $ionicNativeTransitions.stateGo('g_my_xueya', {
          backUrl: 'g_my_equipment',
          yaoqingma: false,
          backUrlFather: $stateParams.backUrl,
          type: 3
        }, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        }
      );
    }
  };

  /*
   我的健康盒子扫一扫页面
   */
  $scope.mySearch = function () {
    /*$ionicNativeTransitions.stateGo('g_my_search', {backUrl: 'g_my_equipment'}, {
     "type": "slide",
     "direction": "left",
     "duration": 500
     });*/
    $cordovaBarcodeScanner
      .scan()
      .then(function (barcodeData) {
        //                   alert("barcodeData：" + JSON.stringify(barcodeData));
        //                   alert("qr的值为："+barcodeData.text);
        //          alert("用户token："+$rootScope.token);
        var qr_data = barcodeData.text;
        if (!barcodeData.cancelled) {
          //TODO 1、判断连接设备为健康盒子
          //2、跳转页面，弹窗
          $ionicNativeTransitions.stateGo('g_my_eqone', {
            backUrl: 'g_my_equipment',
            yaoqingma: false,
            type: 5,
            qrdata: qr_data
          }, {
            "type": "slide",
            "direction": "left",
            "duration": 500
          });


          /*//扫描到文本
           //TODO 可以具体判断条形码类型如 EAN_13形式 取出方式barcodeData.format
           buletoothService.codeSearch(barcodeData.text).then(function (data) {
           alert("扫描后显示的数据data：" + JSON.stringify(data));

           }, function (error) {
           alert("Error");
           });*/
        }
      }, function (error) {
        // 扫描失败
        //                   alert("扫描失败");
      });


  };

  /**
   * 完成
   */
  $scope.complete = function () {
    $ionicNativeTransitions.stateGo('g_my_equipment', {backUrl: 'tab.mine'}, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };

  /**
   * 返回
   */
  $scope.goBack = function () {
    //取出回退页面跳转参数
    var param = $cacheFactory.get($stateParams.backUrl);
    var sp = null;
    //如果不在页面参数则设置为空串
    if (param) {
      sp = param.get('stateParams');
      if (!sp) {
        sp = {};
      }
    } else {
      sp = {};
    }
    $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };
  var c_name = $state.current.name;
  $scope.$on(c_name + '_HARDWARE_BACK', function () {
    $scope.goBack();
  });

  /**
   * 跳转到健康盒子页面
   */
  $scope.toHealthBox = function () {
    $ionicNativeTransitions.stateGo('g_health_box', {backUrl: $state.current.name}, {
      "type": "slide",
      "direction": "left",
      "duration": 500
    });
  }
})
  .controller('MyXueCtrl', function ($rootScope, userService, $scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory, buletoothService, $timeout) {
    //alert('myxue');
    var showyaoqingma = $stateParams.yaoqingma;
    console.log("上个页面传过来的参数：", $stateParams);
    if (showyaoqingma == 'true') {
      $scope.invite = function () {
        userService.getInviteStatus().then(function (d) {
            if (d.invite == 1) {
              userService.showInvite();
            }
          }, function (e) {
            console.log(e);
            ErrorShow("网络异常");
          }
        );
      }
      $scope.invite();
    }
    //$scope.bluetooth_stop = true;
//        $(".load").addClass("g_stop");

    //定义一个设备数组
    $scope.zhezhao = false;
    $scope.lianjie = true;
    $scope.peidui = false;
    $scope.peiduiSucess = false;
    $scope.devices = [];//设备列表
    $scope.saomiaoFail = false;//隐藏图片
    $scope.descriptions = false;
    $scope.saomiaoSuccess = false;
    console.log($stateParams.backUrlFather);
    //type 识别仪器编号
    var type = $stateParams.type;
    var buletooth_name = "ZJ_BLOODPRESSURE";//设备蓝牙协议名
    $scope.devices_name = "设备";//
    $scope.t_type = 0;//判断显示类别，体脂秤为1,其余为0
    if (type == 1) {
      buletooth_name = "ZJ_BLOODPRESSURE";
      $scope.devices_name = "血压计";
    } else if (type == 2) {
      buletooth_name = "ZJ_OXYGEN";
      $scope.devices_name = "血氧计";
    } else if (type == 3) {
      buletooth_name = "ZJ_BFR";
      $scope.t_type = 1;
      $scope.devices_name = "体脂秤";
    } else if (type == 4) {
      buletooth_name = "ZJ_BAND";
      $scope.devices_name = "手环";
    } else if (type == 0) {
      buletooth_name = "ZJ_BLOODGLUCOSE";
      $scope.devices_name = "血糖仪";
    } else if (type == 7) {
      buletooth_name = "ZJ_ECG";
      $scope.devices_name = "心电";
    }
    /**
     * 完成
     */
    $scope.complete = function () {
      $ionicNativeTransitions.stateGo('g_my_xueya', {backUrl: 'tab.mine'}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    };

    $scope.timer_stop = function () {
      $timeout(function () {
        bluetoothle.stopScan(function () {
          console.log("timer_stop", "被调用");
          $("#load").removeClass("load");
          $("#load2").removeClass("load");
          $("#load2").removeClass("load2");
        }, function () {
//                      alert("蓝牙停止扫描失败");
        });
        $scope.saomiaoFail = true;
        $scope.descriptions = true;
        $scope.saomiaoSuccess = false;
        $scope.$apply();
      }, 20000);
    };

//////////////////////////////////////////////////////////////////////////////////////////////////////////
    $scope.scan_for_real = function () {
      console.log("蓝牙名称", buletooth_name);
      bluetoothle.startScan(function (data) {//扫描
        console.log(JSON.stringify(data));
        if (data.status == 'scanStarted') {
          $scope.timer_stop();
        }

        if (data.status == 'scanResult') {
          $scope.saomiaoFail = false;
          $scope.descriptions = false;
          $scope.saomiaoSuccess = true;
          for (var i in $scope.devices) {
            if ($scope.devices[i].address == data.address) {
              return;
            }
          }
          if (data.name == buletooth_name) {
            var d = new Object();
            d.address = data.address;
            d.name = data.name;
            $scope.devices.push(d);
            $scope.$apply();
            console.log("关闭定时任务 timeout");
          }
        }
      }, function (e) {
        console.log("蓝牙扫描失败", e)
        //  alert("蓝牙扫描失败");
      }, {
        "services": [],
        "allowDuplicates": false,
        "scanMode": bluetoothle.SCAN_MODE_LOW_LATENCY,
        "matchMode": bluetoothle.MATCH_MODE_AGGRESSIVE,
        "matchNum": bluetoothle.MATCH_NUM_MAX_ADVERTISEMENT,
        "callbackType": bluetoothle.CALLBACK_TYPE_ALL_MATCHES
      });
    };

    //点击重新扫描蓝牙控件
    $scope.againScan = function () {
      //$scope.bluetooth_stop = false;
      //$(".load").removeClass("g_stop");
//            alert('again');
      $("#load").addClass("load");
      $("#load2").addClass("load");
      $("#load2").addClass("load2");
      $scope.saomiaoFail = false;
      $scope.descriptions = false;
      $scope.saomiaoSuccess = false;
      $scope.devices = [];
      //$scope.$apply();
      // alert("确定重新扫描");
      $scope.blue_scan();

    }

    $scope.blue_scan = function () {
      bluetoothle.isScanning(function (data) {//判断蓝牙是否处于扫描状态
        //                            alert("扫描状态：" + JSON.stringify(data));
        if (data.isScanning) {
          bluetoothle.stopScan(function () {
            //                       alert("为了连接已配对设备而停止扫描成功");
            $scope.scan_for_real();
          }, function () {
            //                     alert("为了连接已配对设备而蓝牙停止扫描失败");
          });
        } else {
          $scope.scan_for_real();
        }
      });

    };
    //同意开启蓝牙
    $scope.agreeConnect = function () {
      $scope.zhezhao = false;//关闭弹窗
      $scope.lianjie = false;
      //          $scope.bluetooth_stop = false;
//                       $(".load").removeClass("g_stop");

      //判断蓝牙是否初始化
      bluetoothle.isInitialized(function (data) {
        // alert('蓝牙初始化状态' + JSON.stringify(data));
        if (data.isInitialized) {//如果蓝牙已经初始化
          //判断蓝牙是否启用
          bluetoothle.isEnabled(function (data) {
            // alert("蓝牙开启状态3：" + JSON.stringify(data));
            if (data.isEnabled) {
              // alert('已经初始化了，并且蓝牙是开启的');
              //TODO 执行扫描操作
              $scope.blue_scan();
            } else {
              //  alert('已经初始化了，但蓝牙是关闭的');
              bluetoothle.enable(function () {//开启蓝牙
              }, function () {
              });
              $timeout(function () {
                // alert('三秒后开始扫描');
                //由于开启蓝牙成功的方法中不执行其他逻辑，所以采用延迟方法
                //TODO 执行扫描操作
                $scope.blue_scan();
              }, 5000);
            }
          });
        } else {
          bluetoothle.initialize(function () {//初始化
            //判断蓝牙是否启用
            bluetoothle.isEnabled(function (data) {
              //alert("蓝牙开启状态：" + JSON.stringify(data));
              if (data.isEnabled) {
                // alert(123);
              } else {
                //alert(456);
                bluetoothle.enable(function () {//开启蓝牙
                }, function () {
                });
              }
            });
            $timeout(function () {//由于开启蓝牙成功的方法中不执行其他逻辑，所以采用延迟方法
              //TODO 执行扫描操作
              $scope.blue_scan();
            }, 3000);
          }, function () {
            //                                                 alert("蓝牙初始化失败");
          }, {
            "request": true,
            "statusReceiver": false
          });
        }
      });

      /////////////////////////////////////////////////////////////////////////////////////////////////////
      /**
       * 连接蓝牙设备
       */
      var bluetooth = new Object();
      $scope.connect = function (address) {
        //弹出是否允许保存蓝牙信息的窗口
        $scope.zhezhao = true;
        $scope.peidui = true;

        //允许
        $scope.pairConnect = function (d_name) {
          if (d_name == '手环') {
            $ionicNativeTransitions.stateGo('g_ts1', {
              backUrl: $stateParams.backUrl
            }, {
              "type": "slide",
              "direction": "right",
              "duration": 500
            });
          }
          //配对停止扫描
          bluetoothle.stopScan(function () {
            console.log("timer_stop", "被调用");
            $("#load").removeClass("load");
            $("#load2").removeClass("load");
            $("#load2").removeClass("load2");
          }, function () {
//                      alert("蓝牙停止扫描失败");
          });
          $scope.zhezhao = true;
          $scope.peiduiSucess = true;
          var deviceName = ['血糖计', '血压计', '血氧计', '体脂秤', '手环', '', '', '心电'];
          var imgs = ['img/g_myset04.png', 'img/g_myset_03.png', 'img/g_myset05.png', 'img/g_myset03.png', 'img/g_myset01.png', '', '', 'img/g_xdt.png'];
          $scope.img = imgs[type];
          $scope.peidui = false;
          if (type == 1 || type == 2 || type == 3 || type == 0 || type == 7) {//血压
            //alert(type);
            bluetooth.blueAddress = address;
            bluetooth.blueType = type;
            bluetooth.blueImg = $scope.img;
            bluetooth.blueName = deviceName[type];
            //TODO 添加之前先清空
            buletoothService.PlaceSearchHistory.deleteByType(bluetooth.blueType);
            //将蓝牙信息插入表中
            buletoothService.PlaceSearchHistory.insert(bluetooth);
            //发送配对成功广播
            var type_t = null;
            if (type == 3) {
              type_t = 4;
              $scope.$emit("pairSuccess", {type: type_t});
            } else {
              $scope.$emit("pairSuccess", {type: type});
            }
          }
          if (type == 4) {
            bluetooth.blueAddress = address;
            bluetooth.blueType = type;
            bluetooth.blueImg = "";
            bluetooth.blueName = deviceName[type];
            $rootScope.strapAddress = address;
            //TODO 添加之前先清空
            $rootScope.connectBlue(address);
            buletoothService.PlaceSearchHistory.deleteByType(bluetooth.blueType);
            //将蓝牙信息插入表中
            buletoothService.PlaceSearchHistory.insert(bluetooth);
            $scope.$emit("pairSuccess", {type: 5});
          }

          //延迟1秒后关闭此弹窗
          if (d_name != '手环') {
            $timeout(function () {
              $scope.zhezhao = false;
              $scope.peiduiSucess = false;
              //跳转 （type为1表示血压）
              //console.log("backUrlFather",$stateParams.backUrlFather);
              if (type == 4) {
                $ionicNativeTransitions.stateGo('z_wristStrap', {backUrl: 'g_my_equipment', address: address}, {
                  "type": "slide",
                  "direction": "left",
                  "duration": 500
                });
              } else {
                $ionicNativeTransitions.stateGo($stateParams.backUrlFather, {
                  "type": "slide",
                  "direction": "left",
                  "duration": 500
                });
              }
            }, 1000);
          }
        }
        //拒绝
        $scope.pairConnectFail = function () {//关闭遮罩以及弹窗
          $scope.zhezhao = false;
          $scope.peidui = false;
        }
      };

    }
    $scope.agreeConnect();
    //拒绝
    $scope.cancleConnect = function () {
      /*//判断蓝牙是否开启，开启的话返回前先关闭
       if(bluetoothle.isEnabled() ==true){
       bluetoothle.close(function(data){

       }, function(){

       }, {
       "address": address
       });
       }*/
      $scope.goBack();
    }

    /**
     * 完成
     */
    $scope.complete = function () {

      $ionicNativeTransitions.stateGo('g_my_xueya', {backUrl: 'tab.mine'}, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });

    };

    /**
     * 返回
     */
    $scope.goBack = function () {
      console.log("回退");
      bluetoothle.isScanning(function (data) {//判断蓝牙是否处于扫描状态
        if (data.isScanning) {
          bluetoothle.stopScan(function () {
          }, function () {
          });
        }
      });
      //取出回退页面跳转参数
      var param = $cacheFactory.get($stateParams.backUrl);
      var sp = null;
      //如果不在页面参数则设置为空串
      if (param) {
        sp = param.get('stateParams');
        if (!sp) {
          sp = {};
        }
      } else {
        sp = {};
      }
      $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };


  }).controller('MyTizhiCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory) {

  /**
   * 完成
   */

  $scope.complete = function () {
    $ionicNativeTransitions.stateGo('g_my_tizhi', {backUrl: 'tab.mine'}, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };

  /**
   * 返回
   */
  $scope.goBack = function () {
    console.log("回退");
    //取出回退页面跳转参数
    var param = $cacheFactory.get($stateParams.backUrl);
    var sp = null;
    //如果不在页面参数则设置为空串
    if (param) {
      sp = param.get('stateParams');
      if (!sp) {
        sp = {};
      }
    } else {
      sp = {};
    }
    $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };
}).controller('MySearchCtrl', function ($scope, $stateParams, $state, $ionicNativeTransitions, $cacheFactory, buletoothService, $cordovaBarcodeScanner) {
  /*
   我的健康盒子扫一扫页面
   */
  /* $scope.mySearch = function () {
   $cordovaBarcodeScanner
   .scan()
   .then(function (barcodeData) {
   alert("barcodeData：" + JSON.stringify(barcodeData));
   if (!barcodeData.cancelled) {
   //扫描到文本
   //TODO 可以具体判断条形码类型如 EAN_13形式 取出方式barcodeData.format
   buletoothService.codeSearch(barcodeData.text).then(function (data) {
   alert("扫描后显示的数据data：" + JSON.stringify(data));


   }, function (error) {
   alert("Error");
   });
   }
   }, function (error) {
   // 扫描失败
   alert("扫描失败");
   });
   };*/


  /**
   * 完成
   */
  $scope.complete = function () {
    $ionicNativeTransitions.stateGo('g_my_search', {backUrl: 'tab.mine'}, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };

  /**
   * 返回
   */
  $scope.goBack = function () {
    console.log("回退");
    //取出回退页面跳转参数
    var param = $cacheFactory.get($stateParams.backUrl);
    var sp = null;
    //如果不在页面参数则设置为空串
    if (param) {
      sp = param.get('stateParams');
      if (!sp) {
        sp = {};
      }
    } else {
      sp = {};
    }
    $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };
}).controller('MyEqoneCtrl', function ($rootScope, userService, $stateParams, $scope, $ionicNativeTransitions, buletoothService, $cacheFactory, $state) {
  //alert('MyEqoneCtrl');
  var showyaoqingma = $stateParams.yaoqingma;
  if (showyaoqingma == 'true') {
    $scope.invite = function () {
      userService.getInviteStatus().then(function (d) {
          if (d.invite == 1) {
            userService.showInvite();
          }
        }, function (e) {
          console.log(e);
          ErrorShow("网络异常");
        }
      );
    }
    $scope.invite();
  }

  //$stateParams为了取出页面传进来的参数 所以需要注入
  $scope.hasEeq = true;
  var deviceName = ['血糖仪', '血压计', '血氧计', '体脂秤', '手环', '', '', '心电'];
  var imgs = ['img/g_myset04.png', 'img/g_myset_03.png', 'img/g_myset05.png', 'img/g_myset03.png', 'img/g_myset01.png', '', '', 'img/g_xdt.png'];

  //设备类型
  var type = $stateParams.type;
  // alert(type);
  var bluetooth = new Object();
  //$scope.address = $stateParams.address;
  $scope.device = deviceName[type];
  $scope.img = imgs[type];
  //[bluetooth.blueName + '', bluetooth.blueAddress + '', bluetooth.blueType + '', bluetooth.blueImg + ''],
  //if (type == 1||type==2||type==3) {//血压
  //alert(type);
  $scope.address = $stateParams.address;
  $scope.isPair = true;
  $scope.isCancel = true;
  if (type == 5) {//健康盒子
    $scope.hezi01 = true;
    $scope.hezi02 = true;
    $scope.isPair = false;
    $scope.isCancel = false;
    // $scope.address = '66666';
    $scope.address = $stateParams.address;
    var qrData = $stateParams.qrdata;
    $scope.healthPair = function () {
      //扫描到文本
      //TODO 可以具体判断条形码类型如 EAN_13形式 取出方式barcodeData.format
      buletoothService.codeSearch(qrData).then(function (data) {
        //alert("扫描后显示的数据data：" + JSON.stringify(data));
        $scope.hezi01 = false;
        $scope.hezi02 = false;
        $scope.isPair = true;
        $scope.isCancel = true;

      }, function (error) {//先返回再提示失败信息
        //取出回退页面跳转参数
        var param = $cacheFactory.get($stateParams.backUrl);
        var sp = null;
        //如果不在页面参数则设置为空串
        if (param) {
          sp = param.get('stateParams');
          if (!sp) {
            sp = {};
          }
        } else {
          sp = {};
        }
        $ionicNativeTransitions.stateGo('g_my_equipment', sp, {
          "type": "slide",
          "direction": "right",
          "duration": 500
        });
        ErrorShow(error);
      });
    }
    $scope.cancelHeziPair = function () {
      //取出回退页面跳转参数
      var param = $cacheFactory.get($stateParams.backUrl);
      var sp = null;
      //如果不在页面参数则设置为空串
      if (param) {
        sp = param.get('stateParams');
        if (!sp) {
          sp = {};
        }
      } else {
        sp = {};
      }
      $ionicNativeTransitions.stateGo('g_my_equipment', sp, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    }
  } else if (type == 0 || type == 1 || type == 2 || type == 3 || type == 7) {//血氧计
    $scope.address = $stateParams.address;
    $scope.isPair = true;
    $scope.isCancel = true;
    bluetooth.blueAddress = $stateParams.address;
    bluetooth.blueType = $stateParams.type;
    bluetooth.blueImg = $scope.img;
    bluetooth.blueName = deviceName[type];
    //TODO 添加之前先清空
    //  buletoothService.PlaceSearchHistory.deleteByType(bluetooth.blueType);
    //将蓝牙信息插入表中
    //buletoothService.PlaceSearchHistory.insert(bluetooth);
  }


  //返回按钮（从蓝牙配对信息页面返回到我的设备页面）
  $scope.goBack = function () {
    //取出回退页面跳转参数
    var param = $cacheFactory.get($stateParams.backUrl);
    var sp = null;
    //如果不在页面参数则设置为空串
    if (param) {
      sp = param.get('stateParams');
      if (!sp) {
        sp = {};
      }
    } else {
      sp = {};
    }
    $ionicNativeTransitions.stateGo('g_my_equipment', sp, {
      "type": "slide",
      "direction": "right",
      "duration": 500
    });
  };
  //TODO 取消配对
  $scope.cancelPair = function () {
    //清空数据库数据
    buletoothService.PlaceSearchHistory.deleteByType($stateParams.type);
    $scope.hasEeq = false;
    $scope.isCancel = false;//取消配对按钮 隐藏
    //发送取消配对广播
    $scope.$emit("cancelPair", {type: $stateParams.type});
    $scope.goBack();
  }
})

//四个主页面图标所在页面

  .controller('ProblemCtrl', function ($stateParams, $scope, $rootScope, $ionicNativeTransitions, $cacheFactory, $state) {
    //页面跳转参数存储
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    cache.put('special_back', true);
    cache.put('stateParams', $stateParams);
//        if(!cache.get("firstBackUrl")){
//            cache.put("firstBackUrl",$stateParams.backUrl);
//        }
    $scope.form = {
      show: 'device'
    }

    /**
     *跳到为什么不能提醒详情页
     */
    $scope.godetail = function () {
      $ionicNativeTransitions.stateGo('g_yindao', {backUrl: 'z_problems'}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    }

    /**
     * 跳到咨询页面
     */
    $scope.consultDoctor = function () {
      $ionicNativeTransitions.stateGo('doctor_consult', {backUrl: 'z_problems'}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    }

    /**
     * 调到客服聊天页面
     */
    $scope.consultServer = function () {
      $ionicNativeTransitions.stateGo('z_message_chat', {backUrl: 'z_problems'}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    }

    /**
     * 显示医院、设备详情
     */
    $scope.toDetail = function (str) {
      $ionicNativeTransitions.stateGo("z_problemDetail", {backUrl: 'z_problems', id: str}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    }

    /**
     * 返回
     */
    $scope.goBack = function () {
      console.log("回退");
      //取出回退页面跳转参数
      var param = $cacheFactory.get($stateParams.backUrl);
      var sp = null;
      //如果不在页面参数则设置为空串
      if (param) {
        sp = param.get('stateParams');
        if (!sp) {
          sp = {};
        }
      } else {
        sp = {};
      }
      $ionicNativeTransitions.stateGo("tab.mine", sp, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };

    /**
     * 收到物理返回键按钮事件
     */
    var c_name = $state.current.name;
    $scope.$on(c_name + '_HARDWARE_BACK', function () {
      $scope.goBack();
    });
  })

  /**
   * 系统设置
   */
  .controller('systemCtrl', function ($stateParams, $scope, $rootScope, $ionicNativeTransitions, $cacheFactory, $state) {
    //页面跳转参数存储
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    cache.put('special_back', true);
    cache.put('stateParams', $stateParams);
//
    console.debug("系统设置页面");

    /**
     * 我的铃声设置页面
     */
    $scope.myMusic = function () {
      if (!$rootScope.token) //未登陆跳到登陆页面
      {
        $ionicNativeTransitions.stateGo('g_load', {backUrl: 'mySetting'}, {
          "type": "slide",
          "direction": "left",
          "duration": 500
        });
        return false;
      }
      $ionicNativeTransitions.stateGo('g_my_music', {backUrl: 'mySetting'}, {
        "type": "slide",
        "direction": "left",
        "duration": 500
      });
    };

    /**
     * 返回
     */
    $scope.goBack = function () {
      console.log("回退");
      //取出回退页面跳转参数
      var param = $cacheFactory.get($stateParams.backUrl);
      var sp = null;
      //如果不在页面参数则设置为空串
      if (param) {
        sp = param.get('stateParams');
        if (!sp) {
          sp = {};
        }
      } else {
        sp = {};
      }
      $ionicNativeTransitions.stateGo("tab.mine", sp, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };
    /**
     * 收到物理返回键按钮事件
     */
    var c_name = $state.current.name;
    $scope.$on(c_name + '_HARDWARE_BACK', function () {
      $scope.goBack();
    });
  })

  /**
   * 字体设置
   */
  .controller('fontCtrl', function ($stateParams, $scope, $rootScope, $ionicNativeTransitions, $cacheFactory, $state) {
    //页面跳转参数存储
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    cache.put('special_back', true);
    cache.put('stateParams', $stateParams);
//
    console.debug("字体设置页面");
    $scope.rangeValue = 0;
    $scope.showFlag = true;
    if (localStorage.getItem("fontSize")) {
      var fontSize = localStorage.getItem("fontSize");
      if (fontSize == 100) {
        $scope.showFlag = false;
        $scope.rangeValue = 100;
        $("html").css({"font-size": "15px"});
        if (!localStorage.getItem("user_message_width")) {
          localStorage.setItem("user_message_width", "30%");
        }
      } else {
        $scope.showFlag = true;
        $scope.rangeValue = 0;
        $("html").css({"font-size": "10px"});
        if (!localStorage.getItem("user_message_width")) {
          localStorage.setItem("user_message_width", "45%");
        }
      }
    }
    $scope.changeFont = function () {
      console.debug("切换字体");
      console.debug('range:', $("#range").val());
      if ($scope.showFlag) {
        $scope.showFlag = false;
        $scope.rangeValue = 0;
        localStorage.setItem("fontSize", 100);
        $("html").css({"font-size": "15px"});
        //设置消息的宽度
        localStorage.setItem("user_message_width", "30%");
      } else {
        $scope.showFlag = true;
        $scope.rangeValue = 100;
        localStorage.setItem("fontSize", 0);
        $("html").css({"font-size": "10px"});
        localStorage.setItem("user_message_width", "45%");
      }
      ;
    };

    /**
     * 返回
     */
    $scope.goBack = function () {
      console.log("回退");
      //取出回退页面跳转参数
      var param = $cacheFactory.get($stateParams.backUrl);
      var sp = null;
      //如果不在页面参数则设置为空串
      if (param) {
        sp = param.get('stateParams');
        if (!sp) {
          sp = {};
        }
      } else {
        sp = {};
      }
      $ionicNativeTransitions.stateGo("mySetting", sp, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };
    /**
     * 收到物理返回键按钮事件
     */
    var c_name = $state.current.name;
    $scope.$on(c_name + '_HARDWARE_BACK', function () {
      $scope.goBack();
    });

  })

  /**
   * 消息列表控制器
   */
  .controller('messageListCtrl', function ($scope, $state, WebSql, $ionicNativeTransitions, $cacheFactory, $stateParams) {
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    console.info("message》=========");
    WebSql.selectInformMessageTable().then(function (data) {
      console.info("$scope.messageLists:", data);
      $scope.messageLists = data;
      cache.put("messageList", $scope.messageLists);
    }, function (e) {
      console.error(e);
    });

    $scope.goDetail = function (id) {
      $ionicNativeTransitions.stateGo("g_news_detail", {id: id, backUrl: 'g_news'}, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    }
    /**
     * 返回
     */
    $scope.goBack = function () {
      console.log("回退");
      //取出回退页面跳转参数

      $ionicNativeTransitions.stateGo('tab.mine', {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };


  })
  .controller('messageDetailCtrl', function ($stateParams, $scope, $rootScope, $ionicNativeTransitions, $cacheFactory, $state, DoctorService, $timeout) {
    //页面跳转参数存储
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    cache.put('stateParams', $stateParams);
    console.info("id。。。。。。" + $stateParams.id);

    var listCache = $cacheFactory.get("g_news");
    var list = listCache.get("messageList");
    console.info('list:', list);
    $scope.detail = null;
    for (var index in list) {
      if (list[index].id == $stateParams.id) {
        $scope.detail = list[index];
        console.info('obj:', list[index]);
      }
    }

    /**
     * 返回
     */
    $scope.goBack = function () {
      console.log("回退");
      //取出回退页面跳转参数
      var param = $cacheFactory.get($stateParams.backUrl);
      var sp = null;
      //如果不在页面参数则设置为空串
      if (param) {
        sp = param.get('stateParams');
        if (!sp) {
          sp = {};
        }
      } else {
        sp = {};
      }
      $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };

  })

  /**
   * 常见问题详情页面
   */
  .controller('problemDetailCtrl', function ($stateParams, $scope, $rootScope, $ionicNativeTransitions, $cacheFactory, $state, $timeout) {
    //页面跳转参数存储
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    cache.put('stateParams', $stateParams);
    console.info("常见问题详情页面");

    $scope.show = $stateParams.id;

    /**
     * 返回
     */
    $scope.goBack = function () {
      console.log("回退");
      //取出回退页面跳转参数
      var param = $cacheFactory.get($stateParams.backUrl);
      var sp = null;
      //如果不在页面参数则设置为空串
      if (param) {
        sp = param.get('stateParams');
        if (!sp) {
          sp = {};
        }
      } else {
        sp = {};
      }
      $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };

  })

  /**
   * 服务详情页面
   */
  .controller('serviceDetailCtrl', function ($stateParams, $scope, $rootScope, $ionicNativeTransitions, $cacheFactory, $state, $timeout) {
    //页面跳转参数存储
    var cache = $cacheFactory.get($state.current.name);
    if (!cache) {
      cache = $cacheFactory($state.current.name);
    }
    cache.put('stateParams', $stateParams);
    console.info("服务详情页面");

    sessionStorage.setItem("lastPage", 'g_pay');
    console.info("$stateParams:", $stateParams);

    /**
     * 返回
     */
    $scope.goBack = function () {
      console.log("回退");
      //取出回退页面跳转参数
      var param = $cacheFactory.get($stateParams.backUrl);
      var sp = null;
      //如果不在页面参数则设置为空串
      if (param) {
        sp = param.get('stateParams');
        if (!sp) {
          sp = {};
        }
      } else {
        sp = {};
      }
      $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
        "type": "slide",
        "direction": "right",
        "duration": 500
      });
    };

  });
