/**
 * Created by WEIQI on 2017/5/11.
 */
angular.module('Wallet', ['OPERATION_REMIND'])
  .factory('walletService', function ($http, $q, $rootScope, $cordovaBarcodeScanner, drugService, $cordovaToast, WebSql) {
          return{
            /**
             * 获取用户零钱余额
             * @returns {Promise}
             */
            getUserBalance:function () {
              var q = $q.defer();
              var req = {
                method: 'post',
                url: $rootScope.reqUrl + "/money/balance.htm",
                params: {
                  token: $rootScope.token
                },
                timeout: 50000
              };
              $http(req).success(function
                (result) {
                if (result) {
                  q.resolve(result);
                } else {
                  q.reject(result);
                }
              }).error(function (result) {
                q.reject("网络异常");
              });
              return q.promise;
            },
            //确认提现
            withdrawDeposit:function (moneyNum,payee) {
              var q = $q.defer();
              var req = {
                method: 'post',
                url: $rootScope.reqUrl + "/trade/transfer.htm",
                params: {
                  token: $rootScope.token,
                  money:moneyNum,
                  payee: payee   //收款账户（支付宝）
                },
                timeout: 50000
              };
              $http(req).success(function
                (result) {
                if (result) {
                  q.resolve(result);
                } else {
                  q.reject(result);
                }
              }).error(function (result) {
                q.reject("网络异常");
              });
              return q.promise;
            },
            //根据用户id查询绑定的支付宝账户列表
            obtainAliPayAllAccount:function () {
              var q = $q.defer();
              var req = {
                method: 'post',
                url: $rootScope.reqUrl + "/patient/draw/alipay/list.htm",
                params: {
                  token: $rootScope.token
                },
                timeout: 50000
              };
              $http(req).success(function
                (result) {
                if (result) {
                  q.resolve(result);
                } else {
                  q.reject(result);
                }
              }).error(function (result) {
                q.reject("网络异常");
              });
              return q.promise;
            },
            // //添加支付宝
            // addAliPayAccount:function () {
            //   var q = $q.defer();
            //   var req = {
            //     method: 'post',
            //     url: $rootScope.reqUrl + "/patient/draw/alipay/add.htm",
            //     params: {
            //       token: $rootScope.token,
            //       alipay:"378397197@qq.com",
            //       regSource:$rootScope.devices_name,
            //       regChannel:"医生邀请码",
            //       password:"前端生成一个6位随机数",
            //       devideId:$rootScope.deviceId
            //     },
            //     timeout: 50000
            //   };
            //   $http(req).success(function
            //     (result) {
            //     if (result) {
            //       q.resolve(result);
            //     } else {
            //       q.reject(result);
            //     }
            //   }).error(function (result) {
            //     q.reject("网络异常");
            //   });
            //   return q.promise;
            // },
            //查询交易记录
            selectRecordList: function (page, pageSize) {
              var q = $q.defer();
              var req = {
                method: 'post',
                url: $rootScope.reqUrl + "/p/order/list.htm",
                params: {
                  token: $rootScope.token,
                  page: page,
                  pageSize: pageSize
                },
                timeout: 50000
              };
              $http(req).success(function
                (result) {
                if (result) {
                  q.resolve(result);
                } else {
                  q.reject(result);
                }
              }).error(function (result) {
                q.reject("网络异常");
              });
              return q.promise;
            },
            //设置默认支付宝
            setAlipayDefault: function (aliPay) {
              var q = $q.defer();
              var req = {
                method: 'post',
                url: $rootScope.reqUrl + "/patient/alipay/default.htm",
                params: {
                  token: $rootScope.token,
                  alipay: aliPay   //收款账户（支付宝）
                },
                timeout: 50000
              };
              $http(req).success(function
                (result) {
                if (result) {
                  q.resolve(result);
                } else {
                  q.reject(result);
                }
              }).error(function (result) {
                q.reject("网络异常");
              });
              return q.promise;
            }
          }
  })
