//网络资源模块
angular.module('NET_WORK', [])
    //药品外观
    .factory('MEDICINE_SURFACE', function ($cordovaFile, $cordovaFileTransfer, $cordovaZip, $rootScope) {
        //药品外观资源下载地址
        var network_download_url = $rootScope.reqUrl + '/shape_color.zip';
        var local_file_dir = window.devicePath + 'HealthPatient/pic/';
        var surface_url = local_file_dir + 'shape_color/';
        var local_zip_dir = window.devicePath + 'HealthPatient/zip/';
        var local_zip_url = local_zip_dir + 'shape_color.zip';
        return {
            //检测
            check: function () {
                var p_this = this;
                $cordovaFile.checkDir(surface_url).then(function (data) {
                    alert('检测药品外观图片文件是否存在' + JSON.stringify(data));
                    //存在压缩文件包
                    //TODO 检测外观文件完整性
                }, function (error) {
                    //检测压缩包目录
                    $cordovaFile.checkFile(local_zip_dir, 'shape_color.zip').then(function (data) {
                        alert('存在外观文件压缩包' + JSON.stringify(data));
                        p_this.unzip_surface();
                        //存在压缩文件包
                        // alert('检测药品外观压缩包是否存在' + JSON.stringify(data));
                    }, function (error) {
                        alert('未检测到外观图片文件与压缩包');
                        //网络下载资源
                        $cordovaFileTransfer.download(network_download_url, local_zip_url, {}, true)
                            .then(function (result) {
                                alert(JSON.stringify(result));
                                p_this.unzip_surface();
                                // Success!
                            }, function (err) {
                                alert(JSON.stringify(err));
                                // Error
                            }, function (progress) {
                            });
                    });
                });
            },
            unzip_surface: function () {
//                alert('开始解压缩文件');
//                alert(local_zip_url);
//                alert(local_file_dir);
                $cordovaZip
                    .unzip(
                    local_zip_url,
                    local_file_dir
                ).then(function () {
                        alert('success');
                    }, function () {
                        alert('error');
                    }, function (progressEvent) {
                        //alert(progressEvent);
                    });
            }
        }
    })
    //网络状态
    .factory('NET_WORK_STATUS', function ($interval) {
        if (window.cordova) {
            var states = {};
            states[Connection.UNKNOWN] = 'Unknown connection';
            states[Connection.ETHERNET] = 'Ethernet connection';
            states[Connection.WIFI] = 'WiFi connection';
            states[Connection.CELL_2G] = 'Cell 2G connection';
            states[Connection.CELL_3G] = 'Cell 3G connection';
            states[Connection.CELL_4G] = 'Cell 4G connection';
            states[Connection.CELL] = 'Cell generic connection';
            states[Connection.NONE] = 'No network connection';
            //断开连接
            var disconnect = false;
        }
        return {
            report_status: function () {
                $interval(function () {
                    if (window.cordova) {
                        var networkState = navigator.connection.type;
                    }
                }, 3000);
            }
        }
    })
    //重发请求队列
    .factory('REQ_ERROR', function ($http) {
        var q = null;
        var l_q = localStorage.getItem('err_queue');
        if (l_q) {
            q = eval("(" + l_q + ")");
        } else {
            q = [];
        }
        return {
            //存放失败请求
            put: function (url, param, broad) {
                var o = new Object();
                o.url = url;
                o.param = param;
                o.broad = broad;
                q.push(o);
            },
            re_send: function () {
                for (var i = 0; i < q; i++) {

                }
            }
        }
    });
