angular.module('PillBox', ['MY_MAP', 'File', 'onezone-datepicker'])
    .service('boxService', function ($http, $q, $rootScope, Plan, $ionicNativeTransitions) {
        return {

            calendarInfo: function (medicineId) {
                var q = $q.defer();//固定用法，设置回调问题 then
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/medicine/plan/calendarInfo.htm",
                    params: {
                        token: $rootScope.token,
                        medicineId: medicineId
                    },
                    timeout: 2000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },

            viewPillBox: function (method, toUser) {
                if (!$rootScope.token) //未登陆跳到登陆页面
                {
                    $ionicNativeTransitions.stateGo('g_load', {backUrl: 'g_load'}, {
                        "type": "slide",
                        "direction": "left",
                        "duration": 500
                    });
                    return false;
                }
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/medicine/plan/query.htm",
                    params: {
                        token: $rootScope.token,
                        method: method,
                        toUser: toUser
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },
            todayDrugs: function (start, count) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/message/query.htm",
                    params: {
                        token: $rootScope.token,
                        start: start,
                        count: count
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },
            /**
             * 提交健康数据
             * @param dataType
             * @param method
             * @param id
             * @param itemCodes
             * @param values
             * @param remark
             * @param time
             * @returns {*}
             */
            submitHeathData: function (dataType, method, id, itemCodes, values, remark, time) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/message/query.htm",
                    params: {
                        token: $rootScope.token,
                        dataType: dataType,
                        method: method,
                        id: id,
                        itemCodes: itemCodes,
                        values: values,
                        remark: remark,
                        time: time
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },
            getUsage: function (medicineName) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/medicine/usage/query.htm",
                    params: {
                        name: medicineName
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },
            stopDrug: function (id) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/medicine/plan/stop.htm",
                    params: {
                        token: $rootScope.token,
                        planId: id
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            },
            takeInfo: function (planid) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/medicine/plan/takeInfo.htm",
                    params: {
                        token: $rootScope.token,
                        planId: planid
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("ERROR");
                });
                return q.promise;
            }
        };  //return
    })

    //药盒信息
    .controller('pillboxCtrl', function ($scope, $cordovaLocalNotification, $cacheFactory, $state, $ionicNativeTransitions, $stateParams, boxService, $rootScope, drugService, $timeout, MY_MAP, $cordovaFile, $interval) {
        console.group("pillbox页面☆☆☆☆");
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        /*  $scope.play=function(){
         alert("11");
         $("#music").attr("src","sound/pillbox.mp3");
         var mp3=$("#music")[0];
         mp3.play();
         }*/

        // $scope.$on("$ionicView.enter", function (scopes, states) {
        //   var cache = $cacheFactory.get('tab.pillbox');
        //   if (!cache) {
        //     cache = $cacheFactory('tab.pillbox');
        //   }
        //   console.log(cache.get('network_error'));
        //   //如果页面存在失败标志进入404页面
        //   if (cache.get('network_error')) {
        //     //$scope.getPlanList();
        //   }
        // });

        MY_MAP.init();
        var toUser = "";
        var method = "effect";
        $scope.flag = {deleting: false, is_empty: false};
        $scope.form = {flag: true, title: '我', refresh: false};
        var plans = [];//计划数组

        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }

        /**
         * 初始化用户缓存
         */
        var likUser = user_cache.get('likUser');
        if (!likUser) {
            likUser = {
                toUser: '',
                userName: '我',
                headImg: $rootScope.user && $rootScope.user.headImg ? $rootScope.user.headImg : 'img/z_sysHeadPic.png',
                gender: $rootScope.user && $rootScope.user.gender == 1 ? '男' : '女'
            },
                user_cache.put('likUser', likUser);
        }
        $scope.likUser = likUser;
        //console.log("plans缓存",user_cache.get('plans'));
        /**
         * 从缓存获取计划列表，若不存在则请求网络
         */
        /* var plan_cache=user_cache.get("plans");
         if(!plan_cache)
         {
         boxService.viewPillBox(method, toUser).then(function (data) {
         $scope.list = data.list;
         user_cache.put("plans", data.list);
         }, function (error) {
         console.log(error);
         });
         }*/
        /**
         * 收到登录的广播
         */
        $rootScope.$on('login', function () {
            console.log("收到登录成功的广播在药盒");
            user_cache = $cacheFactory.get('user');
            alarm_users = user_cache.get("alarm_users");
            if (!alarm_users) {
                drugService.getUser().then(function (data) {
                    user_cache.put('alarm_users', data.list);
                    $scope.users = data.list;
                }, function (error) {
                });
            }
            $scope.getPlanList();
            $scope.bindClick();
            //
            $timeout(function () {
                $scope.form.title = '';
            });

        });

        /**
         * 跳转到医院界面
         * @param type 类型 药店、医院
         */
        $scope.goHospital = function (type) {
            $ionicNativeTransitions.stateGo('nearbyhospital', {type: type, backUrl: 'tab.pillbox'}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        };

        /**
         * 从网络读取列表
         */
        $scope.getPlanList = function () {
            var aa = localStorage.getItem("touserId");
            var touserId = $scope.likUser.toUser;
            if (!touserId) {
                console.log("touserId:", touserId);
                touserId = "";
            }
            console.log('用户id', touserId);
            if (aa) {
                console.log("存在本地存储");
                touserId = localStorage.getItem("touserId");
            }
            boxService.viewPillBox(method, touserId).then(function (data) {
                $scope.list = data.list;
                localStorage.setItem($rootScope.user.userId + "_drugs", JSON.stringify(data.list));
                console.log("toUser:", $scope.likUser.toUser);
                console.log("method:", method);
                user_cache.put("plans_", data.list);
                plans = data.list;
                // $scope.$emit('REFRESH_SUCCESS');
                // cache.put('network_error', false);
                if ($scope.list.length == 0) {  //判空
                    $("#emptyBox").show();
                } else {
                    $("#emptyBox").hide();
                }
                $timeout(function () {
                    $scope.$broadcast('scroll.refreshComplete');
                }, 500);

                localStorage.removeItem("touserId");
                //console.log($scope.list);
            }, function (error) {
                localStorage.setItem("touserId", touserId);
                $scope.$broadcast('scroll.refreshComplete');
                console.error("请求药盒列表失败");
                var drugs = localStorage.getItem($rootScope.user.userId + "_drugs");
                if (!drugs) {
                    $scope.list = JSON.parse(drugs);
                }

                // if ($state.current.name == 'tab.pillbox') {
                //     $timeout(function () {
                //         $state.go('network_error', {backUrl: 'tab.pillbox', broadcast_name: 'GET_PLAN'});
                //     }, 1000);
                // } else {
                //     $scope.$emit("GET_PLAN_ERROR");
                // }
            });
        };

        $rootScope.$on('REFRESH', function () {
            console.log('监听刷新药盒广播');
            $scope.getPlanList();
        });

        /**
         * 下拉结束
         */
        $scope.$on('scroll.refreshComplete', function () {
            $scope.form.refresh = false;
        });

        // $scope.getPlanList(); //页面第一次加载从网络读取数据
        var alarm_users = user_cache.get('alarm_users');
        /**
         * 侧边栏点击事件
         */
        $scope.bindClick = function () {
            $timeout(function () {
                var div = $(".div");
                $(".btn1").unbind("click");
                $(".btn1").click(function () {
                    if (div.hasClass("dest")) {
                        div.removeClass("dest").animate({right: 0, top: 0}, 200);
                        $(".tabs").animate({right: 0}, 200);
                    } else {
                        div.addClass("dest").animate({right: 80, top: 50}, 200);
                        $(".tabs").animate({right: 80}, 200);
                    }
                });
                var a = function () {
                    div.removeClass("dest").animate({right: 0, top: 0}, 200);
                    $(".tabs").animate({right: 0}, 200);
                };
                $(".z_bg").unbind("click");
                $(".z_bg").click(a);
                $(".tabs").unbind("click");
                $(".tabs").click(a);
                $(".z_title").unbind("click");
                $(".z_title").click(a);
                $(".g_top").click(a);
                $(".zzsb img").unbind("click");
                $(".zzsb img").click(a);
            }, 300);
        };
        $scope.users = alarm_users;
        if (!alarm_users) {
            drugService.getUser().then(function (data) {
                // console.log(data.list);
                user_cache.put('alarm_users', data.list);
                $scope.users = data.list;
            }, function (error) {
            });
        }
        $rootScope.$on('addUserSuccess', function () {
            console.log("收到添加用户成功的广播");
            $scope.users = user_cache.get('alarm_users');
            console.log($scope.users);
            $scope.bindClick();
        });
        //收到删除用户的广播
        $rootScope.$on('delFriendSuccess', function () {
            console.log("收到删除用户的广播  ");
            $scope.users = user_cache.get('alarm_users');
            console.log($scope.users);
            $scope.bindClick();
        });
        $scope.bindClick();
        //获取提醒用户id

        $scope.getUserId = function (id, name, header, gender) {
            /*            if (id == toUser) {
             return;
             }*/
            $scope.form.title = name;
            $scope.likUser.toUser = id;
            $scope.likUser.userName = name;
            $scope.likUser.headImg = header;
            $scope.likUser.gender = gender;
            user_cache.put('likUser', $scope.likUser);
            console.log($scope.likUser);
            $scope.getPlanList(id);
            /* boxService.viewPillBox(method, id).then(function (data) {
             $scope.list = data.list;
             plans = data.list;
             if ($scope.list.length == 0) {  //判空
             $("#emptyBox").show();
             } else {
             $("#emptyBox").hide();
             }
             user_cache.put("plans_", data.list);
             console.log($scope.list);
             }, function (error) {
             console.log(error);
             });*/
        };
        $scope.addUser = function () {
            $ionicNativeTransitions.stateGo('g_my_information', {backUrl: 'tab.pillbox'}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        };

        //列表缓存
        /*        plans = user_cache.get('plans');
         $scope.list = plans;*/
        console.log('缓存计划列表：', plans);
        /* if (!plans) {   //若不存在，从网络读取
         console.log("从网络读取");
         $scope.getPlanList();
         }*/
        $scope.getPlanList();

        $rootScope.$on("logout", function () {
            console.log("监听注销事件");
            $scope.list = [];
            $scope.likUser = {};
//            $scope.form.title='我';
//            console.log("收到注销事件，设置title",$scope.form.title);
        });

        /**
         * 监听添加药成功
         */
        $rootScope.$on("addMedicineSuccess", function () {
            $scope.form.title = likUser.userName;
            console.log("addMedicineSuccess title:" + $scope.form.title);
            $scope.flag = true;
            console.log("监听添加药成功");
            $scope.getPlanList();
        });

        /**
         * 播放音频（备忘）
         */
        $scope.audioPlay = function (index) {
            console.log("index:" + index + "\n")
            $("#audio_" + index)[0].play();
        };

        /**
         * 停止用药
         */
        var planId, index;
        $scope.stopPlan = function (p, i) {
            $("#ZHEZHAO").show();
            $("#box_msg").show();
            planId = p;
            index = i;    //界面传过来的索引

            $("#ZHEZHAO").click(function (e) {
                e.stopPropagation;
                $("#ZHEZHAO").hide();
                $("#box_msg").hide();
            });
        };

        /*    $scope.cancel = function () {
         $("#ZHEZHAO").show();
         $("#box_msg").hide();
         };*/
        $("#cancel").click(function () {
            $("#ZHEZHAO").hide();
            $("#box_msg").hide();
        });

        $("#confirm").click(function () {
            for (var i = 0; i < plans.length; i++) {
                if (plans[i].id == planId) {
                    var result = plans.splice(i, 1);
                    $("#ZHEZHAO").hide(); //用绑定不能实时显示出来
                    $("#box_msg").hide();
                    console.log(result);
                    boxService.stopDrug(planId).then(function (d) {
                        //$("#plan_" + index).remove();
                        $scope.list = plans;
                        console.log($scope.list.length);
                        if ($scope.list.length == 0) {  //判空
                            $("#emptyBox").show();
                        } else {
                            $("#emptyBox").hide();
                        }
                        $scope.$emit("RESET_ALARM");
                        $scope.$emit("RELOAD_MESSAGE"); //通知主页面
                        console.log(d);
                    }, function (e) {
                        console.log(e);
                    });
                    user_cache.put("plans", plans);
                    break;
                }
            }

        });
        /* $scope.confirm = function () {

         }*/

        /**
         * 跳到加药选人页面
         */
        $scope.goToAddDrug = function () {
            if (!$rootScope.token) {
                $ionicNativeTransitions.stateGo('g_load', {}, {
                    "type": "slide",
                    "direction": "right",
                    "duration": 500
                });
            }
            $ionicNativeTransitions.stateGo('add_drug', {
                backUrl: 'tab.pillbox', toUser: toUser
            }, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        }
        /**
         * 跳到历史用药页面
         */
        $scope.goToHisDrug = function () {
            console.log("进入历史用药");

            $ionicNativeTransitions.stateGo('drug_history', {
                backUrl: "tab.pillbox", toUser: $scope.likUser.toUser
            }, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });

        }
        /**
         * 进入药品详情
         */
        $scope.detail = function (id) {
            console.log("进入药品详情");
            $ionicNativeTransitions.stateGo('drug_detail', {id: id, backUrl: "tab.pillbox", toUser: $scope.likUser.toUser}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        };

        /**
         * 跳到服药柱状图页面
         */
        $scope.goToYy = function (id, medicineName) {
            console.log("进入柱状图");
            $ionicNativeTransitions.stateGo('drug_schedule', {
                planId: id,
                backUrl: "tab.pillbox",
                medicineName: medicineName
            }, {
                "type": "slide",
                "direction": "leftF",
                "duration": 500
            });
        }

        /**
         * 跳到服药日历页面
         */
        $scope.goToCalendarInfo = function (medicineId, planId, remark, remarkText, remarkTime, imgurl) {
            console.log("进入服药日历页面");
            console.log(medicineId);
            console.debug("planId:", planId);
            console.debug("imgurl:", imgurl);
            $ionicNativeTransitions.stateGo('drug_calendar', {
                backUrl: "tab.pillbox",
                medicineId: medicineId,
                planId: planId,
                remark: remark,
                remarkText: remarkText,
                remarkTime: remarkTime,
                imgurl: imgurl
            }, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });

        }

        /**
         * 使用方法
         */

        $scope.goToUsage = function (url) {
            console.log(url);
            console.log("进入使用方法");
            var url2 = $rootScope.reqUrl + url;
            cordova.ThemeableBrowser.open(url2, '_blank', {
                toolbar: {
                    height: 44,
                    color: '#f0f0f0ff'
                },
                title: {
                    color: '#003264ff',
                    showPageTitle: true
                },
                backButton: {
                    wwwImage: 'img/cha3.png',
                    wwwImagePressed: 'img/cha3.png',
                    align: 'left',
                    event: 'backPressed'
                },
                backButtonCanClose: true
            }).addEventListener('backPressed', function (e) {
                //alert(e);
                /*$ionicNativeTransitions.stateGo('tab.pillbox', {}, {
                 "type": "slide",
                 "direction": "right",
                 "duration": 200
                 });*/
            });
        }

        /**
         * 下拉刷新，重新获取数据（计划列表跟亲朋）
         */
        $scope.doRefresh = function () {
            $scope.form.refresh = true;
            $scope.getPlanList();
            $scope.users = alarm_users;
            if (!alarm_users) {
                drugService.getUser().then(function (data) {
                    // console.log(data.list);
                    user_cache.put('alarm_users', data.list);
                    $scope.users = data.list;
                }, function (error) {
                });
            }
        }
    })

    //药品详情
    .controller('drugDetailCtrl', function ($scope, $cacheFactory, $ionicNativeTransitions, $stateParams, boxService, $rootScope, $state, userService, $cordovaSms) {
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);
        //全局缓存
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }


        //列表缓存
        var plans = user_cache.get('plans_');
        console.log("计划缓存-------", plans);
        $scope.plan = {};
        //从缓存取出列表数据
        console.log(plans);
        //得到上一个页面传过来的toUserId
        var toUser = $stateParams.toUser;
        //alert("touser:" + toUser);
        var toUserPhone = "";
        if (toUser) {
            userService.getInfo(toUser).then(function (d) {
                console.log("提醒用户电话：" + d.phone);
                toUserPhone = d.phone;
            }, function (e) {
                console.log(e);
            });
        }


        /**
         * 打电话
         */
        $scope.callSb = function () {
            //alert("打电话给" + toUserPhone);
            window.PhoneCaller.call(toUserPhone, function () {
                //alert("success!")
            }, function () {
                //alert("fail")
            });
        }

        //找出缓存中的对象与页面参数id比较
        var id = $stateParams.id;
        //alert(id);
        for (var i = 0; i < plans.length; i++) {
            if (id == plans[i].id) {
                $scope.plan = plans[i];
                console.log("name:" + $scope.plan.medicineName);
                //获得试用方法链接
                boxService.getUsage($scope.plan.medicineName).then(function (d) {
                    console.log(d);
                    $scope.plan.url = d.url;  //将详情url带到具体页面
                    $scope.plan.usage = d.remark;
                }, function (e) {
                    console.log(e);
                });
                console.log($scope.plan);
                break;
            }
        }

        $scope.goUsage = function () {
            var url = $rootScope.reqUrl + $scope.plan.url;
            cordova.ThemeableBrowser.open(url, '_blank', {
                toolbar: {
                    height: 44,
                    color: '#f0f0f0ff'
                },
                title: {
                    color: '#003264ff',
                    showPageTitle: true
                },
                backButton: {
                    wwwImage: 'img/cha3.png',
                    wwwImagePressed: 'img/cha3.png',
                    align: 'left',
                    event: 'backPressed'
                },
                backButtonCanClose: true
            }).addEventListener('backPressed', function (e) {
                /*  $ionicNativeTransitions.stateGo('drug_detail', {}, {
                 "type": "slide",
                 "direction": "right",
                 "duration": 200
                 });*/
            });
        }
        /* $ionicNativeTransitions.stateGo("drug_usage", {backUrl: $state.current.name, url: $scope.plan.url}, {
         "type": "slide",
         "direction": "left",
         "duration": 500
         });
         };


         /**
         /**
         * 发短信
         */
        $scope.sendShortMessage = function () {
            $cordovaSms
                .send(toUserPhone, 'SMS content')
                .then(function (d) {
                    // Success! SMS was sent
                    // alert(d);
                }, function (error) {
                    // An error occurred
                    //alert(error);
                });
        }


        /**
         * 返回
         */
        $scope.goBack = function () {
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            /*   $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
             "type": "slide",
             "direction": "right",
             "duration": 500
             });*/
            $ionicNativeTransitions.stateGo('tab.pillbox', {}, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };


    })

    //用法
    .controller('drugUsageCtrl', function ($scope, $cacheFactory, $ionicNativeTransitions, $stateParams, boxService, $rootScope, $state, ThemeableBrowser) {
        console.log("用法页面");
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);

        $scope.form = {};
        //  alert($stateParams.url);
        $scope.form.url = $rootScope.reqUrl + $stateParams.url;
        /**
         * 浏览器插件访问剂量用法页面
         */
        cordova.ThemeableBrowser.open($scope.form.url, '_blank', {
            toolbar: {
                height: 44,
                color: '#f0f0f0ff'
            },
            title: {
                color: '#003264ff',
                showPageTitle: true
            },
            backButton: {
                image: 'img/ass_back.png',
                imagePressed: 'back_pressed',
                align: 'left',
                event: 'backPressed'
            },
            forwardButton: {
                image: 'img/z_newcase_unfold.png',
                imagePressed: 'forward_pressed',
                align: 'left',
                event: 'forwardPressed'
            },
            closeButton: {
                image: 'img/ass_cancel.png',
                imagePressed: 'close_pressed',
                align: 'left',
                event: 'closePressed'
            },
            backButtonCanClose: false
        }).addEventListener('backPressed', function (e) {
            $ionicNativeTransitions.stateGo('drug_detail', {}, {
                "type": "slide",
                "direction": "right",
                "duration": 200
            });
        });

        /*console.log($scope.form.url);
         var url = $scope.form.url;
         $("#usage").attr("src", url);*/
        /**
         * 返回
         */
        $scope.goBack = function () {
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };


    })

    //药瓶（今日药物）
    .controller('drugBottleCtrl', function ($scope, $cordovaNetwork, WebSql, $cacheFactory, $state, $rootScope, $cordovaSms, $ionicNativeTransitions, $ionicModal, $stateParams, $timeout, Plan, drugService, $ionicListDelegate, $ionicHistory) {

        $rootScope.screenHeight = document.documentElement.clientHeight;
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('special_back', true);
        $scope.$on($state.current.name + '_HARDWARE_BACK', function (evt, data) {
            if (!$scope.delay_class.exit()) {
                $scope.goBack();
            } else {
                console.info("全部药品推迟取消模态框");
//                $scope.delay_class.cancel();
                $("#allDelay").trigger("click");
            }

            if (!$scope.SingleDelay.exit()) {
                $scope.goBack();
            } else {
                console.info("单个推迟取消模态框");
//                $scope.SingleDelay.cancel();
                $("#allDelay").trigger("click");
            }
        });

        //设置header背景图显示
        $scope.form = {
            imgUrl: null,
            putoff: '推迟全部',
            take_text: '服用全部',
            title_text: null

        };

        $rootScope.$on('RELOAD_MESSAGE_SUCCESS', function (evt, data) {
            console.log('重载消息成功');
        });

//        var cache = $cacheFactory.get($state.current.name);
//        if (!cache) {
//            cache = $cacheFactory($state.current.name);
//        }
        cache.put('stateParams', $stateParams);
        /**
         * 获取禁用样式
         * @param type 类型
         * @returns {{color: string, background-image: string}}
         */
        $scope.get_disable_style = function (type) {
            return {
                'color': '#bfbfbf',
                'background-image': 'url("img/z_' + type + 'Off.png")'
            }
        };
        var mes_cache = $cacheFactory.get('mes');
        if (!mes_cache) {
            mes_cache = $cacheFactory('mes');
        }

        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('user');
        }
        var plans = user_cache.get('plans');


        $scope.delay_class = {
            modal: null,
            time_plan: null,
            delay: function (minute) {
                //某一时段
                var list = this.time_plan.list;
                console.log('时刻药物列表', list);
                //推迟闹铃对象列表
                var delay_list = [];

                for (var i in list) {
                    var o = list[i];
                    console.log('某项药物', o);
                    if (o.take == 0 || o.take == 2) {
                        console.log('未服用药物', o);
                        var plan_id = list[i].planId;
                        for (var j in plans) {
                            var p = plans[j];
                            if (plan_id == p.id) {
                                console.log('服药计划对象', p);
                                var take_times = p.takeTimes;
                                for (var k in take_times) {
                                    if (take_times[k].time = this.time_plan.time) {
                                        var alarm = {
                                            plan: p,
                                            at: take_times[k],
                                            delay: 'HAVE_ALARM'
                                        };
                                        delay_list.push(alarm);
                                        break;
                                    }
                                }
                                break;
                            }
                        }
                    }
                }
                console.log('推迟闹铃对象个数', delay_list.length);
                if (delay_list.length > 0) {
                    //-------------推迟更新添加数据库和发送广播
                    console.log("delay_list", delay_list);
                    drugService.delayPlanList(delay_list, minute);
                    $timeout(function () {
                        $scope.$emit('REFRESH_PLAN_IMG');
                    }, 500);
                    for (var i in list) {
                        var o = list[i];
                        //未服用置为服用
                        if (o.take != 4 && o.take != 1) {
                            o.take = 4;
                        }
                    }
                    if (self) {
                        this.time_plan.take_all = true;
                        this.time_plan.not_delay = true;
                    } else {
                        this.time_plan.not_delay = false;
                    }
                    console.log('服药', o);
                    //  plantuichi.put();
                    //-------------结束----------------------
                    if (window.cordova) {

                        Plan.delay_alarm(delay_list, minute);
                    }
                }
                this.modal.hide();
            },
            show: function (t_p) {
                this.time_plan = t_p;
                console.info("time_plan", t_p);
                this.modal.show();
            },
            cancel: function () {
                this.modal.hide();
            },
            exit: function () {
                if (this.modal.isShown()) {
                    this.modal.hide();
                    return true;
                } else {
                    return false;
                }
            }
        };

        $scope.delay = function (index) {
//            if (Plan.is_not_fetch($scope.list[index].bucket)) {
            if (!$scope.list[index].take_all) {
                $scope.delay_class.show($scope.list[index]);
            }
//            } else {
//                alert('时段已过，不能推迟');
//            }
        };

        $ionicModal.fromTemplateUrl('plan_delay.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.delay_class.modal = modal;
        });


        $scope.page = {};

//日期
        var day = $stateParams.day;
//自己服药
        var self = eval("(" + $stateParams.self + ")");
//用户id
        var uid = $stateParams.uid;
//缓存获取消息列表
        var messages = mes_cache.get('all');
        //获取时间分段标志
        var time = $stateParams.time;

        var obj = null;

        /**
         * 服药基类方法
         * @param time 时间点
         * @param list 药物列表
         */
        $scope.take_base = function (t) {
            //计划id列表
            console.log("列表", t);
            var plan_ids = Plan.get_remind_message(t.list, 'plan_id');
            //服用全部网络请求
            Plan.takeAll(day, t.time, plan_ids, uid).then(function (data) {
                for (var i in t.list) {
                    var o = t.list[i];
                    //未服用置为服用
                    if (o.take == 0) {
                        o.take = 1;
                        o.not_delay = true;
                    }
                    //未提醒置为提醒
                    else if (o.take == 2) {
                        o.take = 3;
                    }
                }

                t.take_all = true;
                //服药广播
//                if (self) {
//                    t.take_all = true;
//                } else {
//                    t.take_all = false;
//                }
                $scope.$emit('TAKE_MEDICINE');
            }, function (error) {
            });
        };

        /**
         * 电话提醒某人吃药
         * @param index 索引
         */
        $scope.call = function (index) {
            console.log("拨打电话");
            //一个时间点的药物列表
            var time_plan = $scope.list[index];
            var names = Plan.get_remind_message(time_plan.list, 'medicine_name');
            if (names != null) {
                $scope.take_base(time_plan);
                if (window.cordova) {
                    //安卓和ios拨打电话不同之处
                    if ($rootScope.os == "Android") {
                        window.plugins.CallNumber.callNumber(function () {
//                            $scope.list[index].take_all = true; //新加
                        }, function () {
                        }, obj.toUser.telephone);
                    } else {
                        window.PhoneCaller.call(obj.toUser.telephone, function () {
//                            $scope.list[index].take_all = true; //新加
                        }, function () {
                        })
                    }
                }
            }
        };

        /**
         * 短信提醒某人
         * @param index
         */
        $scope.message = function (index) {
            //一个时间点的药物列表
            var time_plan = $scope.list[index];
            var names = Plan.get_remind_message(time_plan.list, 'medicine_name');
            console.log('短信提醒药品名称列表', names);
            if (names != null) {
                $scope.take_base(time_plan);
                if (window.cordova) {
                    var options = {
                        replaceLineBreaks: false, // true to replace \n by a new line, false by default
                        android: {
                            intent: 'INTENT'  // send SMS with the native android SMS messaging
                            //intent: ‘‘ // send SMS without open any other app
                        }
                    };
                    //发送短信
                    $cordovaSms.send(obj.toUser.telephone, '亲爱的' + obj.toUser.name + ',' + $rootScope.user.name + '提醒您' + '，您的' + names + '该用药了', options)
                        .then(function (d) {
//                            $scope.list[index].take_all = true; //新加
                        }, function (error) {
                            // An error occurred
                            //alert(error);
                        });
                }
            }
        };

        /**
         * 微信通知
         * @param index 索引
         */
        $scope.notifyFamily = function (index) {
            //一个时间点的药物列表
            var time_plan = $scope.list[index];
            var names = Plan.get_remind_message(time_plan.list, 'medicine_name');
            if (names != null) {
                $scope.take_base(time_plan);
                if (window.cordova) {
                    //微信通知
                    Wechat.share({
                        text: '亲爱的' + obj.toUser.name + ',' + $rootScope.user.name + '提醒您' + '，您的' + names + '该用药了',
                        scene: Wechat.Scene.SESSION   // share to Timeline
                    }, function () {
                        console.info('this.obj:', this.obj);
//                        $scope.list[index].take_all = true; //新加
                        //alert("Success");
                    }, function (reason) {
                        //alert("Failed: " + reason);
                    });
                }
            }
        };

        $scope.takeAll_mark = function (time_plan) {
            flag_takeAll = false;
            for (var i in time_plan.list) {
                var o = time_plan.list[i];
                //未服用置为服用
                if (o.take == 0) {
                    o.take = 1;
                }
                //未提醒置为提醒
                else if (o.take == 2) {
                    o.take = 3;
                }
            }
            if (self) {
                time_plan.take_all = true;
                time_plan.not_delay = true;
            } else {
                time_plan.take_all = false;
            }
            console.log('服药', o);
            //服药广播
            $scope.$emit('TAKE_MEDICINE');
        }

        /**
         * 跳转分享页面
         */
        $scope.share = function () {
            $timeout(function () {
                $ionicNativeTransitions.stateGo('drug_share', {backUrl: 'drug_bottle'}, {
                    "type": "slide",
                    "direction": "left",
                    "duration": 500
                });
            }, 500);
        };

        $timeout(function () {
            console.log("执行了");
            $scope.isAllEat($scope.list);
        }, 500);

        /**
         * 判断是否全部服用，如果全部服用则显示分享条框
         * @type {boolean}
         */
        $scope.seek = false;
        $scope.isAllEat = function (list_all) {
            // console.log("isAllEat",list_all);
            for (var i in list_all) {
                // console.log("isAllEat1",list_all[i].list);
                for (var j in list_all[i].list) {
                    //    console.log("isAllEat2",list_all[i].list[j]);
                    if (list_all[i].list[j].take != 1) {
                        return;
                    }
                }
            }
            $scope.seek = true;
            //  $scope.$apply();
        }
        /**
         * 服用全部
         * @param index 索引
         */
        var flag_takeAll = false;
        $scope.takeAll = function (index) {
            //一个时间点的药物列表
            var time_plan = $scope.list[index];
            var list_all = $scope.list;
            var plan_ids = Plan.get_remind_message(time_plan.list, 'plan_id');
            console.log('服用全部计划id', plan_ids);
            if (window.cordova) {
                var isOffline = $cordovaNetwork.isOffline()
                if (isOffline) {
                    //alert("网络异常，数据无法同步");
                    $("#ERROR").css('display', 'block').html("网络异常，数据无法同步");
                    $timeout(function () {
                        $("#ERROR").css('display', 'none');
                    }, 500);
                }
            }
            if (plan_ids != null) {
                Plan.takeAll(day, time_plan.time, plan_ids, uid).then(function (data) {
                    flag_takeAll = true;
                    console.log("有网络，上传服务器成功，改变标示");
                    $scope.takeAll_mark(time_plan);
                    $scope.isAllEat(list_all);
                }, function (error) {
                    flag_takeAll = false;
                    console.log("无网络，上传服务器失败，本地更改标示");
                    // $scope.takeAll_mark(time_plan);
                    //$scope.isAllEat(list_all);
                });
            }
            if (flag_takeAll) {

            }
        };
        for (var i in messages) {
            var msg = messages[i];
            if (msg.ymd == day) {
                $scope.page.time = msg.time;
                $scope.page.week = msg.week;
                console.log('找出对应消息');
                //找出对应日期的计划消息
                var plan_messages = msg.drug;
                if (self) {
                    for (var j in plan_messages) {
                        var one = plan_messages[j];
                        if (one.self) {
                            obj = one;
                            break;
                        }
                    }
                } else {
                    for (var j in plan_messages) {
                        var one = plan_messages[j];
                        if (!one.self) {
                            if (one.toUser.id == uid) {
                                obj = one;
                                break;
                            }
                        }
                    }
                }
            }
        }
        $scope.getTodayAllDrug = function (time) {
            console.info("今日所有药物:------", obj);
            $timeout(function () {      //遍历消息列表
                //今日药物总列表
                var time_list = [];
                //某一时刻的药品列表总对象
                var one_time = new Object();
                //某一时刻的药物列表
                var one_time_medicines = [];
                //更替时间临时变量
                var temp_time = null;
                //临时变量
                var temp_m = null;
                //继续遍历变量
                var go_on = true;
                var m = null;
                //遍历凌晨服药消息
                if (time == 0 || time == 10) {
                    $scope.form.imgUrl = 'img/z_morning.jpg';
                    $scope.form.title_text = '凌晨用药';
                    for (var i in obj.beforeDawn) {
                        m = obj.beforeDawn[i];
                        console.log('凌晨药物', m);
                        //判断是否是首条记录
                        if (m.alarmTime != temp_time) {
                            if (temp_time != null) {
                                //存储时间临时变量
                                one_time.time = temp_time;
                                //存放时段描述
                                one_time.bucket = temp_m.bucket;
                                //存放某一时刻药品列表
                                one_time.list = one_time_medicines;
                                //存放对象
                                time_list.push(one_time);
                                //新建对象
                                one_time = new Object();
                                one_time_medicines = [];
                                temp_time = m.alarmTime;
                                temp_m = m;
                            } else {
                                temp_time = m.alarmTime;
                                temp_m = m;
                            }
                        }
                        one_time_medicines.push(m);
                    }
                }

                //遍历上午服药消息
                if (time == 1 || time == 10) {
                    $scope.form.imgUrl = 'img/z_noon.jpg';
                    $scope.form.title_text = '上午用药';
                    for (var i in obj.morning) {
                        //一种药品
                        m = obj.morning[i];
                        console.log('上午药物', m);
                        //判断是否是首条记录
                        if (m.alarmTime != temp_time) {
                            if (temp_time != null) {
                                //存储时间临时变量
                                one_time.time = temp_time;
                                //存放时段描述
                                one_time.bucket = temp_m.bucket;
                                //存放某一时刻药品列表
                                one_time.list = one_time_medicines;
                                //存放对象
                                time_list.push(one_time);
                                //新建对象
                                one_time = new Object();
                                one_time_medicines = [];
                                temp_time = m.alarmTime;
                                temp_m = m;
                                m.putoff = '推迟全部';
                                m.take_text = '服用全部'
                            } else {
                                temp_time = m.alarmTime;
                                temp_m = m;
                                m.putoff = '推迟';
                                m.take_text = '服用'
                            }
                        }
                        one_time_medicines.push(m);
                    }
                }

                //遍历下午服药消息
                if (time == 2 || time == 10) {
                    $scope.form.imgUrl = 'img/z_afternoon.jpg';
                    $scope.form.title_text = '下午用药';
                    for (var i in obj.afternoon) {
                        m = obj.afternoon[i];
                        console.log('下午药物', m);
                        //判断是否是首条记录
                        if (m.alarmTime != temp_time) {
                            if (temp_time != null) {
                                console.log('更替');
                                //存储时间临时变量
                                one_time.time = temp_time;
                                //存放时段描述
                                one_time.bucket = temp_m.bucket;
                                //存放某一时刻药品列表
                                one_time.list = one_time_medicines;
                                //存放对象
                                time_list.push(one_time);
                                //新建对象
                                one_time = new Object();
                                one_time_medicines = [];
                                temp_time = m.alarmTime;
                                temp_m = m;
                            } else {
                                temp_time = m.alarmTime;
                                temp_m = m;
                            }
                        }
                        one_time_medicines.push(m);
                    }
                }

                //遍历晚上服药消息
                if (time == 3 || time == 10) {
                    $scope.form.imgUrl = 'img/z_everning.jpg';
                    $scope.form.title_text = '晚上用药';
                    for (var i in obj.evening) {
                        m = obj.evening[i];
                        console.log('夜间药物', m);
                        //判断是否是首条记录
                        if (m.alarmTime != temp_time) {
                            if (temp_time != null) {
                                //存储时间临时变量
                                one_time.time = temp_time;
                                //存放时段描述
                                one_time.bucket = temp_m.bucket;
                                //存放某一时刻药品列表
                                one_time.list = one_time_medicines;
                                //存放对象
                                time_list.push(one_time);
                                //新建对象
                                one_time = new Object();
                                one_time_medicines = [];
                                temp_time = m.alarmTime;
                                temp_m = m;
                            } else {
                                temp_time = m.alarmTime;
                                temp_m = m;
                            }
                        }
                        one_time_medicines.push(m);
                    }
                }
                if (time == 10) {
                    $scope.form.title_text = '今日药物';
                    $scope.form.imgUrl = 'img/z_oneday.jpg';
                    $("#zz_today").css("display", "none");
                }
                //存在今日药物
                if (temp_time != null) {
                    //存储时间临时变量
                    one_time.time = temp_time;
                    //存放时段描述
                    one_time.bucket = m.bucket;
                    //存放某一时刻药品列表
                    one_time.list = one_time_medicines;
                    //存放对象
                    time_list.push(one_time);
                }
                //判断全部药物吃完状态
                for (var i in time_list) {
                    var o = time_list[i];
                    var meds = o.list;
                    if (day == date2str(new Date(), 'yyyy-MM-dd')) {
                        if (Plan.is_not_fetch(o.time)) {
                            o.not_delay = true;
                            o.take_all = true;
                        } else {
                            o.not_delay = false;
                            var take_num = 0;
                            var num = meds.length;
                            for (var j in meds) {
                                if (meds[j].take == 1 || meds[j].take == 3 || meds[j].take == 4) {
                                    take_num++;

                                }
                            }
                            if (take_num == num) {
//                                if (self) {//2017-1-16
                                o.not_delay = true;
                                time_list[i].take_all = true;
//                                }
                            }
                        }
                    } else {
                        if (self) {
                            o.not_delay = true;
                            var take_num = 0;
                            var num = meds.length;
                            for (var j in meds) {
                                if (meds[j].take == 1 || meds[j].take == 3) {
                                    take_num++;
                                }
                            }
                            if (take_num == num) {
                                time_list[i].take_all = true;
                            }
                        } else {
                            o.take_all = true;
                        }
                    }
                    console.log(time_list[i], '药物总数', num, '服用数量', take_num);
                }
                /*            if (Plan.is_today(day)) {
                 for (i = 0; i < time_list.length; i++) {
                 if (Plan.is_not_fetch(time_list[i].time)) {
                 break;
                 }
                 }
                 console.log('截取长度', i);
                 time_list = time_list.slice(0, i);
                 console.log(time_list.length);
                 }*/
                for (var i in time_list) {
                    var ov = time_list[i];
                    if (ov.list.length > 1) {
                        ov.putoff = '推迟全部';
                        ov.take_text = '服用全部';
                    } else {
                        ov.putoff = '推迟';
                        ov.take_text = '服用';
                    }
                    time_list[i] = ov;
                }
                $scope.list = time_list;
                $scope.self = self;
                console.log('today medicine list', $scope.list);
            }, 50);
        };
        $scope.getTodayAllDrug(time);
        /**
         * 进入今日药物详情
         * @param p_index
         * @param index
         */
        $scope.detail = function (p_index, index) {
            var m = $scope.list[p_index].list[index];
            var toUser = null;
            for (var i in plans) {
                var plan = plans[i];
                if (plan.toUser) {
                    if (plan.id == m.planId) {
                        toUser = plan.toUser;
                    }
                }
            }
            console.log(m);
            console.log('今日药物详情', p_index, index, m);
            $ionicNativeTransitions.stateGo('drug_detailToday', {
                m: JSON.stringify(m),
                backUrl: $state.current.name,
                day: day,
                toUser: JSON.stringify(toUser)
            }, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        };


        /**
         * 单个推迟
         * @type {minute}
         */


        $scope.SingleDelay = {
            modal: null,
            time_plan: null,
            delay: function (minute) {
                //某一时段
                var plan = this.time_plan;
                console.log('时刻药物详情', plan);
                console.log("planId=" + plan.planId)
                //推迟闹铃对象列表
                var delay_list = [];
                var delay_planid_list = [];
                console.log("plans", plans);
                for (var i in plans) {
                    var p = plans[i];
                    if (p.id == plan.planId) {
                        console.log("bidui");
                        var take_times = p.takeTimes;
                        for (var j in take_times) {
                            if (take_times[j].time == plan.alarmTime) {
                                var alarm = {
                                    plan: p,
                                    at: take_times[j],
                                    delay: 'HAVE_ALARM'
                                };
                                delay_list.push(alarm);
                                $scope.m.take = 4;
                                break;
                            }
                        }
                        break;
                    }
                }
                console.log('推迟闹铃对象个数', delay_list.length);
                if (delay_list.length > 0) {
                    //推迟更新添加数据库和发送广播
                    console.log("delay_list", delay_list);
                    drugService.delayPlanList(delay_list, minute);
                    $timeout(function () {
                        $scope.$emit('REFRESH_PLAN_IMG');
                    }, 500);
                    if (self) {
                        this.time_plan.take_all = true;
                        this.time_plan.not_delay = true;
                    } else {
                        this.time_plan.not_delay = false;
                    }
                    //----------------------结束----------------------
                    if (window.cordova) {
                        Plan.delay_alarm(delay_list, minute);
                    }
                }
                this.modal.hide();
            },
            show: function (t_p) {
                this.time_plan = t_p;
                this.modal.show();
            },
            cancel: function () {
                this.modal.hide();
            },
            exit: function () {
                if (this.modal.isShown()) {
                    this.modal.hide();
                    return true;
                } else {
                    return false;
                }
            }
        };

        $ionicModal.fromTemplateUrl('delay_single.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.SingleDelay.modal = modal;
        });


        $scope.today = false;
        if (day == date2str(new Date(), 'yyyy-MM-dd')) {
            $scope.today = true;
        }
        $scope.delayPill_ = function (take) {
            $scope.m = take;
            //判断是否是今天
            console.debug("day:", day);
//            if (day != date2str(new Date(), 'yyyy-MM-dd')) {
//                $scope.today = false;
//
//            } else {
//                console.log("ture");
//                $scope.today = true;
//
//            }
            $scope.SingleDelay.show(take);
            $ionicListDelegate.closeOptionButtons();
//            if ($scope.today && ($scope.m.take == 0 || $scope.m.take == 3)) {
//                console.debug("eeeeeee");
//                console.log("m:", $scope.m);
//                $scope.delay_class.show($scope.m);
//                console.debug("可以推迟");
//            }
        };


        /**
         * 服用单个药品
         */
        console.info("day:", day);
        $scope.takeSingleDrug = function (index, p_index) {
            console.info("scope.list---", $scope.list);
            console.info("p_index---", p_index);
            console.info("index---", index);
            var time_plan = $scope.list[p_index];
            console.info("此刻的所有服药数组", time_plan);
            var changdu = time_plan.list.length;

            var yjc = 0;
            for (var i in time_plan.list) {
                var p = time_plan.list[i];
                if (p.take == 1) {
                    yjc++;
                }
            }
            console.info("已经吃了", yjc);
            var medc = $scope.list[p_index].list[index];
            console.info("总共几种药", time_plan.list.length);
            console.info("此刻服药计划!!!!", medc);
            console.info("药品:" + medc.planId + "成功服用");
            console.log("服用单个药品药瓶页面---", medc.medicine.medicineName);
            if (window.cordova) {
                if ($cordovaNetwork.isOffline()) {
                    //alert("网络异常，数据无法同步");
                    $("#ERROR").css('display', 'block').html("网络异常，数据无法同步");
                    $timeout(function () {
                        $("#ERROR").css('display', 'none');
                    }, 500);
                }
            }
            Plan.take(day, medc.alarmTime, medc.planId, null).then(function (data) {
                medc.take = 1;
                $ionicListDelegate.closeOptionButtons();
                //服药广播
                $scope.$emit('TAKE_MEDICINE');
                if (changdu == yjc + 1) {
                    flag_takeAll = false;
                    time_plan.take_all = true;
                    time_plan.not_delay = true;
                } else {
                    flag_takeAll = true;
                    time_plan.take_all = false;
                    time_plan.not_delay = false;
                }
            }, function (error) {

            });
        };

        /**
         * 返回
         */
      $scope.goBack = function () {
        //取出回退页面跳转参数
        var param = $cacheFactory.get($stateParams.backUrl);
        var sp = null;
        //如果不在页面参数则设置为空串
        if (param) {
          sp = param.get('stateParams');
          if (!sp) {
            sp = {};
          }
        } else {
          sp = {};
        }
        $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
          "type": "slide",
          "direction": "right",
          "duration": 500
        });
      }


    }
).
/**
 * 药品详情
 */
    controller('DrugDetailTodayCtrl', function ($scope, $cordovaNetwork, boxService, $state, $stateParams, $cacheFactory, $ionicNativeTransitions, Plan, $ionicModal, $rootScope, $cordovaSms, drugService, $timeout) {
        $rootScope.screenHeight = document.documentElement.clientHeight;
        /**
         * 获取禁用样式
         * @param type 类型
         * @returns {{color: string, background-image: string}}
         */
        $scope.get_disable_style = function (type) {
            return {
                'color': '#bfbfbf',
                'background-image': 'url("img/z_' + type + 'Off.png")'
            }
        };

        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);
        cache.put('special_back', true);
        $rootScope.$on($state.current.name + '_HARDWARE_BACK', function (evt, data) {
            if (!$scope.delay_class.exit()) {
                $scope.goBack();
            } else {
                $scope.delay_class.cancel();
            }
        });
        var user_cache = $cacheFactory.get('user');
        if (!user_cache) {
            user_cache = $cacheFactory('cache');
        }
        var plans = user_cache.get('plans');
        //取出药品
        var m = JSON.parse($stateParams.m);
        $scope.m = m;
        console.log('今日药品详情', m);
        //服用某一种药
        var date = $stateParams.day;
        var toUser = JSON.parse($stateParams.toUser);
        //判断完是否是今日药物
        if (date != date2str(new Date(), 'yyyy-MM-dd')) {
            $scope.todey = false;//不是今天药物
            if (toUser) {
//                $scope.m.take = 3;
                $scope.m.take_state = true;
            } else {
                $scope.m.delay = true;
            }
        } else {
            $scope.today = true;
            if (toUser) {
                if ($scope.m.take == 4) {
                    $scope.m.take_state = true;
                }
                //$scope.m.take = m.take;
            } else if ($scope.m.take != 0) {
                $scope.m.delay = true;
            }
        }
        $scope.takeOneDrug = function () {
            console.log("服用药品", $scope.m.medicine.medicineName);
            if (window.cordova) {
                if ($cordovaNetwork.isOffline()) {
                    //alert("网络异常，数据无法同步");
                    $("#ERROR").css('display', 'block').html("网络异常，数据无法同步");
                    $timeout(function () {
                        $("#ERROR").css('display', 'none');
                    }, 500);
                }
            }
            Plan.take(date, $scope.m.alarmTime, m.planId, null).then(function (data) {
                //判断是否是自己还是亲朋
                if ($scope.m.medicine.toUser) {
                    $scope.m.take = 0;
                } else {
                    $scope.m.take = 1;
                    $scope.m.delay = true;
                }
                //服药广播
                $scope.$emit('TAKE_MEDICINE');
            }, function (error) {

            });
        };
        $scope.goUsage = function () {
            var url2 = $rootScope.reqUrl + m.medicine.usage.url;
            cordova.ThemeableBrowser.open(url2, '_blank', {
                toolbar: {
                    height: 44,
                    color: '#f0f0f0ff'
                },
                title: {
                    color: '#003264ff',
                    showPageTitle: true
                },
                backButton: {
                    wwwImage: 'img/cha3.png',
                    wwwImagePressed: 'img/cha3.png',
                    align: 'left',
                    event: 'backPressed'
                },
                backButtonCanClose: true
            }).addEventListener('backPressed', function (e) {
                //alert(e);
                /*$ionicNativeTransitions.stateGo('tab.pillbox', {}, {
                 "type": "slide",
                 "direction": "right",
                 "duration": 200
                 });*/
            });
        };
        $scope.delay_class = {
            modal: null,
            time_plan: null,
            delay: function (minute) {
                //某一时段
                var plan = this.time_plan;
                console.log('时刻药物详情', plan);
                console.log("planId=" + plan.planId)
                //推迟闹铃对象列表
                var delay_list = [];
                var delay_planid_list = [];
                console.log("plans", plans);
                for (var i in plans) {
                    var p = plans[i];
                    if (p.id == plan.planId) {
                        console.log("bidui");
                        var take_times = p.takeTimes;
                        for (var j in take_times) {
                            if (take_times[j].time == plan.alarmTime) {
                                var alarm = {
                                    plan: p,
                                    at: take_times[j],
                                    delay: 'HAVE_ALARM'
                                };
                                delay_list.push(alarm);
                                $scope.m.take = 4;
                                break;
                            }
                        }
                        break;
                    }
                }
                console.log('推迟闹铃对象个数', delay_list.length);
                if (delay_list.length > 0) {
                    //推迟更新添加数据库和发送广播
                    console.log("delay_list", delay_list);
                    drugService.delayPlanList(delay_list, minute);
                    $timeout(function () {
                        $scope.$emit('REFRESH_PLAN_IMG');
                    }, 500);
                    if (self) {
                        this.time_plan.take_all = true;
                        this.time_plan.not_delay = true;
                    } else {
                        this.time_plan.not_delay = false;
                    }
                    //----------------------结束----------------------
                    if (window.cordova) {
                        Plan.delay_alarm(delay_list, minute);
                    }
                }
                this.modal.hide();
            },
            show: function (t_p) {
                this.time_plan = t_p;
                this.modal.show();
            },
            cancel: function () {
                this.modal.hide();
            },
            exit: function () {
                if (this.modal.isShown()) {
                    this.modal.hide();
                    return true;
                } else {
                    return false;
                }
            }
        };

        $scope.delay = function () {
            console.log(13);
//            if (Plan.is_not_fetch($scope.list[index].bucket)) {


            if ($scope.today && ($scope.m.take == 0 || $scope.m.take == 3)) {
                console.info("$scope.m", $scope.m);
                $scope.delay_class.show($scope.m);
            }
//            } else {
//                alert('时段已过，不能推迟');
//            }
        };
        $ionicModal.fromTemplateUrl('plan_delay.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.delay_class.modal = modal;
        });

        $scope.take_base = function () {
            Plan.take(date, $scope.m.alarmTime, m.planId, null).then(function (data) {
                //判断是否是自己还是亲朋
                if ($scope.m.medicine.toUser) {
                    $scope.m.take = 3;
                    $scope.m.take_state = true;
                } else {
                    $scope.m.take = 1;
                }
                //服药广播
                $scope.$emit('TAKE_MEDICINE');
            }, function (error) {

            });
        };
        var phone = $stateParams.phone;
        /**
         * 电话提醒某人吃药
         * @param index 索引
         */
        $scope.call = function () {
            //一个时间点的药物列表
            var names = $scope.m.medicine.medicineName;
            if (names != null) {
                $scope.take_base();
                if (window.cordova) {
                    //拨打电话
                    //安卓和ios拨打电话不同之处
                    if ($rootScope.os == "Android") {
                        window.plugins.CallNumber.callNumber(function () {
                        }, function () {
                        }, toUser.telephone);
                    } else {
                        window.PhoneCaller.call(toUser.telephone, function () {
                        }, function () {
                        })
                    }
                }
            }

        };

        /**
         * 短信提醒某人
         * @param index
         */
        $scope.messages = function () {
            //一个时间点的药物
            var names = $scope.m.medicine.medicineName;
            console.log('短信提醒药品名称列表', names);
            if (names != null) {
                $scope.take_base();
                if (window.cordova) {
                    var options = {
                        replaceLineBreaks: false, // true to replace \n by a new line, false by default
                        android: {
                            intent: 'INTENT'  // send SMS with the native android SMS messaging
                            //intent: ‘‘ // send SMS without open any other app
                        }
                    };
                    //发送短信
                    $cordovaSms.send(toUser.telephone, '亲爱的' + toUser.name + ',' + $rootScope.user.name + '提醒您' + '，您的' + names + '该用药了', options)
                        .then(function (d) {
                        }, function (error) {
                            // An error occurred
                            //alert(error);
                        });
                }
            }

        };

        /**
         * 微信通知
         * @param index 索引
         */
        $scope.wechat = function () {
            //一个时间点的药物
            var names = $scope.m.medicine.medicineName;
            if (names != null) {
                $scope.take_base();
                if (window.cordova) {
                    //微信通知
                    Wechat.share({
                        text: '亲爱的' + toUser.name + ',' + $rootScope.user.name + '提醒您' + '，您的' + names + '该用药了',
                        scene: Wechat.Scene.SESSION   // share to Timeline
                    }, function () {
                        //alert("Success");
                    }, function (reason) {
                        //alert("Failed: " + reason);
                    });
                }
            }

        };
        $scope.goBack = function () {
          console.debug("$stateParams.backUrl:",$stateParams.backUrl);
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
    }
)
    .controller('drugScheduleCtrl', function ($scope, $rootScope, $stateParams, boxService) {
        console.log($stateParams.planId);
        //alert($stateParams.medicineName);
        $scope.form = {medicineName: $stateParams.medicineName};
        $scope.yData = new Array();
        //$rootScope.token='0b6f65c74ccb5748790ae5a74000dbf9b311e9a00000001539d733ac9';
        boxService.takeInfo($stateParams.planId).then(function (data) {
            console.log(data);
            //data='{"data":{"highcharts":{"x":[],"take":[],"nt":[]},"list":[]},"status":true}';
            $scope.reportdata = data.data.highcharts;
            //$scope.reportdata={'x':['03/18','03/19','03/20','03/21','03/22','03/23','03/24','03/25','03/26','03/27','03/28','03/29'],
            //'take':[0,2,3,4,1,5,5,4,3,2,4,3],'nt':[5,3,2,1,4,0,0,1,2,3,1,2]};
            $scope.widthstr = $scope.reportdata.x.length;
            var heightstr = ($scope.reportdata.take[0] + $scope.reportdata.nt[0]);
            $scope.bottomsize = (240 / heightstr);
            console.log($scope.bottomsize);
            for (var i = 1; i <= heightstr; i++) {
                $scope.yData.push(i + '次');
            }
        }, function (error) {
            console.log(error);
        });
    })
    .controller('calendarCtrl', function ($scope, $rootScope, $stateParams, boxService, $cacheFactory, $state, $ionicModal, Plan, $ionicNativeTransitions, $timeout, $ionicSlideBoxDelegate) {
        $scope.form = {
            showFlag: '显示'
        };
        $scope.imgFlag = false; //缩放图片显示与否
        var planId = $stateParams.planId; //计划id
        $scope.remarkText = $stateParams.remarkText; //备注文字
        $scope.boxOutLook = $stateParams.imgurl; //计划对应的图片url
        $scope.remark = $stateParams.remark;  //语音url
        $scope.remarkTime = $stateParams.remarkTime; //语音时长
        console.debug("$scope.remark:", $scope.remark);
        console.debug("$scope.remarkTime:", $scope.remarkTime);
        console.debug("planId:", planId);
        console.debug("imgurl:", $scope.boxOutLook);
        //滑动日历遮罩
        console.log(localStorage.getItem('showFlag'));
        if (localStorage.getItem('showFlag') == '隐藏') {
            $scope.form.showFlag = false;
        }
        $scope.showZz = function () {
            $scope.form.showFlag = false;
            localStorage.setItem("showFlag", '隐藏');
        }

        /**
         * 播放语音
         * @param index
         */
        $scope.audioPlay = function () {
            $("#audio_temp")[0].play();
        };

        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);

        //--------

        $rootScope.items = [0, 1, 2, 3, 4];

        var currentDate;
        var beginTime = $stateParams.beginTime;
        if (beginTime == "undefined" || beginTime == "" || beginTime == null) {
            currentDate = new Date();
        } else {
            currentDate = new Date(beginTime);
        }

        var date = new Date(currentDate.getFullYear(), currentDate.getMonth(), 23);
        $scope.date = date;

        var medicineId = $stateParams.medicineId;

        boxService.calendarInfo(medicineId).then(function (data) {
            $scope.calendarInfo = data;
            angular.forEach(data.dateInfo, function (d) {
                if (d.medicineFlag == 1) {
                    $("#" + d.medicineDate).next().css("display", "block");
                } else {
                    $("#" + d.medicineDate).next().next().addClass("calShow");
                    $("#" + d.medicineDate).next().next().removeClass("calHide");
                    if (d.medicineNum <= 50) {
                        $("#" + d.medicineDate).next().next().find(".rount").css("transform", "rotate(" + d.medicineNum * 3.6 + "deg)");
                        $("#" + d.medicineDate).next().next().find(".rount2").css("display", "none");
                    } else {
                        $("#" + d.medicineDate).next().next().find(".rount").css("transform", "rotate(180deg)");
                        $("#" + d.medicineDate).next().next().find(".rount2").css("display", "block");
                        $("#" + d.medicineDate).next().next().find(".rount2").css("transform", "rotate(" + (d.medicineNum - 50) * 3.6 + "deg)");
                    }
                    var currentDate2 = new Date().Format("yyyy_MM_d"); //根据指定格式格式化当前日期
                    if (d.medicineDate == currentDate2) { //如果是当前日期，修改border颜色为白色
                        $("#" + d.medicineDate).next().next().find(".bg").css("border-color", "#fff");
                        $("#" + d.medicineDate).next().next().find(".bg2").css("border-color", "#fff");
                    }
                }
            });
        }, function (e) {
            console.log(e);
        });

        $scope.onezoneDatepicker = {
            date: date,
            mondayFirst: false,
            months: ["01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"],
            daysOfTheWeek: ["周日", "周一", "周二", "周三", "周四", "周五", "周六"],
            startDate: new Date(1989, 1, 26),
            endDate: new Date(2024, 1, 26),
            disablePastDays: false,
            disableSwipe: false,
            disableWeekend: false,
            disableDates: [new Date(date.getFullYear(), date.getMonth(), 15), new Date(date.getFullYear(), date.getMonth(), 16), new Date(date.getFullYear(), date.getMonth(), 17)],
            showDatepicker: true,
            showTodayButton: true,
            calendarMode: true,
            hideCancelButton: false,
            hideSetButton: false,
            medicineId: medicineId
//            callback: boxService.calendarInfo(medicineId)
        };


        $scope.showDatepicker = function () {
            $scope.onezoneDatepicker.showDatepicker = true;
        };
        //--------

        /**
         * 看大图
         */
        $scope.viewBigImg = function () {
//            console.debug("看大图");
            $ionicSlideBoxDelegate.$getByHandle('imghandle').enableSlide(false);
            $scope.imgFlag = true;
        }

        $scope.hideImg = function () {
            $scope.imgFlag = false;
        }

        $scope.goBack = function () {
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
    })
    .controller('hisDrugCtrl', function ($scope, $rootScope, $stateParams, boxService, $cacheFactory, $state, $ionicNativeTransitions, Plan) {
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);

        //历史数据缓存 （其他controller需要调用时打开）
        /*var drug_cache = $cacheFactory.get('hisDrugs');
         if (!drug_cache) {
         drug_cache = $cacheFactory('hisDrugs');
         }*/

        //得到上一个页面传过来的toUserId
        var toUser = $stateParams.toUser;

        //获取后台历史用药记录list
        Plan.findHisDrug(toUser).then(function (data) {
//            drug_cache.put('drugs',data);
//            console.log(data);
            if (isEmptyObject(data)) {
                $scope.flag = false;
            } else {
                $scope.flag = true;
            }
            $scope.drugMons = data;

            var k = [];
            angular.forEach(Object.keys($scope.drugMons), function (value, key) {
                k.push(value);
            });
            console.log("k" + k.sort(function (a, b) {
                if (a > b) {
                    return -1;
                }
                if (a == b) {
                    return 0;
                }
                else {
                    return 1;
                }
            }));

            $scope.keys = k.sort(function (a, b) {
                if (a > b) {
                    return -1;
                }
                if (a == b) {
                    return 0;
                }
                else {
                    return 1;
                }
            });

        }, function (e) {
            console.log(e);
        });

        function isEmptyObject(e) {
            var t;
            for (t in e)
                return !1;
            return !0
        }

        /**
         * 跳到用药日历页面
         */
        $scope.goToCalendar = function (medicineId, beginTime) {
            console.log("进入用药日历页面");

            $ionicNativeTransitions.stateGo('drug_calendar', {
                backUrl: "drug_history",
                medicineId: medicineId,
                beginTime: beginTime
            }, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });

        }

        /**
         * 返回
         */
        $scope.goBack = function () {
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
        console.groupEnd();

    });
