/**
 * Created by john on 2016-8-15.
 */
angular.module('Product', ['Filter'])

    .factory('productService', function ($http, $q, $rootScope) {
        // Might use a resource here that returns a JSON array
        return {
            saveOrder: function (recipients, phone, address, postCode, amount, nameList, numberList) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/save/order.htm",
                    params: {
                        recipients: recipients,
                        phone: phone,
                        address: address,
                        postCode: postCode,
                        amount: amount,
                        nameList: nameList,
                        numberList: numberList,
                        token: $rootScope.token
                    },
                    timeout: 5000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            findProductInfo: function () {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/prdoduct/find/infos.htm",
                    params: {
                    },
                    timeout: 5000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            findOrderInfo: function (method, page, count) {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/find/orderList.htm",
                    params: {
                        token: $rootScope.token,
                        method: method,
                        page: page,
                        count: count
                    },
                    timeout: 5000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            }
        };
    })

    .controller('proInfoCtrl', function ($scope, $ionicNativeTransitions, $stateParams, $state, $cacheFactory, productService, $rootScope, $timeout, $cordovaInAppBrowser) {
        //获取产品信息
        var product_cache = $cacheFactory.get('product');
        if (!product_cache) {
            product_cache = $cacheFactory('product');
        }
        $scope.form = {
            amount: 0,
            number: 0,
            productInfo: null,
            load: false
        }
        //查询产品信息
        $scope.findInfo = function () {
            $scope.form.load = true;
            productService.findProductInfo().then(function (data) {
                $scope.form.productInfo = data.data;
                product_cache.put("productList", data.data);
                $scope.$broadcast('scroll.refreshComplete');
            }, function (e) {
                ErrorShow("加载产品信息失败");
                $scope.$broadcast('scroll.refreshComplete');
            });
        };
        $scope.findInfo();
        $scope.$on('scroll.refreshComplete', function () {
            $scope.form.load = false;
        });
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);
        //设置页面特殊返回键监听标志
        cache.put('special_back', true);

        //监听app.js中返回事件监听发出的广播
        $scope.$on($state.current.name + '_HARDWARE_BACK', function (evt, data) {
            $scope.goBack();
        });
        /**
         * 拨打电话
         */
        var callFlag = false;
        $scope.call = function () {
            if (!callFlag) {
                callFlag = true;
                return;
            }
            if ($rootScope.os == "Android") {
                window.plugins.CallNumber.callNumber(function () {
                }, function () {
                }, "4006910208");
            } else {
                window.PhoneCaller.call("4006910208", function () {
                }, function () {
                })
            }
        };
        $timeout(function () {
            $(document).ready(function (e) {
                $(".g_call2").click(function () {
                    $(".g_call2").animate({right: 0}, 200);
                });
                $(".g_xy_content").click(function () {
                    callFlag = false;
                    $(".g_call2").animate({right: -73}, 200);
                });
            });
        }, 500)
        $(document).ready(function (e) {
            $(".g_call2").click(function () {
                $(".g_call2").animate({right: 0}, 200);
            });
            $(".g_xy_content").click(function () {
                $(".g_call2").animate({right: -73}, 200);
            });
        });
        /**
         * 联系客服
         */
        $scope.kefu = function () {
            $ionicNativeTransitions.stateGo('z_message_chat', {backUrl: 'g_my_product'}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        }
        /**
         * 返回
         */
        $scope.goBack = function () {
            console.log("回退");
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
          $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
        $scope.bp = {
            number: 0
        }
        $scope.bs = {
            number: 0
        }
        $scope.sw = {
            number: 0
        }
        $scope.tz = {
            number: 0
        }
        $scope.tw = {
            number: 0
        }
        $scope.ox = {
            number: 0
        }
        var productInfo = new Array();
        productInfo = product_cache.get("productInfo");
        if (productInfo) {
            for (var i = 0; i < productInfo.length; i++) {
                if (productInfo[i].type == 'BS') {
                    $scope.bs.number = productInfo[i].number;
                } else if (productInfo[i].type == 'BP') {
                    $scope.bp.number = productInfo[i].number;
                } else if (productInfo[i].type == 'OX') {
                    $scope.ox.number = productInfo[i].number;
                } else if (productInfo[i].type == 'TZ') {
                    $scope.tz.number = productInfo[i].number;
                } else if (productInfo[i].type == 'TW') {
                    $scope.tw.number = productInfo[i].number;
                } else if (productInfo[i].type == 'SW') {
                    $scope.sw.number = productInfo[i].number;
                }
            }
        }
        var amount = product_cache.get("amount");
        if (amount) {
            $scope.form.amount = amount.amount;
            $scope.form.number = amount.number;
            $("#zz_balance").removeClass("g_none");
        }
        //减少产品数量
        $scope.cut = function (type, price) {
            if (type == 'BS') {
                if ($scope.bs.number > 0) {
                    $scope.bs.number--;
                    $scope.form.amount = (parseFloat($scope.form.amount) - parseFloat(price)).toFixed(2);
                    $scope.form.number = $scope.form.number - 1;
                }
            } else if (type == 'BP') {
                if ($scope.bp.number > 0) {
                    $scope.bp.number--;
                    $scope.form.amount = (parseFloat($scope.form.amount) - parseFloat(price)).toFixed(2);
                    $scope.form.number = $scope.form.number - 1;
                }
            } else if (type == 'OX') {
                if ($scope.ox.number > 0) {
                    $scope.ox.number--;
                    $scope.form.amount = (parseFloat($scope.form.amount) - parseFloat(price)).toFixed(2);
                    $scope.form.number = $scope.form.number - 1;
                }
            } else if (type == 'SW') {
                if ($scope.sw.number > 0) {
                    $scope.sw.number--;
                    $scope.form.amount = (parseFloat($scope.form.amount) - parseFloat(price)).toFixed(2);
                    $scope.form.number = $scope.form.number - 1;
                }
            } else if (type == 'TW') {
                if ($scope.tw.number > 0) {
                    $scope.tw.number--;
                    $scope.form.amount = (parseFloat($scope.form.amount) - parseFloat(price)).toFixed(2);
                    $scope.form.number = $scope.form.number - 1;
                }
            } else if (type == 'TZ') {
                if ($scope.tz.number > 0) {
                    $scope.tz.number--;
                    $scope.form.amount = (parseFloat($scope.form.amount) - parseFloat(price)).toFixed(2);
                    $scope.form.number = $scope.form.number - 1;
                }
            }
            if ($scope.form.amount == 0) {
                $("#zz_balance").addClass("g_none");
            } else {
                $("#zz_balance").removeClass("g_none");
            }
        };
        //增加产品数量
        $scope.add = function (type, price) {
            $("#zz_balance").removeClass("g_none");
            if (type == 'BS') {
                $scope.bs.number++;
            } else if (type == 'BP') {
                $scope.bp.number++;
            } else if (type == 'OX') {
                $scope.ox.number++;
            } else if (type == 'SW') {
                $scope.sw.number++;
            } else if (type == 'TZ') {
                $scope.tz.number++;
            } else if (type == 'TW') {
                $scope.tw.number++;
            }
            $scope.form.amount = (parseFloat($scope.form.amount) + parseFloat(price)).toFixed(2);
            $scope.form.number = $scope.form.number + 1;
        };
        $scope.balance = function () {
            if ($("#zz_balance").hasClass("g_none")) {
                return;
            }
            product_cache.remove("productInfo");
            product_cache.remove("amount");
            var productInfo = new Array();
            if ($scope.bp.number > 0) {
                var o = new Object();
                o.name = getProductName($scope.form.productInfo, 'BP');
                o.type = 'BP';
                o.number = $scope.bp.number;
                o.price = getProductPrice($scope.form.productInfo, 'BP');
                o.image = getProductImage($scope.form.productInfo, 'BP');
                productInfo.push(o);
            }
            if ($scope.bs.number > 0) {
                var o = new Object();
                o.name = getProductName($scope.form.productInfo, 'BS');
                o.type = 'BS';
                o.number = $scope.bs.number;
                o.price = getProductPrice($scope.form.productInfo, 'BS');
                o.image = getProductImage($scope.form.productInfo, 'BS');
                productInfo.push(o);
            }
            if ($scope.ox.number > 0) {
                var o = new Object();
                o.name = getProductName($scope.form.productInfo, 'OX');
                o.type = 'OX';
                o.number = $scope.ox.number;
                o.price = getProductPrice($scope.form.productInfo, 'OX');
                o.image = getProductImage($scope.form.productInfo, 'OX');
                productInfo.push(o);
            }
            if ($scope.tw.number > 0) {
                var o = new Object();
                o.name = getProductName($scope.form.productInfo, 'TW');
                o.type = 'TW';
                o.number = $scope.tw.number;
                o.price = getProductPrice($scope.form.productInfo, 'TW');
                o.image = getProductImage($scope.form.productInfo, 'TW');
                productInfo.push(o);
            }
            if ($scope.tz.number > 0) {
                var o = new Object();
                o.name = getProductName($scope.form.productInfo, 'TZ');
                o.type = 'TZ';
                o.number = $scope.tz.number;
                o.price = getProductPrice($scope.form.productInfo, 'TZ');
                o.image = getProductImage($scope.form.productInfo, 'TZ');
                productInfo.push(o);
            }
            if ($scope.sw.number > 0) {
                var o = new Object();
                o.name = getProductName($scope.form.productInfo, 'SW');
                o.type = 'SW';
                o.number = $scope.sw.number;
                o.price = getProductPrice($scope.form.productInfo, 'SW');
                o.image = getProductImage($scope.form.productInfo, 'SW');
                productInfo.push(o);
            }
            product_cache.put("productInfo", productInfo);
            product_cache.put("amount", $scope.form);
            $ionicNativeTransitions.stateGo('g_my_order', {backUrl: 'g_my_product'}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        }
        $scope.goProductDetail = function (type) {
            $ionicNativeTransitions.stateGo('g_product_detail', {backUrl: 'g_my_product', type: type}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        }
        $scope.goBuy = function () {
            var options = {
                location: 'yes',
                clearcache: 'yes',
                toolbar: 'no'
            };
            $cordovaInAppBrowser.open('https://mall.jd.com/index-613542.html', '_blank', options).then(function (event) {
            }).catch(function (event) {
            });
        }

    })
    .controller('orderConfirmCtrl', function ($scope, $ionicNativeTransitions, $stateParams, $state, $cacheFactory, $compile, productService, $timeout) {
        //购买的产品缓存
        var product_cache = $cacheFactory.get('product');
        if (!product_cache) {
            product_cache = $cacheFactory('product');
        }
        var productInfo = product_cache.get("productInfo");
        $scope.productInfo = productInfo;
        console.log("产品信息", productInfo);
        $scope.form = {
            amount: 0,
            title: "确认订单",
            clickFlag: true,
            showAddress: false
        }
        var amount = product_cache.get("amount");
        if (amount) {
            $scope.form.amount = amount.amount;
        }
        //查询最近的一条订单
        $scope.addressInfo = {
            address: ',',
            recipients: null,
            phone: null
        };
        var addressInfo = product_cache.get("addressInfo");
        if (addressInfo) {
            $scope.addressInfo = addressInfo;
            $scope.form.showAddress = true
        } else {
            productService.findOrderInfo("queryPage", 1, 1).then(function (data) {
                if (data.data.length > 0) {
                    $scope.addressInfo = data.data[0];
                    product_cache.put("addressInfo", $scope.addressInfo);
                    $scope.form.showAddress = true
                } else {
                    //product_cache.put("addressInfo", $scope.addressInfo);
                    $scope.form.showAddress = false
                }
            }, function (e) {
                $scope.form.showAddress = false
                //product_cache.put("addressInfo", $scope.addressInfo);
            })
        }
        var time = new Date().getTime();
        $scope.confirmOrder = function () {
            if (!$scope.addressInfo.phone || !$scope.addressInfo.recipients || !$scope.addressInfo.address) {
                ErrorShow("请完善收货信息");
                return;
            }
            var nameList = new Array();
            var numberList = new Array();
            for (var i = 0; i < productInfo.length; i++) {
                nameList[i] = productInfo[i].name;
                numberList[i] = productInfo[i].number;
            }
            if (new Date().getTime() - time < 2000) {
                return;
            }
            time = new Date().getTime();
            productService.saveOrder($scope.addressInfo.recipients, $scope.addressInfo.phone, $scope.addressInfo.address,
                $scope.addressInfo.postCode, $scope.form.amount, nameList, numberList).then(function (data) {
                    if (data.status) {
                        product_cache.destroy();
                        $("#zz_g1").css("display", "block");
                        $("#zz_g2").css("display", "block");
                        $timeout(function () {
                            $("#zz_g1").css("display", "none");
                            $("#zz_g2").css("display", "none");
                            $("#zz_s1").css("display", "none");
                            $("#zz_s2").css("display", "none");
                            $("#zz_go").css("display", "block");
                            $scope.form.title = "订单详情";
                            $scope.form.clickFlag = false;
                        }, 1200)
                    } else {
                        ErrorShow("订单提交失败");
                    }
                }, function (error) {
                    ErrorShow("网络异常");
                })

        };
        /**
         * 返回
         */
        $scope.goBack = function () {
            $ionicNativeTransitions.stateGo("g_my_product", {backUrl: 'tab.mine'}, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };
        $scope.goAddress = function () {
            if (!$scope.form.clickFlag) {
                return;
            }
            $ionicNativeTransitions.stateGo("g_my_address", {backUrl: 'g_my_order'}, {
                "type": "slide",
                "direction": "left",
                "duration": 500
            });
        }

    })
    .controller('addressInfoCtrl', function ($scope, $ionicNativeTransitions, $stateParams, $state, $cacheFactory, $timeout) {
        //页面跳转参数存储
        var cache = $cacheFactory.get($state.current.name);
        if (!cache) {
            cache = $cacheFactory($state.current.name);
        }
        cache.put('stateParams', $stateParams);
        //设置页面特殊返回键监听标志
        cache.put('special_back', true);
        //产品信息缓存
        var product_cache = $cacheFactory.get('product');
        if (!product_cache) {
            product_cache = $cacheFactory('product');
        }
        var addressInfo = product_cache.get("addressInfo");
        $scope.form = {
            address: null,
            address2: null,
            recipients: null,
            phone: null
        }
        var address = null;
        if (addressInfo) {
            $scope.form.phone = addressInfo.phone;
            $scope.form.recipients = addressInfo.recipients;
            address = addressInfo.address;
            if (addressInfo.address) {
                $scope.form.address = addressInfo.address.substr(0, addressInfo.address.indexOf(','));
                $scope.form.address2 = address.substr(address.indexOf(',') + 1, address.length);
            }
        } else {
            addressInfo = {
                address: 'null,null',
                recipients: null,
                phone: null
            }
        }
        //选择地址插件
        var selectArea = new MobileSelectArea();
        selectArea.init({
            trigger: '#txt_area',
            value: $scope.form.address,
            data: 'lib/address/data.json',
            position: "bottom"
        });
        //保存地址
        $scope.saveAddress = function () {
            if (!$scope.form.recipients) {
                ErrorShow("请填写姓名");
                return;
            }
            if (!$scope.form.phone) {
                ErrorShow("请填写联系电话");
                return;
            }
            if (!checkPhone($scope.form.phone)) {
                return;
            }
            if (!document.getElementById("txt_area").value.replace(/\s+/g, "")) {
                ErrorShow("请选择所在地区");
                return;
            }
            if (!$scope.form.address2) {
                ErrorShow("请填写详细地址");
                return;
            }
            $("input").blur();
            product_cache.put("addressInfo", $scope.form);
            console.log(product_cache.get("addressInfo"));
            $timeout(function () {
                ErrorShow("保存成功");
                $ionicNativeTransitions.stateGo("g_my_order", {backUrl: 'g_my_product'}, {
                    "type": "slide",
                    "direction": "right",
                    "duration": 500
                });
                $timeout(function () {
                    $scope.form.address = document.getElementById("txt_area").value.replace(/\s+/g, "") + ',' + $scope.form.address2;
                }, 100)
            }, 400)
        };

        //返回按钮
        $scope.goBack = function () {
            $("input").blur();
            $scope.form.address = document.getElementById("txt_area").value.replace(/\s+/g, "");
            $timeout(function () {
                if (($scope.form.address + ',' + $scope.form.address2) != addressInfo.address ||
                    $scope.form.recipients != addressInfo.recipients || $scope.form.phone != addressInfo.phone) {
                    $("#zz_address_info").css("display", 'block');
                    $("#zz_address_2").css("display", 'block');
                    return;
                }
                $ionicNativeTransitions.stateGo("g_my_order", {backUrl: 'g_my_product'}, {
                    "type": "slide",
                    "direction": "right",
                    "duration": 500
                });
                $timeout(function () {
                    $scope.form.address = address;
                }, 100)
            }, 400)
        };
        //监听app.js中返回事件监听发出的广播
        $scope.$on($state.current.name + '_HARDWARE_BACK', function (evt, data) {
            $scope.goBack();
        });
        //取消返回按钮
        $scope.cancelBack = function () {
            $("#zz_address_info").css("display", 'none');
            $("#zz_address_2").css("display", 'none');
        };
        //确定返回按钮
        $scope.confirmBack = function () {
            $("#zz_address_info").css("display", 'none');
            $("#zz_address_2").css("display", 'none');
            $ionicNativeTransitions.stateGo("g_my_order", {backUrl: 'g_my_product'}, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
            $timeout(function () {
                $scope.form.address = address;
            }, 100)
        };
    })
    .controller('orderListCtrl', function ($scope, $ionicNativeTransitions, $stateParams, $state, $cacheFactory, productService, $timeout, $rootScope) {
        var product_cache = $cacheFactory.get('product');
        if (!product_cache) {
            product_cache = $cacheFactory('product');
        }
        $scope.form = {
            loadFlag: true
        }
        $scope.productInfo = product_cache.get("productList");
        $scope.orderInfo = [];
        $scope.page = 1;
        $scope.count = 5;
        $scope.loadList = function () {
            productService.findOrderInfo("queryPage", $scope.page, $scope.count).then(function (data) {
                if (data.data.length > 0) {
                    $scope.form.loadFlag = true;
                    $scope.page = $scope.page + 1;
                    $scope.orderInfo = $scope.orderInfo.concat(data.data);
                    //  $scope.orderInfo = getOrderList(data.data, $scope.productInfo);
                } else {
                    if ($scope.orderInfo.length > $scope.count) {
                        ErrorShow("没有更多了");
                    }
                    $scope.form.loadFlag = false;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }, function (e) {
            });
        };
        var tempIndex = null;
        $scope.slideUp = function (index) {
            $("#zz_xq_" + index).slideUp(600);
            $timeout(function () {
                /*  $("#zz_info_" + index).css("display", "block");*/
                $("#zz_info_" + index).slideDown(600);
            }, 0)
        };
        $scope.slideDown = function (index) {
            $(".g_xq").slideUp(600);
            $("#zz_info_" + tempIndex).css("display", "block");
            $("#zz_xq_" + index).slideDown(600);
            $("#zz_xq_" + index).css("display", "block");
            $("#zz_info_" + index).css("display", "none");
            tempIndex = index;
        };
        //联系客服
        $scope.call = function () {
            if ($rootScope.os == "Android") {
                window.plugins.CallNumber.callNumber(function () {
                }, function () {
                }, "4006910208");
            } else {
                window.PhoneCaller.call("4006910208", function () {
                }, function () {
                })
            }
        };
    })
    .controller('productDetail', function ($scope, $ionicNativeTransitions, $stateParams, $rootScope, $cordovaInAppBrowser) {
        $scope.form = {
            type: null
        }
        $scope.form.type = $stateParams.type;
        //联系客服
        $scope.call = function () {
            if ($rootScope.os == "Android") {
                window.plugins.CallNumber.callNumber(function () {
                }, function () {
                }, "4006910208");
            } else {
                window.PhoneCaller.call("4006910208", function () {
                }, function () {
                })
            }
        };
        $scope.goBack = function () {

            $ionicNativeTransitions.stateGo("g_my_product", {backUrl: 'tab.mine'}, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        }
        $scope.goBuy = function () {
            var url = "";
            if ($scope.form.type == 'BS') {
                url = 'https://item.jd.com/10989909867.html';
            } else if ($scope.form.type == 'BP') {
                url = 'https://item.jd.com/10984955395.html';
            }else if ($scope.form.type == 'SH') {
              url = 'https://item.jd.com/11150539537.html';
            }
            var options = {
                location: 'yes',
                clearcache: 'yes',
                toolbar: 'no'
            };
            $cordovaInAppBrowser.open(url, '_blank', options).then(function (event) {
            }).catch(function (event) {
            });
        }
    })
