//持久化存储模块 包括文件系统和sqllite数据库
angular.module('PSM', [])
    //文件系统
    .factory('FS', function ($cordovaFile) {
        var appName = 'HealthPatient';
        return {
            /**
             * 文件系统初始化
             */
            init: function () {
                $cordovaFile.checkDir(window.devicePath, appName).then(function (res) {
                    $cordovaFile.checkDir(window.devicePath + appName + '/', 'log').then(function (res) {
                    }, function (err) {                      //创建小视频缓存文件夹
                        $cordovaFile.createDir(window.devicePath + appName + '/', 'log', true).then(function (res) {
                        }, function (err) {
                        });
                    });
                    //根部文件存在
                }, function (err) {
                    //根部文件不存在
                    $cordovaFile.createDir(window.devicePath, appName, true).then(function (res) {
                        //创建根部文件成功
                        //创建音频缓存文件夹
                        $cordovaFile.createDir(window.devicePath + appName, 'audio', true).then(function (res) {

                        }, function (err) {

                        });
                        //创建图片缓存文件夹
                        $cordovaFile.createDir(window.devicePath + appName, 'pic', true).then(function (res) {

                        }, function (err) {

                        });
                        //创建文字缓存文件夹
                        $cordovaFile.createDir(window.devicePath + appName, 'txt', true).then(function (res) {

                        }, function (err) {

                        });
                        //创建小视频缓存文件夹
                        $cordovaFile.createDir(window.devicePath + appName, 'video', true).then(function (res) {

                        }, function (err) {

                        });
                        //创建小视频缓存文件夹
                        $cordovaFile.createDir(window.devicePath + appName, 'zip', true).then(function (res) {

                        }, function (err) {

                        });
                        //创建小视频缓存文件夹
                        $cordovaFile.createDir(window.devicePath + appName, 'log', true).then(function (res) {

                        }, function (err) {

                        });
                    }, function (err) {
                        //创建根部文件失败
                        // alert(err);
                    });
                });
            }
        };
    })
    //sqldb
    .factory('SqlDB', function ($cordovaSQLite) {
        var db = null;
        var appName = 'HealthPatient';
        return {
            init: function () {
                db = $cordovaSQLite.openDB({ name: appName + '.db' });

            }
        }
    })
    .factory('WebSql', function ($q, $sce) {
        var db = null;
        return {
            init: function () {
                db = openDatabase("HealthPatient", "1.0", "心常态病人端", 4096 * 1024, function () {
                    db.transaction(function (tx) {
                        /**
                         * 服药历史建表
                         */
                        tx.executeSql(
                            "create table if not exists take_medicine (user_id INTEGER, medicine_id INTEGER, medicine_name TEXT,medicine_count INTEGER, medicine_unit TEXT, medicine_shape TEXT,medicine_color TEXT, medicine_image TEXT, kit_appearance TEXT, user_medicine_id INTEGER, create_time TEXT)",
                            [],
                            function (tx, result) {
                                console.log(" table take_medicine success");
                            },
                            function (tx, error) {
                            });

                    });
                });
            },
            /**
             * 插入服药历史
             * @param medicine_id 药品id
             * @param medicine_name 药品名称
             */
            insertTakeMedicine: function (user_id, medicine_id, medicine_name, medicine_count, medicne_unit, medicine_shape, kit_appearance, user_medicine_id, medicine_image, medicine_color) {
                db.transaction(function (tx) {
                    tx.executeSql(
                        "delete from take_medicine where user_id = ? and medicine_name = ?",
                        [user_id, medicine_name],
                        function () {
                            console.log("remove historyMedicine " + medicine_name);
                        },
                        function (tx, error) {
                            console.log("remove historyMedicine error");
                        });
                    tx.executeSql(
                        "insert into take_medicine(user_id, medicine_id, medicine_name,medicine_count,medicine_unit,medicine_shape,kit_appearance,user_medicine_id, create_time,medicine_image,medicine_color) values( ?,?,?,?,?,?,?,?,?,?,?)",
                        [user_id, medicine_id, medicine_name, medicine_count, medicne_unit, medicine_shape, kit_appearance, user_medicine_id, new Date().getTime() + '', medicine_image, medicine_color],
                        function (tx, result) {
                            console.log("插入数据成功userID" + user_id);
                        },
                        function (tx, error) {
                            console.log(error);
                        });
                });
            },
            getTakeMedicine: function (user_id) {
                var q = $q.defer();
                var mess = new Array();
                db.transaction(function (tx) {
                    tx.executeSql(
                        "select * from take_medicine where user_id = ? order by create_time desc limit 10", [user_id],
                        function (tx, result) {
                            for (var i = 0; i < result.rows.length; i++) {
                                var obj = new Object();
                                obj.userId = result.rows.item(i)["user_id"];
                                obj.medicineId = result.rows.item(i)["medicine_id"];
                                obj.medicineName = result.rows.item(i)["medicine_name"];
                                obj.medicineCount = result.rows.item(i)["medicine_count"];
                                obj.medicineUnit = result.rows.item(i)["medicine_unit"];
                                obj.medicineImgSrc = result.rows.item(i)["medicine_image"];
                                obj.kitAppearance = result.rows.item(i)["kit_appearance"];
                                obj.userMedicineId = result.rows.item(i)["user_medicine_id"];
                                obj.medicineColor = result.rows.item(i)["medicine_color"];
                                obj.medicineShape = result.rows.item(i)["medicine_shape"];
                                obj.createTime = result.rows.item(i)["create_time"];
                                mess.push(obj);
                            }
                            q.resolve(mess);
                        },
                        function (tx, error) {
                            q.resolve(mess);
                        }
                    );
                });
                return q.promise;
            },
            /**
             * 删除历史服药记录
             */
            deleteTakeMedicine: function () {
                db.transaction(function (tx) {
                    tx.executeSql(
                        "delete from take_medicine", [],
                        function (tx, result) {
                            console.log("delete success");
                        },
                        function (tx, error) {

                        }
                    )
                });
            },
            delMedicineInfo: function (userId, medicineName) {
                db.transaction(function (tx) {
                    tx.executeSql(
                        "delete from take_medicine where user_id = ? and medicine_name = ?", [userId, medicineName ],
                        function (tx, result) {
                            console.log("delete success", medicineName);
                        },
                        function (tx, error) {

                        }
                    )
                });
            },
            /**
             * 创建聊天记录表
             */
            createTable: function () {
                db.transaction(function (tx) {
                    tx.executeSql(
                        "create table if not exists chat_message2 (user_id TEXT, service_id INTEGER,service_name TEXT, content TEXT, type TEXT,fileId TEXT,audio_time TEXT, isMe INTEGER, status INTEGER,played INTEGER,send_time TEXT)",
                        [],
                        function (tx, result) {
                            console.log(" table chat_message success");
                        },
                        function (tx, error) {
                        });
                });
            },
            /**
             * 插入消息聊天记录
             */
            insertChatMessage: function (userId, serviceId, service_name, type, content, fileId, audioTime, isMe, status, played, sendTime) {
                db.transaction(function (tx) {
                    tx.executeSql(
                        "insert into chat_message2(user_id, service_id,service_name, content, type, fileId, audio_time, isMe, status,played,send_time) values(?,?,?,?,?,?,?,?,?,?,?)",
                        [userId + '', serviceId, service_name, content, type, fileId, audioTime, isMe, status, played, sendTime + ''],
                        function (tx, result) {
                            console.log("聊天信息插入成功");
                        },
                        function (tx, error) {
                            console.log(error);
                        }
                    )
                });
            },
            loadChatMsg: function (doctorId, count, sendTime, userId) {
                var q = $q.defer();
                var mess = new Array();
                db.transaction(function (tx) {
                    tx.executeSql(
                        "select * from chat_message2 where service_id = ? and user_id=? and send_time < ? order by send_time desc limit ? ", [doctorId, userId + '', sendTime, count],
                        function (tx, result) {
                            var showTimeFlag = true;
                            var tempTime = new Date().getTime();
                            for (var i = result.rows.length - 1; i >= 0; i--) {
                                var obj = new Object();
                                obj.userId = result.rows.item(i)["user_id"];
                                obj.doctorName = result.rows.item(i)["service_name"];  //新增
                                obj.serviceId = result.rows.item(i)["service_id"];
                                obj.type = result.rows.item(i)["type"];
                                obj.fileId = result.rows.item(i)["fileId"];
                                obj.played = result.rows.item(i)["played"];
                                if (result.rows.item(i)["isMe"] == 1) {
                                    obj.isFromeMe = true;
                                } else {
                                    obj.isFromeMe = false;
                                }
                                if (result.rows.item(i)["audio_time"]) {
                                    obj.content = $sce.trustAsResourceUrl(result.rows.item(i)["content"]);
                                    obj.audioTime = result.rows.item(i)["audio_time"];
                                    obj.tempTime = parseInt(obj.audioTime.substr(0, 2));
                                } else {
                                    obj.content = result.rows.item(i)["content"];
                                    console.log('content:', obj.content);
                                }
                                obj.status = result.rows.item(i)["status"];
                                if (Math.abs(tempTime - parseInt(result.rows.item(i)["send_time"])) > 10 * 60 * 1000) {
                                    obj.showTimeFlag = true;
                                } else {
                                    obj.showTimeFlag = false;
                                }
                                tempTime = parseInt(result.rows.item(i)["send_time"]);
                                obj.sendTime = formatDate(new Date(parseInt(result.rows.item(i)["send_time"])));
                                obj.time = result.rows.item(i)["send_time"];
                                mess.push(obj);
                            }
                            q.resolve(mess);
                        },
                        function (tx, error) {
                            q.resolve(mess);
                        }
                    );
                });
                return q.promise;
            },
            /**
             * 查询最近一条记录
             * 用途：用来判断是否显示时间
             * @param userId
             */
            selectOneMessage: function (userId) {
                var q = $q.defer();
                var mess = new Array();
                db.transaction(function (tx) {
                    tx.executeSql(
                        "select * from chat_message2 where user_id = ? order by send_time desc limit 0,1",
                        [userId + ''],
                        function (tx, result) {
                            console.log(result);
                            for (var i = result.rows.length - 1; i >= 0; i--) {
                                var obj = new Object();
                                obj.userId = result.rows.item(i)["user_id"];
                                obj.serviceId = result.rows.item(i)["service_id"];
                                obj.type = result.rows.item(i)["type"];
                                obj.fileId = result.rows.item(i)["fileId"];
                                if (result.rows.item(i)["isMe"] == 1) {
                                    obj.isFromeMe = true;
                                } else {
                                    obj.isFromeMe = false;
                                }
                                if (result.rows.item(i)["audio_time"]) {
                                    obj.content = $sce.trustAsResourceUrl(result.rows.item(i)["content"]);
                                    obj.audioTime = result.rows.item(i)["audio_time"];
                                } else {
                                    obj.content = result.rows.item(i)["content"];
                                }
                                obj.status = result.rows.item(i)["status"];
                                obj.sendTime = date2str(new Date(result.rows.item(i)["send_time"]), 'MM-dd hh:mm');
                                console.log(obj.sendTime);
                                mess.push(obj);
                            }
                            console.log(mess);
                            q.resolve(mess);
                        },
                        function (tx, error) {
                            q.resolve(mess);
                        }
                    )
                });
            },
            /**
             * 查询聊天列表
             * @param userId
             */
            selectChatList: function (userId) {
                var q = $q.defer();
                var mess = new Array();
                db.transaction(function (tx) {
                    tx.executeSql(
                        "select * from chat_message2 where user_id=? and rowid in (select max(rowid) from chat_message2 group by service_id) order by send_time desc",
                        [userId + ''],
                        function (tx, result) {
                            console.log(result);
                            for (var i = 0; i < result.rows.length; i++) {
                                var obj = new Object();
                                obj.userId = result.rows.item(i)["user_id"];
                                obj.serviceId = result.rows.item(i)["service_id"];
                                obj.type = result.rows.item(i)["type"];
                                obj.content = result.rows.item(i)["content"];
                                obj.fileId = result.rows.item(i)["fileId"];
                                obj.serviceName = result.rows.item(i)["service_name"];
                                obj.sendTime = formatDate(new Date(parseInt(result.rows.item(i)["send_time"])));
                                obj.played = result.rows.item(i)["played"];
                                mess.push(obj);
                            }
//                            console.log(mess);
                            q.resolve(mess);
                        },
                        function (tx, error) {
                            q.resolve(mess);
                        }
                    )
                });
                return q.promise;
            },
            /**
             * 查询收到最后一条信息的id
             * @param userId，serviceId
             */
            selectMaxRowid: function (userId, serviceId) {
                var q = $q.defer();
                var rowid = 0;
                db.transaction(function (tx) {
                    tx.executeSql(
                        "select max(rowid) from chat_message2 where user_id=? and service_id=?",
                        [userId + '', serviceId],
                        function (tx, result) {
                            rowid = result.rows.item(0)["max(rowid)"];
                            q.resolve(rowid);
                        },
                        function (tx, error) {
                            q.resolve(rowid);
                        }
                    )
                });
                return q.promise;
            },
            /**
             * 更新音频的阅读状态
             * @param userId，serviceId
             */
            updateAudioStatus: function (time) {
                var q = $q.defer();
                db.transaction(function (tx) {
                    tx.executeSql(
                        "update chat_message2 set played=0 where send_time=?",
                        [time + ''],
                        function (tx, result) {
                            console.log(result);
                            q.resolve(result);
                        },
                        function (tx, error) {
                            q.reject(error);
                        }
                    )
                });
                return q.promise;
            },
            /**
             * 更新医生信息
             * @param name,headImg,id
             * @returns {*}
             */
            updateDoctorInfo: function (name, headImg, id) {
                var q = $q.defer();
                db.transaction(function (tx) {
                    tx.executeSql(
                        "update chat_message2 set service_name=?,fileId=? where service_id=?",
                        ['' + name, '' + headImg, id],
                        function (tx, result) {
                            q.resolve(result);
                        },
                        function (tx, error) {
                            q.reject(error);
                        }
                    )
                });
                return q.promise;
            },

            /**
             * 创建通知消息记录表
             */
            createInformMessageTable: function () {
                db.transaction(function (tx) {
                    tx.executeSql(
                        "create table if not exists inform_message (title TEXT,content TEXT, sendTo TEXT, status INTEGER,sendTime TEXT,messageType TEXT)",
                        [],
                        function (tx, result) {
                            console.log(" table inform_message success");
                        },
                        function (tx, error) {
                        });
                });
            },


            /**
             * 插入通知消息聊天记录
             */
            insertInformMessageTable: function (title, content, sendTo, status, sendTime, messageType) {
                db.transaction(function (tx) {
                    tx.executeSql(
                        "insert into inform_message(title, content,sendTo, status, sendTime,messageType) values(?,?,?,?,?,?)",
                        [title, content, sendTo, status, sendTime, messageType],
                        function (tx, result) {
                            console.log("通知信息插入成功");
                        },
                        function (tx, error) {
                            console.log(error);
                        }
                    )
                });
            },


            /**
             * 查询消息通知列表
             * @param userId
             */
            selectInformMessageTable: function (title) {
                var q = $q.defer();
                var mess = new Array();
                db.transaction(function (tx) {
                    tx.executeSql(
                        "select *,rowid from inform_message",
                        [],
                        function (tx, result) {
                            console.log('result:', result);
                            for (var i = 0; i < result.rows.length; i++) {
                                var obj = new Object();
                                obj.title = result.rows.item(i)["title"];
                                obj.content = result.rows.item(i)["content"];
                                obj.sendTo = result.rows.item(i)["sendTo"];
                                obj.content = result.rows.item(i)["content"];
                                obj.status = result.rows.item(i)["status"];
                                obj.sendTime = result.rows.item(i)["sendTime"];
                                obj.messageType = result.rows.item(i)["messageType"];
                                obj.id = result.rows.item(i)["rowid"];
                                mess.push(obj);
                            }
                            console.log("mess:" + mess);
                            q.resolve(mess);
                        },
                        function (tx, error) {
                            q.resolve(mess);
                        }
                    )
                });

                return q.promise;

            }
        }
    })
;