angular.module('Report', [])

    .factory('reportHealthService', function($q,$rootScope,$http) {
        // Might use a resource here that returns a JSON array

        return {
            userInfo:function(p_token){
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/open/user/profile.htm",
                    params: {
                        token: p_token
                    },
                    timeout: 10000
                };
                $http(req).success(function (result) {
                    console.log("查到的信息->" + JSON.stringify(result));
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;

            },
            patientHealthData:function(p_token,p_healthIndex,p_timeCategory,p_self,p_userId){
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/patient/user/healthindex.htm",
                    params: {
                        token: p_token,
                        healthIndex:p_healthIndex,
                        timeCategory:p_timeCategory,
                        self:p_self,
                        userId:p_userId
                    },
                    timeout: 10000
                };
                $http(req).success(function (result) {
                    console.log("查到的信息->" + JSON.stringify(result));
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;

            }
            ,
            selectLastData:function(p_token,p_self){
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/open/data/queryLastData.htm",
                    params: {
                        token: p_token,
                        self:p_self
                    },
                    timeout: 10000
                };
                $http(req).success(function (result) {
                    console.log("查到的信息->" + JSON.stringify(result));
                    console.log(result.status);
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;

            }
        };
    })

    .controller('HealthReportCtrl', function($scope,$stateParams,$rootScope,reportHealthService) {
        reportHealthService.userInfo($rootScope.token).then(function (data) {
            $scope.userinfo = data;
        }, function (error) {
        });
        reportHealthService.selectLastData($rootScope.token,true).then(function (data) {
            $scope.lastData = data.data;
        }, function (error) {

        });
    });