angular.module('starter.services', [])
    .factory('appService', function ($http, $q, $rootScope) {
        return {
            getLatestVersion: function () {
                var q = $q.defer();
                var req = {
                    method: 'GET',
                    url: $rootScope.reqUrl + "/knowledge/app/getVersion.htm",
                    params: {
                        appName: 'healthpatient'
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.message);
                    }
                }).error(function (result) {
                    q.reject("network error");
                });
                return q.promise;
            }
        }
    });
