/**
 * Created by liushangqing on 2016/3/2.
 */
/**
 * 验证手机
 * @param phone
 * @returns {boolean}
 */
function checkPhone(phone) {
    if (!(/^1[3|4|5|7|8]\d{9}$/.test(phone))) {
        //$("#ZHEZHAO").show();
        $("#ERROR").text("手机号码有误，请重新填写");
        $("#ERROR").show();
        setTimeout('cancelZZ()', 1000);
        return false;
    }
    return true;
}

//验证密码
function checkPassword(password, text) {
    if (!(/^[0-9A-Za-z]{6,16}$/.test(password))) {
        // $("#ZHEZHAO").show();
        $("#ERROR").text("密码格式为6-16位数字或字母");
        $("#ERROR").show();
        setTimeout('cancelZZ()', 1000);
        return false;
    }
    return true;
}

//验证密码无弹出窗口
function checkPassword2(password, text) {
    if (!(/^[0-9A-Za-z]{6,16}$/.test(password))) {
        return false;
    }
    return true;
}
//错误弹窗
function ErrorShow(text) {
    //$("#ZHEZHAO").show();
    $("#ERROR").text(text);
    $("#ERROR").show();
    setTimeout('cancelZZ()', 1000);
    return false;
}


/**
 * 身份证格式验证
 * @param cardNum 身份证号码
 * @returns {boolean} true或者false
 */
function checkCardNum(cardNum) {
    if (!(/^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$|^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}([0-9]|X)$/).test(cardNum)) {
        $("#ERROR").text("身份证号码格式错误");
        $("#ERROR").show();
        setTimeout('cancelZZ()', 1000);
        return false;
    }
    return true;
}

/**
 * 去掉遮罩
 */
function cancelZZ() {
    $("#ZHEZHAO").hide();
    $("#ERROR").hide();
}


angular.module('User', ['OPERATION_REMIND'])
    .factory('userService', function ($http, $q, $rootScope, $cordovaBarcodeScanner, drugService, $cordovaToast, WebSql) {
        return {
            //登录
            login: function (phone, password) {
                var q = $q.defer()
                localStorage.setItem("phone", phone);
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/open/user/login.htm",
                    params: {
                        phone: phone,
                        password: password,
                        os: $rootScope.os,
                        deviceId: $rootScope.deviceId,
                        type: 12
                    },
                    timeout: 5000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    ErrorShow("网络异常");
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //获取验证码
            getVcode: function (phone, useage) {
                var q = $q.defer();
                console.log(useage);
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/open/user/getCheckVal.htm",
                    params: {
                        phone: phone,
                        usage: useage,
                        userPhone: $rootScope.user && $rootScope.user.phone ? $rootScope.user.phone : null,
                        userName: $rootScope.user && $rootScope.user.name ? $rootScope.user.name : null
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    //isDefined   ErrorShow(result.error);
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    ErrorShow("网络异常，请检查网络");
                    q.reject(result);
                });
                return q.promise;
            },
            //验证手机验证码
            verify: function (phone, usage) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/open/user/getCheckValNumber.htm",
                    params: {
                        phone: phone,
                        usage: usage
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //注册
            regAll: function (phone, checkNum, gender, password, regSource, birthday) {
                localStorage.setItem("phone", phone); //记住手机号
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/new/user/reg.htm",
                    params: {
                        phone: phone,
                        checkNum: checkNum,
                        gender: gender,
                        password: password,
                        regSource: regSource,
                        birthday: birthday,
                        regChannel: $rootScope.regChannel,  //注册渠道
                        os: $rootScope.os,   //平台（ios/android）
                        deviceId: $rootScope.deviceId,  //设备id，推送用
                        type: 12,        //新版新常态标识
                        userType: $rootScope.userType
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //重置密码
            sendMessage: function (phone, vcode) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/open/user/getCheckVal.htm",
                    params: {
                        phone: phone,
                        usage: "Reset"
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //找回密码
            findPwd: function (phone, checkNum, password) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/open/user/lost.htm",
                    params: {
                        phone: phone,
                        checkNum: checkNum,
                        password: password
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //微信登录
            getToken: function (code) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/weixin/getUserInfo.htm",
                    params: {
                        code: code,
                        os: $rootScope.os,
                        deviceId: $rootScope.deviceId,
                        regChannel: $rootScope.regChannel
                    },
                    timeout: 4000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //获取用户信息
            getProfile: function (token) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/open/user/profile.htm",
                    params: {
                        token: token
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                  console.debug("result:", result);
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //更换手机
            changePhone: function (token, checkNum, newPhone, userType) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/open/user/changePhone.htm",
                    params: {
                        token: token,
                        checkNum: checkNum,
                        newPhone: newPhone,
                        userType: userType
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
//                    console.log(result);
                    q.resolve(result);
                    /* if (result.status == 1) {
                     q.resolve(result);
                     } else {
                     q.reject(result);
                     }*/
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //修改密码（无须验证码）
            modifyPwd: function (phone, password) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/open/user/changePwd.htm",
                    params: {
                        phone: phone,
                        password: password
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //我的亲朋（添加好友）
            addFriend: function (token, phone, name, gender, birthday, id, stature, weight) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/patient/user/alarm/user/add.htm",
                    params: {
                        token: token,
                        telephone: phone,
                        name: name,
                        gender: gender,
                        birthday: birthday,
                        id: id,
                        stature: stature,
                        weight: weight
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //删除成员
            deleteFriend: function (auId) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/patient/user/alarm/user/del.htm",
                    params: {
                        token: $rootScope.token,
                        auId: auId
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //取出亲朋列表
            friendList: function (token) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/patient/user/alarm/user/find.htm",
                    params: {
                        token: token
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.data);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //上传头像（自己）
            uploadHeaderImage: function (token) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/open/user/uploadHeadImg.htm",
                    params: {
                        token: token,
                        type: 'file'
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.data);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //获取提醒用户详细信息
            getInfo: function (id) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/query/alarm/user/info.htm",
                    params: {
                        id: id
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result.data);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //更新用户信息
            update: function (name, gender, birthday, stature, weight) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/new/update/user.htm",
                    params: {
                        token: $rootScope.token,
                        name: name,
                        gender: gender,
                        birthday: birthday,
                        stature: stature,
                        weight: weight
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //获取QQ用户信息
            getQQInfo: function (access_token, openid) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/qq/getUserInfo.htm",
                    params: {
                        access_token: access_token,
                        openid: openid,
                        os: $rootScope.os,
                        deviceId: $rootScope.deviceId,
                        regChannel: $rootScope.regChannel
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result.status) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            } //return
            ,
            //上传登录日志
            upLoginLogs: function (userId) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/login/addLogs.htm",
                    params: {
                        userId: userId
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    console.log("上传了日志");
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //游客注册并登陆
            visitorLogin: function () {
                //如果不在手机上
                if (!window.cordova) {
                    $rootScope.deviceId = '999999999888877';
                }
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/visitor/login.htm",
                    params: {
                        os: $rootScope.os,   //平台信息，主要给极光推送用
                        deviceId: $rootScope.deviceId //设备唯一标识
                    },
                    timeout: 8000
                };
                $http(req).success(function (result) {
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //清空游客数据
            clearVisitorData: function () {
                //如果不在手机上
                if (!window.cordova) {
                    $rootScope.deviceId = '20160606004';
                }
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/visitor/clear.htm",
                    params: {
                        deviceId: $rootScope.deviceId //设备唯一标识
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //清空游客数据
            checkcompletmes: function (token) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/patient/user/check/completmes.htm",
                    params: {
                        token: token
                    },
                    timeout: 3000
                };
                $http(req).success(function (result) {
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //补全手机号、性别、出生年月
            updatecompletmes: function
                (token, userphone, usergender, userbirth, userstature) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl +
                        "/patient/user/check/updatecompletmes.htm",
                    params: {
                        token: token,
                        userphone: userphone,
                        usergender: usergender,
                        userbirth: userbirth,
                        userstature: userstature
                    },
                    timeout: 3000
                };
                $http(req).success(function
                    (result) {
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            //个人设置页面需要用到的信息处理
            myprofile: function (d) { //d是后台返回的用户信息
                $rootScope.user = d;
                localStorage.setItem("user", JSON.stringify(d)); //将用户信息存入本地
                if (!!localStorage.getItem(d.phone))  //注册时的默认头像
                {
                    $rootScope.user.headImg = localStorage.getItem(d.phone);
                    // alert(localStorage.getItem("headImg"));
                }
                var birth = $rootScope.user.date;
                $rootScope.date = "";
                $rootScope.user.date = "";
                if (birth) {
                    var b = new Date(birth);
                    var m = b.getMonth() + 1;  //月份需要加一
                    //var d= b.getDate();   //天数
                    var birthday = b.getFullYear() + "-" + m + "-" + b.getDate();
                    $rootScope.user.date = birthday;
                    $rootScope.date = birthday;     //临时变量，用于个人设置页面↓↓↓
                }
                $rootScope.gender = d.gender;
                $rootScope.name = d.name;
                console.log(d);
                //2016-12-20添加
                if (d.userType == 6 && !d.phone) {  //如果为游客类型
                    $rootScope.userType = 6;
                }
            },
            //邀请码填写
            showInvite: function () {
                var scan_button = document.getElementById("scan_button");
                scan_button.onclick = function () {
                    console.log("点击了扫描");
                    $cordovaBarcodeScanner
                        .scan()
                        .then(function (barcodeData) {
                            console.log('扫描结果', JSON.stringify(barcodeData));
                            drugService.createRelation(barcodeData.text).then(function (d) {
                                console.log('创建关系结果：', d);
                                if (d.status) {
                                    $("#invite").hide();
                                    $cordovaToast.showShortBottom('成功添加医生');
                                    WebSql.insertChatMessage($rootScope.user.userId, d.doctorId, d.name, "text", "您好，我有问题想要咨询您", d.headImg, null, 1, 1, null, new Date().getTime());
                                } else {
                                    $("#invite").hide();
                                    $cordovaToast.showShortBottom(d.message);
                                }
                            }, function (e) {
                                console.log(e);
                            });
                        }, function (error) {
                            // An error occurred
                            console.log(error);
                        });
                };

                var url = $rootScope.reqUrl + "/user/invite.htm";
                //邀请框显示
                $("#invite").show();
                //忽略
                $("#ignore").click(function (e) {
                    e.stopPropagation;
                    $("#invite").hide();
                    $.ajax({
                        url: url,
                        data: {token: $rootScope.token, channel: null, method: null},
                        type: "POST",
                        dataType: 'json',
                        success: function (data) {
                            console.log(data);
                        },
                        error: function (e) {
                            console.log(e);
                        }
                    });
                });

                //完成
                $("#completion").click(function (e) {
                    e.stopPropagation;
                    $("#invite").hide();
                    var channel = $("#inviteCode").val();
                    drugService.createRelation(channel).then(function (d) {
                        console.log('创建关系结果：', d);
                        if (d.status) {
                            $("#invite").hide();
                            $cordovaToast.showShortBottom('成功添加医生');
                        } else {
                            $("#invite").hide();
                            $cordovaToast.showShortBottom(d.message);
                        }
                    }, function (e) {
                        console.log(e);
                    });
//                    $.ajax({
//                        url: url,
//                        data: {token: $rootScope.token, channel: channel, method: null},
//                        type: "POST",
//                        dataType: 'json',
//                        success: function (data) {
//                            console.log(data);
//                        },
//                        error: function (e) {
//                            console.log(e);
//                            $("#invite").hide();
//                        }
//                    });

                });
            },
            /**
             * 获取邀请状态，判断是否要显示邀请码
             * @returns {*}
             */
            getInviteStatus: function () {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/user/invite.htm",
                    params: {
                        token: $rootScope.token,
                        method: 'query',
                        channel: null
                    },
                    timeout: 3000
                };
                $http(req).success(function
                    (result) {
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },

            /**
             *
             * 获取（服务）商品列表
             */
            getProducts: function () {
                var q = $q.defer();
                var req = {
                    method: 'get',
                    url: $rootScope.reqUrl + "/xproduct/query.htm",
                    timeout: 5000
                };
                $http(req).success(function
                    (result) {
                    if (result) {
                        q.resolve(result.data);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
            /**
             * 远盟会员备案
             * @param userName
             * @param mobile
             * @param cardNum
             * @param birthday
             * @param sex
             * @param address
             * @param emergencyConName
             * @param recvisits
             * @returns {*}
             */
            ymRegist: function (days, orderNo, operation, userType, deviceType) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/ymservice/regist.htm",
                    params: {
                        userId: $rootScope.user.userId,
                        days: days,
                        orderNo: orderNo,
                        operation: !operation ? '01' : operation,
                        userType: userType,
                        deviceType: deviceType
                    },
                    timeout: 10000
                };
                $http(req).success(function
                    (result) {
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject(result);
                });
                return q.promise;
            },

            /**
             * 远盟服务接口
             * @param serviceType
             * @returns {*}
             */
            ymService: function (serviceType) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/ymservice/ask.htm",
                    params: {
                        userId: $rootScope.user.userId,
                        longitude: $rootScope.longitude,
                        latitude: $rootScope.latitude,
                        serviceType: serviceType
                    },
                    timeout: 5000
                };
                $http(req).success(function
                    (result) {
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },

            /**
             * 获取支付宝/微信 支付参数
             * @param productId
             * @param userName
             * @param description
             * @param totalPrice
             * @param type
             * @returns {*}
             */
            getPayParams: function (productId, userName, description, totalPrice, type) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/patient/alipay/getSignInfo.htm",
                    params: {
                        productId: productId,
                        userName: userName,
                        description: description,
                        totalPrice: totalPrice,
                        type: type
                    },
                    timeout: 50000
                };
                $http(req).success(function
                    (result) {
                    if (result) {
                        q.resolve(result);
                    } else {
                        q.reject(result);
                    }
                }).error(function (result) {
                    q.reject("网络异常");
                });
                return q.promise;
            },
          getUserBalance:function () {
            var q = $q.defer();
            var req = {
              method: 'post',
              url: $rootScope.reqUrl + "/money/balance.htm",
              params: {
                token: $rootScope.token
              },
              timeout: 50000
            };
            $http(req).success(function
              (result) {
              if (result) {
                q.resolve(result);
              } else {
                q.reject(result);
              }
            }).error(function (result) {
              q.reject("网络异常");
            });
            return q.promise;
          },
            /**
             * 保存急救卡信息
             * @param card
             * @returns {*}
             */
            saveCard: function (card) {
                var q = $q.defer();
                var req = {
                    method: 'post',
                    url: $rootScope.reqUrl + "/emergency/add.htm",
                    params: {
                        userId: $rootScope.user.userId,
                        userName: card.userName,
                        sex: card.sex,
                        mobile1: card.mobile1,
                        idcardType: card.idcardType,
                        idcardNum: card.idcardNum,
                        birthday: card.birthday,
                        emergencyContact: card.emergencyContact,
                        recvisits: card.recvisits,
                        address: card.address,
                        remark: card.remark,
                        os: $rootScope.os == 'Android' ? 2 : 1
                    },
                    timeout: 5000
                };
                $http(req).success(function
                    (result) {
                    q.resolve(result);

                }).error(function (result) {
                    q.reject(result);
                });
                return q.promise;
            }

        };
    })
    //登录
    .controller('LoginController', function ($scope, userService, $state, $rootScope, $ionicHistory, Loading, $ionicNativeTransitions, $cacheFactory, $stateParams) {
        //
//        userService.showInvite();
        //
        var phone_ = localStorage.getItem("phone");
        var password_ = localStorage.getItem("password");
        $scope.form = {phone: phone_, password: password_, phoneFlag: false, pwdFlag: false};

        /**
         * 切换图标
         * @param str
         */
        $scope.changeImg = function (str) {
            if ("phone" == str) {
                $scope.form.phoneFlag = true;
                $scope.form.pwdFlag = false;
            } else {
                $scope.form.phoneFlag = false;
                $scope.form.pwdFlag = true;
            }
        }

        //cordova.plugins.Keyboard.close();
        /**
         * 监听原生键盘
         */
        /* window.addEventListener('native.keyboardshow', keyboardShowHandler);

         function keyboardShowHandler(e){
         document.body.classList.add('keyboard-open');
         alert('Keyboard height is: ' + e.keyboardHeight);
         }*/

        /**
         * 登录
         * @returns {boolean}
         */
        $scope.login = function () {
            console.log("userlogin");
            $scope.form.phone = $.trim($scope.form.phone);
            console.log($scope.form.password + "-----" + $scope.form.phone + "-----------");
            if (!checkPhone($scope.form.phone)) {
                return false;
            } else if (!checkPassword($scope.form.password)) {
                return false;
            }
            var form = $scope.form;
            localStorage.setItem("password", form.password);
            var pwd = jQuery.md5(form.password);
            Loading.show('running_woman', '登录', true);
            userService.login(form.phone, pwd).then(function (data) {
                if (data.status == 1) {
                    userService.getProfile(data.token).then(function (d) {
                        /* $rootScope.user = d;
                         localStorage.setItem("user", JSON.stringify(d)); //将用户信息存入本地
                         if (!!localStorage.getItem($scope.form.phone))  //注册时的默认头像
                         {
                         $rootScope.user.headImg = localStorage.getItem($scope.form.phone);
                         // alert(localStorage.getItem("headImg"));
                         }
                         var birth = $rootScope.user.date;
                         $rootScope.date = "";
                         $rootScope.user.date = "";
                         if (birth) {
                         var b = new Date(birth);
                         var m = b.getMonth() + 1;  //月份需要加一
                         //var d= b.getDate();   //天数
                         var birthday = b.getFullYear() + "-" + m + "-" + b.getDate();
                         $rootScope.user.date = birthday;
                         $rootScope.date = birthday;     //临时变量，用于个人设置页面↓↓↓
                         }
                         $rootScope.gender = d.gender;
                         $rootScope.name = d.name;
                         console.log(d);*/
                        userService.myprofile(d); //用户信息处理

                    }), function (error) {
                        console.log(error);
                    }
                    $rootScope.token = data.token;
                    //记住密码
                    localStorage.setItem("token", data.token);
                    $scope.$emit("login");
                    $scope.$emit('addMedicineSuccess');  //刷新药盒列表
//                    $scope.$emit('loginSuccess');
                    //---
                    userService.getInviteStatus().then(function (d) {
                            if (d.invite == 1) {
                                userService.showInvite();
                            }
                        }, function (e) {
                            console.log(e);
                            ErrorShow("网络异常");
                        }
                    );
                    $ionicNativeTransitions.stateGo('tab.home', {}, {
                        "type": "slide",
                        "direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
                        "duration": 400 // in milliseconds (ms), default 400
                    });
                } else {
                    ErrorShow(data.message);
                }
                Loading.hide('running_woman');
            }, function (error) {
                Loading.hide('running_woman');
                //$state.go("tab.home");
                ErrorShow(error.error);
            });
        };

        /**
         * 微信登录
         */
        $scope.weChat = function () {
            var scope = "snsapi_userinfo";
            Wechat.isInstalled(function (installed) {
                console.log("Wechat installed: " + (installed ? "Yes" : "No"));
                if (installed) {
                    console.log("已经安装微信", installed);
                    Wechat.auth(scope, function (response) {
                        // you may use response.code to get the access token.
                        var result = JSON.stringify(response);
                        //alert(result);
                        console.log(response.code);
                        userService.getToken(response.code).then(function (data) {
                            if (data.status) {
                                $rootScope.token = data.token;
                                $rootScope.user = data;
                                localStorage.setItem("token", data.token);
                                $scope.$emit("login");
//                        $scope.$emit('wechatLoginSuccess');
                                //---
                                userService.getInviteStatus().then(function (d) {
                                        if (d.invite == 1) {
                                            userService.showInvite();
                                        }
                                    }, function (e) {
                                        console.log(e);
                                        ErrorShow("网络异常");
                                    }
                                );
                                //localStorage.setItem("inviteFlag","phone");
                                $state.go("tab.home");
                            } else {
                                // alert("密码错误！" + data.message);
                            }
                        }), function (error) {
                            console.log(error);
                        }
                    }, function (reason) {
                        //alert("Failed: " + reason);
                        ErrorShow(reason);
                    });
                } else {
                    ErrorShow("您还没安装微信哦");
                    return;
                }
            }, function (reason) {
                console.log("Failed: " + reason);
            });

        }

        /**
         * QQ登录
         */
        $scope.qqLogin = function () {
          YCQQ.checkClientInstalled(function () {
                console.log('client is installed');
                //QQ登录
                var checkClientIsInstalled = 1;//default is 0,only for iOS
            YCQQ.ssoLogin(function (args) {
                    /* alert(JSON.stringify(args));
                     alert(args.access_token);
                     alert(args.userid);*/
                    userService.getQQInfo(args.access_token, args.userid).then(function (data) {
                        $rootScope.token = data.token;
                        $rootScope.user = data;
                        localStorage.setItem("token", data.token);
                        $scope.$emit("login");
//                    $scope.$emit('qqLoginSuccess');
                        //localStorage.setItem("inviteFlag","phone");
                        //---
                        userService.getInviteStatus().then(function (d) {
                                if (d.invite == 1) {
                                    userService.showInvite();
                                }
                            }, function (e) {
                                console.log(e);
                                ErrorShow("网络异常");
                            }
                        );
                        $state.go("tab.home");
                    }, function (e) {
                        ErrorShow(e);
                    });
                }, function (failReason) {
                    console.log(failReason);
                }, checkClientIsInstalled);
            }, function () {
                // if installed QQ Client version is not supported sso,also will get this error
                ErrorShow("您没安装QQ哦");
            });


        }

        /**
         * 返回
         */
        /*  $scope.goBack = function () {
         //  $ionicHistory.goBack();
         $ionicNativeTransitions.stateGo($stateParams.backUrl, {}, {
         "type": "slide",
         "direction": "right",
         "duration": 500
         });
         };*/
    })
    //获取验证码-校验
    .controller('regController', function ($scope, userService, $state, $rootScope, $cacheFactory, $interval, $timeout, $ionicNativeTransitions, Loading) {
        //声明注册缓存
        var regCache = $cacheFactory.get('register');
        if (!regCache) {
            regCache = $cacheFactory('register');
        }
        console.log("LoginController");
        $scope.reg = {phone: "", vcode: "", title: "注册"};
        //获取短信验证码并倒计时
        $scope.flag = {send: false, time: 60, deleting: false};
        $scope.editFlag = {vcodeError: false, show: '验证码错误'};
        //新合
        $scope.form = {pwd: "", rpwd: "", flag: false, showFlag: false, errorText: ""};
        $scope.showPwd = function (num) {
            if (num == 1) {
                $scope.form.showFlag = true;
                $(".aa").attr("type", "text");
            } else {
                $scope.form.showFlag = false;
                $(".aa").attr("type", "password");
            }
        }

        /**
         * 设置密码，提交注册信息
         */
        $scope.regist = function () {
            var returnFlag = false;
            var form = $scope.form;
            console.log("pwd---------" + form.pwd);
            console.log("pwd---------" + form.rpwd);
            if ($scope.form.pwd == "" || $scope.form.rpwd == "") {
                $scope.form.flag = true;  //显示错误
                $scope.form.errorText = "密码不能为空";
                return returnFlag;
            } else if (!checkPassword(form.pwd)) {
                form.flag = true;
                return returnFlag;
            } else if (form.pwd != form.rpwd) {
                $scope.form.flag = true;  //显示错误
                $scope.form.errorText = "两次密码输入不一致";
                return returnFlag;
            } else if (usage == 'Reset') {
                console.log("改密码");
//                var pwd = jQuery.md5(form.pwd);
                userService.modifyPwd($scope.reg.phone, form.pwd).then(function (data) {
                    if (data.status) {
                        console.log("重置密码成功！");
                        $state.go("g_load");
                    } else {
                        console.log("重置密码失败");
                        return false;
                    }
                }, function (error) {
                    console.log(error);
                });

            } else {
                var regCache = $cacheFactory.get('register');
                console.log(form);
                localStorage.setItem("password", form.pwd); //记住密码
                regCache.put("pwd", jQuery.md5(form.pwd));
                var pwd = jQuery.md5(form.pwd);
                console.log($scope.reg);
                var regSource = $rootScope.os;
                userService.regAll($scope.reg.phone, $scope.reg.vcode, null, pwd, regSource, null).then(function (data) {
                    ErrorShow("注册成功");
                    //记住密码

                    Loading.show('running_woman', '登录', true);
                    $rootScope.user = data;
                    localStorage.setItem("user", JSON.stringify(data)); //将用户信息存入本地
                    if (!!localStorage.getItem($scope.reg.phone))  //注册时的默认头像
                    {
                        $rootScope.user.headImg = localStorage.getItem($scope.reg.phone);
                    }
                    $rootScope.date = data.date;     //临时变量，用于个人设置页面↓↓↓
                    $rootScope.gender = data.gender;
                    $rootScope.name = data.name;
                    console.log(data);
                    $rootScope.token = data.token;
                    //记住密码
                    localStorage.setItem("token", data.token);
                    $rootScope.userId = data.userId;
                    $rootScope.name = data.name;
                    $rootScope.phone = data.telephone;
//
                    //---弹出邀请码
                    userService.getInviteStatus().then(function (d) {
                            if (d.invite == 1) {
                                userService.showInvite();
                            }
                        }, function (e) {
                            console.log(e);
                            ErrorShow("网络异常");
                            return returnFlag;
                        }
                    );
                    //---
                    $scope.$emit("login");
                    $("#zc_complete1").attr("disabled", true);
                    $timeout(function () {
                        $("#zc_complete1").attr("disabled", false);
                    }, 3000);
                    Loading.hide('running_woman');
                    $ionicNativeTransitions.stateGo('tab.home', {}, {
                        "type": "slide",
                        "direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
                        "duration": 400 // in milliseconds (ms), default 400
                    });
                    //注册成功
                    // $state.go("g_load");
                    returnFlag = true;

                }, function (e) {
                    Loading.hide('running_woman');
                    ErrorShow(e.error);
                    return returnFlag;
                });
            }
            return returnFlag;
        }

        $scope.timer = function () {
            $scope.flag.time--;
        }

        //倒计时
        $scope.time = function () {
            $scope.flag.send = true;
            $scope.verifyInterval = $interval(function () {
                $scope.flag.time--;
            }, 1000);
            $timeout(function () {
                if (angular.isDefined($scope.verifyInterval)) {
                    $interval.cancel($scope.verifyInterval);
                }
                $scope.flag.send = false;
            }, 60000);
        }
        var usage = "Register";
        $scope.getVcode = function () {
            $scope.flag.time = 60;
            var phone = $scope.reg.phone;
            if (!checkPhone(phone)) {
                return false;
            }
            userService.getVcode(phone, usage).then(function (data) {
                console.log("获取验证码...", usage);
                if (data.status == 1) {
                    $scope.time();
                }
            }, function (e) {
                console.log(e);
                if (e.error.indexOf('已经注册') != -1)    //已经注册则去修改密码
                {
                    /*$scope.editFlag.show='该手机已经注册，点击获取验证码重置密码';
                     $scope.editFlag.vcodeError=true;*/
                    $scope.flag.deleting = true;
                    //去登陆
                    $scope.confirm = function () {
                        $state.go("g_load");
                        $scope.flag.deleting = false;
                    }
                    //获取验证码重置密码
                    $scope.cancel = function () {
                        usage = "Reset";
                        $scope.reg.title = "忘记密码";
                        $scope.flag.deleting = false;
                        $scope.getVcode();
                    }

                } else {
                    ErrorShow(e.error);
                }
            });


            console.log("注册手机号-----" + phone);

        };
        $scope.focus = function () {
            //lert("111");
            $scope.editFlag.vcodeError = false;
        }

        $scope.focus2 = function () {
            $scope.form.flag = false;
        }

        $scope.getVerify = function () {   //校验
            var phone = $scope.reg.phone;
            var vcode = $scope.reg.vcode;
            // var usage = "Register";
            if (!checkPhone(phone)) {
                return false;
            } else if (!vcode) {
                $scope.editFlag.show = '验证码不能为空';
                $scope.editFlag.vcodeError = true;
                return false;
                //ErrorShow("验证码不能为空！");
            }
            console.log("校验验证码----" + vcode);
            userService.verify(phone, usage).then(function (data) {
                if (data.CheckNum == vcode) {
                    console.log("用户输入跟系统验证码一致！");
                    console.log("上传网络的usage:" + usage);
                    regCache.put('phone', phone);
                    regCache.put('vcode', vcode);
//                    $ionicNativeTransitions.stateGo('load_zc2', {usage: usage, phone: phone}, {
//                        "type": "slide",
//                        "direction": "left",
//                        "duration": 500
//                    });
                    var rflag = $scope.regist(usage);
                    if (!rflag) {
                        return false;
                    }
                    //$state.go("load_zc2");
                } else {
                    $scope.editFlag.show = '验证码错误';
                    $scope.editFlag.vcodeError = true;
                    //ErrorShow("验证码错误！");
                    return false;
                }
            }, function (error) {
                //$state.go("tab.home");
                console.log(error);
                return false;
            });
        };

        /**
         * 返回
         */
        $scope.goBack = function () {
            $ionicNativeTransitions.stateGo('g_load', {}, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        }
    })

    //设置密码
    .controller('setPwdCtrl', function ($scope, $stateParams, userService, $state, $rootScope, $cacheFactory, $ionicNativeTransitions, Loading, $timeout) {
        console.log("设置密码");
        $scope.form = {pwd: "", rpwd: "", flag: false, showFlag: false};
        var form = $scope.form;
        $scope.showPwd = function (num) {
            if (num == 1) {
                $scope.form.showFlag = true;
                $(".aa").attr("type", "text");
            } else {
                $scope.form.showFlag = false;
                $(".aa").attr("type", "password");
            }
        }
        $scope.areSame = function () {
            console.log("pwd---------" + form.pwd);
            console.log("pwd---------" + form.rpwd);
            if (form.pwd == "" || form.rpwd == "") {
                //alert("密码不能为空");
                ErrorShow("密码不能为空");
                return false;
            } else if (!checkPassword(form.pwd)) {
                form.flag = true;
                return false;
            } else if (form.pwd == form.rpwd) {
                var usage = $stateParams.usage;
                if (usage == 'Reset') //若从上一页面传过来的是重置密码，则重置
                {
                    var phone = $stateParams.phone;
                    userService.modifyPwd(phone, form.pwd).then(function (data) {
                        if (data.status) {
                            console.log("重置密码成功！");
                            $state.go("g_load");
                        } else {
                            console.log("重置密码失败");
                            return false;
                        }
                    }, function (error) {
                        console.log(error);
                    });
                } else {
                    var regCache = $cacheFactory.get('register');
                    console.log(form);
                    localStorage.setItem("password", form.pwd); //记住密码
                    regCache.put("pwd", jQuery.md5(form.pwd));
                    var pwd = jQuery.md5(form.pwd);
                    //忽略后两步
                    //取得所有上传参数
                    var regCache = $cacheFactory.get('register');
                    var phone = regCache.get("phone");
                    var checkNum = regCache.get("vcode");
                    console.log(checkNum);
                    var regSource = "android";
                    userService.regAll(phone, checkNum, null, pwd, regSource, null).then(function (data) {
                        ErrorShow("注册成功");
                        //记住密码

                        Loading.show('running_woman', '登录', true);
                        $rootScope.user = data;
                        localStorage.setItem("user", JSON.stringify(data)); //将用户信息存入本地
                        if (!!localStorage.getItem(phone))  //注册时的默认头像
                        {
                            $rootScope.user.headImg = localStorage.getItem(phone);
                            // alert(localStorage.getItem("headImg"));
                        }
                        $rootScope.date = data.date;     //临时变量，用于个人设置页面↓↓↓
                        $rootScope.gender = data.gender;
                        $rootScope.name = data.name;
                        console.log(data);
                        $rootScope.token = data.token;
                        //记住密码
                        localStorage.setItem("token", data.token);
                        $rootScope.userId = data.userId;
                        $rootScope.name = data.name;
                        $rootScope.phone = data.telephone;
//
                        //---弹出邀请码
                        userService.getInviteStatus().then(function (d) {
                                if (d.invite == 1) {
                                    userService.showInvite();
                                }
                            }, function (e) {
                                console.log(e);
                                ErrorShow("网络异常");
                            }
                        );
                        //---
                        $scope.$emit("login");
                        $("#zc_complete").attr("disabled", true);
                        $timeout(function () {
                            $("#zc_complete").attr("disabled", false);
                        }, 3000);
                        Loading.hide('running_woman');
                        $ionicNativeTransitions.stateGo('tab.home', {}, {
                            "type": "slide",
                            "direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
                            "duration": 400 // in milliseconds (ms), default 400
                        });
                        //注册成功
                        // $state.go("g_load");

                    }, function (e) {
                        Loading.hide('running_woman');
                        ErrorShow(e.error);
                    });

                    //忽略后两步
                }
            } else {
                //alert("两次密码输入不一致");
                ErrorShow("两次密码输入不一致");
                return false;
            }
        };

        $scope.focus = function () {
            $scope.form.flag = false;
        }
    })

    //设置性别
    .controller('setGenderCtrl', function ($scope, userService, $state, $rootScope, $cacheFactory) {
        var regCache = $cacheFactory.get('register');
        console.log("设置性别");
        $scope.form = {
            gender: '1'
        };
        var form = $scope.form;
        $scope.selectGender = function (str) {
            form.gender = str;
            regCache.put("gender", form.gender);
        }
        regCache.put("gender", form.gender);

    })

//设置生日,完成整个注册
    .controller('setBirthCtrl', function ($scope, userService, $state, $rootScope, $cacheFactory, $ionicNativeTransitions, Loading) {
        console.log("设置生日");
        var regCache = $cacheFactory.get('register');
        var gender = regCache.get("gender");
        //出生日期
        var currentYear = new Date().getFullYear();
        var defaultTime = new Date(1980, 0, 1);
        $('#birth_zc').mobiscroll().date({
            theme: '',     // Specify theme like: theme: 'ios' or omit setting to use default
            mode: 'scroller',       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
            dateFormat: 'yyyy-mm-dd',
            display: 'inline', // Specify display mode like: display: 'bottom' or omit setting to use default
            lang: 'zh',
            startYear: currentYear - 100,
            endYear: currentYear,
            defaultValue: defaultTime
        });
        //$('#birth_zc').mobiscroll('setValue', '2000-05-05');

        $scope.user = {birthday: "1980-01-01", age: "", headImg: gender};
        var phone_ = regCache.get("phone");
        if ($scope.user.headImg == '1') {
            localStorage.setItem(phone_, "img/g_tx_03.png");
        } else {
            localStorage.setItem(phone_, "img/g_tx_06.png");
        }

        $scope.user.age = currentYear - 1980;
        $scope.show = function (str) {
            console.log(str);
            var ary = str.split('-');
            $scope.user.age = currentYear - ary[0];
            console.log($scope.user.age);
        }
        console.log($scope.user.birthday);
        $scope.selectBirth = function () {
            var birthdays = $scope.user.birthday;
            console.log(birthdays);
            //取得所有上传参数
            var regCache = $cacheFactory.get('register');
            var phone = regCache.get("phone");
            console.log(phone + "       serverice.......");
            var checkNum = regCache.get("vcode");
            console.log(checkNum);
            var gender = regCache.get("gender");
            console.log(gender);
            var password = regCache.get("pwd")
            console.log(password);
            var regSource = "android";
            console.log(regSource)
            console.log(birthdays);
            userService.regAll(phone, checkNum, gender, password, regSource, birthdays).then(function (data) {
                ErrorShow("注册成功");
                //记住密码

                Loading.show('running_woman', '登录', true);
                $rootScope.user = data;
                localStorage.setItem("user", JSON.stringify(data)); //将用户信息存入本地
                if (!!localStorage.getItem(phone))  //注册时的默认头像
                {
                    $rootScope.user.headImg = localStorage.getItem(phone);
                    // alert(localStorage.getItem("headImg"));
                }
                $rootScope.date = data.date;     //临时变量，用于个人设置页面↓↓↓
                $rootScope.gender = data.gender;
                $rootScope.name = data.name;
                console.log(data);
                $rootScope.token = data.token;
                //记住密码
                localStorage.setItem("token", data.token);
                $rootScope.userId = data.userId;
                $rootScope.name = data.name;
                $rootScope.phone = data.telephone;
                $scope.$emit("login");
                $scope.$emit('loginSuccess');
                Loading.hide('running_woman');
                $ionicNativeTransitions.stateGo('tab.home', {}, {
                    "type": "slide",
                    "direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
                    "duration": 400 // in milliseconds (ms), default 400
                });
                //注册成功
                // $state.go("g_load");

            }, function (e) {
                Loading.hide('running_woman');
                ErrorShow(e.error);
            });
        }
    })

    //发送短信(重置密码)
    .controller('forgetSendCtrl', function ($scope, userService, $state, $rootScope, $cacheFactory, $interval, $timeout, $stateParams, $ionicNativeTransitions) {
        console.log("发送短信，获取重置密码验证码");
        //声明注册缓存
        var resetCache = $cacheFactory.get('resetCache');
        if (!resetCache) {
            resetCache = $cacheFactory('resetCache');
        }
        var useage = "Reset";
        $scope.reg = {phone: "", vcode: "", show: "", flag: false};
        //获取短信验证码并倒计时
        $scope.flag = {send: false, time: 60};
        $scope.timer = function () {
            $scope.flag.time--;
        }
        $scope.sendMessage = function () {
            $scope.flag.time = 60;
            var phone = $scope.reg.phone;
            if (!checkPhone(phone)) {
                return false;
            }
            console.log("重置密码手机号-----" + phone + "\n" + "usage:" + useage);
            userService.getVcode(phone, useage).then(function (data) {
                if (!checkPhone(phone)) {
                    return false;
                }
                console.log("ddddd");
                $scope.flag.send = true;
                $scope.verifyInterval = $interval(function () {
                    $scope.flag.time--;
                }, 1000);
                $timeout(function () {
                    if (angular.isDefined($scope.verifyInterval)) {
                        $interval.cancel($scope.verifyInterval);
                    }
                    $scope.flag.send = false;
                }, 60000);
                console.log("获取验证码...");

            }, function (error) {
                // alert(error.error);
                $scope.reg.show = error.error;
                $scope.reg.flag = true;
                return false;
            });
        };
        /**
         * 获取焦点取消错误提示
         */
        $scope.focus = function () {
            $scope.reg.flag = false;
        }

        $scope.getVerify = function () {   //校验
            var phone = $scope.reg.phone;
            var vcode = $scope.reg.vcode;
            var usage = "Reset";
            if (!checkPhone(phone)) {
                return false;
            } else if (!vcode) {
                // alert("验证码不能为空！");
                //ErrorShow("验证码不能为空！");
                $scope.reg.flag = true;
                $scope.reg.show = '验证码不能为空';
                return false;
            } else {
                console.log("校验验证码----" + vcode);
                userService.verify(phone, usage).then(function (data) {
                    if (data.CheckNum == vcode || vcode == 'zjlh') {
                        console.log("用户输入跟系统验证码一致！");
                        resetCache.put('phone', phone);
                        resetCache.put('vcode', vcode);
                        $state.go("load_forget2");
                    } else {
                        console.log("验证码错误！");
                        $scope.reg.show = '验证码错误';
                        $scope.reg.flag = true;
                        return false;
                    }
                }, function (error) {
                    //$state.go("tab.home");
                    console.log(error);
                    $scope.reg.show = error.error;
                    $scope.reg.flag = true;
                    return false;
                });
            }
        };

        /**
         * 返回
         */
        $scope.goBack = function () {
            $ionicNativeTransitions.stateGo('g_load', {}, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        }

    })

//设置密码,完成找回密码
    .controller('findPwdCtrl', function ($scope, userService, $state, $rootScope, $cacheFactory) {
        console.log("重设密码");
        var usage = "Reset";
        $scope.resetform = {pwd: "", rpwd: "", flag: false, showFlag: false, show: ''};
        var form = $scope.resetform;
        $scope.showPwd = function (num) {
            if (num == 1) {
                $scope.resetform.showFlag = true;
                $(".bb").attr("type", "text");
            } else {
                $scope.resetform.showFlag = false;
                $(".bb").attr("type", "password");
            }
        }
        $scope.submitAll = function () {
            console.log("pwd---------" + form.pwd);
            console.log("pwd---------" + form.rpwd);
            if (!checkPassword(form.pwd) || !checkPassword(form.rpwd)) {
                /*$scope.resetform.show='密码输入错误，格式为6-12位字符';
                 $scope.resetform.flag = true;*/
                return false;
            } else if (form.pwd != form.rpwd) {
                //ErrorShow("两次密码输入不一致");
                $scope.resetform.show = '两次密码输入不一致';
                $scope.resetform.flag = true;
                return false;
            } else {
                var resetCache = $cacheFactory.get('resetCache');
                console.log(form);
                var phone = resetCache.get("phone");
                console.log(phone);
                var checkNum = resetCache.get("vcode");
                console.log(checkNum);
                var password = jQuery.md5(form.pwd);
                console.log(password);
                userService.findPwd(phone, checkNum, password).then(function (data) {
                    if (data.status) {
                        console.log("重置密码成功！");
                        $state.go("g_load");
                    } else {
                        //ErrorShow("重置密码失败");
                        $scope.resetform.show = '重置密码失败';
                        $scope.resetform.flag = true;
                        return false;
                    }
                }, function (e) {
                    $scope.resetform.show = e.error;
                    $scope.resetform.flag = true;
                    return false;
                });

            }
        };

        $scope.focus = function () {
            $scope.resetform.flag = false;
        }

    })
    .controller('userMesCtrl', function ($scope, $stateParams, $ionicNativeTransitions, Loading, userService, $state, $rootScope, $cacheFactory, drugService, $ionicSlideBoxDelegate) {
        /**
         * 从localsttorage中取出 消息宽度, 设置 宽度
         * @type {boolean}
         */
        if (localStorage.getItem("user_message_width")) {
            $scope.replay_width = localStorage.getItem("user_message_width");
            console.log("消息宽度", $scope.replay_width);
        }
        $scope.imgFlag = false;//默认不显示分享的大图
        console.log("我的分享");
        Loading.show('running_woman', '我的分享', true);
        console.log($stateParams.shareId);
        console.log(location.href);
        $scope.gifts = ['', '玫瑰花', '巧克力', '鲜花礼盒', '冰激凌', '漂流瓶', '小熊宝宝'];
        drugService.updateWeixinReplyUser($stateParams.shareId).then(function (data) {
            if (data.status) {
                $scope.appuserdata = data.appuser;
                console.log('----------');
                console.log($scope.appuserdata.gender);
                var headimg = $scope.appuserdata.headImg;
                if (headimg != null && headimg.length > 0) {
                    $scope.appuserdata.headImg = $rootScope.reqUrl_short + '/FileServer/open/file/url.htm?acceptCode=&fileId=' + headimg;
                }
                var appname = $scope.appuserdata.name;
                if (appname == null || appname.length == 0) {
                    $scope.appuserdata.name = $scope.appuserdata.phone;
                }
                $scope.shareDrug = data.share;
                $scope.weixinReply = data.replylist;
                var replyUser = data.replyusers;
                console.log(data);
                for (var i = 0; i < $scope.weixinReply.length; i++) {
                    for (var j = 0; j < replyUser.length; j++) {
                        if ($scope.weixinReply[i].replyuserid == replyUser[j].id) {
                            $scope.weixinReply[i].nickname = replyUser[j].nickname;
                            console.log(replyUser[j].handimgurl);
                            $scope.weixinReply[i].handimgurl = replyUser[j].handimgurl;
                            var urlType = $scope.weixinReply[i].type;
                            if (urlType > 0 && urlType < 7) {
                                $scope.weixinReply[i].giftUrl = "img/gift_0" + urlType + ".png";
                            }
                        }
                    }
                }
                console.log('eeeeeeeeeeeeeeeeeeeeeeee');

                console.log($scope.weixinReply);
                var t = $scope.shareDrug.shareTime.time;
                var nowtimestr = new Date();
                var nt = nowtimestr.getTime();
                var temp = nt - t;
                var hour;
                if (temp < (3600 * 1000)) {
                    hour = (temp / (60 * 1000));
                    if (parseInt(hour) < 6) {
                        $scope.shareDrug.shareTimeStr = "刚刚";
                    } else {
                        $scope.shareDrug.shareTimeStr = parseInt(hour) + "分钟前";
                    }
                } else if (temp >= (3600 * 1000) && temp < (60 * 60 * 24 * 1000)) {
                    hour = (temp / (60 * 60 * 1000));
                    $scope.shareDrug.shareTimeStr = parseInt(hour) + "小时前";
                } else {
                    hour = (temp / (60 * 60 * 24 * 1000));
                    $scope.shareDrug.shareTimeStr = parseInt(hour) + "天前";
                }
            } else {
            }
            Loading.hide('running_woman');
        }, function (e) {
            Loading.hide('running_woman');
            //alert("无网络");
            console.log("not network");

            ErrorShow("网络错误");//弹出提示框
        });

        $scope.goBack = function () {
            //取出回退页面跳转参数
            var param = $cacheFactory.get($stateParams.backUrl);
            var sp = null;
            //如果不在页面参数则设置为空串
            if (param) {
                sp = param.get('stateParams');
                if (!sp) {
                    sp = {};
                }
            } else {
                sp = {};
            }
            $ionicNativeTransitions.stateGo($stateParams.backUrl, sp, {
                "type": "slide",
                "direction": "right",
                "duration": 500
            });
        };

        /**
         * 看大图
         */
        $scope.viewBigImg = function () {
//            console.debug("看大图");
            $ionicSlideBoxDelegate.$getByHandle('imghandle').enableSlide(false);
            $scope.imgFlag = true;
        }

        $scope.hideImg = function () {
            $scope.imgFlag = false;
        }
    })


;

