angular.module('FileUtil', [])
    .factory('imageUtil', function ($rootScope, $q, $cordovaCamera, $cordovaImagePicker) {
        return {
            //图片上传
            uploadImages: function (img, url, token) {
                var q = $q.defer();
                var imageData = img;
                var options = new FileUploadOptions();
                //alert('image');
                options.fileKey = "file";//用于设置参数，对应form表单里控件的name属性，这是关键，废了一天时间，完全是因为这里，这里的参数名字，和表单提交的form对应
                // alert('原始文件地址' + imageData);
                options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
                //alert('文件名称' + options.fileName);
                //如果是图片格式，就用image/jpeg，其他文件格式上官网查API
                options.mimeType = "image/jpeg";
                //options.mimeType = "multipart/form-data";
                // 这两个参数修改了，后台就跟普通表单页面post上传一样 enctype="multipart/form-data"
                console.info("上传地址：", $rootScope.reqUrl + url);
                var uri = encodeURI($rootScope.reqUrl + url);
                options.chunkedMode = false;
                //-------------尝试设置请求超时时间---------
                options.headers = {"Max-Forwards": 5};
//                options.timeout = 5000;
                //-------------尝试设置请求超时时间---------
                var params = new Object();
                params.fileAddPic = imageData;
                params.token = token;
                options.params = params;
                var ft = new FileTransfer();
                ft.upload(imageData, uri, function (result) {
                    console.info("上传返回结果：", result);
                    var res = eval('(' + result.response + ')');
                    q.resolve(res);
                }, function (error) {
                    q.reject(error);
                }, options);
                return q.promise;
            },
            //拍照
            takePhoto: function (p_width, p_height, dest) {
                var q = $q.defer();
                var options = {
                    destinationType: dest,
                    sourceType: Camera.PictureSourceType.CAMERA,
                    //=====关键部分=========================================
                    allowEdit: true, //出现裁剪框
                    targetWidth: p_width, //图片输出宽度
                    targetHeight: p_width, //图片输出高度
                    quality: 100
                };
                $cordovaCamera.getPicture(options).then(function (imageData) {
                    q.resolve(imageData);
                }, function (err) {
                    /*ErrorShow(err);*/
                });
                return q.promise;
            },
            //拍照
            takePhotoGyzz: function (p_width, p_height, dest) {
                var q = $q.defer();
                console.log(p_width + "----" + p_height);
                var options = {
                    destinationType: dest,
                    sourceType: Camera.PictureSourceType.CAMERA,
                    //=====关键部分=========================================
                    allowEdit: false, //出现裁剪框
                    targetWidth: p_width, //图片输出宽度
                    targetHeight: p_height, //图片输出高度
                    quality: 100,
                    saveToPhotoAlbum: true,
                    correctOrientation: true,
                    cameraDirection: 0,
                    encodingType: Camera.EncodingType.JPEG
                };
                $cordovaCamera.getPicture(options).then(function (imageData) {
                    q.resolve(imageData);
                }, function (err) {
                    /*ErrorShow(err);*/
                });
                return q.promise;
            },
            takePhotoHead: function (p_width, p_height, dest) {
                var q = $q.defer();
                var options = {
                    destinationType: dest,
                    sourceType: Camera.PictureSourceType.CAMERA,
                    //=====关键部分=========================================
                    allowEdit: true, //出现裁剪框
                    targetWidth: p_width, //图片输出宽度
                    targetHeight: p_height,
                    quality: 50
                };
                $cordovaCamera.getPicture(options).then(function (imageData) {
                    q.resolve(imageData);
                }, function (err) {

                });
                return q.promise;
            },
            //图片选择
            imagePick: function (p_width, p_height) {
                var q = $q.defer();
                var ret = [];
                var options = {
                    maximumImagesCount: 1,
                    width: p_width,
                    height: p_height,
                    quality: 100
                };
                $cordovaImagePicker.getPictures(options)
                    .then(function (results) {
                        q.resolve(results[0]);
                    }, function (error) {
                        // error getting photos
                        q.reject(error);
                    });
                return q.promise;
            },
            pickOne: function (p_width, p_height) {
                var q = $q.defer();
                var options = {
                    quality: 100,
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                    allowEdit: true,
                    encodingType: Camera.EncodingType.PNG,
                    targetWidth: p_width,
                    targetHeight: p_width,
                    popoverOptions: CameraPopoverOptions,
                    saveToPhotoAlbum: false
                };
                $cordovaCamera.getPicture(options).then(function (imageData) {
                    //alert(imageData);
                    q.resolve(imageData);
                }, function (err) {
                    // alert(err);
                    q.reject(err);
                });
                return q.promise;
            },
            //图片上传
            uploadHeadImages: function (img, url) {
                var q = $q.defer();
                var imageData = img;
                var options = new FileUploadOptions();
                options.fileKey = "file";//用于设置参数，对应form表单里控件的name属性，这是关键，废了一天时间，完全是因为这里，这里的参数名字，和表单提交的form对应
                options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
                //如果是图片格式，就用image/jpeg，其他文件格式上官网查API
                options.mimeType = "image/jpeg";
                //options.mimeType = "multipart/form-data";
                // 这两个参数修改了，后台就跟普通表单页面post上传一样 enctype="multipart/form-data"
                var uri = encodeURI($rootScope.reqUrl + url);
                options.chunkedMode = false;
                var params = new Object();
                params.fileAddPic = imageData;
                options.params = params;
                var ft = new FileTransfer();
                ft.upload(imageData, uri, function (result) {
                    var res = eval('(' + result.response + ')');
                    if (res.status) {
                        q.resolve(res.headImg);
                    } else {
                        q.reject(res.message);
                    }
                }, null, options);
                return q.promise;
            },
            //图片上传
            uploadCertImages: function (img, url) {
                var q = $q.defer();
                var imageData = img;
                var options = new FileUploadOptions();
                options.fileKey = "file";//用于设置参数，对应form表单里控件的name属性，这是关键，废了一天时间，完全是因为这里，这里的参数名字，和表单提交的form对应
                options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
                //如果是图片格式，就用image/jpeg，其他文件格式上官网查API
                options.mimeType = "image/jpeg";
                //options.mimeType = "multipart/form-data";
                // 这两个参数修改了，后台就跟普通表单页面post上传一样 enctype="multipart/form-data"
                var uri = encodeURI($rootScope.reqUrl + url);
                options.chunkedMode = false;
                var params = new Object();
                params.fileAddPic = imageData;
                options.params = params;
                var ft = new FileTransfer();
                ft.upload(imageData, uri, function (result) {
                    var res = eval('(' + result.response + ')');
                    q.resolve(res);
                }, null, options);
                return q.promise;
            }
        }
    }).factory('fileUtil', function ($rootScope, $q) {
        return {
            /**
             * 文件上传
             * @param file 文件地址
             * @param type 文件类型
             * @param url 上传地址
             * @param token 令牌信息
             * @returns {*}
             */
            upload: function (file, type, url, token) {
                var q = $q.defer();
                var fileData = file;
                var options = new FileUploadOptions();
                options.fileKey = "file";//用于设置参数，对应form表单里控件的name属性，这是关键，废了一天时间，完全是因为这里，这里的参数名字，和表单提交的form对应
                options.fileName = fileData.substr(fileData.lastIndexOf('/') + 1);
                //如果是图片格式，就用image/jpeg，其他文件格式上官网查API
                if (type == 'image') {
                    options.mimeType = "image/jpeg";
                } else if (type == 'audio') {
                    options.mimeType = "audio/3gpp";
                }
                //options.mimeType = "multipart/form-data";
                // 这两个参数修改了，后台就跟普通表单页面post上传一样 enctype="multipart/form-data"
                var uri = encodeURI($rootScope.reqUrl + url);
                options.chunkedMode = false;
                var params = new Object();
                params.fileAddPic = fileData;
                params.token = token;
                params.type = type;
                options.params = params;
                var ft = new FileTransfer();
                ft.upload(fileData, uri, function (result) {
                    var res = eval('(' + result.response + ')');
                    if (res.status) {
                        q.resolve(res.data);
                    } else {
                        q.reject(res.message);
                    }
                }, null, options);
                return q.promise;
            }
        }
    });
