function myCharts(data) {
    var tickData = getTickData(data);
    var nData = getNdata(data);
    $("#xy_" + data.healthIndex).highcharts({
        chart: {
        },
        title: {
            text: ''
        },
        subtitle: {
            text: ''
        },
        xAxis: {
            categories: getXArray(data),
            title: {
                text: getText(data.healthIndex),
                align: 'high',
                style: {
                    fontSize: "12px"
                }
            },
            tickLength: null,
            lineWidth: 0.1,
            labels: {
                formatter: function (val) {
                    if(this.value == ""){
                        return "";
                    }
                    if (data.healthIndex == 'stepnum') {
                        return this.value;
                    }
                    return '<p style="font: normal 10px 微软雅黑;color: #333">' + this.value.split(" ")[0] + '</p>' + '<br>' + '<p style="font-size:10px;color: #a9a9a9;">' + this.value.split(" ")[1] + '</p>';
                }
            }
        },
        yAxis: {
            max: tickData[0],
            min: tickData[1],
            gridLineWidth: 0.15,
            gridLineColor: '#e6e6e6',
            tickInterval: Math.abs(tickData[2]),
            tickPositions: getTickPost(data),
            labels: {
                formatter: function () {
                    return this.value.toFixed(getFixedNum(data.healthIndex));
                }
            },
            labels: {
                enabled: false
            },
            title: {
                text: getTitleText(data.healthIndex),
                style: {
                    fontSize: "10px"
                }
            },
            plotBands: [
                {
                    from: nData[0],               // 标示区开始值
                    to: nData[1],                 // 标示区结束值
                    label: {              // 标示区文字标签配置，详见API
                    },
                    color: '#defde9',            // 标示区背景颜色
                    borderWidth: 1,        // 标示区边框宽度
                    borderColor: null        // 标示区边框颜色
                },
                {
                    from: nData[2],               // 标示区开始值
                    to: nData[3],                 // 标示区结束值
                    label: {              // 标示区文字标签配置，详见API
                    },
                    color: '#ffede0',            // 标示区背景颜色
                    borderWidth: 1,        // 标示区边框宽度
                    borderColor: null       // 标示区边框颜色
                }
            ]
        },
        exporting: {
            enabled: false
        },
        credits: {
            enabled: false
        },
        plotOptions: {
            series: {
                color: getColor(data.healthIndex),
                lineWidth: setLineWidth(data.healthIndex),
                pointWidth: getPointWidth(data.healthIndex),
                marker: {
                    radius: 3,
                    lineColor: getColor(data.healthIndex),
                    lineWidth: 1,
                    fillColor: "#fff",
                    symbol: 'circle'//曲线点类型："circle", "square", "diamond", "triangle","triangle-down"，默认是"circle"
                }
            },
            columnrange: {
                dataLabels: {
                    enabled: true,
                    style: {
                        'fontSize': '10px',
                        'fontWeight': 'normal'
                    }
                },
                enableMouseTracking: false
            },
            column: {
                borderRadius: 4,
                dataLabels: {
                    enabled: true,
                    style: {
                        'fontSize': '10px',
                        'fontWeight': 'normal'
                    }
                },
                enableMouseTracking: false
            },
            scatter: {
                dataLabels: {
                    enabled: false,
                    style: {
                        'fontSize': '10px',
                        'fontWeight': 'normal'
                    }
                },
                enableMouseTracking: false
            },
            line: {
                dataLabels: {
                    enabled: true,
                    style: {
                        'fontSize': '10px',
                        'fontWeight': 'normal'
                    }
                },
                enableMouseTracking: false
            }
        },
        legend: {
            enabled: false
        },
        series: [
            {
                type: changeType(data.healthIndex),
                name: changeName(data.healthIndex),
                data: getyArray(data),
                dashStyle: getLineStyle(data.healthIndex)

            },
            {
                type: "scatter",
                name: '舒张压',
                data: getSsy(data),
                color: '#F4922F'
            },
            {
                type: "scatter",
                name: '收缩压',
                data: getSzy(data),
                color: '#F4922F'
            }
        ]
    })
}
